#include <memory>
#include <iostream>
#include "DATEXIISchema_2_0_2_0.hxx"


using namespace std;
using namespace datex2;


int main (int argc, char* argv[])
{
	try
	{
		auto_ptr<D2LogicalModel> data(d2LogicalModel("MeasurementSiteTablePublication.xml"));

		// List supplier identification info.
		cout << "Country             = " << data->exchange().supplierIdentification().country()            << endl;
		cout << "National identifier = " << data->exchange().supplierIdentification().nationalIdentifier() << endl;

		if (data->payloadPublication().present())
		{
			D2LogicalModel::payloadPublication_type& pp = data->payloadPublication().get();

			// List publication time.
			cout << "Publication time    = " << pp.publicationTime().year() << "-" << pp.publicationTime().month() << "-" << pp.publicationTime().day() << endl;

			// Get pointer to derived class.
			if (MeasurementSiteTablePublication* mstp = dynamic_cast<MeasurementSiteTablePublication*> (&pp))
//--> FAILS
			{
				// Derived class.

				// Iterate through all measurement site tables.
				for (MeasurementSiteTablePublication::measurementSiteTable_const_iterator table = mstp->measurementSiteTable().begin();
					 table != mstp->measurementSiteTable().end();
					 table++)
				{
					// List measurement site table id.
					cout << "Measurement site table id = " << table->id();

					// Iterate through all measurement site table records.
					for (MeasurementSiteTable::measurementSiteRecord_const_iterator record = table->measurementSiteRecord().begin();
						 record != table->measurementSiteRecord().end();
						 record++)
					{
						// List measurement site record id.
						cout << "Measurement site record id = " << record->id();
					}
				}
			}
		}
	}
	catch (const xml_schema::exception& e)
	{
		cerr << e << endl;
		return 1;
	}

	return 0;
}
