// Copyright (C) 2005-2010 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

#ifndef DATEXIISCHEMA_2_0_2_0_HXX
#define DATEXIISCHEMA_2_0_2_0_HXX

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/config.hxx>

#if (XSD_INT_VERSION != 3030000L)
#error XSD runtime version mismatch
#endif

#include <xsd/cxx/pre.hxx>

#ifndef XSD_USE_CHAR
#define XSD_USE_CHAR
#endif

#ifndef XSD_CXX_TREE_USE_CHAR
#define XSD_CXX_TREE_USE_CHAR
#endif

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/types.hxx>

#include <xsd/cxx/xml/error-handler.hxx>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

#include <xsd/cxx/tree/parsing.hxx>
#include <xsd/cxx/tree/parsing/byte.hxx>
#include <xsd/cxx/tree/parsing/unsigned-byte.hxx>
#include <xsd/cxx/tree/parsing/short.hxx>
#include <xsd/cxx/tree/parsing/unsigned-short.hxx>
#include <xsd/cxx/tree/parsing/int.hxx>
#include <xsd/cxx/tree/parsing/unsigned-int.hxx>
#include <xsd/cxx/tree/parsing/long.hxx>
#include <xsd/cxx/tree/parsing/unsigned-long.hxx>
#include <xsd/cxx/tree/parsing/boolean.hxx>
#include <xsd/cxx/tree/parsing/float.hxx>
#include <xsd/cxx/tree/parsing/double.hxx>
#include <xsd/cxx/tree/parsing/decimal.hxx>

namespace xml_schema
{
  // anyType and anySimpleType.
  //
  typedef ::xsd::cxx::tree::type type;
  typedef ::xsd::cxx::tree::simple_type< type > simple_type;
  typedef ::xsd::cxx::tree::type container;

  // 8-bit
  //
  typedef signed char byte;
  typedef unsigned char unsigned_byte;

  // 16-bit
  //
  typedef short short_;
  typedef unsigned short unsigned_short;

  // 32-bit
  //
  typedef int int_;
  typedef unsigned int unsigned_int;

  // 64-bit
  //
  typedef long long long_;
  typedef unsigned long long unsigned_long;

  // Supposed to be arbitrary-length integral types.
  //
  typedef long long integer;
  typedef long long non_positive_integer;
  typedef unsigned long long non_negative_integer;
  typedef unsigned long long positive_integer;
  typedef long long negative_integer;

  // Boolean.
  //
  typedef bool boolean;

  // Floating-point types.
  //
  typedef float float_;
  typedef double double_;
  typedef double decimal;

  // String types.
  //
  typedef ::xsd::cxx::tree::string< char, simple_type > string;
  typedef ::xsd::cxx::tree::normalized_string< char, string > normalized_string;
  typedef ::xsd::cxx::tree::token< char, normalized_string > token;
  typedef ::xsd::cxx::tree::name< char, token > name;
  typedef ::xsd::cxx::tree::nmtoken< char, token > nmtoken;
  typedef ::xsd::cxx::tree::nmtokens< char, simple_type, nmtoken > nmtokens;
  typedef ::xsd::cxx::tree::ncname< char, name > ncname;
  typedef ::xsd::cxx::tree::language< char, token > language;

  // ID/IDREF.
  //
  typedef ::xsd::cxx::tree::id< char, ncname > id;
  typedef ::xsd::cxx::tree::idref< char, ncname, type > idref;
  typedef ::xsd::cxx::tree::idrefs< char, simple_type, idref > idrefs;

  // URI.
  //
  typedef ::xsd::cxx::tree::uri< char, simple_type > uri;

  // Qualified name.
  //
  typedef ::xsd::cxx::tree::qname< char, simple_type, uri, ncname > qname;

  // Binary.
  //
  typedef ::xsd::cxx::tree::buffer< char > buffer;
  typedef ::xsd::cxx::tree::base64_binary< char, simple_type > base64_binary;
  typedef ::xsd::cxx::tree::hex_binary< char, simple_type > hex_binary;

  // Date/time.
  //
  typedef ::xsd::cxx::tree::time_zone time_zone;
  typedef ::xsd::cxx::tree::date< char, simple_type > date;
  typedef ::xsd::cxx::tree::date_time< char, simple_type > date_time;
  typedef ::xsd::cxx::tree::duration< char, simple_type > duration;
  typedef ::xsd::cxx::tree::gday< char, simple_type > gday;
  typedef ::xsd::cxx::tree::gmonth< char, simple_type > gmonth;
  typedef ::xsd::cxx::tree::gmonth_day< char, simple_type > gmonth_day;
  typedef ::xsd::cxx::tree::gyear< char, simple_type > gyear;
  typedef ::xsd::cxx::tree::gyear_month< char, simple_type > gyear_month;
  typedef ::xsd::cxx::tree::time< char, simple_type > time;

  // Entity.
  //
  typedef ::xsd::cxx::tree::entity< char, ncname > entity;
  typedef ::xsd::cxx::tree::entities< char, simple_type, entity > entities;

  // Flags and properties.
  //
  typedef ::xsd::cxx::tree::flags flags;
  typedef ::xsd::cxx::tree::properties< char > properties;

  // Parsing/serialization diagnostics.
  //
  typedef ::xsd::cxx::tree::severity severity;
  typedef ::xsd::cxx::tree::error< char > error;
  typedef ::xsd::cxx::tree::diagnostics< char > diagnostics;

  // Exceptions.
  //
  typedef ::xsd::cxx::tree::exception< char > exception;
  typedef ::xsd::cxx::tree::bounds< char > bounds;
  typedef ::xsd::cxx::tree::duplicate_id< char > duplicate_id;
  typedef ::xsd::cxx::tree::parsing< char > parsing;
  typedef ::xsd::cxx::tree::expected_element< char > expected_element;
  typedef ::xsd::cxx::tree::unexpected_element< char > unexpected_element;
  typedef ::xsd::cxx::tree::expected_attribute< char > expected_attribute;
  typedef ::xsd::cxx::tree::unexpected_enumerator< char > unexpected_enumerator;
  typedef ::xsd::cxx::tree::expected_text_content< char > expected_text_content;
  typedef ::xsd::cxx::tree::no_prefix_mapping< char > no_prefix_mapping;
  typedef ::xsd::cxx::tree::no_type_info< char > no_type_info;
  typedef ::xsd::cxx::tree::not_derived< char > not_derived;

  // Error handler callback interface.
  //
  typedef ::xsd::cxx::xml::error_handler< char > error_handler;

  // DOM interaction.
  //
  namespace dom
  {
    // Automatic pointer for DOMDocument.
    //
    using ::xsd::cxx::xml::dom::auto_ptr;

#ifndef XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
#define XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
    // DOM user data key for back pointers to tree nodes.
    //
    const XMLCh* const tree_node_key = ::xsd::cxx::tree::user_data_keys::node;
#endif
  }
}

// Forward declarations.
//
namespace datex2
{
  class SituationRecord;
  class TrafficElement;
  class AbnormalTraffic;
  class AbnormalTrafficTypeEnum;
  class Accident;
  class AccidentCauseEnum;
  class AccidentTypeEnum;
  class Activity;
  class AlertCArea;
  class AlertCDirection;
  class AlertCDirectionEnum;
  class AlertCLinear;
  class AlertCLinearByCode;
  class AlertCLocation;
  class NonNegativeInteger;
  class AlertCLocationCode;
  class AlertCMethod2Linear;
  class AlertCPoint;
  class AlertCMethod2Point;
  class AlertCMethod2PrimaryPointLocation;
  class AlertCMethod2SecondaryPointLocation;
  class AlertCMethod4Linear;
  class AlertCMethod4Point;
  class AlertCMethod4PrimaryPointLocation;
  class AlertCMethod4SecondaryPointLocation;
  class AngleInDegrees;
  class Obstruction;
  class AnimalPresenceObstruction;
  class AnimalPresenceTypeEnum;
  class Location;
  class Area;
  class Destination;
  class AreaDestination;
  class AreaOfInterestEnum;
  class AuthorityOperation;
  class AuthorityOperationTypeEnum;
  class AxleSpacing;
  class AxlesPerHour;
  class AxleWeight;
  class BasicDataValue;
  class Boolean;
  class CarParkConfigurationEnum;
  class NonRoadEventInformation;
  class CarParks;
  class CarParkStatusEnum;
  class CarriagewayEnum;
  class CatalogueReference;
  class Cause;
  class CauseTypeEnum;
  class ChangedFlagEnum;
  class Comment;
  class ComparisonOperatorEnum;
  class ComplianceOptionEnum;
  class ComputationMethodEnum;
  class Float;
  class ConcentrationGramsPerCubicCentimetre;
  class ConcentrationMicrogramsPerCubicMetre;
  class ConcentrationVehiclesPerKilometre;
  class Conditions;
  class ConfidentialityValueEnum;
  class OperatorAction;
  class Roadworks;
  class ConstructionWorks;
  class ConstructionWorkTypeEnum;
  class CountryEnum;
  class CubicMetres;
  class D2LogicalModel;
  class DangerousGoodsRegulationsEnum;
  class DateTime;
  class DatexPictogramEnum;
  class DayEnum;
  class DayWeekMonth;
  class DelayBandEnum;
  class Delays;
  class DelaysTypeEnum;
  class DenyReasonEnum;
  class DirectionCompassEnum;
  class DirectionEnum;
  class DisturbanceActivity;
  class DisturbanceActivityTypeEnum;
  class DrivingConditionTypeEnum;
  class ElaboratedData;
  class PayloadPublication;
  class ElaboratedDataPublication;
  class EnvironmentalObstruction;
  class EnvironmentalObstructionTypeEnum;
  class EquipmentOrSystemFault;
  class EquipmentOrSystemFaultTypeEnum;
  class EquipmentOrSystemTypeEnum;
  class Exchange;
  class ExchangeEnumerations;
  class ExtensionType;
  class ExternalReferencing;
  class FilterExitManagement;
  class FilterReference;
  class FuelTypeEnum;
  class NetworkManagement;
  class GeneralInstructionToRoadUsers;
  class GeneralInstructionToRoadUsersTypeEnum;
  class GeneralNetworkManagement;
  class GeneralNetworkManagementTypeEnum;
  class GeneralObstruction;
  class GenericPublication;
  class GenericSituationRecord;
  class GrossWeightCharacteristic;
  class GroupOfLocations;
  class GroupOfLocationsByReference;
  class GroupOfNonOrderedLocations;
  class GroupOfPeopleInvolved;
  class GroupOfVehiclesInvolved;
  class HazardousMaterials;
  class HeaderInformation;
  class HeaviestAxleWeightCharacteristic;
  class HeightCharacteristic;
  class Humidity;
  class WeatherValue;
  class HumidityInformation;
  class Impact;
  class TrafficValue;
  class IndividualVehicleMeasurements;
  class InformationStatusEnum;
  class InfrastructureDamageObstruction;
  class InfrastructureDamageTypeEnum;
  class InjuryStatusTypeEnum;
  class IntensityKilogrammesPerSquareMetre;
  class IntensityMillimetresPerHour;
  class InternationalIdentifier;
  class InvolvementRolesEnum;
  class Itinerary;
  class KilometresPerHour;
  class LaneEnum;
  class Language;
  class LengthCharacteristic;
  class LifeCycleManagement;
  class NetworkLocation;
  class Linear;
  class LinearTrafficView;
  class LoadTypeEnum;
  class LocationByReference;
  class LocationCharacteristicsOverride;
  class LocationDescriptorEnum;
  class MaintenanceVehicleActionsEnum;
  class MaintenanceVehicles;
  class MaintenanceWorks;
  class ManagedCause;
  class Management;
  class MatrixFaultEnum;
  class SignSetting;
  class MatrixSignSetting;
  class MeasuredDataPublication;
  class MeasuredOrDerivedDataTypeEnum;
  class MeasuredValue;
  class MeasurementSiteRecord;
  class MeasurementSiteTable;
  class MeasurementSiteTablePublication;
  class MeasurementSpecificCharacteristics;
  class MetresAsFloat;
  class MetresAsNonNegativeInteger;
  class Mobility;
  class MobilityEnum;
  class MonthOfYearEnum;
  class MultilingualString;
  class MultilingualStringValueType;
  class MultilingualStringValue;
  class NonManagedCause;
  class RoadConditions;
  class NonWeatherRelatedRoadConditions;
  class NonWeatherRelatedRoadConditionTypeEnum;
  class NumberOfAxlesCharacteristic;
  class ObstructionTypeEnum;
  class OffsetDistance;
  class OperatingModeEnum;
  class OperatorActionOriginEnum;
  class OperatorActionStatusEnum;
  class OverallPeriod;
  class OverallSeverityEnum;
  class PassengerCarUnitsPerHour;
  class Percentage;
  class Period;
  class PersonCategoryEnum;
  class PlacesEnum;
  class Point;
  class PointByCoordinates;
  class PointCoordinates;
  class PointDestination;
  class PollutantTypeEnum;
  class PollutionInformation;
  class PollutionMeasurement;
  class PoorEnvironmentConditions;
  class PoorEnvironmentTypeEnum;
  class PrecipitationDetail;
  class PrecipitationInformation;
  class PrecipitationTypeEnum;
  class PredefinedLocation;
  class PredefinedLocationSet;
  class PredefinedLocationsPublication;
  class ProbabilityOfOccurrenceEnum;
  class PublicEvent;
  class PublicEventTypeEnum;
  class String;
  class Reference;
  class ReferencePointDirectionEnum;
  class ReferenceSettings;
  class RelativeTrafficFlowEnum;
  class RequestTypeEnum;
  class ReroutingManagement;
  class ReroutingManagementTypeEnum;
  class ResponseEnum;
  class RoadMaintenanceTypeEnum;
  class RoadOperatorServiceDisruption;
  class RoadOperatorServiceDisruptionTypeEnum;
  class RoadOrCarriagewayOrLaneManagement;
  class RoadOrCarriagewayOrLaneManagementTypeEnum;
  class RoadsideAssistance;
  class RoadsideAssistanceTypeEnum;
  class RoadsideReferencePoint;
  class RoadsideReferencePointLinear;
  class RoadsideReferencePointPrimaryLocation;
  class RoadsideReferencePointSecondaryLocation;
  class RoadsideServiceDisruption;
  class RoadsideServiceDisruptionTypeEnum;
  class RoadSurfaceConditionInformation;
  class RoadSurfaceConditionMeasurements;
  class RoadworksDurationEnum;
  class RoadworksScaleEnum;
  class Seconds;
  class SiteMeasurements;
  class Situation;
  class SituationPublication;
  class Source;
  class SourceTypeEnum;
  class SpeedManagement;
  class SpeedManagementTypeEnum;
  class SpeedPercentile;
  class Subjects;
  class SubjectTypeOfWorksEnum;
  class Subscription;
  class SubscriptionStateEnum;
  class SupplementaryPositionalDescription;
  class Target;
  class Temperature;
  class TemperatureCelsius;
  class TemperatureInformation;
  class Time;
  class TimePeriodOfDay;
  class TimePeriodByHour;
  class Tonnes;
  class TpegDescriptor;
  class TpegAreaDescriptor;
  class TpegAreaLocation;
  class TpegPointLocation;
  class TpegFramedPoint;
  class TpegGeometricArea;
  class TpegHeight;
  class TpegPointDescriptor;
  class TpegIlcPointDescriptor;
  class TpegPoint;
  class TpegJunction;
  class TpegJunctionPointDescriptor;
  class TpegLinearLocation;
  class TpegLoc01AreaLocationSubtypeEnum;
  class TpegLoc01FramedPointLocationSubtypeEnum;
  class TpegLoc01LinearLocationSubtypeEnum;
  class TpegLoc01SimplePointLocationSubtypeEnum;
  class TpegLoc02DirectionTypeEnum;
  class TpegLoc03AreaDescriptorSubtypeEnum;
  class TpegLoc03IlcPointDescriptorSubtypeEnum;
  class TpegLoc03JunctionPointDescriptorSubtypeEnum;
  class TpegLoc03OtherPointDescriptorSubtypeEnum;
  class TpegLoc04HeightTypeEnum;
  class TpegNamedOnlyArea;
  class TpegNonJunctionPoint;
  class TpegOtherPointDescriptor;
  class TpegSimplePoint;
  class TrafficConcentration;
  class TrafficConstrictionTypeEnum;
  class TrafficFlow;
  class TrafficFlowCharacteristicsEnum;
  class TrafficHeadway;
  class TrafficSpeed;
  class TrafficStatusEnum;
  class TrafficStatusValue;
  class TrafficTrendTypeEnum;
  class TrafficTypeEnum;
  class TrafficView;
  class TrafficViewPublication;
  class TrafficViewRecord;
  class TransitInformation;
  class TransitServiceInformationEnum;
  class TransitServiceTypeEnum;
  class TravelTimeTrendTypeEnum;
  class TravelTimeTypeEnum;
  class TravelTimeValue;
  class UpdateMethodEnum;
  class UrgencyEnum;
  class Url;
  class UrlLink;
  class UrlLinkTypeEnum;
  class Validity;
  class ValidityStatusEnum;
  class VariableMessageSignSetting;
  class Vehicle;
  class VehicleCharacteristics;
  class VehicleDetectionTime;
  class VehicleEquipmentEnum;
  class VehicleHeadway;
  class VehicleObstruction;
  class VehicleObstructionTypeEnum;
  class VehicleSpeed;
  class VehiclesPerHour;
  class VehicleStatusEnum;
  class VehicleTypeEnum;
  class VehicleUsageEnum;
  class Visibility;
  class VisibilityInformation;
  class VmsFaultEnum;
  class VmsTypeEnum;
  class WeatherRelatedRoadConditions;
  class WeatherRelatedRoadConditionTypeEnum;
  class WeekOfMonthEnum;
  class WidthCharacteristic;
  class Wind;
  class WindInformation;
  class WinterDrivingManagement;
  class WinterEquipmentManagementTypeEnum;
  class measurementSpecificCharacteristics;
  class measuredValue;
}


#include <memory>    // std::auto_ptr
#include <limits>    // std::numeric_limits
#include <algorithm> // std::binary_search

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/containers.hxx>
#include <xsd/cxx/tree/list.hxx>

#include <xsd/cxx/xml/dom/parsing-header.hxx>

namespace datex2
{
  class SituationRecord: public ::xml_schema::type
  {
    public:
    // situationRecordCreationReference
    // 
    typedef ::datex2::String situationRecordCreationReference_type;
    typedef ::xsd::cxx::tree::optional< situationRecordCreationReference_type > situationRecordCreationReference_optional;
    typedef ::xsd::cxx::tree::traits< situationRecordCreationReference_type, char > situationRecordCreationReference_traits;

    const situationRecordCreationReference_optional&
    situationRecordCreationReference () const;

    situationRecordCreationReference_optional&
    situationRecordCreationReference ();

    void
    situationRecordCreationReference (const situationRecordCreationReference_type& x);

    void
    situationRecordCreationReference (const situationRecordCreationReference_optional& x);

    void
    situationRecordCreationReference (::std::auto_ptr< situationRecordCreationReference_type > p);

    // situationRecordCreationTime
    // 
    typedef ::datex2::DateTime situationRecordCreationTime_type;
    typedef ::xsd::cxx::tree::traits< situationRecordCreationTime_type, char > situationRecordCreationTime_traits;

    const situationRecordCreationTime_type&
    situationRecordCreationTime () const;

    situationRecordCreationTime_type&
    situationRecordCreationTime ();

    void
    situationRecordCreationTime (const situationRecordCreationTime_type& x);

    void
    situationRecordCreationTime (::std::auto_ptr< situationRecordCreationTime_type > p);

    // situationRecordObservationTime
    // 
    typedef ::datex2::DateTime situationRecordObservationTime_type;
    typedef ::xsd::cxx::tree::optional< situationRecordObservationTime_type > situationRecordObservationTime_optional;
    typedef ::xsd::cxx::tree::traits< situationRecordObservationTime_type, char > situationRecordObservationTime_traits;

    const situationRecordObservationTime_optional&
    situationRecordObservationTime () const;

    situationRecordObservationTime_optional&
    situationRecordObservationTime ();

    void
    situationRecordObservationTime (const situationRecordObservationTime_type& x);

    void
    situationRecordObservationTime (const situationRecordObservationTime_optional& x);

    void
    situationRecordObservationTime (::std::auto_ptr< situationRecordObservationTime_type > p);

    // situationRecordVersion
    // 
    typedef ::datex2::NonNegativeInteger situationRecordVersion_type;
    typedef ::xsd::cxx::tree::traits< situationRecordVersion_type, char > situationRecordVersion_traits;

    const situationRecordVersion_type&
    situationRecordVersion () const;

    situationRecordVersion_type&
    situationRecordVersion ();

    void
    situationRecordVersion (const situationRecordVersion_type& x);

    void
    situationRecordVersion (::std::auto_ptr< situationRecordVersion_type > p);

    // situationRecordVersionTime
    // 
    typedef ::datex2::DateTime situationRecordVersionTime_type;
    typedef ::xsd::cxx::tree::traits< situationRecordVersionTime_type, char > situationRecordVersionTime_traits;

    const situationRecordVersionTime_type&
    situationRecordVersionTime () const;

    situationRecordVersionTime_type&
    situationRecordVersionTime ();

    void
    situationRecordVersionTime (const situationRecordVersionTime_type& x);

    void
    situationRecordVersionTime (::std::auto_ptr< situationRecordVersionTime_type > p);

    // situationRecordFirstSupplierVersionTime
    // 
    typedef ::datex2::DateTime situationRecordFirstSupplierVersionTime_type;
    typedef ::xsd::cxx::tree::optional< situationRecordFirstSupplierVersionTime_type > situationRecordFirstSupplierVersionTime_optional;
    typedef ::xsd::cxx::tree::traits< situationRecordFirstSupplierVersionTime_type, char > situationRecordFirstSupplierVersionTime_traits;

    const situationRecordFirstSupplierVersionTime_optional&
    situationRecordFirstSupplierVersionTime () const;

    situationRecordFirstSupplierVersionTime_optional&
    situationRecordFirstSupplierVersionTime ();

    void
    situationRecordFirstSupplierVersionTime (const situationRecordFirstSupplierVersionTime_type& x);

    void
    situationRecordFirstSupplierVersionTime (const situationRecordFirstSupplierVersionTime_optional& x);

    void
    situationRecordFirstSupplierVersionTime (::std::auto_ptr< situationRecordFirstSupplierVersionTime_type > p);

    // confidentialityOverride
    // 
    typedef ::datex2::ConfidentialityValueEnum confidentialityOverride_type;
    typedef ::xsd::cxx::tree::optional< confidentialityOverride_type > confidentialityOverride_optional;
    typedef ::xsd::cxx::tree::traits< confidentialityOverride_type, char > confidentialityOverride_traits;

    const confidentialityOverride_optional&
    confidentialityOverride () const;

    confidentialityOverride_optional&
    confidentialityOverride ();

    void
    confidentialityOverride (const confidentialityOverride_type& x);

    void
    confidentialityOverride (const confidentialityOverride_optional& x);

    void
    confidentialityOverride (::std::auto_ptr< confidentialityOverride_type > p);

    // probabilityOfOccurrence
    // 
    typedef ::datex2::ProbabilityOfOccurrenceEnum probabilityOfOccurrence_type;
    typedef ::xsd::cxx::tree::traits< probabilityOfOccurrence_type, char > probabilityOfOccurrence_traits;

    const probabilityOfOccurrence_type&
    probabilityOfOccurrence () const;

    probabilityOfOccurrence_type&
    probabilityOfOccurrence ();

    void
    probabilityOfOccurrence (const probabilityOfOccurrence_type& x);

    void
    probabilityOfOccurrence (::std::auto_ptr< probabilityOfOccurrence_type > p);

    // source
    // 
    typedef ::datex2::Source source_type;
    typedef ::xsd::cxx::tree::optional< source_type > source_optional;
    typedef ::xsd::cxx::tree::traits< source_type, char > source_traits;

    const source_optional&
    source () const;

    source_optional&
    source ();

    void
    source (const source_type& x);

    void
    source (const source_optional& x);

    void
    source (::std::auto_ptr< source_type > p);

    // validity
    // 
    typedef ::datex2::Validity validity_type;
    typedef ::xsd::cxx::tree::traits< validity_type, char > validity_traits;

    const validity_type&
    validity () const;

    validity_type&
    validity ();

    void
    validity (const validity_type& x);

    void
    validity (::std::auto_ptr< validity_type > p);

    // impact
    // 
    typedef ::datex2::Impact impact_type;
    typedef ::xsd::cxx::tree::optional< impact_type > impact_optional;
    typedef ::xsd::cxx::tree::traits< impact_type, char > impact_traits;

    const impact_optional&
    impact () const;

    impact_optional&
    impact ();

    void
    impact (const impact_type& x);

    void
    impact (const impact_optional& x);

    void
    impact (::std::auto_ptr< impact_type > p);

    // cause
    // 
    typedef ::datex2::Cause cause_type;
    typedef ::xsd::cxx::tree::optional< cause_type > cause_optional;
    typedef ::xsd::cxx::tree::traits< cause_type, char > cause_traits;

    const cause_optional&
    cause () const;

    cause_optional&
    cause ();

    void
    cause (const cause_type& x);

    void
    cause (const cause_optional& x);

    void
    cause (::std::auto_ptr< cause_type > p);

    // generalPublicComment
    // 
    typedef ::datex2::Comment generalPublicComment_type;
    typedef ::xsd::cxx::tree::sequence< generalPublicComment_type > generalPublicComment_sequence;
    typedef xsd::cxx::tree::sequence< generalPublicComment_type >::iterator generalPublicComment_iterator;
    typedef xsd::cxx::tree::sequence< generalPublicComment_type >::const_iterator generalPublicComment_const_iterator;
    typedef ::xsd::cxx::tree::traits< generalPublicComment_type, char > generalPublicComment_traits;

    const generalPublicComment_sequence&
    generalPublicComment () const;

    generalPublicComment_sequence&
    generalPublicComment ();

    void
    generalPublicComment (const generalPublicComment_sequence& s);

    // nonGeneralPublicComment
    // 
    typedef ::datex2::Comment nonGeneralPublicComment_type;
    typedef ::xsd::cxx::tree::sequence< nonGeneralPublicComment_type > nonGeneralPublicComment_sequence;
    typedef xsd::cxx::tree::sequence< nonGeneralPublicComment_type >::iterator nonGeneralPublicComment_iterator;
    typedef xsd::cxx::tree::sequence< nonGeneralPublicComment_type >::const_iterator nonGeneralPublicComment_const_iterator;
    typedef ::xsd::cxx::tree::traits< nonGeneralPublicComment_type, char > nonGeneralPublicComment_traits;

    const nonGeneralPublicComment_sequence&
    nonGeneralPublicComment () const;

    nonGeneralPublicComment_sequence&
    nonGeneralPublicComment ();

    void
    nonGeneralPublicComment (const nonGeneralPublicComment_sequence& s);

    // urlLink
    // 
    typedef ::datex2::UrlLink urlLink_type;
    typedef ::xsd::cxx::tree::sequence< urlLink_type > urlLink_sequence;
    typedef xsd::cxx::tree::sequence< urlLink_type >::iterator urlLink_iterator;
    typedef xsd::cxx::tree::sequence< urlLink_type >::const_iterator urlLink_const_iterator;
    typedef ::xsd::cxx::tree::traits< urlLink_type, char > urlLink_traits;

    const urlLink_sequence&
    urlLink () const;

    urlLink_sequence&
    urlLink ();

    void
    urlLink (const urlLink_sequence& s);

    // groupOfLocations
    // 
    typedef ::datex2::GroupOfLocations groupOfLocations_type;
    typedef ::xsd::cxx::tree::traits< groupOfLocations_type, char > groupOfLocations_traits;

    const groupOfLocations_type&
    groupOfLocations () const;

    groupOfLocations_type&
    groupOfLocations ();

    void
    groupOfLocations (const groupOfLocations_type& x);

    void
    groupOfLocations (::std::auto_ptr< groupOfLocations_type > p);

    // management
    // 
    typedef ::datex2::Management management_type;
    typedef ::xsd::cxx::tree::optional< management_type > management_optional;
    typedef ::xsd::cxx::tree::traits< management_type, char > management_traits;

    const management_optional&
    management () const;

    management_optional&
    management ();

    void
    management (const management_type& x);

    void
    management (const management_optional& x);

    void
    management (::std::auto_ptr< management_type > p);

    // situationRecordExtension
    // 
    typedef ::datex2::ExtensionType situationRecordExtension_type;
    typedef ::xsd::cxx::tree::optional< situationRecordExtension_type > situationRecordExtension_optional;
    typedef ::xsd::cxx::tree::traits< situationRecordExtension_type, char > situationRecordExtension_traits;

    const situationRecordExtension_optional&
    situationRecordExtension () const;

    situationRecordExtension_optional&
    situationRecordExtension ();

    void
    situationRecordExtension (const situationRecordExtension_type& x);

    void
    situationRecordExtension (const situationRecordExtension_optional& x);

    void
    situationRecordExtension (::std::auto_ptr< situationRecordExtension_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_type&
    id () const;

    id_type&
    id ();

    void
    id (const id_type& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    SituationRecord (const situationRecordCreationTime_type&,
                     const situationRecordVersion_type&,
                     const situationRecordVersionTime_type&,
                     const probabilityOfOccurrence_type&,
                     const validity_type&,
                     const groupOfLocations_type&,
                     const id_type&);

    SituationRecord (const situationRecordCreationTime_type&,
                     const situationRecordVersion_type&,
                     const situationRecordVersionTime_type&,
                     const probabilityOfOccurrence_type&,
                     ::std::auto_ptr< validity_type >&,
                     ::std::auto_ptr< groupOfLocations_type >&,
                     const id_type&);

    SituationRecord (const xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    SituationRecord (const SituationRecord& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual SituationRecord*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SituationRecord ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    situationRecordCreationReference_optional situationRecordCreationReference_;
    ::xsd::cxx::tree::one< situationRecordCreationTime_type > situationRecordCreationTime_;
    situationRecordObservationTime_optional situationRecordObservationTime_;
    ::xsd::cxx::tree::one< situationRecordVersion_type > situationRecordVersion_;
    ::xsd::cxx::tree::one< situationRecordVersionTime_type > situationRecordVersionTime_;
    situationRecordFirstSupplierVersionTime_optional situationRecordFirstSupplierVersionTime_;
    confidentialityOverride_optional confidentialityOverride_;
    ::xsd::cxx::tree::one< probabilityOfOccurrence_type > probabilityOfOccurrence_;
    source_optional source_;
    ::xsd::cxx::tree::one< validity_type > validity_;
    impact_optional impact_;
    cause_optional cause_;
    generalPublicComment_sequence generalPublicComment_;
    nonGeneralPublicComment_sequence nonGeneralPublicComment_;
    urlLink_sequence urlLink_;
    ::xsd::cxx::tree::one< groupOfLocations_type > groupOfLocations_;
    management_optional management_;
    situationRecordExtension_optional situationRecordExtension_;
    ::xsd::cxx::tree::one< id_type > id_;
  };

  class TrafficElement: public ::datex2::SituationRecord
  {
    public:
    // trafficElementExtension
    // 
    typedef ::datex2::ExtensionType trafficElementExtension_type;
    typedef ::xsd::cxx::tree::optional< trafficElementExtension_type > trafficElementExtension_optional;
    typedef ::xsd::cxx::tree::traits< trafficElementExtension_type, char > trafficElementExtension_traits;

    const trafficElementExtension_optional&
    trafficElementExtension () const;

    trafficElementExtension_optional&
    trafficElementExtension ();

    void
    trafficElementExtension (const trafficElementExtension_type& x);

    void
    trafficElementExtension (const trafficElementExtension_optional& x);

    void
    trafficElementExtension (::std::auto_ptr< trafficElementExtension_type > p);

    // Constructors.
    //
    TrafficElement (const situationRecordCreationTime_type&,
                    const situationRecordVersion_type&,
                    const situationRecordVersionTime_type&,
                    const probabilityOfOccurrence_type&,
                    const validity_type&,
                    const groupOfLocations_type&,
                    const id_type&);

    TrafficElement (const situationRecordCreationTime_type&,
                    const situationRecordVersion_type&,
                    const situationRecordVersionTime_type&,
                    const probabilityOfOccurrence_type&,
                    ::std::auto_ptr< validity_type >&,
                    ::std::auto_ptr< groupOfLocations_type >&,
                    const id_type&);

    TrafficElement (const xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    TrafficElement (const TrafficElement& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual TrafficElement*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TrafficElement ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    trafficElementExtension_optional trafficElementExtension_;
  };

  class AbnormalTraffic: public ::datex2::TrafficElement
  {
    public:
    // abnormalTrafficType
    // 
    typedef ::datex2::AbnormalTrafficTypeEnum abnormalTrafficType_type;
    typedef ::xsd::cxx::tree::optional< abnormalTrafficType_type > abnormalTrafficType_optional;
    typedef ::xsd::cxx::tree::traits< abnormalTrafficType_type, char > abnormalTrafficType_traits;

    const abnormalTrafficType_optional&
    abnormalTrafficType () const;

    abnormalTrafficType_optional&
    abnormalTrafficType ();

    void
    abnormalTrafficType (const abnormalTrafficType_type& x);

    void
    abnormalTrafficType (const abnormalTrafficType_optional& x);

    void
    abnormalTrafficType (::std::auto_ptr< abnormalTrafficType_type > p);

    // numberOfVehiclesWaiting
    // 
    typedef ::datex2::NonNegativeInteger numberOfVehiclesWaiting_type;
    typedef ::xsd::cxx::tree::optional< numberOfVehiclesWaiting_type > numberOfVehiclesWaiting_optional;
    typedef ::xsd::cxx::tree::traits< numberOfVehiclesWaiting_type, char > numberOfVehiclesWaiting_traits;

    const numberOfVehiclesWaiting_optional&
    numberOfVehiclesWaiting () const;

    numberOfVehiclesWaiting_optional&
    numberOfVehiclesWaiting ();

    void
    numberOfVehiclesWaiting (const numberOfVehiclesWaiting_type& x);

    void
    numberOfVehiclesWaiting (const numberOfVehiclesWaiting_optional& x);

    void
    numberOfVehiclesWaiting (::std::auto_ptr< numberOfVehiclesWaiting_type > p);

    // queueLength
    // 
    typedef ::datex2::MetresAsNonNegativeInteger queueLength_type;
    typedef ::xsd::cxx::tree::optional< queueLength_type > queueLength_optional;
    typedef ::xsd::cxx::tree::traits< queueLength_type, char > queueLength_traits;

    const queueLength_optional&
    queueLength () const;

    queueLength_optional&
    queueLength ();

    void
    queueLength (const queueLength_type& x);

    void
    queueLength (const queueLength_optional& x);

    void
    queueLength (::std::auto_ptr< queueLength_type > p);

    // relativeTrafficFlow
    // 
    typedef ::datex2::RelativeTrafficFlowEnum relativeTrafficFlow_type;
    typedef ::xsd::cxx::tree::optional< relativeTrafficFlow_type > relativeTrafficFlow_optional;
    typedef ::xsd::cxx::tree::traits< relativeTrafficFlow_type, char > relativeTrafficFlow_traits;

    const relativeTrafficFlow_optional&
    relativeTrafficFlow () const;

    relativeTrafficFlow_optional&
    relativeTrafficFlow ();

    void
    relativeTrafficFlow (const relativeTrafficFlow_type& x);

    void
    relativeTrafficFlow (const relativeTrafficFlow_optional& x);

    void
    relativeTrafficFlow (::std::auto_ptr< relativeTrafficFlow_type > p);

    // trafficFlowCharacteristics
    // 
    typedef ::datex2::TrafficFlowCharacteristicsEnum trafficFlowCharacteristics_type;
    typedef ::xsd::cxx::tree::optional< trafficFlowCharacteristics_type > trafficFlowCharacteristics_optional;
    typedef ::xsd::cxx::tree::traits< trafficFlowCharacteristics_type, char > trafficFlowCharacteristics_traits;

    const trafficFlowCharacteristics_optional&
    trafficFlowCharacteristics () const;

    trafficFlowCharacteristics_optional&
    trafficFlowCharacteristics ();

    void
    trafficFlowCharacteristics (const trafficFlowCharacteristics_type& x);

    void
    trafficFlowCharacteristics (const trafficFlowCharacteristics_optional& x);

    void
    trafficFlowCharacteristics (::std::auto_ptr< trafficFlowCharacteristics_type > p);

    // trafficTrendType
    // 
    typedef ::datex2::TrafficTrendTypeEnum trafficTrendType_type;
    typedef ::xsd::cxx::tree::optional< trafficTrendType_type > trafficTrendType_optional;
    typedef ::xsd::cxx::tree::traits< trafficTrendType_type, char > trafficTrendType_traits;

    const trafficTrendType_optional&
    trafficTrendType () const;

    trafficTrendType_optional&
    trafficTrendType ();

    void
    trafficTrendType (const trafficTrendType_type& x);

    void
    trafficTrendType (const trafficTrendType_optional& x);

    void
    trafficTrendType (::std::auto_ptr< trafficTrendType_type > p);

    // abnormalTrafficExtension
    // 
    typedef ::datex2::ExtensionType abnormalTrafficExtension_type;
    typedef ::xsd::cxx::tree::optional< abnormalTrafficExtension_type > abnormalTrafficExtension_optional;
    typedef ::xsd::cxx::tree::traits< abnormalTrafficExtension_type, char > abnormalTrafficExtension_traits;

    const abnormalTrafficExtension_optional&
    abnormalTrafficExtension () const;

    abnormalTrafficExtension_optional&
    abnormalTrafficExtension ();

    void
    abnormalTrafficExtension (const abnormalTrafficExtension_type& x);

    void
    abnormalTrafficExtension (const abnormalTrafficExtension_optional& x);

    void
    abnormalTrafficExtension (::std::auto_ptr< abnormalTrafficExtension_type > p);

    // Constructors.
    //
    AbnormalTraffic (const situationRecordCreationTime_type&,
                     const situationRecordVersion_type&,
                     const situationRecordVersionTime_type&,
                     const probabilityOfOccurrence_type&,
                     const validity_type&,
                     const groupOfLocations_type&,
                     const id_type&);

    AbnormalTraffic (const situationRecordCreationTime_type&,
                     const situationRecordVersion_type&,
                     const situationRecordVersionTime_type&,
                     const probabilityOfOccurrence_type&,
                     ::std::auto_ptr< validity_type >&,
                     ::std::auto_ptr< groupOfLocations_type >&,
                     const id_type&);

    AbnormalTraffic (const xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    AbnormalTraffic (const AbnormalTraffic& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual AbnormalTraffic*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AbnormalTraffic ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    abnormalTrafficType_optional abnormalTrafficType_;
    numberOfVehiclesWaiting_optional numberOfVehiclesWaiting_;
    queueLength_optional queueLength_;
    relativeTrafficFlow_optional relativeTrafficFlow_;
    trafficFlowCharacteristics_optional trafficFlowCharacteristics_;
    trafficTrendType_optional trafficTrendType_;
    abnormalTrafficExtension_optional abnormalTrafficExtension_;
  };

  class AbnormalTrafficTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      stationaryTraffic,
      queueingTraffic,
      slowTraffic,
      unspecifiedAbnormalTraffic,
      other
    };

    AbnormalTrafficTypeEnum (value v);

    AbnormalTrafficTypeEnum (const char* v);

    AbnormalTrafficTypeEnum (const ::std::string& v);

    AbnormalTrafficTypeEnum (const ::xml_schema::string& v);

    AbnormalTrafficTypeEnum (const xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    AbnormalTrafficTypeEnum (const xercesc::DOMAttr& a,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    AbnormalTrafficTypeEnum (const ::std::string& s,
                             const xercesc::DOMElement* e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    AbnormalTrafficTypeEnum (const AbnormalTrafficTypeEnum& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual AbnormalTrafficTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    AbnormalTrafficTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_AbnormalTrafficTypeEnum_convert ();
    }

    protected:
    value
    _xsd_AbnormalTrafficTypeEnum_convert () const;

    public:
    static const char* const _xsd_AbnormalTrafficTypeEnum_literals_[5];
    static const value _xsd_AbnormalTrafficTypeEnum_indexes_[5];
  };

  class Accident: public ::datex2::TrafficElement
  {
    public:
    // accidentCause
    // 
    typedef ::datex2::AccidentCauseEnum accidentCause_type;
    typedef ::xsd::cxx::tree::optional< accidentCause_type > accidentCause_optional;
    typedef ::xsd::cxx::tree::traits< accidentCause_type, char > accidentCause_traits;

    const accidentCause_optional&
    accidentCause () const;

    accidentCause_optional&
    accidentCause ();

    void
    accidentCause (const accidentCause_type& x);

    void
    accidentCause (const accidentCause_optional& x);

    void
    accidentCause (::std::auto_ptr< accidentCause_type > p);

    // accidentType
    // 
    typedef ::datex2::AccidentTypeEnum accidentType_type;
    typedef ::xsd::cxx::tree::sequence< accidentType_type > accidentType_sequence;
    typedef xsd::cxx::tree::sequence< accidentType_type >::iterator accidentType_iterator;
    typedef xsd::cxx::tree::sequence< accidentType_type >::const_iterator accidentType_const_iterator;
    typedef ::xsd::cxx::tree::traits< accidentType_type, char > accidentType_traits;

    const accidentType_sequence&
    accidentType () const;

    accidentType_sequence&
    accidentType ();

    void
    accidentType (const accidentType_sequence& s);

    // totalNumberOfPeopleInvolved
    // 
    typedef ::datex2::NonNegativeInteger totalNumberOfPeopleInvolved_type;
    typedef ::xsd::cxx::tree::optional< totalNumberOfPeopleInvolved_type > totalNumberOfPeopleInvolved_optional;
    typedef ::xsd::cxx::tree::traits< totalNumberOfPeopleInvolved_type, char > totalNumberOfPeopleInvolved_traits;

    const totalNumberOfPeopleInvolved_optional&
    totalNumberOfPeopleInvolved () const;

    totalNumberOfPeopleInvolved_optional&
    totalNumberOfPeopleInvolved ();

    void
    totalNumberOfPeopleInvolved (const totalNumberOfPeopleInvolved_type& x);

    void
    totalNumberOfPeopleInvolved (const totalNumberOfPeopleInvolved_optional& x);

    void
    totalNumberOfPeopleInvolved (::std::auto_ptr< totalNumberOfPeopleInvolved_type > p);

    // totalNumberOfVehiclesInvolved
    // 
    typedef ::datex2::NonNegativeInteger totalNumberOfVehiclesInvolved_type;
    typedef ::xsd::cxx::tree::optional< totalNumberOfVehiclesInvolved_type > totalNumberOfVehiclesInvolved_optional;
    typedef ::xsd::cxx::tree::traits< totalNumberOfVehiclesInvolved_type, char > totalNumberOfVehiclesInvolved_traits;

    const totalNumberOfVehiclesInvolved_optional&
    totalNumberOfVehiclesInvolved () const;

    totalNumberOfVehiclesInvolved_optional&
    totalNumberOfVehiclesInvolved ();

    void
    totalNumberOfVehiclesInvolved (const totalNumberOfVehiclesInvolved_type& x);

    void
    totalNumberOfVehiclesInvolved (const totalNumberOfVehiclesInvolved_optional& x);

    void
    totalNumberOfVehiclesInvolved (::std::auto_ptr< totalNumberOfVehiclesInvolved_type > p);

    // vehicleInvolved
    // 
    typedef ::datex2::Vehicle vehicleInvolved_type;
    typedef ::xsd::cxx::tree::sequence< vehicleInvolved_type > vehicleInvolved_sequence;
    typedef xsd::cxx::tree::sequence< vehicleInvolved_type >::iterator vehicleInvolved_iterator;
    typedef xsd::cxx::tree::sequence< vehicleInvolved_type >::const_iterator vehicleInvolved_const_iterator;
    typedef ::xsd::cxx::tree::traits< vehicleInvolved_type, char > vehicleInvolved_traits;

    const vehicleInvolved_sequence&
    vehicleInvolved () const;

    vehicleInvolved_sequence&
    vehicleInvolved ();

    void
    vehicleInvolved (const vehicleInvolved_sequence& s);

    // groupOfVehiclesInvolved
    // 
    typedef ::datex2::GroupOfVehiclesInvolved groupOfVehiclesInvolved_type;
    typedef ::xsd::cxx::tree::sequence< groupOfVehiclesInvolved_type > groupOfVehiclesInvolved_sequence;
    typedef xsd::cxx::tree::sequence< groupOfVehiclesInvolved_type >::iterator groupOfVehiclesInvolved_iterator;
    typedef xsd::cxx::tree::sequence< groupOfVehiclesInvolved_type >::const_iterator groupOfVehiclesInvolved_const_iterator;
    typedef ::xsd::cxx::tree::traits< groupOfVehiclesInvolved_type, char > groupOfVehiclesInvolved_traits;

    const groupOfVehiclesInvolved_sequence&
    groupOfVehiclesInvolved () const;

    groupOfVehiclesInvolved_sequence&
    groupOfVehiclesInvolved ();

    void
    groupOfVehiclesInvolved (const groupOfVehiclesInvolved_sequence& s);

    // groupOfPeopleInvolved
    // 
    typedef ::datex2::GroupOfPeopleInvolved groupOfPeopleInvolved_type;
    typedef ::xsd::cxx::tree::sequence< groupOfPeopleInvolved_type > groupOfPeopleInvolved_sequence;
    typedef xsd::cxx::tree::sequence< groupOfPeopleInvolved_type >::iterator groupOfPeopleInvolved_iterator;
    typedef xsd::cxx::tree::sequence< groupOfPeopleInvolved_type >::const_iterator groupOfPeopleInvolved_const_iterator;
    typedef ::xsd::cxx::tree::traits< groupOfPeopleInvolved_type, char > groupOfPeopleInvolved_traits;

    const groupOfPeopleInvolved_sequence&
    groupOfPeopleInvolved () const;

    groupOfPeopleInvolved_sequence&
    groupOfPeopleInvolved ();

    void
    groupOfPeopleInvolved (const groupOfPeopleInvolved_sequence& s);

    // accidentExtension
    // 
    typedef ::datex2::ExtensionType accidentExtension_type;
    typedef ::xsd::cxx::tree::optional< accidentExtension_type > accidentExtension_optional;
    typedef ::xsd::cxx::tree::traits< accidentExtension_type, char > accidentExtension_traits;

    const accidentExtension_optional&
    accidentExtension () const;

    accidentExtension_optional&
    accidentExtension ();

    void
    accidentExtension (const accidentExtension_type& x);

    void
    accidentExtension (const accidentExtension_optional& x);

    void
    accidentExtension (::std::auto_ptr< accidentExtension_type > p);

    // Constructors.
    //
    Accident (const situationRecordCreationTime_type&,
              const situationRecordVersion_type&,
              const situationRecordVersionTime_type&,
              const probabilityOfOccurrence_type&,
              const validity_type&,
              const groupOfLocations_type&,
              const id_type&);

    Accident (const situationRecordCreationTime_type&,
              const situationRecordVersion_type&,
              const situationRecordVersionTime_type&,
              const probabilityOfOccurrence_type&,
              ::std::auto_ptr< validity_type >&,
              ::std::auto_ptr< groupOfLocations_type >&,
              const id_type&);

    Accident (const xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    Accident (const Accident& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual Accident*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Accident ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    accidentCause_optional accidentCause_;
    accidentType_sequence accidentType_;
    totalNumberOfPeopleInvolved_optional totalNumberOfPeopleInvolved_;
    totalNumberOfVehiclesInvolved_optional totalNumberOfVehiclesInvolved_;
    vehicleInvolved_sequence vehicleInvolved_;
    groupOfVehiclesInvolved_sequence groupOfVehiclesInvolved_;
    groupOfPeopleInvolved_sequence groupOfPeopleInvolved_;
    accidentExtension_optional accidentExtension_;
  };

  class AccidentCauseEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      avoidanceOfObstacles,
      driverDistraction,
      driverDrugAbuse,
      driverIllness,
      exceedingSpeedsLimits,
      excessAlcohol,
      excessiveDriverTiredness,
      impermissibleManoeuvre,
      limitedVisibility,
      notKeepingASafeDistance,
      onTheWrongSideOfTheRoad,
      pedestrianInRoad,
      poorLaneAdherence,
      poorMergeEntryOrExitJudgement,
      poorRoadSurfaceCondition,
      poorSurfaceAdherence,
      undisclosed,
      unknown,
      vehicleFailure,
      other
    };

    AccidentCauseEnum (value v);

    AccidentCauseEnum (const char* v);

    AccidentCauseEnum (const ::std::string& v);

    AccidentCauseEnum (const ::xml_schema::string& v);

    AccidentCauseEnum (const xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    AccidentCauseEnum (const xercesc::DOMAttr& a,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    AccidentCauseEnum (const ::std::string& s,
                       const xercesc::DOMElement* e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    AccidentCauseEnum (const AccidentCauseEnum& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual AccidentCauseEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    AccidentCauseEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_AccidentCauseEnum_convert ();
    }

    protected:
    value
    _xsd_AccidentCauseEnum_convert () const;

    public:
    static const char* const _xsd_AccidentCauseEnum_literals_[20];
    static const value _xsd_AccidentCauseEnum_indexes_[20];
  };

  class AccidentTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      accident,
      accidentInvolvingBicycles,
      accidentInvolvingBuses,
      accidentInvolvingHazardousMaterials,
      accidentInvolvingHeavyLorries,
      accidentInvolvingMassTransitVehicle,
      accidentInvolvingMopeds,
      accidentInvolvingMotorcycles,
      accidentInvolvingRadioactiveMaterial,
      accidentInvolvingTrain,
      chemicalSpillageAccident,
      collision,
      collisionWithAnimal,
      collisionWithObstruction,
      collisionWithPerson,
      earlierAccident,
      fuelSpillageAccident,
      headOnCollision,
      headOnOrSideCollision,
      jackknifedArticulatedLorry,
      jackknifedCaravan,
      jackknifedTrailer,
      multipleVehicleCollision,
      multivehicleAccident,
      oilSpillageAccident,
      overturnedHeavyLorry,
      overturnedTrailer,
      overturnedVehicle,
      rearCollision,
      secondaryAccident,
      seriousAccident,
      sideCollision,
      vehicleOffRoad,
      vehicleSpunAround,
      other
    };

    AccidentTypeEnum (value v);

    AccidentTypeEnum (const char* v);

    AccidentTypeEnum (const ::std::string& v);

    AccidentTypeEnum (const ::xml_schema::string& v);

    AccidentTypeEnum (const xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    AccidentTypeEnum (const xercesc::DOMAttr& a,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    AccidentTypeEnum (const ::std::string& s,
                      const xercesc::DOMElement* e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    AccidentTypeEnum (const AccidentTypeEnum& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual AccidentTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    AccidentTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_AccidentTypeEnum_convert ();
    }

    protected:
    value
    _xsd_AccidentTypeEnum_convert () const;

    public:
    static const char* const _xsd_AccidentTypeEnum_literals_[35];
    static const value _xsd_AccidentTypeEnum_indexes_[35];
  };

  class Activity: public ::datex2::TrafficElement
  {
    public:
    // mobilityOfActivity
    // 
    typedef ::datex2::Mobility mobilityOfActivity_type;
    typedef ::xsd::cxx::tree::optional< mobilityOfActivity_type > mobilityOfActivity_optional;
    typedef ::xsd::cxx::tree::traits< mobilityOfActivity_type, char > mobilityOfActivity_traits;

    const mobilityOfActivity_optional&
    mobilityOfActivity () const;

    mobilityOfActivity_optional&
    mobilityOfActivity ();

    void
    mobilityOfActivity (const mobilityOfActivity_type& x);

    void
    mobilityOfActivity (const mobilityOfActivity_optional& x);

    void
    mobilityOfActivity (::std::auto_ptr< mobilityOfActivity_type > p);

    // activityExtension
    // 
    typedef ::datex2::ExtensionType activityExtension_type;
    typedef ::xsd::cxx::tree::optional< activityExtension_type > activityExtension_optional;
    typedef ::xsd::cxx::tree::traits< activityExtension_type, char > activityExtension_traits;

    const activityExtension_optional&
    activityExtension () const;

    activityExtension_optional&
    activityExtension ();

    void
    activityExtension (const activityExtension_type& x);

    void
    activityExtension (const activityExtension_optional& x);

    void
    activityExtension (::std::auto_ptr< activityExtension_type > p);

    // Constructors.
    //
    Activity (const situationRecordCreationTime_type&,
              const situationRecordVersion_type&,
              const situationRecordVersionTime_type&,
              const probabilityOfOccurrence_type&,
              const validity_type&,
              const groupOfLocations_type&,
              const id_type&);

    Activity (const situationRecordCreationTime_type&,
              const situationRecordVersion_type&,
              const situationRecordVersionTime_type&,
              const probabilityOfOccurrence_type&,
              ::std::auto_ptr< validity_type >&,
              ::std::auto_ptr< groupOfLocations_type >&,
              const id_type&);

    Activity (const xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    Activity (const Activity& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual Activity*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Activity ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    mobilityOfActivity_optional mobilityOfActivity_;
    activityExtension_optional activityExtension_;
  };

  class AlertCArea: public ::xml_schema::type
  {
    public:
    // alertCLocationCountryCode
    // 
    typedef ::datex2::String alertCLocationCountryCode_type;
    typedef ::xsd::cxx::tree::traits< alertCLocationCountryCode_type, char > alertCLocationCountryCode_traits;

    const alertCLocationCountryCode_type&
    alertCLocationCountryCode () const;

    alertCLocationCountryCode_type&
    alertCLocationCountryCode ();

    void
    alertCLocationCountryCode (const alertCLocationCountryCode_type& x);

    void
    alertCLocationCountryCode (::std::auto_ptr< alertCLocationCountryCode_type > p);

    // alertCLocationTableNumber
    // 
    typedef ::datex2::String alertCLocationTableNumber_type;
    typedef ::xsd::cxx::tree::traits< alertCLocationTableNumber_type, char > alertCLocationTableNumber_traits;

    const alertCLocationTableNumber_type&
    alertCLocationTableNumber () const;

    alertCLocationTableNumber_type&
    alertCLocationTableNumber ();

    void
    alertCLocationTableNumber (const alertCLocationTableNumber_type& x);

    void
    alertCLocationTableNumber (::std::auto_ptr< alertCLocationTableNumber_type > p);

    // alertCLocationTableVersion
    // 
    typedef ::datex2::String alertCLocationTableVersion_type;
    typedef ::xsd::cxx::tree::traits< alertCLocationTableVersion_type, char > alertCLocationTableVersion_traits;

    const alertCLocationTableVersion_type&
    alertCLocationTableVersion () const;

    alertCLocationTableVersion_type&
    alertCLocationTableVersion ();

    void
    alertCLocationTableVersion (const alertCLocationTableVersion_type& x);

    void
    alertCLocationTableVersion (::std::auto_ptr< alertCLocationTableVersion_type > p);

    // areaLocation
    // 
    typedef ::datex2::AlertCLocation areaLocation_type;
    typedef ::xsd::cxx::tree::traits< areaLocation_type, char > areaLocation_traits;

    const areaLocation_type&
    areaLocation () const;

    areaLocation_type&
    areaLocation ();

    void
    areaLocation (const areaLocation_type& x);

    void
    areaLocation (::std::auto_ptr< areaLocation_type > p);

    // alertCAreaExtension
    // 
    typedef ::datex2::ExtensionType alertCAreaExtension_type;
    typedef ::xsd::cxx::tree::optional< alertCAreaExtension_type > alertCAreaExtension_optional;
    typedef ::xsd::cxx::tree::traits< alertCAreaExtension_type, char > alertCAreaExtension_traits;

    const alertCAreaExtension_optional&
    alertCAreaExtension () const;

    alertCAreaExtension_optional&
    alertCAreaExtension ();

    void
    alertCAreaExtension (const alertCAreaExtension_type& x);

    void
    alertCAreaExtension (const alertCAreaExtension_optional& x);

    void
    alertCAreaExtension (::std::auto_ptr< alertCAreaExtension_type > p);

    // Constructors.
    //
    AlertCArea (const alertCLocationCountryCode_type&,
                const alertCLocationTableNumber_type&,
                const alertCLocationTableVersion_type&,
                const areaLocation_type&);

    AlertCArea (const alertCLocationCountryCode_type&,
                const alertCLocationTableNumber_type&,
                const alertCLocationTableVersion_type&,
                ::std::auto_ptr< areaLocation_type >&);

    AlertCArea (const xercesc::DOMElement& e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    AlertCArea (const AlertCArea& x,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    virtual AlertCArea*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AlertCArea ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< alertCLocationCountryCode_type > alertCLocationCountryCode_;
    ::xsd::cxx::tree::one< alertCLocationTableNumber_type > alertCLocationTableNumber_;
    ::xsd::cxx::tree::one< alertCLocationTableVersion_type > alertCLocationTableVersion_;
    ::xsd::cxx::tree::one< areaLocation_type > areaLocation_;
    alertCAreaExtension_optional alertCAreaExtension_;
  };

  class AlertCDirection: public ::xml_schema::type
  {
    public:
    // alertCDirectionCoded
    // 
    typedef ::datex2::AlertCDirectionEnum alertCDirectionCoded_type;
    typedef ::xsd::cxx::tree::traits< alertCDirectionCoded_type, char > alertCDirectionCoded_traits;

    const alertCDirectionCoded_type&
    alertCDirectionCoded () const;

    alertCDirectionCoded_type&
    alertCDirectionCoded ();

    void
    alertCDirectionCoded (const alertCDirectionCoded_type& x);

    void
    alertCDirectionCoded (::std::auto_ptr< alertCDirectionCoded_type > p);

    // alertCDirectionNamed
    // 
    typedef ::datex2::MultilingualString alertCDirectionNamed_type;
    typedef ::xsd::cxx::tree::optional< alertCDirectionNamed_type > alertCDirectionNamed_optional;
    typedef ::xsd::cxx::tree::traits< alertCDirectionNamed_type, char > alertCDirectionNamed_traits;

    const alertCDirectionNamed_optional&
    alertCDirectionNamed () const;

    alertCDirectionNamed_optional&
    alertCDirectionNamed ();

    void
    alertCDirectionNamed (const alertCDirectionNamed_type& x);

    void
    alertCDirectionNamed (const alertCDirectionNamed_optional& x);

    void
    alertCDirectionNamed (::std::auto_ptr< alertCDirectionNamed_type > p);

    // alertCDirectionSense
    // 
    typedef ::datex2::Boolean alertCDirectionSense_type;
    typedef ::xsd::cxx::tree::optional< alertCDirectionSense_type > alertCDirectionSense_optional;
    typedef ::xsd::cxx::tree::traits< alertCDirectionSense_type, char > alertCDirectionSense_traits;

    const alertCDirectionSense_optional&
    alertCDirectionSense () const;

    alertCDirectionSense_optional&
    alertCDirectionSense ();

    void
    alertCDirectionSense (const alertCDirectionSense_type& x);

    void
    alertCDirectionSense (const alertCDirectionSense_optional& x);

    void
    alertCDirectionSense (::std::auto_ptr< alertCDirectionSense_type > p);

    // alertCDirectionExtension
    // 
    typedef ::datex2::ExtensionType alertCDirectionExtension_type;
    typedef ::xsd::cxx::tree::optional< alertCDirectionExtension_type > alertCDirectionExtension_optional;
    typedef ::xsd::cxx::tree::traits< alertCDirectionExtension_type, char > alertCDirectionExtension_traits;

    const alertCDirectionExtension_optional&
    alertCDirectionExtension () const;

    alertCDirectionExtension_optional&
    alertCDirectionExtension ();

    void
    alertCDirectionExtension (const alertCDirectionExtension_type& x);

    void
    alertCDirectionExtension (const alertCDirectionExtension_optional& x);

    void
    alertCDirectionExtension (::std::auto_ptr< alertCDirectionExtension_type > p);

    // Constructors.
    //
    AlertCDirection (const alertCDirectionCoded_type&);

    AlertCDirection (const xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    AlertCDirection (const AlertCDirection& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual AlertCDirection*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AlertCDirection ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< alertCDirectionCoded_type > alertCDirectionCoded_;
    alertCDirectionNamed_optional alertCDirectionNamed_;
    alertCDirectionSense_optional alertCDirectionSense_;
    alertCDirectionExtension_optional alertCDirectionExtension_;
  };

  class AlertCDirectionEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      both,
      negative,
      positive,
      unknown
    };

    AlertCDirectionEnum (value v);

    AlertCDirectionEnum (const char* v);

    AlertCDirectionEnum (const ::std::string& v);

    AlertCDirectionEnum (const ::xml_schema::string& v);

    AlertCDirectionEnum (const xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    AlertCDirectionEnum (const xercesc::DOMAttr& a,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    AlertCDirectionEnum (const ::std::string& s,
                         const xercesc::DOMElement* e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    AlertCDirectionEnum (const AlertCDirectionEnum& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual AlertCDirectionEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    AlertCDirectionEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_AlertCDirectionEnum_convert ();
    }

    protected:
    value
    _xsd_AlertCDirectionEnum_convert () const;

    public:
    static const char* const _xsd_AlertCDirectionEnum_literals_[4];
    static const value _xsd_AlertCDirectionEnum_indexes_[4];
  };

  class AlertCLinear: public ::xml_schema::type
  {
    public:
    // alertCLocationCountryCode
    // 
    typedef ::datex2::String alertCLocationCountryCode_type;
    typedef ::xsd::cxx::tree::traits< alertCLocationCountryCode_type, char > alertCLocationCountryCode_traits;

    const alertCLocationCountryCode_type&
    alertCLocationCountryCode () const;

    alertCLocationCountryCode_type&
    alertCLocationCountryCode ();

    void
    alertCLocationCountryCode (const alertCLocationCountryCode_type& x);

    void
    alertCLocationCountryCode (::std::auto_ptr< alertCLocationCountryCode_type > p);

    // alertCLocationTableNumber
    // 
    typedef ::datex2::String alertCLocationTableNumber_type;
    typedef ::xsd::cxx::tree::traits< alertCLocationTableNumber_type, char > alertCLocationTableNumber_traits;

    const alertCLocationTableNumber_type&
    alertCLocationTableNumber () const;

    alertCLocationTableNumber_type&
    alertCLocationTableNumber ();

    void
    alertCLocationTableNumber (const alertCLocationTableNumber_type& x);

    void
    alertCLocationTableNumber (::std::auto_ptr< alertCLocationTableNumber_type > p);

    // alertCLocationTableVersion
    // 
    typedef ::datex2::String alertCLocationTableVersion_type;
    typedef ::xsd::cxx::tree::traits< alertCLocationTableVersion_type, char > alertCLocationTableVersion_traits;

    const alertCLocationTableVersion_type&
    alertCLocationTableVersion () const;

    alertCLocationTableVersion_type&
    alertCLocationTableVersion ();

    void
    alertCLocationTableVersion (const alertCLocationTableVersion_type& x);

    void
    alertCLocationTableVersion (::std::auto_ptr< alertCLocationTableVersion_type > p);

    // alertCLinearExtension
    // 
    typedef ::datex2::ExtensionType alertCLinearExtension_type;
    typedef ::xsd::cxx::tree::optional< alertCLinearExtension_type > alertCLinearExtension_optional;
    typedef ::xsd::cxx::tree::traits< alertCLinearExtension_type, char > alertCLinearExtension_traits;

    const alertCLinearExtension_optional&
    alertCLinearExtension () const;

    alertCLinearExtension_optional&
    alertCLinearExtension ();

    void
    alertCLinearExtension (const alertCLinearExtension_type& x);

    void
    alertCLinearExtension (const alertCLinearExtension_optional& x);

    void
    alertCLinearExtension (::std::auto_ptr< alertCLinearExtension_type > p);

    // Constructors.
    //
    AlertCLinear (const alertCLocationCountryCode_type&,
                  const alertCLocationTableNumber_type&,
                  const alertCLocationTableVersion_type&);

    AlertCLinear (const xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    AlertCLinear (const AlertCLinear& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual AlertCLinear*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AlertCLinear ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< alertCLocationCountryCode_type > alertCLocationCountryCode_;
    ::xsd::cxx::tree::one< alertCLocationTableNumber_type > alertCLocationTableNumber_;
    ::xsd::cxx::tree::one< alertCLocationTableVersion_type > alertCLocationTableVersion_;
    alertCLinearExtension_optional alertCLinearExtension_;
  };

  class AlertCLinearByCode: public ::datex2::AlertCLinear
  {
    public:
    // alertCDirection
    // 
    typedef ::datex2::AlertCDirection alertCDirection_type;
    typedef ::xsd::cxx::tree::traits< alertCDirection_type, char > alertCDirection_traits;

    const alertCDirection_type&
    alertCDirection () const;

    alertCDirection_type&
    alertCDirection ();

    void
    alertCDirection (const alertCDirection_type& x);

    void
    alertCDirection (::std::auto_ptr< alertCDirection_type > p);

    // locationCodeForLinearLocation
    // 
    typedef ::datex2::AlertCLocation locationCodeForLinearLocation_type;
    typedef ::xsd::cxx::tree::traits< locationCodeForLinearLocation_type, char > locationCodeForLinearLocation_traits;

    const locationCodeForLinearLocation_type&
    locationCodeForLinearLocation () const;

    locationCodeForLinearLocation_type&
    locationCodeForLinearLocation ();

    void
    locationCodeForLinearLocation (const locationCodeForLinearLocation_type& x);

    void
    locationCodeForLinearLocation (::std::auto_ptr< locationCodeForLinearLocation_type > p);

    // alertCLinearByCodeExtension
    // 
    typedef ::datex2::ExtensionType alertCLinearByCodeExtension_type;
    typedef ::xsd::cxx::tree::optional< alertCLinearByCodeExtension_type > alertCLinearByCodeExtension_optional;
    typedef ::xsd::cxx::tree::traits< alertCLinearByCodeExtension_type, char > alertCLinearByCodeExtension_traits;

    const alertCLinearByCodeExtension_optional&
    alertCLinearByCodeExtension () const;

    alertCLinearByCodeExtension_optional&
    alertCLinearByCodeExtension ();

    void
    alertCLinearByCodeExtension (const alertCLinearByCodeExtension_type& x);

    void
    alertCLinearByCodeExtension (const alertCLinearByCodeExtension_optional& x);

    void
    alertCLinearByCodeExtension (::std::auto_ptr< alertCLinearByCodeExtension_type > p);

    // Constructors.
    //
    AlertCLinearByCode (const alertCLocationCountryCode_type&,
                        const alertCLocationTableNumber_type&,
                        const alertCLocationTableVersion_type&,
                        const alertCDirection_type&,
                        const locationCodeForLinearLocation_type&);

    AlertCLinearByCode (const alertCLocationCountryCode_type&,
                        const alertCLocationTableNumber_type&,
                        const alertCLocationTableVersion_type&,
                        ::std::auto_ptr< alertCDirection_type >&,
                        ::std::auto_ptr< locationCodeForLinearLocation_type >&);

    AlertCLinearByCode (const xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    AlertCLinearByCode (const AlertCLinearByCode& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual AlertCLinearByCode*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AlertCLinearByCode ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< alertCDirection_type > alertCDirection_;
    ::xsd::cxx::tree::one< locationCodeForLinearLocation_type > locationCodeForLinearLocation_;
    alertCLinearByCodeExtension_optional alertCLinearByCodeExtension_;
  };

  class AlertCLocation: public ::xml_schema::type
  {
    public:
    // alertCLocationName
    // 
    typedef ::datex2::MultilingualString alertCLocationName_type;
    typedef ::xsd::cxx::tree::optional< alertCLocationName_type > alertCLocationName_optional;
    typedef ::xsd::cxx::tree::traits< alertCLocationName_type, char > alertCLocationName_traits;

    const alertCLocationName_optional&
    alertCLocationName () const;

    alertCLocationName_optional&
    alertCLocationName ();

    void
    alertCLocationName (const alertCLocationName_type& x);

    void
    alertCLocationName (const alertCLocationName_optional& x);

    void
    alertCLocationName (::std::auto_ptr< alertCLocationName_type > p);

    // specificLocation
    // 
    typedef ::datex2::AlertCLocationCode specificLocation_type;
    typedef ::xsd::cxx::tree::traits< specificLocation_type, char > specificLocation_traits;

    const specificLocation_type&
    specificLocation () const;

    specificLocation_type&
    specificLocation ();

    void
    specificLocation (const specificLocation_type& x);

    void
    specificLocation (::std::auto_ptr< specificLocation_type > p);

    // alertCLocationExtension
    // 
    typedef ::datex2::ExtensionType alertCLocationExtension_type;
    typedef ::xsd::cxx::tree::optional< alertCLocationExtension_type > alertCLocationExtension_optional;
    typedef ::xsd::cxx::tree::traits< alertCLocationExtension_type, char > alertCLocationExtension_traits;

    const alertCLocationExtension_optional&
    alertCLocationExtension () const;

    alertCLocationExtension_optional&
    alertCLocationExtension ();

    void
    alertCLocationExtension (const alertCLocationExtension_type& x);

    void
    alertCLocationExtension (const alertCLocationExtension_optional& x);

    void
    alertCLocationExtension (::std::auto_ptr< alertCLocationExtension_type > p);

    // Constructors.
    //
    AlertCLocation (const specificLocation_type&);

    AlertCLocation (const xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    AlertCLocation (const AlertCLocation& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual AlertCLocation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AlertCLocation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    alertCLocationName_optional alertCLocationName_;
    ::xsd::cxx::tree::one< specificLocation_type > specificLocation_;
    alertCLocationExtension_optional alertCLocationExtension_;
  };

  class NonNegativeInteger: public ::xsd::cxx::tree::fundamental_base< ::xml_schema::non_negative_integer, char, ::xml_schema::simple_type >
  {
    public:
    // Constructors.
    //
    NonNegativeInteger (const ::xml_schema::non_negative_integer&);

    NonNegativeInteger (const xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    NonNegativeInteger (const xercesc::DOMAttr& a,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    NonNegativeInteger (const ::std::string& s,
                        const xercesc::DOMElement* e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    NonNegativeInteger (const NonNegativeInteger& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual NonNegativeInteger*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~NonNegativeInteger ();
  };

  class AlertCLocationCode: public ::datex2::NonNegativeInteger
  {
    public:
    // Constructors.
    //
    AlertCLocationCode (const ::xml_schema::non_negative_integer&);

    AlertCLocationCode (const xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    AlertCLocationCode (const xercesc::DOMAttr& a,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    AlertCLocationCode (const ::std::string& s,
                        const xercesc::DOMElement* e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    AlertCLocationCode (const AlertCLocationCode& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual AlertCLocationCode*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AlertCLocationCode ();
  };

  class AlertCMethod2Linear: public ::datex2::AlertCLinear
  {
    public:
    // alertCDirection
    // 
    typedef ::datex2::AlertCDirection alertCDirection_type;
    typedef ::xsd::cxx::tree::traits< alertCDirection_type, char > alertCDirection_traits;

    const alertCDirection_type&
    alertCDirection () const;

    alertCDirection_type&
    alertCDirection ();

    void
    alertCDirection (const alertCDirection_type& x);

    void
    alertCDirection (::std::auto_ptr< alertCDirection_type > p);

    // alertCMethod2PrimaryPointLocation
    // 
    typedef ::datex2::AlertCMethod2PrimaryPointLocation alertCMethod2PrimaryPointLocation_type;
    typedef ::xsd::cxx::tree::traits< alertCMethod2PrimaryPointLocation_type, char > alertCMethod2PrimaryPointLocation_traits;

    const alertCMethod2PrimaryPointLocation_type&
    alertCMethod2PrimaryPointLocation () const;

    alertCMethod2PrimaryPointLocation_type&
    alertCMethod2PrimaryPointLocation ();

    void
    alertCMethod2PrimaryPointLocation (const alertCMethod2PrimaryPointLocation_type& x);

    void
    alertCMethod2PrimaryPointLocation (::std::auto_ptr< alertCMethod2PrimaryPointLocation_type > p);

    // alertCMethod2SecondaryPointLocation
    // 
    typedef ::datex2::AlertCMethod2SecondaryPointLocation alertCMethod2SecondaryPointLocation_type;
    typedef ::xsd::cxx::tree::traits< alertCMethod2SecondaryPointLocation_type, char > alertCMethod2SecondaryPointLocation_traits;

    const alertCMethod2SecondaryPointLocation_type&
    alertCMethod2SecondaryPointLocation () const;

    alertCMethod2SecondaryPointLocation_type&
    alertCMethod2SecondaryPointLocation ();

    void
    alertCMethod2SecondaryPointLocation (const alertCMethod2SecondaryPointLocation_type& x);

    void
    alertCMethod2SecondaryPointLocation (::std::auto_ptr< alertCMethod2SecondaryPointLocation_type > p);

    // alertCMethod2LinearExtension
    // 
    typedef ::datex2::ExtensionType alertCMethod2LinearExtension_type;
    typedef ::xsd::cxx::tree::optional< alertCMethod2LinearExtension_type > alertCMethod2LinearExtension_optional;
    typedef ::xsd::cxx::tree::traits< alertCMethod2LinearExtension_type, char > alertCMethod2LinearExtension_traits;

    const alertCMethod2LinearExtension_optional&
    alertCMethod2LinearExtension () const;

    alertCMethod2LinearExtension_optional&
    alertCMethod2LinearExtension ();

    void
    alertCMethod2LinearExtension (const alertCMethod2LinearExtension_type& x);

    void
    alertCMethod2LinearExtension (const alertCMethod2LinearExtension_optional& x);

    void
    alertCMethod2LinearExtension (::std::auto_ptr< alertCMethod2LinearExtension_type > p);

    // Constructors.
    //
    AlertCMethod2Linear (const alertCLocationCountryCode_type&,
                         const alertCLocationTableNumber_type&,
                         const alertCLocationTableVersion_type&,
                         const alertCDirection_type&,
                         const alertCMethod2PrimaryPointLocation_type&,
                         const alertCMethod2SecondaryPointLocation_type&);

    AlertCMethod2Linear (const alertCLocationCountryCode_type&,
                         const alertCLocationTableNumber_type&,
                         const alertCLocationTableVersion_type&,
                         ::std::auto_ptr< alertCDirection_type >&,
                         ::std::auto_ptr< alertCMethod2PrimaryPointLocation_type >&,
                         ::std::auto_ptr< alertCMethod2SecondaryPointLocation_type >&);

    AlertCMethod2Linear (const xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    AlertCMethod2Linear (const AlertCMethod2Linear& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual AlertCMethod2Linear*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AlertCMethod2Linear ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< alertCDirection_type > alertCDirection_;
    ::xsd::cxx::tree::one< alertCMethod2PrimaryPointLocation_type > alertCMethod2PrimaryPointLocation_;
    ::xsd::cxx::tree::one< alertCMethod2SecondaryPointLocation_type > alertCMethod2SecondaryPointLocation_;
    alertCMethod2LinearExtension_optional alertCMethod2LinearExtension_;
  };

  class AlertCPoint: public ::xml_schema::type
  {
    public:
    // alertCLocationCountryCode
    // 
    typedef ::datex2::String alertCLocationCountryCode_type;
    typedef ::xsd::cxx::tree::traits< alertCLocationCountryCode_type, char > alertCLocationCountryCode_traits;

    const alertCLocationCountryCode_type&
    alertCLocationCountryCode () const;

    alertCLocationCountryCode_type&
    alertCLocationCountryCode ();

    void
    alertCLocationCountryCode (const alertCLocationCountryCode_type& x);

    void
    alertCLocationCountryCode (::std::auto_ptr< alertCLocationCountryCode_type > p);

    // alertCLocationTableNumber
    // 
    typedef ::datex2::String alertCLocationTableNumber_type;
    typedef ::xsd::cxx::tree::traits< alertCLocationTableNumber_type, char > alertCLocationTableNumber_traits;

    const alertCLocationTableNumber_type&
    alertCLocationTableNumber () const;

    alertCLocationTableNumber_type&
    alertCLocationTableNumber ();

    void
    alertCLocationTableNumber (const alertCLocationTableNumber_type& x);

    void
    alertCLocationTableNumber (::std::auto_ptr< alertCLocationTableNumber_type > p);

    // alertCLocationTableVersion
    // 
    typedef ::datex2::String alertCLocationTableVersion_type;
    typedef ::xsd::cxx::tree::traits< alertCLocationTableVersion_type, char > alertCLocationTableVersion_traits;

    const alertCLocationTableVersion_type&
    alertCLocationTableVersion () const;

    alertCLocationTableVersion_type&
    alertCLocationTableVersion ();

    void
    alertCLocationTableVersion (const alertCLocationTableVersion_type& x);

    void
    alertCLocationTableVersion (::std::auto_ptr< alertCLocationTableVersion_type > p);

    // alertCPointExtension
    // 
    typedef ::datex2::ExtensionType alertCPointExtension_type;
    typedef ::xsd::cxx::tree::optional< alertCPointExtension_type > alertCPointExtension_optional;
    typedef ::xsd::cxx::tree::traits< alertCPointExtension_type, char > alertCPointExtension_traits;

    const alertCPointExtension_optional&
    alertCPointExtension () const;

    alertCPointExtension_optional&
    alertCPointExtension ();

    void
    alertCPointExtension (const alertCPointExtension_type& x);

    void
    alertCPointExtension (const alertCPointExtension_optional& x);

    void
    alertCPointExtension (::std::auto_ptr< alertCPointExtension_type > p);

    // Constructors.
    //
    AlertCPoint (const alertCLocationCountryCode_type&,
                 const alertCLocationTableNumber_type&,
                 const alertCLocationTableVersion_type&);

    AlertCPoint (const xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    AlertCPoint (const AlertCPoint& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual AlertCPoint*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AlertCPoint ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< alertCLocationCountryCode_type > alertCLocationCountryCode_;
    ::xsd::cxx::tree::one< alertCLocationTableNumber_type > alertCLocationTableNumber_;
    ::xsd::cxx::tree::one< alertCLocationTableVersion_type > alertCLocationTableVersion_;
    alertCPointExtension_optional alertCPointExtension_;
  };

  class AlertCMethod2Point: public ::datex2::AlertCPoint
  {
    public:
    // alertCDirection
    // 
    typedef ::datex2::AlertCDirection alertCDirection_type;
    typedef ::xsd::cxx::tree::traits< alertCDirection_type, char > alertCDirection_traits;

    const alertCDirection_type&
    alertCDirection () const;

    alertCDirection_type&
    alertCDirection ();

    void
    alertCDirection (const alertCDirection_type& x);

    void
    alertCDirection (::std::auto_ptr< alertCDirection_type > p);

    // alertCMethod2PrimaryPointLocation
    // 
    typedef ::datex2::AlertCMethod2PrimaryPointLocation alertCMethod2PrimaryPointLocation_type;
    typedef ::xsd::cxx::tree::traits< alertCMethod2PrimaryPointLocation_type, char > alertCMethod2PrimaryPointLocation_traits;

    const alertCMethod2PrimaryPointLocation_type&
    alertCMethod2PrimaryPointLocation () const;

    alertCMethod2PrimaryPointLocation_type&
    alertCMethod2PrimaryPointLocation ();

    void
    alertCMethod2PrimaryPointLocation (const alertCMethod2PrimaryPointLocation_type& x);

    void
    alertCMethod2PrimaryPointLocation (::std::auto_ptr< alertCMethod2PrimaryPointLocation_type > p);

    // alertCMethod2PointExtension
    // 
    typedef ::datex2::ExtensionType alertCMethod2PointExtension_type;
    typedef ::xsd::cxx::tree::optional< alertCMethod2PointExtension_type > alertCMethod2PointExtension_optional;
    typedef ::xsd::cxx::tree::traits< alertCMethod2PointExtension_type, char > alertCMethod2PointExtension_traits;

    const alertCMethod2PointExtension_optional&
    alertCMethod2PointExtension () const;

    alertCMethod2PointExtension_optional&
    alertCMethod2PointExtension ();

    void
    alertCMethod2PointExtension (const alertCMethod2PointExtension_type& x);

    void
    alertCMethod2PointExtension (const alertCMethod2PointExtension_optional& x);

    void
    alertCMethod2PointExtension (::std::auto_ptr< alertCMethod2PointExtension_type > p);

    // Constructors.
    //
    AlertCMethod2Point (const alertCLocationCountryCode_type&,
                        const alertCLocationTableNumber_type&,
                        const alertCLocationTableVersion_type&,
                        const alertCDirection_type&,
                        const alertCMethod2PrimaryPointLocation_type&);

    AlertCMethod2Point (const alertCLocationCountryCode_type&,
                        const alertCLocationTableNumber_type&,
                        const alertCLocationTableVersion_type&,
                        ::std::auto_ptr< alertCDirection_type >&,
                        ::std::auto_ptr< alertCMethod2PrimaryPointLocation_type >&);

    AlertCMethod2Point (const xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    AlertCMethod2Point (const AlertCMethod2Point& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual AlertCMethod2Point*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AlertCMethod2Point ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< alertCDirection_type > alertCDirection_;
    ::xsd::cxx::tree::one< alertCMethod2PrimaryPointLocation_type > alertCMethod2PrimaryPointLocation_;
    alertCMethod2PointExtension_optional alertCMethod2PointExtension_;
  };

  class AlertCMethod2PrimaryPointLocation: public ::xml_schema::type
  {
    public:
    // alertCLocation
    // 
    typedef ::datex2::AlertCLocation alertCLocation_type;
    typedef ::xsd::cxx::tree::traits< alertCLocation_type, char > alertCLocation_traits;

    const alertCLocation_type&
    alertCLocation () const;

    alertCLocation_type&
    alertCLocation ();

    void
    alertCLocation (const alertCLocation_type& x);

    void
    alertCLocation (::std::auto_ptr< alertCLocation_type > p);

    // alertCMethod2PrimaryPointLocationExtension
    // 
    typedef ::datex2::ExtensionType alertCMethod2PrimaryPointLocationExtension_type;
    typedef ::xsd::cxx::tree::optional< alertCMethod2PrimaryPointLocationExtension_type > alertCMethod2PrimaryPointLocationExtension_optional;
    typedef ::xsd::cxx::tree::traits< alertCMethod2PrimaryPointLocationExtension_type, char > alertCMethod2PrimaryPointLocationExtension_traits;

    const alertCMethod2PrimaryPointLocationExtension_optional&
    alertCMethod2PrimaryPointLocationExtension () const;

    alertCMethod2PrimaryPointLocationExtension_optional&
    alertCMethod2PrimaryPointLocationExtension ();

    void
    alertCMethod2PrimaryPointLocationExtension (const alertCMethod2PrimaryPointLocationExtension_type& x);

    void
    alertCMethod2PrimaryPointLocationExtension (const alertCMethod2PrimaryPointLocationExtension_optional& x);

    void
    alertCMethod2PrimaryPointLocationExtension (::std::auto_ptr< alertCMethod2PrimaryPointLocationExtension_type > p);

    // Constructors.
    //
    AlertCMethod2PrimaryPointLocation (const alertCLocation_type&);

    AlertCMethod2PrimaryPointLocation (::std::auto_ptr< alertCLocation_type >&);

    AlertCMethod2PrimaryPointLocation (const xercesc::DOMElement& e,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    AlertCMethod2PrimaryPointLocation (const AlertCMethod2PrimaryPointLocation& x,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    virtual AlertCMethod2PrimaryPointLocation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AlertCMethod2PrimaryPointLocation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< alertCLocation_type > alertCLocation_;
    alertCMethod2PrimaryPointLocationExtension_optional alertCMethod2PrimaryPointLocationExtension_;
  };

  class AlertCMethod2SecondaryPointLocation: public ::xml_schema::type
  {
    public:
    // alertCLocation
    // 
    typedef ::datex2::AlertCLocation alertCLocation_type;
    typedef ::xsd::cxx::tree::traits< alertCLocation_type, char > alertCLocation_traits;

    const alertCLocation_type&
    alertCLocation () const;

    alertCLocation_type&
    alertCLocation ();

    void
    alertCLocation (const alertCLocation_type& x);

    void
    alertCLocation (::std::auto_ptr< alertCLocation_type > p);

    // alertCMethod2SecondaryPointLocationExtension
    // 
    typedef ::datex2::ExtensionType alertCMethod2SecondaryPointLocationExtension_type;
    typedef ::xsd::cxx::tree::optional< alertCMethod2SecondaryPointLocationExtension_type > alertCMethod2SecondaryPointLocationExtension_optional;
    typedef ::xsd::cxx::tree::traits< alertCMethod2SecondaryPointLocationExtension_type, char > alertCMethod2SecondaryPointLocationExtension_traits;

    const alertCMethod2SecondaryPointLocationExtension_optional&
    alertCMethod2SecondaryPointLocationExtension () const;

    alertCMethod2SecondaryPointLocationExtension_optional&
    alertCMethod2SecondaryPointLocationExtension ();

    void
    alertCMethod2SecondaryPointLocationExtension (const alertCMethod2SecondaryPointLocationExtension_type& x);

    void
    alertCMethod2SecondaryPointLocationExtension (const alertCMethod2SecondaryPointLocationExtension_optional& x);

    void
    alertCMethod2SecondaryPointLocationExtension (::std::auto_ptr< alertCMethod2SecondaryPointLocationExtension_type > p);

    // Constructors.
    //
    AlertCMethod2SecondaryPointLocation (const alertCLocation_type&);

    AlertCMethod2SecondaryPointLocation (::std::auto_ptr< alertCLocation_type >&);

    AlertCMethod2SecondaryPointLocation (const xercesc::DOMElement& e,
                                         ::xml_schema::flags f = 0,
                                         ::xml_schema::container* c = 0);

    AlertCMethod2SecondaryPointLocation (const AlertCMethod2SecondaryPointLocation& x,
                                         ::xml_schema::flags f = 0,
                                         ::xml_schema::container* c = 0);

    virtual AlertCMethod2SecondaryPointLocation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AlertCMethod2SecondaryPointLocation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< alertCLocation_type > alertCLocation_;
    alertCMethod2SecondaryPointLocationExtension_optional alertCMethod2SecondaryPointLocationExtension_;
  };

  class AlertCMethod4Linear: public ::datex2::AlertCLinear
  {
    public:
    // alertCDirection
    // 
    typedef ::datex2::AlertCDirection alertCDirection_type;
    typedef ::xsd::cxx::tree::traits< alertCDirection_type, char > alertCDirection_traits;

    const alertCDirection_type&
    alertCDirection () const;

    alertCDirection_type&
    alertCDirection ();

    void
    alertCDirection (const alertCDirection_type& x);

    void
    alertCDirection (::std::auto_ptr< alertCDirection_type > p);

    // alertCMethod4PrimaryPointLocation
    // 
    typedef ::datex2::AlertCMethod4PrimaryPointLocation alertCMethod4PrimaryPointLocation_type;
    typedef ::xsd::cxx::tree::traits< alertCMethod4PrimaryPointLocation_type, char > alertCMethod4PrimaryPointLocation_traits;

    const alertCMethod4PrimaryPointLocation_type&
    alertCMethod4PrimaryPointLocation () const;

    alertCMethod4PrimaryPointLocation_type&
    alertCMethod4PrimaryPointLocation ();

    void
    alertCMethod4PrimaryPointLocation (const alertCMethod4PrimaryPointLocation_type& x);

    void
    alertCMethod4PrimaryPointLocation (::std::auto_ptr< alertCMethod4PrimaryPointLocation_type > p);

    // alertCMethod4SecondaryPointLocation
    // 
    typedef ::datex2::AlertCMethod4SecondaryPointLocation alertCMethod4SecondaryPointLocation_type;
    typedef ::xsd::cxx::tree::traits< alertCMethod4SecondaryPointLocation_type, char > alertCMethod4SecondaryPointLocation_traits;

    const alertCMethod4SecondaryPointLocation_type&
    alertCMethod4SecondaryPointLocation () const;

    alertCMethod4SecondaryPointLocation_type&
    alertCMethod4SecondaryPointLocation ();

    void
    alertCMethod4SecondaryPointLocation (const alertCMethod4SecondaryPointLocation_type& x);

    void
    alertCMethod4SecondaryPointLocation (::std::auto_ptr< alertCMethod4SecondaryPointLocation_type > p);

    // alertCMethod4LinearExtension
    // 
    typedef ::datex2::ExtensionType alertCMethod4LinearExtension_type;
    typedef ::xsd::cxx::tree::optional< alertCMethod4LinearExtension_type > alertCMethod4LinearExtension_optional;
    typedef ::xsd::cxx::tree::traits< alertCMethod4LinearExtension_type, char > alertCMethod4LinearExtension_traits;

    const alertCMethod4LinearExtension_optional&
    alertCMethod4LinearExtension () const;

    alertCMethod4LinearExtension_optional&
    alertCMethod4LinearExtension ();

    void
    alertCMethod4LinearExtension (const alertCMethod4LinearExtension_type& x);

    void
    alertCMethod4LinearExtension (const alertCMethod4LinearExtension_optional& x);

    void
    alertCMethod4LinearExtension (::std::auto_ptr< alertCMethod4LinearExtension_type > p);

    // Constructors.
    //
    AlertCMethod4Linear (const alertCLocationCountryCode_type&,
                         const alertCLocationTableNumber_type&,
                         const alertCLocationTableVersion_type&,
                         const alertCDirection_type&,
                         const alertCMethod4PrimaryPointLocation_type&,
                         const alertCMethod4SecondaryPointLocation_type&);

    AlertCMethod4Linear (const alertCLocationCountryCode_type&,
                         const alertCLocationTableNumber_type&,
                         const alertCLocationTableVersion_type&,
                         ::std::auto_ptr< alertCDirection_type >&,
                         ::std::auto_ptr< alertCMethod4PrimaryPointLocation_type >&,
                         ::std::auto_ptr< alertCMethod4SecondaryPointLocation_type >&);

    AlertCMethod4Linear (const xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    AlertCMethod4Linear (const AlertCMethod4Linear& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual AlertCMethod4Linear*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AlertCMethod4Linear ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< alertCDirection_type > alertCDirection_;
    ::xsd::cxx::tree::one< alertCMethod4PrimaryPointLocation_type > alertCMethod4PrimaryPointLocation_;
    ::xsd::cxx::tree::one< alertCMethod4SecondaryPointLocation_type > alertCMethod4SecondaryPointLocation_;
    alertCMethod4LinearExtension_optional alertCMethod4LinearExtension_;
  };

  class AlertCMethod4Point: public ::datex2::AlertCPoint
  {
    public:
    // alertCDirection
    // 
    typedef ::datex2::AlertCDirection alertCDirection_type;
    typedef ::xsd::cxx::tree::traits< alertCDirection_type, char > alertCDirection_traits;

    const alertCDirection_type&
    alertCDirection () const;

    alertCDirection_type&
    alertCDirection ();

    void
    alertCDirection (const alertCDirection_type& x);

    void
    alertCDirection (::std::auto_ptr< alertCDirection_type > p);

    // alertCMethod4PrimaryPointLocation
    // 
    typedef ::datex2::AlertCMethod4PrimaryPointLocation alertCMethod4PrimaryPointLocation_type;
    typedef ::xsd::cxx::tree::traits< alertCMethod4PrimaryPointLocation_type, char > alertCMethod4PrimaryPointLocation_traits;

    const alertCMethod4PrimaryPointLocation_type&
    alertCMethod4PrimaryPointLocation () const;

    alertCMethod4PrimaryPointLocation_type&
    alertCMethod4PrimaryPointLocation ();

    void
    alertCMethod4PrimaryPointLocation (const alertCMethod4PrimaryPointLocation_type& x);

    void
    alertCMethod4PrimaryPointLocation (::std::auto_ptr< alertCMethod4PrimaryPointLocation_type > p);

    // alertCMethod4PointExtension
    // 
    typedef ::datex2::ExtensionType alertCMethod4PointExtension_type;
    typedef ::xsd::cxx::tree::optional< alertCMethod4PointExtension_type > alertCMethod4PointExtension_optional;
    typedef ::xsd::cxx::tree::traits< alertCMethod4PointExtension_type, char > alertCMethod4PointExtension_traits;

    const alertCMethod4PointExtension_optional&
    alertCMethod4PointExtension () const;

    alertCMethod4PointExtension_optional&
    alertCMethod4PointExtension ();

    void
    alertCMethod4PointExtension (const alertCMethod4PointExtension_type& x);

    void
    alertCMethod4PointExtension (const alertCMethod4PointExtension_optional& x);

    void
    alertCMethod4PointExtension (::std::auto_ptr< alertCMethod4PointExtension_type > p);

    // Constructors.
    //
    AlertCMethod4Point (const alertCLocationCountryCode_type&,
                        const alertCLocationTableNumber_type&,
                        const alertCLocationTableVersion_type&,
                        const alertCDirection_type&,
                        const alertCMethod4PrimaryPointLocation_type&);

    AlertCMethod4Point (const alertCLocationCountryCode_type&,
                        const alertCLocationTableNumber_type&,
                        const alertCLocationTableVersion_type&,
                        ::std::auto_ptr< alertCDirection_type >&,
                        ::std::auto_ptr< alertCMethod4PrimaryPointLocation_type >&);

    AlertCMethod4Point (const xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    AlertCMethod4Point (const AlertCMethod4Point& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual AlertCMethod4Point*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AlertCMethod4Point ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< alertCDirection_type > alertCDirection_;
    ::xsd::cxx::tree::one< alertCMethod4PrimaryPointLocation_type > alertCMethod4PrimaryPointLocation_;
    alertCMethod4PointExtension_optional alertCMethod4PointExtension_;
  };

  class AlertCMethod4PrimaryPointLocation: public ::xml_schema::type
  {
    public:
    // alertCLocation
    // 
    typedef ::datex2::AlertCLocation alertCLocation_type;
    typedef ::xsd::cxx::tree::traits< alertCLocation_type, char > alertCLocation_traits;

    const alertCLocation_type&
    alertCLocation () const;

    alertCLocation_type&
    alertCLocation ();

    void
    alertCLocation (const alertCLocation_type& x);

    void
    alertCLocation (::std::auto_ptr< alertCLocation_type > p);

    // offsetDistance
    // 
    typedef ::datex2::OffsetDistance offsetDistance_type;
    typedef ::xsd::cxx::tree::traits< offsetDistance_type, char > offsetDistance_traits;

    const offsetDistance_type&
    offsetDistance () const;

    offsetDistance_type&
    offsetDistance ();

    void
    offsetDistance (const offsetDistance_type& x);

    void
    offsetDistance (::std::auto_ptr< offsetDistance_type > p);

    // alertCMethod4PrimaryPointLocationExtension
    // 
    typedef ::datex2::ExtensionType alertCMethod4PrimaryPointLocationExtension_type;
    typedef ::xsd::cxx::tree::optional< alertCMethod4PrimaryPointLocationExtension_type > alertCMethod4PrimaryPointLocationExtension_optional;
    typedef ::xsd::cxx::tree::traits< alertCMethod4PrimaryPointLocationExtension_type, char > alertCMethod4PrimaryPointLocationExtension_traits;

    const alertCMethod4PrimaryPointLocationExtension_optional&
    alertCMethod4PrimaryPointLocationExtension () const;

    alertCMethod4PrimaryPointLocationExtension_optional&
    alertCMethod4PrimaryPointLocationExtension ();

    void
    alertCMethod4PrimaryPointLocationExtension (const alertCMethod4PrimaryPointLocationExtension_type& x);

    void
    alertCMethod4PrimaryPointLocationExtension (const alertCMethod4PrimaryPointLocationExtension_optional& x);

    void
    alertCMethod4PrimaryPointLocationExtension (::std::auto_ptr< alertCMethod4PrimaryPointLocationExtension_type > p);

    // Constructors.
    //
    AlertCMethod4PrimaryPointLocation (const alertCLocation_type&,
                                       const offsetDistance_type&);

    AlertCMethod4PrimaryPointLocation (::std::auto_ptr< alertCLocation_type >&,
                                       ::std::auto_ptr< offsetDistance_type >&);

    AlertCMethod4PrimaryPointLocation (const xercesc::DOMElement& e,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    AlertCMethod4PrimaryPointLocation (const AlertCMethod4PrimaryPointLocation& x,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    virtual AlertCMethod4PrimaryPointLocation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AlertCMethod4PrimaryPointLocation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< alertCLocation_type > alertCLocation_;
    ::xsd::cxx::tree::one< offsetDistance_type > offsetDistance_;
    alertCMethod4PrimaryPointLocationExtension_optional alertCMethod4PrimaryPointLocationExtension_;
  };

  class AlertCMethod4SecondaryPointLocation: public ::xml_schema::type
  {
    public:
    // alertCLocation
    // 
    typedef ::datex2::AlertCLocation alertCLocation_type;
    typedef ::xsd::cxx::tree::traits< alertCLocation_type, char > alertCLocation_traits;

    const alertCLocation_type&
    alertCLocation () const;

    alertCLocation_type&
    alertCLocation ();

    void
    alertCLocation (const alertCLocation_type& x);

    void
    alertCLocation (::std::auto_ptr< alertCLocation_type > p);

    // offsetDistance
    // 
    typedef ::datex2::OffsetDistance offsetDistance_type;
    typedef ::xsd::cxx::tree::traits< offsetDistance_type, char > offsetDistance_traits;

    const offsetDistance_type&
    offsetDistance () const;

    offsetDistance_type&
    offsetDistance ();

    void
    offsetDistance (const offsetDistance_type& x);

    void
    offsetDistance (::std::auto_ptr< offsetDistance_type > p);

    // alertCMethod4SecondaryPointLocationExtension
    // 
    typedef ::datex2::ExtensionType alertCMethod4SecondaryPointLocationExtension_type;
    typedef ::xsd::cxx::tree::optional< alertCMethod4SecondaryPointLocationExtension_type > alertCMethod4SecondaryPointLocationExtension_optional;
    typedef ::xsd::cxx::tree::traits< alertCMethod4SecondaryPointLocationExtension_type, char > alertCMethod4SecondaryPointLocationExtension_traits;

    const alertCMethod4SecondaryPointLocationExtension_optional&
    alertCMethod4SecondaryPointLocationExtension () const;

    alertCMethod4SecondaryPointLocationExtension_optional&
    alertCMethod4SecondaryPointLocationExtension ();

    void
    alertCMethod4SecondaryPointLocationExtension (const alertCMethod4SecondaryPointLocationExtension_type& x);

    void
    alertCMethod4SecondaryPointLocationExtension (const alertCMethod4SecondaryPointLocationExtension_optional& x);

    void
    alertCMethod4SecondaryPointLocationExtension (::std::auto_ptr< alertCMethod4SecondaryPointLocationExtension_type > p);

    // Constructors.
    //
    AlertCMethod4SecondaryPointLocation (const alertCLocation_type&,
                                         const offsetDistance_type&);

    AlertCMethod4SecondaryPointLocation (::std::auto_ptr< alertCLocation_type >&,
                                         ::std::auto_ptr< offsetDistance_type >&);

    AlertCMethod4SecondaryPointLocation (const xercesc::DOMElement& e,
                                         ::xml_schema::flags f = 0,
                                         ::xml_schema::container* c = 0);

    AlertCMethod4SecondaryPointLocation (const AlertCMethod4SecondaryPointLocation& x,
                                         ::xml_schema::flags f = 0,
                                         ::xml_schema::container* c = 0);

    virtual AlertCMethod4SecondaryPointLocation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AlertCMethod4SecondaryPointLocation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< alertCLocation_type > alertCLocation_;
    ::xsd::cxx::tree::one< offsetDistance_type > offsetDistance_;
    alertCMethod4SecondaryPointLocationExtension_optional alertCMethod4SecondaryPointLocationExtension_;
  };

  class AngleInDegrees: public ::datex2::NonNegativeInteger
  {
    public:
    // Constructors.
    //
    AngleInDegrees (const ::xml_schema::non_negative_integer&);

    AngleInDegrees (const xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    AngleInDegrees (const xercesc::DOMAttr& a,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    AngleInDegrees (const ::std::string& s,
                    const xercesc::DOMElement* e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    AngleInDegrees (const AngleInDegrees& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual AngleInDegrees*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AngleInDegrees ();
  };

  class Obstruction: public ::datex2::TrafficElement
  {
    public:
    // numberOfObstructions
    // 
    typedef ::datex2::NonNegativeInteger numberOfObstructions_type;
    typedef ::xsd::cxx::tree::optional< numberOfObstructions_type > numberOfObstructions_optional;
    typedef ::xsd::cxx::tree::traits< numberOfObstructions_type, char > numberOfObstructions_traits;

    const numberOfObstructions_optional&
    numberOfObstructions () const;

    numberOfObstructions_optional&
    numberOfObstructions ();

    void
    numberOfObstructions (const numberOfObstructions_type& x);

    void
    numberOfObstructions (const numberOfObstructions_optional& x);

    void
    numberOfObstructions (::std::auto_ptr< numberOfObstructions_type > p);

    // mobilityOfObstruction
    // 
    typedef ::datex2::Mobility mobilityOfObstruction_type;
    typedef ::xsd::cxx::tree::optional< mobilityOfObstruction_type > mobilityOfObstruction_optional;
    typedef ::xsd::cxx::tree::traits< mobilityOfObstruction_type, char > mobilityOfObstruction_traits;

    const mobilityOfObstruction_optional&
    mobilityOfObstruction () const;

    mobilityOfObstruction_optional&
    mobilityOfObstruction ();

    void
    mobilityOfObstruction (const mobilityOfObstruction_type& x);

    void
    mobilityOfObstruction (const mobilityOfObstruction_optional& x);

    void
    mobilityOfObstruction (::std::auto_ptr< mobilityOfObstruction_type > p);

    // obstructionExtension
    // 
    typedef ::datex2::ExtensionType obstructionExtension_type;
    typedef ::xsd::cxx::tree::optional< obstructionExtension_type > obstructionExtension_optional;
    typedef ::xsd::cxx::tree::traits< obstructionExtension_type, char > obstructionExtension_traits;

    const obstructionExtension_optional&
    obstructionExtension () const;

    obstructionExtension_optional&
    obstructionExtension ();

    void
    obstructionExtension (const obstructionExtension_type& x);

    void
    obstructionExtension (const obstructionExtension_optional& x);

    void
    obstructionExtension (::std::auto_ptr< obstructionExtension_type > p);

    // Constructors.
    //
    Obstruction (const situationRecordCreationTime_type&,
                 const situationRecordVersion_type&,
                 const situationRecordVersionTime_type&,
                 const probabilityOfOccurrence_type&,
                 const validity_type&,
                 const groupOfLocations_type&,
                 const id_type&);

    Obstruction (const situationRecordCreationTime_type&,
                 const situationRecordVersion_type&,
                 const situationRecordVersionTime_type&,
                 const probabilityOfOccurrence_type&,
                 ::std::auto_ptr< validity_type >&,
                 ::std::auto_ptr< groupOfLocations_type >&,
                 const id_type&);

    Obstruction (const xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    Obstruction (const Obstruction& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual Obstruction*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Obstruction ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    numberOfObstructions_optional numberOfObstructions_;
    mobilityOfObstruction_optional mobilityOfObstruction_;
    obstructionExtension_optional obstructionExtension_;
  };

  class AnimalPresenceObstruction: public ::datex2::Obstruction
  {
    public:
    // alive
    // 
    typedef ::datex2::Boolean alive_type;
    typedef ::xsd::cxx::tree::optional< alive_type > alive_optional;
    typedef ::xsd::cxx::tree::traits< alive_type, char > alive_traits;

    const alive_optional&
    alive () const;

    alive_optional&
    alive ();

    void
    alive (const alive_type& x);

    void
    alive (const alive_optional& x);

    void
    alive (::std::auto_ptr< alive_type > p);

    // animalPresenceType
    // 
    typedef ::datex2::AnimalPresenceTypeEnum animalPresenceType_type;
    typedef ::xsd::cxx::tree::traits< animalPresenceType_type, char > animalPresenceType_traits;

    const animalPresenceType_type&
    animalPresenceType () const;

    animalPresenceType_type&
    animalPresenceType ();

    void
    animalPresenceType (const animalPresenceType_type& x);

    void
    animalPresenceType (::std::auto_ptr< animalPresenceType_type > p);

    // animalPresenceObstructionExtension
    // 
    typedef ::datex2::ExtensionType animalPresenceObstructionExtension_type;
    typedef ::xsd::cxx::tree::optional< animalPresenceObstructionExtension_type > animalPresenceObstructionExtension_optional;
    typedef ::xsd::cxx::tree::traits< animalPresenceObstructionExtension_type, char > animalPresenceObstructionExtension_traits;

    const animalPresenceObstructionExtension_optional&
    animalPresenceObstructionExtension () const;

    animalPresenceObstructionExtension_optional&
    animalPresenceObstructionExtension ();

    void
    animalPresenceObstructionExtension (const animalPresenceObstructionExtension_type& x);

    void
    animalPresenceObstructionExtension (const animalPresenceObstructionExtension_optional& x);

    void
    animalPresenceObstructionExtension (::std::auto_ptr< animalPresenceObstructionExtension_type > p);

    // Constructors.
    //
    AnimalPresenceObstruction (const situationRecordCreationTime_type&,
                               const situationRecordVersion_type&,
                               const situationRecordVersionTime_type&,
                               const probabilityOfOccurrence_type&,
                               const validity_type&,
                               const groupOfLocations_type&,
                               const id_type&,
                               const animalPresenceType_type&);

    AnimalPresenceObstruction (const situationRecordCreationTime_type&,
                               const situationRecordVersion_type&,
                               const situationRecordVersionTime_type&,
                               const probabilityOfOccurrence_type&,
                               ::std::auto_ptr< validity_type >&,
                               ::std::auto_ptr< groupOfLocations_type >&,
                               const id_type&,
                               const animalPresenceType_type&);

    AnimalPresenceObstruction (const xercesc::DOMElement& e,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    AnimalPresenceObstruction (const AnimalPresenceObstruction& x,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    virtual AnimalPresenceObstruction*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AnimalPresenceObstruction ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    alive_optional alive_;
    ::xsd::cxx::tree::one< animalPresenceType_type > animalPresenceType_;
    animalPresenceObstructionExtension_optional animalPresenceObstructionExtension_;
  };

  class AnimalPresenceTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      animalsOnTheRoad,
      herdOfAnimalsOnTheRoad,
      largeAnimalsOnTheRoad
    };

    AnimalPresenceTypeEnum (value v);

    AnimalPresenceTypeEnum (const char* v);

    AnimalPresenceTypeEnum (const ::std::string& v);

    AnimalPresenceTypeEnum (const ::xml_schema::string& v);

    AnimalPresenceTypeEnum (const xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    AnimalPresenceTypeEnum (const xercesc::DOMAttr& a,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    AnimalPresenceTypeEnum (const ::std::string& s,
                            const xercesc::DOMElement* e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    AnimalPresenceTypeEnum (const AnimalPresenceTypeEnum& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual AnimalPresenceTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    AnimalPresenceTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_AnimalPresenceTypeEnum_convert ();
    }

    protected:
    value
    _xsd_AnimalPresenceTypeEnum_convert () const;

    public:
    static const char* const _xsd_AnimalPresenceTypeEnum_literals_[3];
    static const value _xsd_AnimalPresenceTypeEnum_indexes_[3];
  };

  class Location: public ::xml_schema::type
  {
    public:
    // externalReferencing
    // 
    typedef ::datex2::ExternalReferencing externalReferencing_type;
    typedef ::xsd::cxx::tree::sequence< externalReferencing_type > externalReferencing_sequence;
    typedef xsd::cxx::tree::sequence< externalReferencing_type >::iterator externalReferencing_iterator;
    typedef xsd::cxx::tree::sequence< externalReferencing_type >::const_iterator externalReferencing_const_iterator;
    typedef ::xsd::cxx::tree::traits< externalReferencing_type, char > externalReferencing_traits;

    const externalReferencing_sequence&
    externalReferencing () const;

    externalReferencing_sequence&
    externalReferencing ();

    void
    externalReferencing (const externalReferencing_sequence& s);

    // locationForDisplay
    // 
    typedef ::datex2::PointCoordinates locationForDisplay_type;
    typedef ::xsd::cxx::tree::optional< locationForDisplay_type > locationForDisplay_optional;
    typedef ::xsd::cxx::tree::traits< locationForDisplay_type, char > locationForDisplay_traits;

    const locationForDisplay_optional&
    locationForDisplay () const;

    locationForDisplay_optional&
    locationForDisplay ();

    void
    locationForDisplay (const locationForDisplay_type& x);

    void
    locationForDisplay (const locationForDisplay_optional& x);

    void
    locationForDisplay (::std::auto_ptr< locationForDisplay_type > p);

    // locationExtension
    // 
    typedef ::datex2::ExtensionType locationExtension_type;
    typedef ::xsd::cxx::tree::optional< locationExtension_type > locationExtension_optional;
    typedef ::xsd::cxx::tree::traits< locationExtension_type, char > locationExtension_traits;

    const locationExtension_optional&
    locationExtension () const;

    locationExtension_optional&
    locationExtension ();

    void
    locationExtension (const locationExtension_type& x);

    void
    locationExtension (const locationExtension_optional& x);

    void
    locationExtension (::std::auto_ptr< locationExtension_type > p);

    // Constructors.
    //
    Location ();

    Location (const xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    Location (const Location& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual Location*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Location ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    externalReferencing_sequence externalReferencing_;
    locationForDisplay_optional locationForDisplay_;
    locationExtension_optional locationExtension_;
  };

  class Area: public ::datex2::Location
  {
    public:
    // alertCArea
    // 
    typedef ::datex2::AlertCArea alertCArea_type;
    typedef ::xsd::cxx::tree::optional< alertCArea_type > alertCArea_optional;
    typedef ::xsd::cxx::tree::traits< alertCArea_type, char > alertCArea_traits;

    const alertCArea_optional&
    alertCArea () const;

    alertCArea_optional&
    alertCArea ();

    void
    alertCArea (const alertCArea_type& x);

    void
    alertCArea (const alertCArea_optional& x);

    void
    alertCArea (::std::auto_ptr< alertCArea_type > p);

    // tpegAreaLocation
    // 
    typedef ::datex2::TpegAreaLocation tpegAreaLocation_type;
    typedef ::xsd::cxx::tree::optional< tpegAreaLocation_type > tpegAreaLocation_optional;
    typedef ::xsd::cxx::tree::traits< tpegAreaLocation_type, char > tpegAreaLocation_traits;

    const tpegAreaLocation_optional&
    tpegAreaLocation () const;

    tpegAreaLocation_optional&
    tpegAreaLocation ();

    void
    tpegAreaLocation (const tpegAreaLocation_type& x);

    void
    tpegAreaLocation (const tpegAreaLocation_optional& x);

    void
    tpegAreaLocation (::std::auto_ptr< tpegAreaLocation_type > p);

    // areaExtension
    // 
    typedef ::datex2::ExtensionType areaExtension_type;
    typedef ::xsd::cxx::tree::optional< areaExtension_type > areaExtension_optional;
    typedef ::xsd::cxx::tree::traits< areaExtension_type, char > areaExtension_traits;

    const areaExtension_optional&
    areaExtension () const;

    areaExtension_optional&
    areaExtension ();

    void
    areaExtension (const areaExtension_type& x);

    void
    areaExtension (const areaExtension_optional& x);

    void
    areaExtension (::std::auto_ptr< areaExtension_type > p);

    // Constructors.
    //
    Area ();

    Area (const xercesc::DOMElement& e,
          ::xml_schema::flags f = 0,
          ::xml_schema::container* c = 0);

    Area (const Area& x,
          ::xml_schema::flags f = 0,
          ::xml_schema::container* c = 0);

    virtual Area*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Area ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    alertCArea_optional alertCArea_;
    tpegAreaLocation_optional tpegAreaLocation_;
    areaExtension_optional areaExtension_;
  };

  class Destination: public ::xml_schema::type
  {
    public:
    // destinationExtension
    // 
    typedef ::datex2::ExtensionType destinationExtension_type;
    typedef ::xsd::cxx::tree::optional< destinationExtension_type > destinationExtension_optional;
    typedef ::xsd::cxx::tree::traits< destinationExtension_type, char > destinationExtension_traits;

    const destinationExtension_optional&
    destinationExtension () const;

    destinationExtension_optional&
    destinationExtension ();

    void
    destinationExtension (const destinationExtension_type& x);

    void
    destinationExtension (const destinationExtension_optional& x);

    void
    destinationExtension (::std::auto_ptr< destinationExtension_type > p);

    // Constructors.
    //
    Destination ();

    Destination (const xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    Destination (const Destination& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual Destination*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Destination ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    destinationExtension_optional destinationExtension_;
  };

  class AreaDestination: public ::datex2::Destination
  {
    public:
    // area
    // 
    typedef ::datex2::Area area_type;
    typedef ::xsd::cxx::tree::traits< area_type, char > area_traits;

    const area_type&
    area () const;

    area_type&
    area ();

    void
    area (const area_type& x);

    void
    area (::std::auto_ptr< area_type > p);

    // areaDestinationExtension
    // 
    typedef ::datex2::ExtensionType areaDestinationExtension_type;
    typedef ::xsd::cxx::tree::optional< areaDestinationExtension_type > areaDestinationExtension_optional;
    typedef ::xsd::cxx::tree::traits< areaDestinationExtension_type, char > areaDestinationExtension_traits;

    const areaDestinationExtension_optional&
    areaDestinationExtension () const;

    areaDestinationExtension_optional&
    areaDestinationExtension ();

    void
    areaDestinationExtension (const areaDestinationExtension_type& x);

    void
    areaDestinationExtension (const areaDestinationExtension_optional& x);

    void
    areaDestinationExtension (::std::auto_ptr< areaDestinationExtension_type > p);

    // Constructors.
    //
    AreaDestination (const area_type&);

    AreaDestination (::std::auto_ptr< area_type >&);

    AreaDestination (const xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    AreaDestination (const AreaDestination& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual AreaDestination*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AreaDestination ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< area_type > area_;
    areaDestinationExtension_optional areaDestinationExtension_;
  };

  class AreaOfInterestEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      continentWide,
      national,
      neighbouringCountries,
      notSpecified,
      regional
    };

    AreaOfInterestEnum (value v);

    AreaOfInterestEnum (const char* v);

    AreaOfInterestEnum (const ::std::string& v);

    AreaOfInterestEnum (const ::xml_schema::string& v);

    AreaOfInterestEnum (const xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    AreaOfInterestEnum (const xercesc::DOMAttr& a,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    AreaOfInterestEnum (const ::std::string& s,
                        const xercesc::DOMElement* e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    AreaOfInterestEnum (const AreaOfInterestEnum& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual AreaOfInterestEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    AreaOfInterestEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_AreaOfInterestEnum_convert ();
    }

    protected:
    value
    _xsd_AreaOfInterestEnum_convert () const;

    public:
    static const char* const _xsd_AreaOfInterestEnum_literals_[5];
    static const value _xsd_AreaOfInterestEnum_indexes_[5];
  };

  class AuthorityOperation: public ::datex2::Activity
  {
    public:
    // authorityOperationType
    // 
    typedef ::datex2::AuthorityOperationTypeEnum authorityOperationType_type;
    typedef ::xsd::cxx::tree::traits< authorityOperationType_type, char > authorityOperationType_traits;

    const authorityOperationType_type&
    authorityOperationType () const;

    authorityOperationType_type&
    authorityOperationType ();

    void
    authorityOperationType (const authorityOperationType_type& x);

    void
    authorityOperationType (::std::auto_ptr< authorityOperationType_type > p);

    // authorityOperationExtension
    // 
    typedef ::datex2::ExtensionType authorityOperationExtension_type;
    typedef ::xsd::cxx::tree::optional< authorityOperationExtension_type > authorityOperationExtension_optional;
    typedef ::xsd::cxx::tree::traits< authorityOperationExtension_type, char > authorityOperationExtension_traits;

    const authorityOperationExtension_optional&
    authorityOperationExtension () const;

    authorityOperationExtension_optional&
    authorityOperationExtension ();

    void
    authorityOperationExtension (const authorityOperationExtension_type& x);

    void
    authorityOperationExtension (const authorityOperationExtension_optional& x);

    void
    authorityOperationExtension (::std::auto_ptr< authorityOperationExtension_type > p);

    // Constructors.
    //
    AuthorityOperation (const situationRecordCreationTime_type&,
                        const situationRecordVersion_type&,
                        const situationRecordVersionTime_type&,
                        const probabilityOfOccurrence_type&,
                        const validity_type&,
                        const groupOfLocations_type&,
                        const id_type&,
                        const authorityOperationType_type&);

    AuthorityOperation (const situationRecordCreationTime_type&,
                        const situationRecordVersion_type&,
                        const situationRecordVersionTime_type&,
                        const probabilityOfOccurrence_type&,
                        ::std::auto_ptr< validity_type >&,
                        ::std::auto_ptr< groupOfLocations_type >&,
                        const id_type&,
                        const authorityOperationType_type&);

    AuthorityOperation (const xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    AuthorityOperation (const AuthorityOperation& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual AuthorityOperation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AuthorityOperation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< authorityOperationType_type > authorityOperationType_;
    authorityOperationExtension_optional authorityOperationExtension_;
  };

  class AuthorityOperationTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      accidentInvestigationWork,
      bombSquadInAction,
      civilEmergency,
      customsOperation,
      juridicalReconstruction,
      policeCheckPoint,
      policeInvestigation,
      roadOperatorCheckPoint,
      survey,
      transportOfVip,
      undefinedAuthorityActivity,
      vehicleInspectionCheckPoint,
      vehicleWeighing,
      weighInMotion,
      other
    };

    AuthorityOperationTypeEnum (value v);

    AuthorityOperationTypeEnum (const char* v);

    AuthorityOperationTypeEnum (const ::std::string& v);

    AuthorityOperationTypeEnum (const ::xml_schema::string& v);

    AuthorityOperationTypeEnum (const xercesc::DOMElement& e,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    AuthorityOperationTypeEnum (const xercesc::DOMAttr& a,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    AuthorityOperationTypeEnum (const ::std::string& s,
                                const xercesc::DOMElement* e,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    AuthorityOperationTypeEnum (const AuthorityOperationTypeEnum& x,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    virtual AuthorityOperationTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    AuthorityOperationTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_AuthorityOperationTypeEnum_convert ();
    }

    protected:
    value
    _xsd_AuthorityOperationTypeEnum_convert () const;

    public:
    static const char* const _xsd_AuthorityOperationTypeEnum_literals_[15];
    static const value _xsd_AuthorityOperationTypeEnum_indexes_[15];
  };

  class AxleSpacing: public ::xml_schema::type
  {
    public:
    // axleSpacing
    // 
    typedef ::datex2::MetresAsFloat axleSpacing_type;
    typedef ::xsd::cxx::tree::traits< axleSpacing_type, char > axleSpacing_traits;

    const axleSpacing_type&
    axleSpacing () const;

    axleSpacing_type&
    axleSpacing ();

    void
    axleSpacing (const axleSpacing_type& x);

    void
    axleSpacing (::std::auto_ptr< axleSpacing_type > p);

    // axleSpacingSequenceIdentifier
    // 
    typedef ::datex2::NonNegativeInteger axleSpacingSequenceIdentifier_type;
    typedef ::xsd::cxx::tree::traits< axleSpacingSequenceIdentifier_type, char > axleSpacingSequenceIdentifier_traits;

    const axleSpacingSequenceIdentifier_type&
    axleSpacingSequenceIdentifier () const;

    axleSpacingSequenceIdentifier_type&
    axleSpacingSequenceIdentifier ();

    void
    axleSpacingSequenceIdentifier (const axleSpacingSequenceIdentifier_type& x);

    void
    axleSpacingSequenceIdentifier (::std::auto_ptr< axleSpacingSequenceIdentifier_type > p);

    // axleSpacingExtension
    // 
    typedef ::datex2::ExtensionType axleSpacingExtension_type;
    typedef ::xsd::cxx::tree::optional< axleSpacingExtension_type > axleSpacingExtension_optional;
    typedef ::xsd::cxx::tree::traits< axleSpacingExtension_type, char > axleSpacingExtension_traits;

    const axleSpacingExtension_optional&
    axleSpacingExtension () const;

    axleSpacingExtension_optional&
    axleSpacingExtension ();

    void
    axleSpacingExtension (const axleSpacingExtension_type& x);

    void
    axleSpacingExtension (const axleSpacingExtension_optional& x);

    void
    axleSpacingExtension (::std::auto_ptr< axleSpacingExtension_type > p);

    // Constructors.
    //
    AxleSpacing (const axleSpacing_type&,
                 const axleSpacingSequenceIdentifier_type&);

    AxleSpacing (const xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    AxleSpacing (const AxleSpacing& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual AxleSpacing*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AxleSpacing ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< axleSpacing_type > axleSpacing_;
    ::xsd::cxx::tree::one< axleSpacingSequenceIdentifier_type > axleSpacingSequenceIdentifier_;
    axleSpacingExtension_optional axleSpacingExtension_;
  };

  class AxlesPerHour: public ::datex2::NonNegativeInteger
  {
    public:
    // Constructors.
    //
    AxlesPerHour (const ::xml_schema::non_negative_integer&);

    AxlesPerHour (const xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    AxlesPerHour (const xercesc::DOMAttr& a,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    AxlesPerHour (const ::std::string& s,
                  const xercesc::DOMElement* e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    AxlesPerHour (const AxlesPerHour& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual AxlesPerHour*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AxlesPerHour ();
  };

  class AxleWeight: public ::xml_schema::type
  {
    public:
    // axlePositionIdentifier
    // 
    typedef ::datex2::NonNegativeInteger axlePositionIdentifier_type;
    typedef ::xsd::cxx::tree::traits< axlePositionIdentifier_type, char > axlePositionIdentifier_traits;

    const axlePositionIdentifier_type&
    axlePositionIdentifier () const;

    axlePositionIdentifier_type&
    axlePositionIdentifier ();

    void
    axlePositionIdentifier (const axlePositionIdentifier_type& x);

    void
    axlePositionIdentifier (::std::auto_ptr< axlePositionIdentifier_type > p);

    // axleWeight
    // 
    typedef ::datex2::Tonnes axleWeight_type;
    typedef ::xsd::cxx::tree::optional< axleWeight_type > axleWeight_optional;
    typedef ::xsd::cxx::tree::traits< axleWeight_type, char > axleWeight_traits;

    const axleWeight_optional&
    axleWeight () const;

    axleWeight_optional&
    axleWeight ();

    void
    axleWeight (const axleWeight_type& x);

    void
    axleWeight (const axleWeight_optional& x);

    void
    axleWeight (::std::auto_ptr< axleWeight_type > p);

    // maximumPermittedAxleWeight
    // 
    typedef ::datex2::Tonnes maximumPermittedAxleWeight_type;
    typedef ::xsd::cxx::tree::optional< maximumPermittedAxleWeight_type > maximumPermittedAxleWeight_optional;
    typedef ::xsd::cxx::tree::traits< maximumPermittedAxleWeight_type, char > maximumPermittedAxleWeight_traits;

    const maximumPermittedAxleWeight_optional&
    maximumPermittedAxleWeight () const;

    maximumPermittedAxleWeight_optional&
    maximumPermittedAxleWeight ();

    void
    maximumPermittedAxleWeight (const maximumPermittedAxleWeight_type& x);

    void
    maximumPermittedAxleWeight (const maximumPermittedAxleWeight_optional& x);

    void
    maximumPermittedAxleWeight (::std::auto_ptr< maximumPermittedAxleWeight_type > p);

    // axleWeightExtension
    // 
    typedef ::datex2::ExtensionType axleWeightExtension_type;
    typedef ::xsd::cxx::tree::optional< axleWeightExtension_type > axleWeightExtension_optional;
    typedef ::xsd::cxx::tree::traits< axleWeightExtension_type, char > axleWeightExtension_traits;

    const axleWeightExtension_optional&
    axleWeightExtension () const;

    axleWeightExtension_optional&
    axleWeightExtension ();

    void
    axleWeightExtension (const axleWeightExtension_type& x);

    void
    axleWeightExtension (const axleWeightExtension_optional& x);

    void
    axleWeightExtension (::std::auto_ptr< axleWeightExtension_type > p);

    // Constructors.
    //
    AxleWeight (const axlePositionIdentifier_type&);

    AxleWeight (const xercesc::DOMElement& e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    AxleWeight (const AxleWeight& x,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    virtual AxleWeight*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AxleWeight ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< axlePositionIdentifier_type > axlePositionIdentifier_;
    axleWeight_optional axleWeight_;
    maximumPermittedAxleWeight_optional maximumPermittedAxleWeight_;
    axleWeightExtension_optional axleWeightExtension_;
  };

  class BasicDataValue: public ::xml_schema::type
  {
    public:
    // accuracy
    // 
    typedef ::datex2::Percentage accuracy_type;
    typedef ::xsd::cxx::tree::optional< accuracy_type > accuracy_optional;
    typedef ::xsd::cxx::tree::traits< accuracy_type, char > accuracy_traits;

    const accuracy_optional&
    accuracy () const;

    accuracy_optional&
    accuracy ();

    void
    accuracy (const accuracy_type& x);

    void
    accuracy (const accuracy_optional& x);

    void
    accuracy (::std::auto_ptr< accuracy_type > p);

    // computationalMethod
    // 
    typedef ::datex2::ComputationMethodEnum computationalMethod_type;
    typedef ::xsd::cxx::tree::optional< computationalMethod_type > computationalMethod_optional;
    typedef ::xsd::cxx::tree::traits< computationalMethod_type, char > computationalMethod_traits;

    const computationalMethod_optional&
    computationalMethod () const;

    computationalMethod_optional&
    computationalMethod ();

    void
    computationalMethod (const computationalMethod_type& x);

    void
    computationalMethod (const computationalMethod_optional& x);

    void
    computationalMethod (::std::auto_ptr< computationalMethod_type > p);

    // fault
    // 
    typedef ::datex2::Boolean fault_type;
    typedef ::xsd::cxx::tree::optional< fault_type > fault_optional;
    typedef ::xsd::cxx::tree::traits< fault_type, char > fault_traits;

    const fault_optional&
    fault () const;

    fault_optional&
    fault ();

    void
    fault (const fault_type& x);

    void
    fault (const fault_optional& x);

    void
    fault (::std::auto_ptr< fault_type > p);

    // faultReason
    // 
    typedef ::datex2::MultilingualString faultReason_type;
    typedef ::xsd::cxx::tree::optional< faultReason_type > faultReason_optional;
    typedef ::xsd::cxx::tree::traits< faultReason_type, char > faultReason_traits;

    const faultReason_optional&
    faultReason () const;

    faultReason_optional&
    faultReason ();

    void
    faultReason (const faultReason_type& x);

    void
    faultReason (const faultReason_optional& x);

    void
    faultReason (::std::auto_ptr< faultReason_type > p);

    // numberOfIncompleteInputs
    // 
    typedef ::datex2::NonNegativeInteger numberOfIncompleteInputs_type;
    typedef ::xsd::cxx::tree::optional< numberOfIncompleteInputs_type > numberOfIncompleteInputs_optional;
    typedef ::xsd::cxx::tree::traits< numberOfIncompleteInputs_type, char > numberOfIncompleteInputs_traits;

    const numberOfIncompleteInputs_optional&
    numberOfIncompleteInputs () const;

    numberOfIncompleteInputs_optional&
    numberOfIncompleteInputs ();

    void
    numberOfIncompleteInputs (const numberOfIncompleteInputs_type& x);

    void
    numberOfIncompleteInputs (const numberOfIncompleteInputs_optional& x);

    void
    numberOfIncompleteInputs (::std::auto_ptr< numberOfIncompleteInputs_type > p);

    // numberOfInputValuesUsed
    // 
    typedef ::datex2::NonNegativeInteger numberOfInputValuesUsed_type;
    typedef ::xsd::cxx::tree::optional< numberOfInputValuesUsed_type > numberOfInputValuesUsed_optional;
    typedef ::xsd::cxx::tree::traits< numberOfInputValuesUsed_type, char > numberOfInputValuesUsed_traits;

    const numberOfInputValuesUsed_optional&
    numberOfInputValuesUsed () const;

    numberOfInputValuesUsed_optional&
    numberOfInputValuesUsed ();

    void
    numberOfInputValuesUsed (const numberOfInputValuesUsed_type& x);

    void
    numberOfInputValuesUsed (const numberOfInputValuesUsed_optional& x);

    void
    numberOfInputValuesUsed (::std::auto_ptr< numberOfInputValuesUsed_type > p);

    // period
    // 
    typedef ::datex2::Seconds period_type;
    typedef ::xsd::cxx::tree::optional< period_type > period_optional;
    typedef ::xsd::cxx::tree::traits< period_type, char > period_traits;

    const period_optional&
    period () const;

    period_optional&
    period ();

    void
    period (const period_type& x);

    void
    period (const period_optional& x);

    void
    period (::std::auto_ptr< period_type > p);

    // smoothingFactor
    // 
    typedef ::datex2::Float smoothingFactor_type;
    typedef ::xsd::cxx::tree::optional< smoothingFactor_type > smoothingFactor_optional;
    typedef ::xsd::cxx::tree::traits< smoothingFactor_type, char > smoothingFactor_traits;

    const smoothingFactor_optional&
    smoothingFactor () const;

    smoothingFactor_optional&
    smoothingFactor ();

    void
    smoothingFactor (const smoothingFactor_type& x);

    void
    smoothingFactor (const smoothingFactor_optional& x);

    void
    smoothingFactor (::std::auto_ptr< smoothingFactor_type > p);

    // standardDeviation
    // 
    typedef ::datex2::Float standardDeviation_type;
    typedef ::xsd::cxx::tree::optional< standardDeviation_type > standardDeviation_optional;
    typedef ::xsd::cxx::tree::traits< standardDeviation_type, char > standardDeviation_traits;

    const standardDeviation_optional&
    standardDeviation () const;

    standardDeviation_optional&
    standardDeviation ();

    void
    standardDeviation (const standardDeviation_type& x);

    void
    standardDeviation (const standardDeviation_optional& x);

    void
    standardDeviation (::std::auto_ptr< standardDeviation_type > p);

    // supplierCalculatedDataQuality
    // 
    typedef ::datex2::Percentage supplierCalculatedDataQuality_type;
    typedef ::xsd::cxx::tree::optional< supplierCalculatedDataQuality_type > supplierCalculatedDataQuality_optional;
    typedef ::xsd::cxx::tree::traits< supplierCalculatedDataQuality_type, char > supplierCalculatedDataQuality_traits;

    const supplierCalculatedDataQuality_optional&
    supplierCalculatedDataQuality () const;

    supplierCalculatedDataQuality_optional&
    supplierCalculatedDataQuality ();

    void
    supplierCalculatedDataQuality (const supplierCalculatedDataQuality_type& x);

    void
    supplierCalculatedDataQuality (const supplierCalculatedDataQuality_optional& x);

    void
    supplierCalculatedDataQuality (::std::auto_ptr< supplierCalculatedDataQuality_type > p);

    // time
    // 
    typedef ::datex2::DateTime time_type;
    typedef ::xsd::cxx::tree::optional< time_type > time_optional;
    typedef ::xsd::cxx::tree::traits< time_type, char > time_traits;

    const time_optional&
    time () const;

    time_optional&
    time ();

    void
    time (const time_type& x);

    void
    time (const time_optional& x);

    void
    time (::std::auto_ptr< time_type > p);

    // pertinentLocation
    // 
    typedef ::datex2::GroupOfLocations pertinentLocation_type;
    typedef ::xsd::cxx::tree::optional< pertinentLocation_type > pertinentLocation_optional;
    typedef ::xsd::cxx::tree::traits< pertinentLocation_type, char > pertinentLocation_traits;

    const pertinentLocation_optional&
    pertinentLocation () const;

    pertinentLocation_optional&
    pertinentLocation ();

    void
    pertinentLocation (const pertinentLocation_type& x);

    void
    pertinentLocation (const pertinentLocation_optional& x);

    void
    pertinentLocation (::std::auto_ptr< pertinentLocation_type > p);

    // basicDataValueExtension
    // 
    typedef ::datex2::ExtensionType basicDataValueExtension_type;
    typedef ::xsd::cxx::tree::optional< basicDataValueExtension_type > basicDataValueExtension_optional;
    typedef ::xsd::cxx::tree::traits< basicDataValueExtension_type, char > basicDataValueExtension_traits;

    const basicDataValueExtension_optional&
    basicDataValueExtension () const;

    basicDataValueExtension_optional&
    basicDataValueExtension ();

    void
    basicDataValueExtension (const basicDataValueExtension_type& x);

    void
    basicDataValueExtension (const basicDataValueExtension_optional& x);

    void
    basicDataValueExtension (::std::auto_ptr< basicDataValueExtension_type > p);

    // Constructors.
    //
    BasicDataValue ();

    BasicDataValue (const xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    BasicDataValue (const BasicDataValue& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual BasicDataValue*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~BasicDataValue ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    accuracy_optional accuracy_;
    computationalMethod_optional computationalMethod_;
    fault_optional fault_;
    faultReason_optional faultReason_;
    numberOfIncompleteInputs_optional numberOfIncompleteInputs_;
    numberOfInputValuesUsed_optional numberOfInputValuesUsed_;
    period_optional period_;
    smoothingFactor_optional smoothingFactor_;
    standardDeviation_optional standardDeviation_;
    supplierCalculatedDataQuality_optional supplierCalculatedDataQuality_;
    time_optional time_;
    pertinentLocation_optional pertinentLocation_;
    basicDataValueExtension_optional basicDataValueExtension_;
  };

  class Boolean: public ::xsd::cxx::tree::fundamental_base< ::xml_schema::boolean, char, ::xml_schema::simple_type >
  {
    public:
    // Constructors.
    //
    Boolean (const ::xml_schema::boolean&);

    Boolean (const xercesc::DOMElement& e,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    Boolean (const xercesc::DOMAttr& a,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    Boolean (const ::std::string& s,
             const xercesc::DOMElement* e,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    Boolean (const Boolean& x,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    virtual Boolean*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Boolean ();
  };

  class CarParkConfigurationEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      multiStorey,
      parkAndRide,
      singleLevel,
      underground
    };

    CarParkConfigurationEnum (value v);

    CarParkConfigurationEnum (const char* v);

    CarParkConfigurationEnum (const ::std::string& v);

    CarParkConfigurationEnum (const ::xml_schema::string& v);

    CarParkConfigurationEnum (const xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    CarParkConfigurationEnum (const xercesc::DOMAttr& a,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    CarParkConfigurationEnum (const ::std::string& s,
                              const xercesc::DOMElement* e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    CarParkConfigurationEnum (const CarParkConfigurationEnum& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual CarParkConfigurationEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    CarParkConfigurationEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_CarParkConfigurationEnum_convert ();
    }

    protected:
    value
    _xsd_CarParkConfigurationEnum_convert () const;

    public:
    static const char* const _xsd_CarParkConfigurationEnum_literals_[4];
    static const value _xsd_CarParkConfigurationEnum_indexes_[4];
  };

  class NonRoadEventInformation: public ::datex2::SituationRecord
  {
    public:
    // nonRoadEventInformationExtension
    // 
    typedef ::datex2::ExtensionType nonRoadEventInformationExtension_type;
    typedef ::xsd::cxx::tree::optional< nonRoadEventInformationExtension_type > nonRoadEventInformationExtension_optional;
    typedef ::xsd::cxx::tree::traits< nonRoadEventInformationExtension_type, char > nonRoadEventInformationExtension_traits;

    const nonRoadEventInformationExtension_optional&
    nonRoadEventInformationExtension () const;

    nonRoadEventInformationExtension_optional&
    nonRoadEventInformationExtension ();

    void
    nonRoadEventInformationExtension (const nonRoadEventInformationExtension_type& x);

    void
    nonRoadEventInformationExtension (const nonRoadEventInformationExtension_optional& x);

    void
    nonRoadEventInformationExtension (::std::auto_ptr< nonRoadEventInformationExtension_type > p);

    // Constructors.
    //
    NonRoadEventInformation (const situationRecordCreationTime_type&,
                             const situationRecordVersion_type&,
                             const situationRecordVersionTime_type&,
                             const probabilityOfOccurrence_type&,
                             const validity_type&,
                             const groupOfLocations_type&,
                             const id_type&);

    NonRoadEventInformation (const situationRecordCreationTime_type&,
                             const situationRecordVersion_type&,
                             const situationRecordVersionTime_type&,
                             const probabilityOfOccurrence_type&,
                             ::std::auto_ptr< validity_type >&,
                             ::std::auto_ptr< groupOfLocations_type >&,
                             const id_type&);

    NonRoadEventInformation (const xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    NonRoadEventInformation (const NonRoadEventInformation& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual NonRoadEventInformation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~NonRoadEventInformation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    nonRoadEventInformationExtension_optional nonRoadEventInformationExtension_;
  };

  class CarParks: public ::datex2::NonRoadEventInformation
  {
    public:
    // carParkConfiguration
    // 
    typedef ::datex2::CarParkConfigurationEnum carParkConfiguration_type;
    typedef ::xsd::cxx::tree::optional< carParkConfiguration_type > carParkConfiguration_optional;
    typedef ::xsd::cxx::tree::traits< carParkConfiguration_type, char > carParkConfiguration_traits;

    const carParkConfiguration_optional&
    carParkConfiguration () const;

    carParkConfiguration_optional&
    carParkConfiguration ();

    void
    carParkConfiguration (const carParkConfiguration_type& x);

    void
    carParkConfiguration (const carParkConfiguration_optional& x);

    void
    carParkConfiguration (::std::auto_ptr< carParkConfiguration_type > p);

    // carParkIdentity
    // 
    typedef ::datex2::String carParkIdentity_type;
    typedef ::xsd::cxx::tree::traits< carParkIdentity_type, char > carParkIdentity_traits;

    const carParkIdentity_type&
    carParkIdentity () const;

    carParkIdentity_type&
    carParkIdentity ();

    void
    carParkIdentity (const carParkIdentity_type& x);

    void
    carParkIdentity (::std::auto_ptr< carParkIdentity_type > p);

    // carParkOccupancy
    // 
    typedef ::datex2::Percentage carParkOccupancy_type;
    typedef ::xsd::cxx::tree::optional< carParkOccupancy_type > carParkOccupancy_optional;
    typedef ::xsd::cxx::tree::traits< carParkOccupancy_type, char > carParkOccupancy_traits;

    const carParkOccupancy_optional&
    carParkOccupancy () const;

    carParkOccupancy_optional&
    carParkOccupancy ();

    void
    carParkOccupancy (const carParkOccupancy_type& x);

    void
    carParkOccupancy (const carParkOccupancy_optional& x);

    void
    carParkOccupancy (::std::auto_ptr< carParkOccupancy_type > p);

    // carParkStatus
    // 
    typedef ::datex2::CarParkStatusEnum carParkStatus_type;
    typedef ::xsd::cxx::tree::optional< carParkStatus_type > carParkStatus_optional;
    typedef ::xsd::cxx::tree::traits< carParkStatus_type, char > carParkStatus_traits;

    const carParkStatus_optional&
    carParkStatus () const;

    carParkStatus_optional&
    carParkStatus ();

    void
    carParkStatus (const carParkStatus_type& x);

    void
    carParkStatus (const carParkStatus_optional& x);

    void
    carParkStatus (::std::auto_ptr< carParkStatus_type > p);

    // exitRate
    // 
    typedef ::datex2::VehiclesPerHour exitRate_type;
    typedef ::xsd::cxx::tree::optional< exitRate_type > exitRate_optional;
    typedef ::xsd::cxx::tree::traits< exitRate_type, char > exitRate_traits;

    const exitRate_optional&
    exitRate () const;

    exitRate_optional&
    exitRate ();

    void
    exitRate (const exitRate_type& x);

    void
    exitRate (const exitRate_optional& x);

    void
    exitRate (::std::auto_ptr< exitRate_type > p);

    // fillRate
    // 
    typedef ::datex2::VehiclesPerHour fillRate_type;
    typedef ::xsd::cxx::tree::optional< fillRate_type > fillRate_optional;
    typedef ::xsd::cxx::tree::traits< fillRate_type, char > fillRate_traits;

    const fillRate_optional&
    fillRate () const;

    fillRate_optional&
    fillRate ();

    void
    fillRate (const fillRate_type& x);

    void
    fillRate (const fillRate_optional& x);

    void
    fillRate (::std::auto_ptr< fillRate_type > p);

    // numberOfVacantParkingSpaces
    // 
    typedef ::datex2::NonNegativeInteger numberOfVacantParkingSpaces_type;
    typedef ::xsd::cxx::tree::optional< numberOfVacantParkingSpaces_type > numberOfVacantParkingSpaces_optional;
    typedef ::xsd::cxx::tree::traits< numberOfVacantParkingSpaces_type, char > numberOfVacantParkingSpaces_traits;

    const numberOfVacantParkingSpaces_optional&
    numberOfVacantParkingSpaces () const;

    numberOfVacantParkingSpaces_optional&
    numberOfVacantParkingSpaces ();

    void
    numberOfVacantParkingSpaces (const numberOfVacantParkingSpaces_type& x);

    void
    numberOfVacantParkingSpaces (const numberOfVacantParkingSpaces_optional& x);

    void
    numberOfVacantParkingSpaces (::std::auto_ptr< numberOfVacantParkingSpaces_type > p);

    // occupiedSpaces
    // 
    typedef ::datex2::NonNegativeInteger occupiedSpaces_type;
    typedef ::xsd::cxx::tree::optional< occupiedSpaces_type > occupiedSpaces_optional;
    typedef ::xsd::cxx::tree::traits< occupiedSpaces_type, char > occupiedSpaces_traits;

    const occupiedSpaces_optional&
    occupiedSpaces () const;

    occupiedSpaces_optional&
    occupiedSpaces ();

    void
    occupiedSpaces (const occupiedSpaces_type& x);

    void
    occupiedSpaces (const occupiedSpaces_optional& x);

    void
    occupiedSpaces (::std::auto_ptr< occupiedSpaces_type > p);

    // queueingTime
    // 
    typedef ::datex2::Seconds queueingTime_type;
    typedef ::xsd::cxx::tree::optional< queueingTime_type > queueingTime_optional;
    typedef ::xsd::cxx::tree::traits< queueingTime_type, char > queueingTime_traits;

    const queueingTime_optional&
    queueingTime () const;

    queueingTime_optional&
    queueingTime ();

    void
    queueingTime (const queueingTime_type& x);

    void
    queueingTime (const queueingTime_optional& x);

    void
    queueingTime (::std::auto_ptr< queueingTime_type > p);

    // totalCapacity
    // 
    typedef ::datex2::NonNegativeInteger totalCapacity_type;
    typedef ::xsd::cxx::tree::optional< totalCapacity_type > totalCapacity_optional;
    typedef ::xsd::cxx::tree::traits< totalCapacity_type, char > totalCapacity_traits;

    const totalCapacity_optional&
    totalCapacity () const;

    totalCapacity_optional&
    totalCapacity ();

    void
    totalCapacity (const totalCapacity_type& x);

    void
    totalCapacity (const totalCapacity_optional& x);

    void
    totalCapacity (::std::auto_ptr< totalCapacity_type > p);

    // carParksExtension
    // 
    typedef ::datex2::ExtensionType carParksExtension_type;
    typedef ::xsd::cxx::tree::optional< carParksExtension_type > carParksExtension_optional;
    typedef ::xsd::cxx::tree::traits< carParksExtension_type, char > carParksExtension_traits;

    const carParksExtension_optional&
    carParksExtension () const;

    carParksExtension_optional&
    carParksExtension ();

    void
    carParksExtension (const carParksExtension_type& x);

    void
    carParksExtension (const carParksExtension_optional& x);

    void
    carParksExtension (::std::auto_ptr< carParksExtension_type > p);

    // Constructors.
    //
    CarParks (const situationRecordCreationTime_type&,
              const situationRecordVersion_type&,
              const situationRecordVersionTime_type&,
              const probabilityOfOccurrence_type&,
              const validity_type&,
              const groupOfLocations_type&,
              const id_type&,
              const carParkIdentity_type&);

    CarParks (const situationRecordCreationTime_type&,
              const situationRecordVersion_type&,
              const situationRecordVersionTime_type&,
              const probabilityOfOccurrence_type&,
              ::std::auto_ptr< validity_type >&,
              ::std::auto_ptr< groupOfLocations_type >&,
              const id_type&,
              const carParkIdentity_type&);

    CarParks (const xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    CarParks (const CarParks& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual CarParks*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CarParks ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    carParkConfiguration_optional carParkConfiguration_;
    ::xsd::cxx::tree::one< carParkIdentity_type > carParkIdentity_;
    carParkOccupancy_optional carParkOccupancy_;
    carParkStatus_optional carParkStatus_;
    exitRate_optional exitRate_;
    fillRate_optional fillRate_;
    numberOfVacantParkingSpaces_optional numberOfVacantParkingSpaces_;
    occupiedSpaces_optional occupiedSpaces_;
    queueingTime_optional queueingTime_;
    totalCapacity_optional totalCapacity_;
    carParksExtension_optional carParksExtension_;
  };

  class CarParkStatusEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      carParkClosed,
      allCarParksFull,
      carParkFacilityFaulty,
      carParkFull,
      carParkStatusUnknown,
      enoughSpacesAvailable,
      multiStoryCarParksFull,
      noMoreParkingSpacesAvailable,
      noParkAndRideInformation,
      noParkingAllowed,
      noParkingInformationAvailable,
      normalParkingRestrictionsLifted,
      onlyAFewSpacesAvailable,
      parkAndRideServiceNotOperating,
      parkAndRideServiceOperating,
      specialParkingRestrictionsInForce
    };

    CarParkStatusEnum (value v);

    CarParkStatusEnum (const char* v);

    CarParkStatusEnum (const ::std::string& v);

    CarParkStatusEnum (const ::xml_schema::string& v);

    CarParkStatusEnum (const xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    CarParkStatusEnum (const xercesc::DOMAttr& a,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    CarParkStatusEnum (const ::std::string& s,
                       const xercesc::DOMElement* e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    CarParkStatusEnum (const CarParkStatusEnum& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual CarParkStatusEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    CarParkStatusEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_CarParkStatusEnum_convert ();
    }

    protected:
    value
    _xsd_CarParkStatusEnum_convert () const;

    public:
    static const char* const _xsd_CarParkStatusEnum_literals_[16];
    static const value _xsd_CarParkStatusEnum_indexes_[16];
  };

  class CarriagewayEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      connectingCarriageway,
      entrySlipRoad,
      exitSlipRoad,
      flyover,
      leftHandFeederRoad,
      leftHandParallelCarriageway,
      mainCarriageway,
      oppositeCarriageway,
      parallelCarriageway,
      rightHandFeederRoad,
      rightHandParallelCarriageway,
      serviceRoad,
      slipRoads,
      underpass
    };

    CarriagewayEnum (value v);

    CarriagewayEnum (const char* v);

    CarriagewayEnum (const ::std::string& v);

    CarriagewayEnum (const ::xml_schema::string& v);

    CarriagewayEnum (const xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    CarriagewayEnum (const xercesc::DOMAttr& a,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    CarriagewayEnum (const ::std::string& s,
                     const xercesc::DOMElement* e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    CarriagewayEnum (const CarriagewayEnum& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual CarriagewayEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    CarriagewayEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_CarriagewayEnum_convert ();
    }

    protected:
    value
    _xsd_CarriagewayEnum_convert () const;

    public:
    static const char* const _xsd_CarriagewayEnum_literals_[14];
    static const value _xsd_CarriagewayEnum_indexes_[14];
  };

  class CatalogueReference: public ::xml_schema::type
  {
    public:
    // keyCatalogueReference
    // 
    typedef ::datex2::Reference keyCatalogueReference_type;
    typedef ::xsd::cxx::tree::traits< keyCatalogueReference_type, char > keyCatalogueReference_traits;

    const keyCatalogueReference_type&
    keyCatalogueReference () const;

    keyCatalogueReference_type&
    keyCatalogueReference ();

    void
    keyCatalogueReference (const keyCatalogueReference_type& x);

    void
    keyCatalogueReference (::std::auto_ptr< keyCatalogueReference_type > p);

    // catalogueReferenceExtension
    // 
    typedef ::datex2::ExtensionType catalogueReferenceExtension_type;
    typedef ::xsd::cxx::tree::optional< catalogueReferenceExtension_type > catalogueReferenceExtension_optional;
    typedef ::xsd::cxx::tree::traits< catalogueReferenceExtension_type, char > catalogueReferenceExtension_traits;

    const catalogueReferenceExtension_optional&
    catalogueReferenceExtension () const;

    catalogueReferenceExtension_optional&
    catalogueReferenceExtension ();

    void
    catalogueReferenceExtension (const catalogueReferenceExtension_type& x);

    void
    catalogueReferenceExtension (const catalogueReferenceExtension_optional& x);

    void
    catalogueReferenceExtension (::std::auto_ptr< catalogueReferenceExtension_type > p);

    // Constructors.
    //
    CatalogueReference (const keyCatalogueReference_type&);

    CatalogueReference (const xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    CatalogueReference (const CatalogueReference& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual CatalogueReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CatalogueReference ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< keyCatalogueReference_type > keyCatalogueReference_;
    catalogueReferenceExtension_optional catalogueReferenceExtension_;
  };

  class Cause: public ::xml_schema::type
  {
    public:
    // causeExtension
    // 
    typedef ::datex2::ExtensionType causeExtension_type;
    typedef ::xsd::cxx::tree::optional< causeExtension_type > causeExtension_optional;
    typedef ::xsd::cxx::tree::traits< causeExtension_type, char > causeExtension_traits;

    const causeExtension_optional&
    causeExtension () const;

    causeExtension_optional&
    causeExtension ();

    void
    causeExtension (const causeExtension_type& x);

    void
    causeExtension (const causeExtension_optional& x);

    void
    causeExtension (::std::auto_ptr< causeExtension_type > p);

    // Constructors.
    //
    Cause ();

    Cause (const xercesc::DOMElement& e,
           ::xml_schema::flags f = 0,
           ::xml_schema::container* c = 0);

    Cause (const Cause& x,
           ::xml_schema::flags f = 0,
           ::xml_schema::container* c = 0);

    virtual Cause*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Cause ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    causeExtension_optional causeExtension_;
  };

  class CauseTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      accident,
      congestion,
      earlierAccident,
      earlierEvent,
      earlierIncident,
      equipmentFailure,
      excessiveHeat,
      frost,
      holidayTraffic,
      infrastructureFailure,
      largeNumbersOfVisitors,
      obstruction,
      pollutionAlert,
      poorWeather,
      problemsAtBorderPost,
      problemsAtCustomPost,
      problemsOnLocalRoads,
      radioactiveLeekAlert,
      roadsideEvent,
      rubberNecking,
      securityIncident,
      shearWeightOfTraffic,
      technicalProblems,
      terrorism,
      toxicCloudAlert,
      vandalism,
      other
    };

    CauseTypeEnum (value v);

    CauseTypeEnum (const char* v);

    CauseTypeEnum (const ::std::string& v);

    CauseTypeEnum (const ::xml_schema::string& v);

    CauseTypeEnum (const xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    CauseTypeEnum (const xercesc::DOMAttr& a,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    CauseTypeEnum (const ::std::string& s,
                   const xercesc::DOMElement* e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    CauseTypeEnum (const CauseTypeEnum& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual CauseTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    CauseTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_CauseTypeEnum_convert ();
    }

    protected:
    value
    _xsd_CauseTypeEnum_convert () const;

    public:
    static const char* const _xsd_CauseTypeEnum_literals_[27];
    static const value _xsd_CauseTypeEnum_indexes_[27];
  };

  class ChangedFlagEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      catalogue,
      filter
    };

    ChangedFlagEnum (value v);

    ChangedFlagEnum (const char* v);

    ChangedFlagEnum (const ::std::string& v);

    ChangedFlagEnum (const ::xml_schema::string& v);

    ChangedFlagEnum (const xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    ChangedFlagEnum (const xercesc::DOMAttr& a,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    ChangedFlagEnum (const ::std::string& s,
                     const xercesc::DOMElement* e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    ChangedFlagEnum (const ChangedFlagEnum& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual ChangedFlagEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    ChangedFlagEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_ChangedFlagEnum_convert ();
    }

    protected:
    value
    _xsd_ChangedFlagEnum_convert () const;

    public:
    static const char* const _xsd_ChangedFlagEnum_literals_[2];
    static const value _xsd_ChangedFlagEnum_indexes_[2];
  };

  class Comment: public ::xml_schema::type
  {
    public:
    // comment
    // 
    typedef ::datex2::MultilingualString comment_type;
    typedef ::xsd::cxx::tree::traits< comment_type, char > comment_traits;

    const comment_type&
    comment () const;

    comment_type&
    comment ();

    void
    comment (const comment_type& x);

    void
    comment (::std::auto_ptr< comment_type > p);

    // commentDateTime
    // 
    typedef ::datex2::DateTime commentDateTime_type;
    typedef ::xsd::cxx::tree::optional< commentDateTime_type > commentDateTime_optional;
    typedef ::xsd::cxx::tree::traits< commentDateTime_type, char > commentDateTime_traits;

    const commentDateTime_optional&
    commentDateTime () const;

    commentDateTime_optional&
    commentDateTime ();

    void
    commentDateTime (const commentDateTime_type& x);

    void
    commentDateTime (const commentDateTime_optional& x);

    void
    commentDateTime (::std::auto_ptr< commentDateTime_type > p);

    // commentExtension
    // 
    typedef ::datex2::ExtensionType commentExtension_type;
    typedef ::xsd::cxx::tree::optional< commentExtension_type > commentExtension_optional;
    typedef ::xsd::cxx::tree::traits< commentExtension_type, char > commentExtension_traits;

    const commentExtension_optional&
    commentExtension () const;

    commentExtension_optional&
    commentExtension ();

    void
    commentExtension (const commentExtension_type& x);

    void
    commentExtension (const commentExtension_optional& x);

    void
    commentExtension (::std::auto_ptr< commentExtension_type > p);

    // Constructors.
    //
    Comment (const comment_type&);

    Comment (::std::auto_ptr< comment_type >&);

    Comment (const xercesc::DOMElement& e,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    Comment (const Comment& x,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    virtual Comment*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Comment ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< comment_type > comment_;
    commentDateTime_optional commentDateTime_;
    commentExtension_optional commentExtension_;
  };

  class ComparisonOperatorEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      equalTo,
      greaterThan,
      greatherThanOrEqualTo,
      lessThan,
      lessThanOrEqualTo
    };

    ComparisonOperatorEnum (value v);

    ComparisonOperatorEnum (const char* v);

    ComparisonOperatorEnum (const ::std::string& v);

    ComparisonOperatorEnum (const ::xml_schema::string& v);

    ComparisonOperatorEnum (const xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    ComparisonOperatorEnum (const xercesc::DOMAttr& a,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    ComparisonOperatorEnum (const ::std::string& s,
                            const xercesc::DOMElement* e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    ComparisonOperatorEnum (const ComparisonOperatorEnum& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual ComparisonOperatorEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    ComparisonOperatorEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_ComparisonOperatorEnum_convert ();
    }

    protected:
    value
    _xsd_ComparisonOperatorEnum_convert () const;

    public:
    static const char* const _xsd_ComparisonOperatorEnum_literals_[5];
    static const value _xsd_ComparisonOperatorEnum_indexes_[5];
  };

  class ComplianceOptionEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      advisory,
      mandatory
    };

    ComplianceOptionEnum (value v);

    ComplianceOptionEnum (const char* v);

    ComplianceOptionEnum (const ::std::string& v);

    ComplianceOptionEnum (const ::xml_schema::string& v);

    ComplianceOptionEnum (const xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    ComplianceOptionEnum (const xercesc::DOMAttr& a,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    ComplianceOptionEnum (const ::std::string& s,
                          const xercesc::DOMElement* e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    ComplianceOptionEnum (const ComplianceOptionEnum& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual ComplianceOptionEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    ComplianceOptionEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_ComplianceOptionEnum_convert ();
    }

    protected:
    value
    _xsd_ComplianceOptionEnum_convert () const;

    public:
    static const char* const _xsd_ComplianceOptionEnum_literals_[2];
    static const value _xsd_ComplianceOptionEnum_indexes_[2];
  };

  class ComputationMethodEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      arithmeticAverageOfSamplesBasedOnAFixedNumberOfSamples,
      arithmeticAverageOfSamplesInATimePeriod,
      harmonicAverageOfSamplesInATimePeriod,
      medianOfSamplesInATimePeriod,
      movingAverageOfSamples
    };

    ComputationMethodEnum (value v);

    ComputationMethodEnum (const char* v);

    ComputationMethodEnum (const ::std::string& v);

    ComputationMethodEnum (const ::xml_schema::string& v);

    ComputationMethodEnum (const xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    ComputationMethodEnum (const xercesc::DOMAttr& a,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    ComputationMethodEnum (const ::std::string& s,
                           const xercesc::DOMElement* e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    ComputationMethodEnum (const ComputationMethodEnum& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual ComputationMethodEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    ComputationMethodEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_ComputationMethodEnum_convert ();
    }

    protected:
    value
    _xsd_ComputationMethodEnum_convert () const;

    public:
    static const char* const _xsd_ComputationMethodEnum_literals_[5];
    static const value _xsd_ComputationMethodEnum_indexes_[5];
  };

  class Float: public ::xsd::cxx::tree::fundamental_base< ::xml_schema::float_, char, ::xml_schema::simple_type >
  {
    public:
    // Constructors.
    //
    Float (const ::xml_schema::float_&);

    Float (const xercesc::DOMElement& e,
           ::xml_schema::flags f = 0,
           ::xml_schema::container* c = 0);

    Float (const xercesc::DOMAttr& a,
           ::xml_schema::flags f = 0,
           ::xml_schema::container* c = 0);

    Float (const ::std::string& s,
           const xercesc::DOMElement* e,
           ::xml_schema::flags f = 0,
           ::xml_schema::container* c = 0);

    Float (const Float& x,
           ::xml_schema::flags f = 0,
           ::xml_schema::container* c = 0);

    virtual Float*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Float ();
  };

  class ConcentrationGramsPerCubicCentimetre: public ::datex2::Float
  {
    public:
    // Constructors.
    //
    ConcentrationGramsPerCubicCentimetre (const ::xml_schema::float_&);

    ConcentrationGramsPerCubicCentimetre (const xercesc::DOMElement& e,
                                          ::xml_schema::flags f = 0,
                                          ::xml_schema::container* c = 0);

    ConcentrationGramsPerCubicCentimetre (const xercesc::DOMAttr& a,
                                          ::xml_schema::flags f = 0,
                                          ::xml_schema::container* c = 0);

    ConcentrationGramsPerCubicCentimetre (const ::std::string& s,
                                          const xercesc::DOMElement* e,
                                          ::xml_schema::flags f = 0,
                                          ::xml_schema::container* c = 0);

    ConcentrationGramsPerCubicCentimetre (const ConcentrationGramsPerCubicCentimetre& x,
                                          ::xml_schema::flags f = 0,
                                          ::xml_schema::container* c = 0);

    virtual ConcentrationGramsPerCubicCentimetre*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ConcentrationGramsPerCubicCentimetre ();
  };

  class ConcentrationMicrogramsPerCubicMetre: public ::datex2::Float
  {
    public:
    // Constructors.
    //
    ConcentrationMicrogramsPerCubicMetre (const ::xml_schema::float_&);

    ConcentrationMicrogramsPerCubicMetre (const xercesc::DOMElement& e,
                                          ::xml_schema::flags f = 0,
                                          ::xml_schema::container* c = 0);

    ConcentrationMicrogramsPerCubicMetre (const xercesc::DOMAttr& a,
                                          ::xml_schema::flags f = 0,
                                          ::xml_schema::container* c = 0);

    ConcentrationMicrogramsPerCubicMetre (const ::std::string& s,
                                          const xercesc::DOMElement* e,
                                          ::xml_schema::flags f = 0,
                                          ::xml_schema::container* c = 0);

    ConcentrationMicrogramsPerCubicMetre (const ConcentrationMicrogramsPerCubicMetre& x,
                                          ::xml_schema::flags f = 0,
                                          ::xml_schema::container* c = 0);

    virtual ConcentrationMicrogramsPerCubicMetre*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ConcentrationMicrogramsPerCubicMetre ();
  };

  class ConcentrationVehiclesPerKilometre: public ::datex2::NonNegativeInteger
  {
    public:
    // Constructors.
    //
    ConcentrationVehiclesPerKilometre (const ::xml_schema::non_negative_integer&);

    ConcentrationVehiclesPerKilometre (const xercesc::DOMElement& e,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    ConcentrationVehiclesPerKilometre (const xercesc::DOMAttr& a,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    ConcentrationVehiclesPerKilometre (const ::std::string& s,
                                       const xercesc::DOMElement* e,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    ConcentrationVehiclesPerKilometre (const ConcentrationVehiclesPerKilometre& x,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    virtual ConcentrationVehiclesPerKilometre*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ConcentrationVehiclesPerKilometre ();
  };

  class Conditions: public ::datex2::TrafficElement
  {
    public:
    // drivingConditionType
    // 
    typedef ::datex2::DrivingConditionTypeEnum drivingConditionType_type;
    typedef ::xsd::cxx::tree::optional< drivingConditionType_type > drivingConditionType_optional;
    typedef ::xsd::cxx::tree::traits< drivingConditionType_type, char > drivingConditionType_traits;

    const drivingConditionType_optional&
    drivingConditionType () const;

    drivingConditionType_optional&
    drivingConditionType ();

    void
    drivingConditionType (const drivingConditionType_type& x);

    void
    drivingConditionType (const drivingConditionType_optional& x);

    void
    drivingConditionType (::std::auto_ptr< drivingConditionType_type > p);

    // conditionsExtension
    // 
    typedef ::datex2::ExtensionType conditionsExtension_type;
    typedef ::xsd::cxx::tree::optional< conditionsExtension_type > conditionsExtension_optional;
    typedef ::xsd::cxx::tree::traits< conditionsExtension_type, char > conditionsExtension_traits;

    const conditionsExtension_optional&
    conditionsExtension () const;

    conditionsExtension_optional&
    conditionsExtension ();

    void
    conditionsExtension (const conditionsExtension_type& x);

    void
    conditionsExtension (const conditionsExtension_optional& x);

    void
    conditionsExtension (::std::auto_ptr< conditionsExtension_type > p);

    // Constructors.
    //
    Conditions (const situationRecordCreationTime_type&,
                const situationRecordVersion_type&,
                const situationRecordVersionTime_type&,
                const probabilityOfOccurrence_type&,
                const validity_type&,
                const groupOfLocations_type&,
                const id_type&);

    Conditions (const situationRecordCreationTime_type&,
                const situationRecordVersion_type&,
                const situationRecordVersionTime_type&,
                const probabilityOfOccurrence_type&,
                ::std::auto_ptr< validity_type >&,
                ::std::auto_ptr< groupOfLocations_type >&,
                const id_type&);

    Conditions (const xercesc::DOMElement& e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    Conditions (const Conditions& x,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    virtual Conditions*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Conditions ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    drivingConditionType_optional drivingConditionType_;
    conditionsExtension_optional conditionsExtension_;
  };

  class ConfidentialityValueEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      internalUse,
      noRestriction,
      restrictedToAuthorities,
      restrictedToAuthoritiesAndTrafficOperators,
      restrictedToAuthoritiesTrafficOperatorsAndPublishers,
      restrictedToAuthoritiesTrafficOperatorsAndVms
    };

    ConfidentialityValueEnum (value v);

    ConfidentialityValueEnum (const char* v);

    ConfidentialityValueEnum (const ::std::string& v);

    ConfidentialityValueEnum (const ::xml_schema::string& v);

    ConfidentialityValueEnum (const xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    ConfidentialityValueEnum (const xercesc::DOMAttr& a,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    ConfidentialityValueEnum (const ::std::string& s,
                              const xercesc::DOMElement* e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    ConfidentialityValueEnum (const ConfidentialityValueEnum& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual ConfidentialityValueEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    ConfidentialityValueEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_ConfidentialityValueEnum_convert ();
    }

    protected:
    value
    _xsd_ConfidentialityValueEnum_convert () const;

    public:
    static const char* const _xsd_ConfidentialityValueEnum_literals_[6];
    static const value _xsd_ConfidentialityValueEnum_indexes_[6];
  };

  class OperatorAction: public ::datex2::SituationRecord
  {
    public:
    // actionOrigin
    // 
    typedef ::datex2::OperatorActionOriginEnum actionOrigin_type;
    typedef ::xsd::cxx::tree::optional< actionOrigin_type > actionOrigin_optional;
    typedef ::xsd::cxx::tree::traits< actionOrigin_type, char > actionOrigin_traits;

    const actionOrigin_optional&
    actionOrigin () const;

    actionOrigin_optional&
    actionOrigin ();

    void
    actionOrigin (const actionOrigin_type& x);

    void
    actionOrigin (const actionOrigin_optional& x);

    void
    actionOrigin (::std::auto_ptr< actionOrigin_type > p);

    // operatorActionStatus
    // 
    typedef ::datex2::OperatorActionStatusEnum operatorActionStatus_type;
    typedef ::xsd::cxx::tree::optional< operatorActionStatus_type > operatorActionStatus_optional;
    typedef ::xsd::cxx::tree::traits< operatorActionStatus_type, char > operatorActionStatus_traits;

    const operatorActionStatus_optional&
    operatorActionStatus () const;

    operatorActionStatus_optional&
    operatorActionStatus ();

    void
    operatorActionStatus (const operatorActionStatus_type& x);

    void
    operatorActionStatus (const operatorActionStatus_optional& x);

    void
    operatorActionStatus (::std::auto_ptr< operatorActionStatus_type > p);

    // operatorActionExtension
    // 
    typedef ::datex2::ExtensionType operatorActionExtension_type;
    typedef ::xsd::cxx::tree::optional< operatorActionExtension_type > operatorActionExtension_optional;
    typedef ::xsd::cxx::tree::traits< operatorActionExtension_type, char > operatorActionExtension_traits;

    const operatorActionExtension_optional&
    operatorActionExtension () const;

    operatorActionExtension_optional&
    operatorActionExtension ();

    void
    operatorActionExtension (const operatorActionExtension_type& x);

    void
    operatorActionExtension (const operatorActionExtension_optional& x);

    void
    operatorActionExtension (::std::auto_ptr< operatorActionExtension_type > p);

    // Constructors.
    //
    OperatorAction (const situationRecordCreationTime_type&,
                    const situationRecordVersion_type&,
                    const situationRecordVersionTime_type&,
                    const probabilityOfOccurrence_type&,
                    const validity_type&,
                    const groupOfLocations_type&,
                    const id_type&);

    OperatorAction (const situationRecordCreationTime_type&,
                    const situationRecordVersion_type&,
                    const situationRecordVersionTime_type&,
                    const probabilityOfOccurrence_type&,
                    ::std::auto_ptr< validity_type >&,
                    ::std::auto_ptr< groupOfLocations_type >&,
                    const id_type&);

    OperatorAction (const xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    OperatorAction (const OperatorAction& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual OperatorAction*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~OperatorAction ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    actionOrigin_optional actionOrigin_;
    operatorActionStatus_optional operatorActionStatus_;
    operatorActionExtension_optional operatorActionExtension_;
  };

  class Roadworks: public ::datex2::OperatorAction
  {
    public:
    // roadworksDuration
    // 
    typedef ::datex2::RoadworksDurationEnum roadworksDuration_type;
    typedef ::xsd::cxx::tree::optional< roadworksDuration_type > roadworksDuration_optional;
    typedef ::xsd::cxx::tree::traits< roadworksDuration_type, char > roadworksDuration_traits;

    const roadworksDuration_optional&
    roadworksDuration () const;

    roadworksDuration_optional&
    roadworksDuration ();

    void
    roadworksDuration (const roadworksDuration_type& x);

    void
    roadworksDuration (const roadworksDuration_optional& x);

    void
    roadworksDuration (::std::auto_ptr< roadworksDuration_type > p);

    // roadworksScale
    // 
    typedef ::datex2::RoadworksScaleEnum roadworksScale_type;
    typedef ::xsd::cxx::tree::optional< roadworksScale_type > roadworksScale_optional;
    typedef ::xsd::cxx::tree::traits< roadworksScale_type, char > roadworksScale_traits;

    const roadworksScale_optional&
    roadworksScale () const;

    roadworksScale_optional&
    roadworksScale ();

    void
    roadworksScale (const roadworksScale_type& x);

    void
    roadworksScale (const roadworksScale_optional& x);

    void
    roadworksScale (::std::auto_ptr< roadworksScale_type > p);

    // underTraffic
    // 
    typedef ::datex2::Boolean underTraffic_type;
    typedef ::xsd::cxx::tree::optional< underTraffic_type > underTraffic_optional;
    typedef ::xsd::cxx::tree::traits< underTraffic_type, char > underTraffic_traits;

    const underTraffic_optional&
    underTraffic () const;

    underTraffic_optional&
    underTraffic ();

    void
    underTraffic (const underTraffic_type& x);

    void
    underTraffic (const underTraffic_optional& x);

    void
    underTraffic (::std::auto_ptr< underTraffic_type > p);

    // urgentRoadworks
    // 
    typedef ::datex2::Boolean urgentRoadworks_type;
    typedef ::xsd::cxx::tree::optional< urgentRoadworks_type > urgentRoadworks_optional;
    typedef ::xsd::cxx::tree::traits< urgentRoadworks_type, char > urgentRoadworks_traits;

    const urgentRoadworks_optional&
    urgentRoadworks () const;

    urgentRoadworks_optional&
    urgentRoadworks ();

    void
    urgentRoadworks (const urgentRoadworks_type& x);

    void
    urgentRoadworks (const urgentRoadworks_optional& x);

    void
    urgentRoadworks (::std::auto_ptr< urgentRoadworks_type > p);

    // mobility
    // 
    typedef ::datex2::Mobility mobility_type;
    typedef ::xsd::cxx::tree::optional< mobility_type > mobility_optional;
    typedef ::xsd::cxx::tree::traits< mobility_type, char > mobility_traits;

    const mobility_optional&
    mobility () const;

    mobility_optional&
    mobility ();

    void
    mobility (const mobility_type& x);

    void
    mobility (const mobility_optional& x);

    void
    mobility (::std::auto_ptr< mobility_type > p);

    // subjects
    // 
    typedef ::datex2::Subjects subjects_type;
    typedef ::xsd::cxx::tree::optional< subjects_type > subjects_optional;
    typedef ::xsd::cxx::tree::traits< subjects_type, char > subjects_traits;

    const subjects_optional&
    subjects () const;

    subjects_optional&
    subjects ();

    void
    subjects (const subjects_type& x);

    void
    subjects (const subjects_optional& x);

    void
    subjects (::std::auto_ptr< subjects_type > p);

    // maintenanceVehicles
    // 
    typedef ::datex2::MaintenanceVehicles maintenanceVehicles_type;
    typedef ::xsd::cxx::tree::optional< maintenanceVehicles_type > maintenanceVehicles_optional;
    typedef ::xsd::cxx::tree::traits< maintenanceVehicles_type, char > maintenanceVehicles_traits;

    const maintenanceVehicles_optional&
    maintenanceVehicles () const;

    maintenanceVehicles_optional&
    maintenanceVehicles ();

    void
    maintenanceVehicles (const maintenanceVehicles_type& x);

    void
    maintenanceVehicles (const maintenanceVehicles_optional& x);

    void
    maintenanceVehicles (::std::auto_ptr< maintenanceVehicles_type > p);

    // roadworksExtension
    // 
    typedef ::datex2::ExtensionType roadworksExtension_type;
    typedef ::xsd::cxx::tree::optional< roadworksExtension_type > roadworksExtension_optional;
    typedef ::xsd::cxx::tree::traits< roadworksExtension_type, char > roadworksExtension_traits;

    const roadworksExtension_optional&
    roadworksExtension () const;

    roadworksExtension_optional&
    roadworksExtension ();

    void
    roadworksExtension (const roadworksExtension_type& x);

    void
    roadworksExtension (const roadworksExtension_optional& x);

    void
    roadworksExtension (::std::auto_ptr< roadworksExtension_type > p);

    // Constructors.
    //
    Roadworks (const situationRecordCreationTime_type&,
               const situationRecordVersion_type&,
               const situationRecordVersionTime_type&,
               const probabilityOfOccurrence_type&,
               const validity_type&,
               const groupOfLocations_type&,
               const id_type&);

    Roadworks (const situationRecordCreationTime_type&,
               const situationRecordVersion_type&,
               const situationRecordVersionTime_type&,
               const probabilityOfOccurrence_type&,
               ::std::auto_ptr< validity_type >&,
               ::std::auto_ptr< groupOfLocations_type >&,
               const id_type&);

    Roadworks (const xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    Roadworks (const Roadworks& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual Roadworks*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Roadworks ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    roadworksDuration_optional roadworksDuration_;
    roadworksScale_optional roadworksScale_;
    underTraffic_optional underTraffic_;
    urgentRoadworks_optional urgentRoadworks_;
    mobility_optional mobility_;
    subjects_optional subjects_;
    maintenanceVehicles_optional maintenanceVehicles_;
    roadworksExtension_optional roadworksExtension_;
  };

  class ConstructionWorks: public ::datex2::Roadworks
  {
    public:
    // constructionWorkType
    // 
    typedef ::datex2::ConstructionWorkTypeEnum constructionWorkType_type;
    typedef ::xsd::cxx::tree::optional< constructionWorkType_type > constructionWorkType_optional;
    typedef ::xsd::cxx::tree::traits< constructionWorkType_type, char > constructionWorkType_traits;

    const constructionWorkType_optional&
    constructionWorkType () const;

    constructionWorkType_optional&
    constructionWorkType ();

    void
    constructionWorkType (const constructionWorkType_type& x);

    void
    constructionWorkType (const constructionWorkType_optional& x);

    void
    constructionWorkType (::std::auto_ptr< constructionWorkType_type > p);

    // constructionWorksExtension
    // 
    typedef ::datex2::ExtensionType constructionWorksExtension_type;
    typedef ::xsd::cxx::tree::optional< constructionWorksExtension_type > constructionWorksExtension_optional;
    typedef ::xsd::cxx::tree::traits< constructionWorksExtension_type, char > constructionWorksExtension_traits;

    const constructionWorksExtension_optional&
    constructionWorksExtension () const;

    constructionWorksExtension_optional&
    constructionWorksExtension ();

    void
    constructionWorksExtension (const constructionWorksExtension_type& x);

    void
    constructionWorksExtension (const constructionWorksExtension_optional& x);

    void
    constructionWorksExtension (::std::auto_ptr< constructionWorksExtension_type > p);

    // Constructors.
    //
    ConstructionWorks (const situationRecordCreationTime_type&,
                       const situationRecordVersion_type&,
                       const situationRecordVersionTime_type&,
                       const probabilityOfOccurrence_type&,
                       const validity_type&,
                       const groupOfLocations_type&,
                       const id_type&);

    ConstructionWorks (const situationRecordCreationTime_type&,
                       const situationRecordVersion_type&,
                       const situationRecordVersionTime_type&,
                       const probabilityOfOccurrence_type&,
                       ::std::auto_ptr< validity_type >&,
                       ::std::auto_ptr< groupOfLocations_type >&,
                       const id_type&);

    ConstructionWorks (const xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    ConstructionWorks (const ConstructionWorks& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual ConstructionWorks*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ConstructionWorks ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    constructionWorkType_optional constructionWorkType_;
    constructionWorksExtension_optional constructionWorksExtension_;
  };

  class ConstructionWorkTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      blastingWork,
      constructionWork,
      demolitionWork,
      roadWideningWork
    };

    ConstructionWorkTypeEnum (value v);

    ConstructionWorkTypeEnum (const char* v);

    ConstructionWorkTypeEnum (const ::std::string& v);

    ConstructionWorkTypeEnum (const ::xml_schema::string& v);

    ConstructionWorkTypeEnum (const xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    ConstructionWorkTypeEnum (const xercesc::DOMAttr& a,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    ConstructionWorkTypeEnum (const ::std::string& s,
                              const xercesc::DOMElement* e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    ConstructionWorkTypeEnum (const ConstructionWorkTypeEnum& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual ConstructionWorkTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    ConstructionWorkTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_ConstructionWorkTypeEnum_convert ();
    }

    protected:
    value
    _xsd_ConstructionWorkTypeEnum_convert () const;

    public:
    static const char* const _xsd_ConstructionWorkTypeEnum_literals_[4];
    static const value _xsd_ConstructionWorkTypeEnum_indexes_[4];
  };

  class CountryEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      at,
      be,
      bg,
      ch,
      cs,
      cy,
      cz,
      de,
      dk,
      ee,
      es,
      fi,
      fo,
      fr,
      gb,
      gg,
      gi,
      gr,
      hr,
      hu,
      ie,
      im,
      is,
      it,
      je,
      li,
      lt,
      lu,
      lv,
      ma,
      mc,
      mk,
      mt,
      nl,
      no,
      pl,
      pt,
      ro,
      se,
      si,
      sk,
      sm,
      tr,
      va,
      other
    };

    CountryEnum (value v);

    CountryEnum (const char* v);

    CountryEnum (const ::std::string& v);

    CountryEnum (const ::xml_schema::string& v);

    CountryEnum (const xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    CountryEnum (const xercesc::DOMAttr& a,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    CountryEnum (const ::std::string& s,
                 const xercesc::DOMElement* e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    CountryEnum (const CountryEnum& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual CountryEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    CountryEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_CountryEnum_convert ();
    }

    protected:
    value
    _xsd_CountryEnum_convert () const;

    public:
    static const char* const _xsd_CountryEnum_literals_[45];
    static const value _xsd_CountryEnum_indexes_[45];
  };

  class CubicMetres: public ::datex2::Float
  {
    public:
    // Constructors.
    //
    CubicMetres (const ::xml_schema::float_&);

    CubicMetres (const xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    CubicMetres (const xercesc::DOMAttr& a,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    CubicMetres (const ::std::string& s,
                 const xercesc::DOMElement* e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    CubicMetres (const CubicMetres& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual CubicMetres*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CubicMetres ();
  };

  class D2LogicalModel: public ::xml_schema::type
  {
    public:
    // exchange
    // 
    typedef ::datex2::Exchange exchange_type;
    typedef ::xsd::cxx::tree::traits< exchange_type, char > exchange_traits;

    const exchange_type&
    exchange () const;

    exchange_type&
    exchange ();

    void
    exchange (const exchange_type& x);

    void
    exchange (::std::auto_ptr< exchange_type > p);

    // payloadPublication
    // 
    typedef ::datex2::PayloadPublication payloadPublication_type;
    typedef ::xsd::cxx::tree::optional< payloadPublication_type > payloadPublication_optional;
    typedef ::xsd::cxx::tree::traits< payloadPublication_type, char > payloadPublication_traits;

    const payloadPublication_optional&
    payloadPublication () const;

    payloadPublication_optional&
    payloadPublication ();

    void
    payloadPublication (const payloadPublication_type& x);

    void
    payloadPublication (const payloadPublication_optional& x);

    void
    payloadPublication (::std::auto_ptr< payloadPublication_type > p);

    // d2LogicalModelExtension
    // 
    typedef ::datex2::ExtensionType d2LogicalModelExtension_type;
    typedef ::xsd::cxx::tree::optional< d2LogicalModelExtension_type > d2LogicalModelExtension_optional;
    typedef ::xsd::cxx::tree::traits< d2LogicalModelExtension_type, char > d2LogicalModelExtension_traits;

    const d2LogicalModelExtension_optional&
    d2LogicalModelExtension () const;

    d2LogicalModelExtension_optional&
    d2LogicalModelExtension ();

    void
    d2LogicalModelExtension (const d2LogicalModelExtension_type& x);

    void
    d2LogicalModelExtension (const d2LogicalModelExtension_optional& x);

    void
    d2LogicalModelExtension (::std::auto_ptr< d2LogicalModelExtension_type > p);

    // modelBaseVersion
    // 
    typedef ::xml_schema::simple_type modelBaseVersion_type;
    typedef ::xsd::cxx::tree::traits< modelBaseVersion_type, char > modelBaseVersion_traits;

    const modelBaseVersion_type&
    modelBaseVersion () const;

    static const modelBaseVersion_type&
    modelBaseVersion_default_value ();

    // Constructors.
    //
    D2LogicalModel (const exchange_type&);

    D2LogicalModel (::std::auto_ptr< exchange_type >&);

    D2LogicalModel (const xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    D2LogicalModel (const D2LogicalModel& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual D2LogicalModel*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~D2LogicalModel ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< exchange_type > exchange_;
    payloadPublication_optional payloadPublication_;
    d2LogicalModelExtension_optional d2LogicalModelExtension_;
    ::xsd::cxx::tree::one< modelBaseVersion_type > modelBaseVersion_;
    static const modelBaseVersion_type modelBaseVersion_default_value_;
  };

  class DangerousGoodsRegulationsEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      adr,
      iataIcao,
      imoImdg,
      railroadDangerousGoodsBook
    };

    DangerousGoodsRegulationsEnum (value v);

    DangerousGoodsRegulationsEnum (const char* v);

    DangerousGoodsRegulationsEnum (const ::std::string& v);

    DangerousGoodsRegulationsEnum (const ::xml_schema::string& v);

    DangerousGoodsRegulationsEnum (const xercesc::DOMElement& e,
                                   ::xml_schema::flags f = 0,
                                   ::xml_schema::container* c = 0);

    DangerousGoodsRegulationsEnum (const xercesc::DOMAttr& a,
                                   ::xml_schema::flags f = 0,
                                   ::xml_schema::container* c = 0);

    DangerousGoodsRegulationsEnum (const ::std::string& s,
                                   const xercesc::DOMElement* e,
                                   ::xml_schema::flags f = 0,
                                   ::xml_schema::container* c = 0);

    DangerousGoodsRegulationsEnum (const DangerousGoodsRegulationsEnum& x,
                                   ::xml_schema::flags f = 0,
                                   ::xml_schema::container* c = 0);

    virtual DangerousGoodsRegulationsEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    DangerousGoodsRegulationsEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_DangerousGoodsRegulationsEnum_convert ();
    }

    protected:
    value
    _xsd_DangerousGoodsRegulationsEnum_convert () const;

    public:
    static const char* const _xsd_DangerousGoodsRegulationsEnum_literals_[4];
    static const value _xsd_DangerousGoodsRegulationsEnum_indexes_[4];
  };

  class DateTime: public ::xml_schema::date_time
  {
    public:
    // Constructors.
    //
    DateTime (const ::xml_schema::date_time&);

    DateTime (const xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    DateTime (const xercesc::DOMAttr& a,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    DateTime (const ::std::string& s,
              const xercesc::DOMElement* e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    DateTime (const DateTime& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual DateTime*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~DateTime ();
  };

  class DatexPictogramEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      advisorySpeed,
      blankVoid,
      chainsOrSnowTyresRecommended,
      crossWind,
      drivingOfVehiclesLessThanXMetresApartProhibited,
      endOfAdvisorySpeed,
      endOfProhibitionOfOvertaking,
      endOfProhibitionOfOvertakingForGoodsVehicles,
      endOfSpeedLimit,
      exitClosed,
      fog,
      keepASafeDistance,
      maximumSpeedLimit,
      noEntry,
      noEntryForGoodsVehicles,
      noEntryForVehiclesExceedingXTonnesLadenMass,
      noEntryForVehiclesHavingAMassExceedingXTonnesOnOneAxle,
      noEntryForVehiclesHavingAnOverallHeightExceedingXMetres,
      noEntryForVehiclesHavingAnOverallLengthExceedingXMetres,
      noEntryForVehiclesCarryingDangerousGoods,
      otherDanger,
      overtakingByGoodsVehiclesProhibited,
      overtakingProhibited,
      roadClosedAhead,
      roadworks,
      slipperyRoad,
      snow,
      snowTyresCompulsory,
      trafficCongestion
    };

    DatexPictogramEnum (value v);

    DatexPictogramEnum (const char* v);

    DatexPictogramEnum (const ::std::string& v);

    DatexPictogramEnum (const ::xml_schema::string& v);

    DatexPictogramEnum (const xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    DatexPictogramEnum (const xercesc::DOMAttr& a,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    DatexPictogramEnum (const ::std::string& s,
                        const xercesc::DOMElement* e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    DatexPictogramEnum (const DatexPictogramEnum& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual DatexPictogramEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    DatexPictogramEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_DatexPictogramEnum_convert ();
    }

    protected:
    value
    _xsd_DatexPictogramEnum_convert () const;

    public:
    static const char* const _xsd_DatexPictogramEnum_literals_[29];
    static const value _xsd_DatexPictogramEnum_indexes_[29];
  };

  class DayEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      monday,
      tuesday,
      wednesday,
      thursday,
      friday,
      saturday,
      sunday
    };

    DayEnum (value v);

    DayEnum (const char* v);

    DayEnum (const ::std::string& v);

    DayEnum (const ::xml_schema::string& v);

    DayEnum (const xercesc::DOMElement& e,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    DayEnum (const xercesc::DOMAttr& a,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    DayEnum (const ::std::string& s,
             const xercesc::DOMElement* e,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    DayEnum (const DayEnum& x,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    virtual DayEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    DayEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_DayEnum_convert ();
    }

    protected:
    value
    _xsd_DayEnum_convert () const;

    public:
    static const char* const _xsd_DayEnum_literals_[7];
    static const value _xsd_DayEnum_indexes_[7];
  };

  class DayWeekMonth: public ::xml_schema::type
  {
    public:
    // applicableDay
    // 
    typedef ::datex2::DayEnum applicableDay_type;
    typedef ::xsd::cxx::tree::sequence< applicableDay_type > applicableDay_sequence;
    typedef xsd::cxx::tree::sequence< applicableDay_type >::iterator applicableDay_iterator;
    typedef xsd::cxx::tree::sequence< applicableDay_type >::const_iterator applicableDay_const_iterator;
    typedef ::xsd::cxx::tree::traits< applicableDay_type, char > applicableDay_traits;

    const applicableDay_sequence&
    applicableDay () const;

    applicableDay_sequence&
    applicableDay ();

    void
    applicableDay (const applicableDay_sequence& s);

    // applicableWeek
    // 
    typedef ::datex2::WeekOfMonthEnum applicableWeek_type;
    typedef ::xsd::cxx::tree::sequence< applicableWeek_type > applicableWeek_sequence;
    typedef xsd::cxx::tree::sequence< applicableWeek_type >::iterator applicableWeek_iterator;
    typedef xsd::cxx::tree::sequence< applicableWeek_type >::const_iterator applicableWeek_const_iterator;
    typedef ::xsd::cxx::tree::traits< applicableWeek_type, char > applicableWeek_traits;

    const applicableWeek_sequence&
    applicableWeek () const;

    applicableWeek_sequence&
    applicableWeek ();

    void
    applicableWeek (const applicableWeek_sequence& s);

    // applicableMonth
    // 
    typedef ::datex2::MonthOfYearEnum applicableMonth_type;
    typedef ::xsd::cxx::tree::sequence< applicableMonth_type > applicableMonth_sequence;
    typedef xsd::cxx::tree::sequence< applicableMonth_type >::iterator applicableMonth_iterator;
    typedef xsd::cxx::tree::sequence< applicableMonth_type >::const_iterator applicableMonth_const_iterator;
    typedef ::xsd::cxx::tree::traits< applicableMonth_type, char > applicableMonth_traits;

    const applicableMonth_sequence&
    applicableMonth () const;

    applicableMonth_sequence&
    applicableMonth ();

    void
    applicableMonth (const applicableMonth_sequence& s);

    // dayWeekMonthExtension
    // 
    typedef ::datex2::ExtensionType dayWeekMonthExtension_type;
    typedef ::xsd::cxx::tree::optional< dayWeekMonthExtension_type > dayWeekMonthExtension_optional;
    typedef ::xsd::cxx::tree::traits< dayWeekMonthExtension_type, char > dayWeekMonthExtension_traits;

    const dayWeekMonthExtension_optional&
    dayWeekMonthExtension () const;

    dayWeekMonthExtension_optional&
    dayWeekMonthExtension ();

    void
    dayWeekMonthExtension (const dayWeekMonthExtension_type& x);

    void
    dayWeekMonthExtension (const dayWeekMonthExtension_optional& x);

    void
    dayWeekMonthExtension (::std::auto_ptr< dayWeekMonthExtension_type > p);

    // Constructors.
    //
    DayWeekMonth ();

    DayWeekMonth (const xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    DayWeekMonth (const DayWeekMonth& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual DayWeekMonth*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~DayWeekMonth ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    applicableDay_sequence applicableDay_;
    applicableWeek_sequence applicableWeek_;
    applicableMonth_sequence applicableMonth_;
    dayWeekMonthExtension_optional dayWeekMonthExtension_;
  };

  class DelayBandEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      negligible,
      upToTenMinutes,
      betweenTenMinutesAndThirtyMinutes,
      betweenThirtyMinutesAndOneHour,
      betweenOneHourAndThreeHours,
      betweenThreeHoursAndSixHours,
      longerThanSixHours
    };

    DelayBandEnum (value v);

    DelayBandEnum (const char* v);

    DelayBandEnum (const ::std::string& v);

    DelayBandEnum (const ::xml_schema::string& v);

    DelayBandEnum (const xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    DelayBandEnum (const xercesc::DOMAttr& a,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    DelayBandEnum (const ::std::string& s,
                   const xercesc::DOMElement* e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    DelayBandEnum (const DelayBandEnum& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual DelayBandEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    DelayBandEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_DelayBandEnum_convert ();
    }

    protected:
    value
    _xsd_DelayBandEnum_convert () const;

    public:
    static const char* const _xsd_DelayBandEnum_literals_[7];
    static const value _xsd_DelayBandEnum_indexes_[7];
  };

  class Delays: public ::xml_schema::type
  {
    public:
    // delayBand
    // 
    typedef ::datex2::DelayBandEnum delayBand_type;
    typedef ::xsd::cxx::tree::optional< delayBand_type > delayBand_optional;
    typedef ::xsd::cxx::tree::traits< delayBand_type, char > delayBand_traits;

    const delayBand_optional&
    delayBand () const;

    delayBand_optional&
    delayBand ();

    void
    delayBand (const delayBand_type& x);

    void
    delayBand (const delayBand_optional& x);

    void
    delayBand (::std::auto_ptr< delayBand_type > p);

    // delaysType
    // 
    typedef ::datex2::DelaysTypeEnum delaysType_type;
    typedef ::xsd::cxx::tree::optional< delaysType_type > delaysType_optional;
    typedef ::xsd::cxx::tree::traits< delaysType_type, char > delaysType_traits;

    const delaysType_optional&
    delaysType () const;

    delaysType_optional&
    delaysType ();

    void
    delaysType (const delaysType_type& x);

    void
    delaysType (const delaysType_optional& x);

    void
    delaysType (::std::auto_ptr< delaysType_type > p);

    // delayTimeValue
    // 
    typedef ::datex2::Seconds delayTimeValue_type;
    typedef ::xsd::cxx::tree::optional< delayTimeValue_type > delayTimeValue_optional;
    typedef ::xsd::cxx::tree::traits< delayTimeValue_type, char > delayTimeValue_traits;

    const delayTimeValue_optional&
    delayTimeValue () const;

    delayTimeValue_optional&
    delayTimeValue ();

    void
    delayTimeValue (const delayTimeValue_type& x);

    void
    delayTimeValue (const delayTimeValue_optional& x);

    void
    delayTimeValue (::std::auto_ptr< delayTimeValue_type > p);

    // delaysExtension
    // 
    typedef ::datex2::ExtensionType delaysExtension_type;
    typedef ::xsd::cxx::tree::optional< delaysExtension_type > delaysExtension_optional;
    typedef ::xsd::cxx::tree::traits< delaysExtension_type, char > delaysExtension_traits;

    const delaysExtension_optional&
    delaysExtension () const;

    delaysExtension_optional&
    delaysExtension ();

    void
    delaysExtension (const delaysExtension_type& x);

    void
    delaysExtension (const delaysExtension_optional& x);

    void
    delaysExtension (::std::auto_ptr< delaysExtension_type > p);

    // Constructors.
    //
    Delays ();

    Delays (const xercesc::DOMElement& e,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    Delays (const Delays& x,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    virtual Delays*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Delays ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    delayBand_optional delayBand_;
    delaysType_optional delaysType_;
    delayTimeValue_optional delayTimeValue_;
    delaysExtension_optional delaysExtension_;
  };

  class DelaysTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      delays,
      delaysOfUncertainDuration,
      longDelays,
      veryLongDelays
    };

    DelaysTypeEnum (value v);

    DelaysTypeEnum (const char* v);

    DelaysTypeEnum (const ::std::string& v);

    DelaysTypeEnum (const ::xml_schema::string& v);

    DelaysTypeEnum (const xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    DelaysTypeEnum (const xercesc::DOMAttr& a,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    DelaysTypeEnum (const ::std::string& s,
                    const xercesc::DOMElement* e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    DelaysTypeEnum (const DelaysTypeEnum& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual DelaysTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    DelaysTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_DelaysTypeEnum_convert ();
    }

    protected:
    value
    _xsd_DelaysTypeEnum_convert () const;

    public:
    static const char* const _xsd_DelaysTypeEnum_literals_[4];
    static const value _xsd_DelaysTypeEnum_indexes_[4];
  };

  class DenyReasonEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      unknownReason,
      wrongCatalogue,
      wrongFilter,
      wrongOrder,
      wrongPartner
    };

    DenyReasonEnum (value v);

    DenyReasonEnum (const char* v);

    DenyReasonEnum (const ::std::string& v);

    DenyReasonEnum (const ::xml_schema::string& v);

    DenyReasonEnum (const xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    DenyReasonEnum (const xercesc::DOMAttr& a,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    DenyReasonEnum (const ::std::string& s,
                    const xercesc::DOMElement* e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    DenyReasonEnum (const DenyReasonEnum& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual DenyReasonEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    DenyReasonEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_DenyReasonEnum_convert ();
    }

    protected:
    value
    _xsd_DenyReasonEnum_convert () const;

    public:
    static const char* const _xsd_DenyReasonEnum_literals_[5];
    static const value _xsd_DenyReasonEnum_indexes_[5];
  };

  class DirectionCompassEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      east,
      eastNorthEast,
      eastSouthEast,
      north,
      northEast,
      northNorthEast,
      northNorthWest,
      northWest,
      south,
      southEast,
      southSouthEast,
      southSouthWest,
      southWest,
      west,
      westNorthWest,
      westSouthWest
    };

    DirectionCompassEnum (value v);

    DirectionCompassEnum (const char* v);

    DirectionCompassEnum (const ::std::string& v);

    DirectionCompassEnum (const ::xml_schema::string& v);

    DirectionCompassEnum (const xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    DirectionCompassEnum (const xercesc::DOMAttr& a,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    DirectionCompassEnum (const ::std::string& s,
                          const xercesc::DOMElement* e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    DirectionCompassEnum (const DirectionCompassEnum& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual DirectionCompassEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    DirectionCompassEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_DirectionCompassEnum_convert ();
    }

    protected:
    value
    _xsd_DirectionCompassEnum_convert () const;

    public:
    static const char* const _xsd_DirectionCompassEnum_literals_[16];
    static const value _xsd_DirectionCompassEnum_indexes_[16];
  };

  class DirectionEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      anticlockwise,
      clockwise,
      northBound,
      northEastBound,
      eastBound,
      southEastBound,
      southBound,
      southWestBound,
      westBound,
      northWestBound,
      inboundTowardsTown,
      outboundFromTown
    };

    DirectionEnum (value v);

    DirectionEnum (const char* v);

    DirectionEnum (const ::std::string& v);

    DirectionEnum (const ::xml_schema::string& v);

    DirectionEnum (const xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    DirectionEnum (const xercesc::DOMAttr& a,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    DirectionEnum (const ::std::string& s,
                   const xercesc::DOMElement* e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    DirectionEnum (const DirectionEnum& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual DirectionEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    DirectionEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_DirectionEnum_convert ();
    }

    protected:
    value
    _xsd_DirectionEnum_convert () const;

    public:
    static const char* const _xsd_DirectionEnum_literals_[12];
    static const value _xsd_DirectionEnum_indexes_[12];
  };

  class DisturbanceActivity: public ::datex2::Activity
  {
    public:
    // disturbanceActivityType
    // 
    typedef ::datex2::DisturbanceActivityTypeEnum disturbanceActivityType_type;
    typedef ::xsd::cxx::tree::traits< disturbanceActivityType_type, char > disturbanceActivityType_traits;

    const disturbanceActivityType_type&
    disturbanceActivityType () const;

    disturbanceActivityType_type&
    disturbanceActivityType ();

    void
    disturbanceActivityType (const disturbanceActivityType_type& x);

    void
    disturbanceActivityType (::std::auto_ptr< disturbanceActivityType_type > p);

    // disturbanceActivityExtension
    // 
    typedef ::datex2::ExtensionType disturbanceActivityExtension_type;
    typedef ::xsd::cxx::tree::optional< disturbanceActivityExtension_type > disturbanceActivityExtension_optional;
    typedef ::xsd::cxx::tree::traits< disturbanceActivityExtension_type, char > disturbanceActivityExtension_traits;

    const disturbanceActivityExtension_optional&
    disturbanceActivityExtension () const;

    disturbanceActivityExtension_optional&
    disturbanceActivityExtension ();

    void
    disturbanceActivityExtension (const disturbanceActivityExtension_type& x);

    void
    disturbanceActivityExtension (const disturbanceActivityExtension_optional& x);

    void
    disturbanceActivityExtension (::std::auto_ptr< disturbanceActivityExtension_type > p);

    // Constructors.
    //
    DisturbanceActivity (const situationRecordCreationTime_type&,
                         const situationRecordVersion_type&,
                         const situationRecordVersionTime_type&,
                         const probabilityOfOccurrence_type&,
                         const validity_type&,
                         const groupOfLocations_type&,
                         const id_type&,
                         const disturbanceActivityType_type&);

    DisturbanceActivity (const situationRecordCreationTime_type&,
                         const situationRecordVersion_type&,
                         const situationRecordVersionTime_type&,
                         const probabilityOfOccurrence_type&,
                         ::std::auto_ptr< validity_type >&,
                         ::std::auto_ptr< groupOfLocations_type >&,
                         const id_type&,
                         const disturbanceActivityType_type&);

    DisturbanceActivity (const xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    DisturbanceActivity (const DisturbanceActivity& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual DisturbanceActivity*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~DisturbanceActivity ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< disturbanceActivityType_type > disturbanceActivityType_;
    disturbanceActivityExtension_optional disturbanceActivityExtension_;
  };

  class DisturbanceActivityTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      airRaid,
      altercationOfVehicleOccupants,
      assault,
      assetDestruction,
      attack,
      attackOnVehicle,
      blockadeOrBarrier,
      bombAlert,
      crowd,
      demonstration,
      evacuation,
      filterBlockade,
      goSlowOperation,
      gunfireOnRoadway,
      illVehicleOccupants,
      march,
      publicDisturbance,
      radioactiveLeekAlert,
      riot,
      sabotage,
      securityAlert,
      securityIncident,
      sightseersObstructingAccess,
      strike,
      terroristIncident,
      theft,
      toxicCloudAlert,
      unspecifiedAlert,
      other
    };

    DisturbanceActivityTypeEnum (value v);

    DisturbanceActivityTypeEnum (const char* v);

    DisturbanceActivityTypeEnum (const ::std::string& v);

    DisturbanceActivityTypeEnum (const ::xml_schema::string& v);

    DisturbanceActivityTypeEnum (const xercesc::DOMElement& e,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    DisturbanceActivityTypeEnum (const xercesc::DOMAttr& a,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    DisturbanceActivityTypeEnum (const ::std::string& s,
                                 const xercesc::DOMElement* e,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    DisturbanceActivityTypeEnum (const DisturbanceActivityTypeEnum& x,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    virtual DisturbanceActivityTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    DisturbanceActivityTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_DisturbanceActivityTypeEnum_convert ();
    }

    protected:
    value
    _xsd_DisturbanceActivityTypeEnum_convert () const;

    public:
    static const char* const _xsd_DisturbanceActivityTypeEnum_literals_[29];
    static const value _xsd_DisturbanceActivityTypeEnum_indexes_[29];
  };

  class DrivingConditionTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      impossible,
      hazardous,
      normal,
      passableWithCare,
      unknown,
      veryHazardous,
      winterConditions,
      other
    };

    DrivingConditionTypeEnum (value v);

    DrivingConditionTypeEnum (const char* v);

    DrivingConditionTypeEnum (const ::std::string& v);

    DrivingConditionTypeEnum (const ::xml_schema::string& v);

    DrivingConditionTypeEnum (const xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    DrivingConditionTypeEnum (const xercesc::DOMAttr& a,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    DrivingConditionTypeEnum (const ::std::string& s,
                              const xercesc::DOMElement* e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    DrivingConditionTypeEnum (const DrivingConditionTypeEnum& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual DrivingConditionTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    DrivingConditionTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_DrivingConditionTypeEnum_convert ();
    }

    protected:
    value
    _xsd_DrivingConditionTypeEnum_convert () const;

    public:
    static const char* const _xsd_DrivingConditionTypeEnum_literals_[8];
    static const value _xsd_DrivingConditionTypeEnum_indexes_[8];
  };

  class ElaboratedData: public ::xml_schema::type
  {
    public:
    // forecast
    // 
    typedef ::datex2::Boolean forecast_type;
    typedef ::xsd::cxx::tree::optional< forecast_type > forecast_optional;
    typedef ::xsd::cxx::tree::traits< forecast_type, char > forecast_traits;

    const forecast_optional&
    forecast () const;

    forecast_optional&
    forecast ();

    void
    forecast (const forecast_type& x);

    void
    forecast (const forecast_optional& x);

    void
    forecast (::std::auto_ptr< forecast_type > p);

    // source
    // 
    typedef ::datex2::Source source_type;
    typedef ::xsd::cxx::tree::optional< source_type > source_optional;
    typedef ::xsd::cxx::tree::traits< source_type, char > source_traits;

    const source_optional&
    source () const;

    source_optional&
    source ();

    void
    source (const source_type& x);

    void
    source (const source_optional& x);

    void
    source (::std::auto_ptr< source_type > p);

    // validity
    // 
    typedef ::datex2::Validity validity_type;
    typedef ::xsd::cxx::tree::optional< validity_type > validity_optional;
    typedef ::xsd::cxx::tree::traits< validity_type, char > validity_traits;

    const validity_optional&
    validity () const;

    validity_optional&
    validity ();

    void
    validity (const validity_type& x);

    void
    validity (const validity_optional& x);

    void
    validity (::std::auto_ptr< validity_type > p);

    // basicDataValue
    // 
    typedef ::datex2::BasicDataValue basicDataValue_type;
    typedef ::xsd::cxx::tree::traits< basicDataValue_type, char > basicDataValue_traits;

    const basicDataValue_type&
    basicDataValue () const;

    basicDataValue_type&
    basicDataValue ();

    void
    basicDataValue (const basicDataValue_type& x);

    void
    basicDataValue (::std::auto_ptr< basicDataValue_type > p);

    // elaboratedDataExtension
    // 
    typedef ::datex2::ExtensionType elaboratedDataExtension_type;
    typedef ::xsd::cxx::tree::optional< elaboratedDataExtension_type > elaboratedDataExtension_optional;
    typedef ::xsd::cxx::tree::traits< elaboratedDataExtension_type, char > elaboratedDataExtension_traits;

    const elaboratedDataExtension_optional&
    elaboratedDataExtension () const;

    elaboratedDataExtension_optional&
    elaboratedDataExtension ();

    void
    elaboratedDataExtension (const elaboratedDataExtension_type& x);

    void
    elaboratedDataExtension (const elaboratedDataExtension_optional& x);

    void
    elaboratedDataExtension (::std::auto_ptr< elaboratedDataExtension_type > p);

    // Constructors.
    //
    ElaboratedData (const basicDataValue_type&);

    ElaboratedData (::std::auto_ptr< basicDataValue_type >&);

    ElaboratedData (const xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    ElaboratedData (const ElaboratedData& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual ElaboratedData*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ElaboratedData ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    forecast_optional forecast_;
    source_optional source_;
    validity_optional validity_;
    ::xsd::cxx::tree::one< basicDataValue_type > basicDataValue_;
    elaboratedDataExtension_optional elaboratedDataExtension_;
  };

  class PayloadPublication: public ::xml_schema::type
  {
    public:
    // feedDescription
    // 
    typedef ::datex2::MultilingualString feedDescription_type;
    typedef ::xsd::cxx::tree::optional< feedDescription_type > feedDescription_optional;
    typedef ::xsd::cxx::tree::traits< feedDescription_type, char > feedDescription_traits;

    const feedDescription_optional&
    feedDescription () const;

    feedDescription_optional&
    feedDescription ();

    void
    feedDescription (const feedDescription_type& x);

    void
    feedDescription (const feedDescription_optional& x);

    void
    feedDescription (::std::auto_ptr< feedDescription_type > p);

    // feedType
    // 
    typedef ::datex2::String feedType_type;
    typedef ::xsd::cxx::tree::optional< feedType_type > feedType_optional;
    typedef ::xsd::cxx::tree::traits< feedType_type, char > feedType_traits;

    const feedType_optional&
    feedType () const;

    feedType_optional&
    feedType ();

    void
    feedType (const feedType_type& x);

    void
    feedType (const feedType_optional& x);

    void
    feedType (::std::auto_ptr< feedType_type > p);

    // publicationTime
    // 
    typedef ::datex2::DateTime publicationTime_type;
    typedef ::xsd::cxx::tree::traits< publicationTime_type, char > publicationTime_traits;

    const publicationTime_type&
    publicationTime () const;

    publicationTime_type&
    publicationTime ();

    void
    publicationTime (const publicationTime_type& x);

    void
    publicationTime (::std::auto_ptr< publicationTime_type > p);

    // publicationCreator
    // 
    typedef ::datex2::InternationalIdentifier publicationCreator_type;
    typedef ::xsd::cxx::tree::traits< publicationCreator_type, char > publicationCreator_traits;

    const publicationCreator_type&
    publicationCreator () const;

    publicationCreator_type&
    publicationCreator ();

    void
    publicationCreator (const publicationCreator_type& x);

    void
    publicationCreator (::std::auto_ptr< publicationCreator_type > p);

    // payloadPublicationExtension
    // 
    typedef ::datex2::ExtensionType payloadPublicationExtension_type;
    typedef ::xsd::cxx::tree::optional< payloadPublicationExtension_type > payloadPublicationExtension_optional;
    typedef ::xsd::cxx::tree::traits< payloadPublicationExtension_type, char > payloadPublicationExtension_traits;

    const payloadPublicationExtension_optional&
    payloadPublicationExtension () const;

    payloadPublicationExtension_optional&
    payloadPublicationExtension ();

    void
    payloadPublicationExtension (const payloadPublicationExtension_type& x);

    void
    payloadPublicationExtension (const payloadPublicationExtension_optional& x);

    void
    payloadPublicationExtension (::std::auto_ptr< payloadPublicationExtension_type > p);

    // lang
    // 
    typedef ::datex2::Language lang_type;
    typedef ::xsd::cxx::tree::traits< lang_type, char > lang_traits;

    const lang_type&
    lang () const;

    lang_type&
    lang ();

    void
    lang (const lang_type& x);

    void
    lang (::std::auto_ptr< lang_type > p);

    // Constructors.
    //
    PayloadPublication (const publicationTime_type&,
                        const publicationCreator_type&,
                        const lang_type&);

    PayloadPublication (const publicationTime_type&,
                        ::std::auto_ptr< publicationCreator_type >&,
                        const lang_type&);

    PayloadPublication (const xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    PayloadPublication (const PayloadPublication& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual PayloadPublication*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PayloadPublication ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    feedDescription_optional feedDescription_;
    feedType_optional feedType_;
    ::xsd::cxx::tree::one< publicationTime_type > publicationTime_;
    ::xsd::cxx::tree::one< publicationCreator_type > publicationCreator_;
    payloadPublicationExtension_optional payloadPublicationExtension_;
    ::xsd::cxx::tree::one< lang_type > lang_;
  };

  class ElaboratedDataPublication: public ::datex2::PayloadPublication
  {
    public:
    // forecastDefault
    // 
    typedef ::datex2::Boolean forecastDefault_type;
    typedef ::xsd::cxx::tree::optional< forecastDefault_type > forecastDefault_optional;
    typedef ::xsd::cxx::tree::traits< forecastDefault_type, char > forecastDefault_traits;

    const forecastDefault_optional&
    forecastDefault () const;

    forecastDefault_optional&
    forecastDefault ();

    void
    forecastDefault (const forecastDefault_type& x);

    void
    forecastDefault (const forecastDefault_optional& x);

    void
    forecastDefault (::std::auto_ptr< forecastDefault_type > p);

    // periodDefault
    // 
    typedef ::datex2::Seconds periodDefault_type;
    typedef ::xsd::cxx::tree::optional< periodDefault_type > periodDefault_optional;
    typedef ::xsd::cxx::tree::traits< periodDefault_type, char > periodDefault_traits;

    const periodDefault_optional&
    periodDefault () const;

    periodDefault_optional&
    periodDefault ();

    void
    periodDefault (const periodDefault_type& x);

    void
    periodDefault (const periodDefault_optional& x);

    void
    periodDefault (::std::auto_ptr< periodDefault_type > p);

    // timeDefault
    // 
    typedef ::datex2::DateTime timeDefault_type;
    typedef ::xsd::cxx::tree::optional< timeDefault_type > timeDefault_optional;
    typedef ::xsd::cxx::tree::traits< timeDefault_type, char > timeDefault_traits;

    const timeDefault_optional&
    timeDefault () const;

    timeDefault_optional&
    timeDefault ();

    void
    timeDefault (const timeDefault_type& x);

    void
    timeDefault (const timeDefault_optional& x);

    void
    timeDefault (::std::auto_ptr< timeDefault_type > p);

    // headerInformation
    // 
    typedef ::datex2::HeaderInformation headerInformation_type;
    typedef ::xsd::cxx::tree::traits< headerInformation_type, char > headerInformation_traits;

    const headerInformation_type&
    headerInformation () const;

    headerInformation_type&
    headerInformation ();

    void
    headerInformation (const headerInformation_type& x);

    void
    headerInformation (::std::auto_ptr< headerInformation_type > p);

    // referenceSettings
    // 
    typedef ::datex2::ReferenceSettings referenceSettings_type;
    typedef ::xsd::cxx::tree::optional< referenceSettings_type > referenceSettings_optional;
    typedef ::xsd::cxx::tree::traits< referenceSettings_type, char > referenceSettings_traits;

    const referenceSettings_optional&
    referenceSettings () const;

    referenceSettings_optional&
    referenceSettings ();

    void
    referenceSettings (const referenceSettings_type& x);

    void
    referenceSettings (const referenceSettings_optional& x);

    void
    referenceSettings (::std::auto_ptr< referenceSettings_type > p);

    // elaboratedData
    // 
    typedef ::datex2::ElaboratedData elaboratedData_type;
    typedef ::xsd::cxx::tree::sequence< elaboratedData_type > elaboratedData_sequence;
    typedef xsd::cxx::tree::sequence< elaboratedData_type >::iterator elaboratedData_iterator;
    typedef xsd::cxx::tree::sequence< elaboratedData_type >::const_iterator elaboratedData_const_iterator;
    typedef ::xsd::cxx::tree::traits< elaboratedData_type, char > elaboratedData_traits;

    const elaboratedData_sequence&
    elaboratedData () const;

    elaboratedData_sequence&
    elaboratedData ();

    void
    elaboratedData (const elaboratedData_sequence& s);

    // elaboratedDataPublicationExtension
    // 
    typedef ::datex2::ExtensionType elaboratedDataPublicationExtension_type;
    typedef ::xsd::cxx::tree::optional< elaboratedDataPublicationExtension_type > elaboratedDataPublicationExtension_optional;
    typedef ::xsd::cxx::tree::traits< elaboratedDataPublicationExtension_type, char > elaboratedDataPublicationExtension_traits;

    const elaboratedDataPublicationExtension_optional&
    elaboratedDataPublicationExtension () const;

    elaboratedDataPublicationExtension_optional&
    elaboratedDataPublicationExtension ();

    void
    elaboratedDataPublicationExtension (const elaboratedDataPublicationExtension_type& x);

    void
    elaboratedDataPublicationExtension (const elaboratedDataPublicationExtension_optional& x);

    void
    elaboratedDataPublicationExtension (::std::auto_ptr< elaboratedDataPublicationExtension_type > p);

    // Constructors.
    //
    ElaboratedDataPublication (const publicationTime_type&,
                               const publicationCreator_type&,
                               const lang_type&,
                               const headerInformation_type&);

    ElaboratedDataPublication (const publicationTime_type&,
                               ::std::auto_ptr< publicationCreator_type >&,
                               const lang_type&,
                               ::std::auto_ptr< headerInformation_type >&);

    ElaboratedDataPublication (const xercesc::DOMElement& e,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    ElaboratedDataPublication (const ElaboratedDataPublication& x,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    virtual ElaboratedDataPublication*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ElaboratedDataPublication ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    forecastDefault_optional forecastDefault_;
    periodDefault_optional periodDefault_;
    timeDefault_optional timeDefault_;
    ::xsd::cxx::tree::one< headerInformation_type > headerInformation_;
    referenceSettings_optional referenceSettings_;
    elaboratedData_sequence elaboratedData_;
    elaboratedDataPublicationExtension_optional elaboratedDataPublicationExtension_;
  };

  class EnvironmentalObstruction: public ::datex2::Obstruction
  {
    public:
    // depth
    // 
    typedef ::datex2::MetresAsFloat depth_type;
    typedef ::xsd::cxx::tree::optional< depth_type > depth_optional;
    typedef ::xsd::cxx::tree::traits< depth_type, char > depth_traits;

    const depth_optional&
    depth () const;

    depth_optional&
    depth ();

    void
    depth (const depth_type& x);

    void
    depth (const depth_optional& x);

    void
    depth (::std::auto_ptr< depth_type > p);

    // environmentalObstructionType
    // 
    typedef ::datex2::EnvironmentalObstructionTypeEnum environmentalObstructionType_type;
    typedef ::xsd::cxx::tree::traits< environmentalObstructionType_type, char > environmentalObstructionType_traits;

    const environmentalObstructionType_type&
    environmentalObstructionType () const;

    environmentalObstructionType_type&
    environmentalObstructionType ();

    void
    environmentalObstructionType (const environmentalObstructionType_type& x);

    void
    environmentalObstructionType (::std::auto_ptr< environmentalObstructionType_type > p);

    // environmentalObstructionExtension
    // 
    typedef ::datex2::ExtensionType environmentalObstructionExtension_type;
    typedef ::xsd::cxx::tree::optional< environmentalObstructionExtension_type > environmentalObstructionExtension_optional;
    typedef ::xsd::cxx::tree::traits< environmentalObstructionExtension_type, char > environmentalObstructionExtension_traits;

    const environmentalObstructionExtension_optional&
    environmentalObstructionExtension () const;

    environmentalObstructionExtension_optional&
    environmentalObstructionExtension ();

    void
    environmentalObstructionExtension (const environmentalObstructionExtension_type& x);

    void
    environmentalObstructionExtension (const environmentalObstructionExtension_optional& x);

    void
    environmentalObstructionExtension (::std::auto_ptr< environmentalObstructionExtension_type > p);

    // Constructors.
    //
    EnvironmentalObstruction (const situationRecordCreationTime_type&,
                              const situationRecordVersion_type&,
                              const situationRecordVersionTime_type&,
                              const probabilityOfOccurrence_type&,
                              const validity_type&,
                              const groupOfLocations_type&,
                              const id_type&,
                              const environmentalObstructionType_type&);

    EnvironmentalObstruction (const situationRecordCreationTime_type&,
                              const situationRecordVersion_type&,
                              const situationRecordVersionTime_type&,
                              const probabilityOfOccurrence_type&,
                              ::std::auto_ptr< validity_type >&,
                              ::std::auto_ptr< groupOfLocations_type >&,
                              const id_type&,
                              const environmentalObstructionType_type&);

    EnvironmentalObstruction (const xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    EnvironmentalObstruction (const EnvironmentalObstruction& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual EnvironmentalObstruction*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~EnvironmentalObstruction ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    depth_optional depth_;
    ::xsd::cxx::tree::one< environmentalObstructionType_type > environmentalObstructionType_;
    environmentalObstructionExtension_optional environmentalObstructionExtension_;
  };

  class EnvironmentalObstructionTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      avalanches,
      earthquakeDamage,
      fallenTrees,
      fallingIce,
      fallingLightIceOrSnow,
      flashFloods,
      flooding,
      forestFire,
      grassFire,
      landslips,
      mudSlide,
      sewerOverflow,
      rockfalls,
      seriousFire,
      smokeOrFumes,
      stormDamage,
      subsidence,
      other
    };

    EnvironmentalObstructionTypeEnum (value v);

    EnvironmentalObstructionTypeEnum (const char* v);

    EnvironmentalObstructionTypeEnum (const ::std::string& v);

    EnvironmentalObstructionTypeEnum (const ::xml_schema::string& v);

    EnvironmentalObstructionTypeEnum (const xercesc::DOMElement& e,
                                      ::xml_schema::flags f = 0,
                                      ::xml_schema::container* c = 0);

    EnvironmentalObstructionTypeEnum (const xercesc::DOMAttr& a,
                                      ::xml_schema::flags f = 0,
                                      ::xml_schema::container* c = 0);

    EnvironmentalObstructionTypeEnum (const ::std::string& s,
                                      const xercesc::DOMElement* e,
                                      ::xml_schema::flags f = 0,
                                      ::xml_schema::container* c = 0);

    EnvironmentalObstructionTypeEnum (const EnvironmentalObstructionTypeEnum& x,
                                      ::xml_schema::flags f = 0,
                                      ::xml_schema::container* c = 0);

    virtual EnvironmentalObstructionTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    EnvironmentalObstructionTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_EnvironmentalObstructionTypeEnum_convert ();
    }

    protected:
    value
    _xsd_EnvironmentalObstructionTypeEnum_convert () const;

    public:
    static const char* const _xsd_EnvironmentalObstructionTypeEnum_literals_[18];
    static const value _xsd_EnvironmentalObstructionTypeEnum_indexes_[18];
  };

  class EquipmentOrSystemFault: public ::datex2::TrafficElement
  {
    public:
    // equipmentOrSystemFaultType
    // 
    typedef ::datex2::EquipmentOrSystemFaultTypeEnum equipmentOrSystemFaultType_type;
    typedef ::xsd::cxx::tree::traits< equipmentOrSystemFaultType_type, char > equipmentOrSystemFaultType_traits;

    const equipmentOrSystemFaultType_type&
    equipmentOrSystemFaultType () const;

    equipmentOrSystemFaultType_type&
    equipmentOrSystemFaultType ();

    void
    equipmentOrSystemFaultType (const equipmentOrSystemFaultType_type& x);

    void
    equipmentOrSystemFaultType (::std::auto_ptr< equipmentOrSystemFaultType_type > p);

    // faultyEquipmentOrSystemType
    // 
    typedef ::datex2::EquipmentOrSystemTypeEnum faultyEquipmentOrSystemType_type;
    typedef ::xsd::cxx::tree::traits< faultyEquipmentOrSystemType_type, char > faultyEquipmentOrSystemType_traits;

    const faultyEquipmentOrSystemType_type&
    faultyEquipmentOrSystemType () const;

    faultyEquipmentOrSystemType_type&
    faultyEquipmentOrSystemType ();

    void
    faultyEquipmentOrSystemType (const faultyEquipmentOrSystemType_type& x);

    void
    faultyEquipmentOrSystemType (::std::auto_ptr< faultyEquipmentOrSystemType_type > p);

    // equipmentOrSystemFaultExtension
    // 
    typedef ::datex2::ExtensionType equipmentOrSystemFaultExtension_type;
    typedef ::xsd::cxx::tree::optional< equipmentOrSystemFaultExtension_type > equipmentOrSystemFaultExtension_optional;
    typedef ::xsd::cxx::tree::traits< equipmentOrSystemFaultExtension_type, char > equipmentOrSystemFaultExtension_traits;

    const equipmentOrSystemFaultExtension_optional&
    equipmentOrSystemFaultExtension () const;

    equipmentOrSystemFaultExtension_optional&
    equipmentOrSystemFaultExtension ();

    void
    equipmentOrSystemFaultExtension (const equipmentOrSystemFaultExtension_type& x);

    void
    equipmentOrSystemFaultExtension (const equipmentOrSystemFaultExtension_optional& x);

    void
    equipmentOrSystemFaultExtension (::std::auto_ptr< equipmentOrSystemFaultExtension_type > p);

    // Constructors.
    //
    EquipmentOrSystemFault (const situationRecordCreationTime_type&,
                            const situationRecordVersion_type&,
                            const situationRecordVersionTime_type&,
                            const probabilityOfOccurrence_type&,
                            const validity_type&,
                            const groupOfLocations_type&,
                            const id_type&,
                            const equipmentOrSystemFaultType_type&,
                            const faultyEquipmentOrSystemType_type&);

    EquipmentOrSystemFault (const situationRecordCreationTime_type&,
                            const situationRecordVersion_type&,
                            const situationRecordVersionTime_type&,
                            const probabilityOfOccurrence_type&,
                            ::std::auto_ptr< validity_type >&,
                            ::std::auto_ptr< groupOfLocations_type >&,
                            const id_type&,
                            const equipmentOrSystemFaultType_type&,
                            const faultyEquipmentOrSystemType_type&);

    EquipmentOrSystemFault (const xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    EquipmentOrSystemFault (const EquipmentOrSystemFault& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual EquipmentOrSystemFault*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~EquipmentOrSystemFault ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< equipmentOrSystemFaultType_type > equipmentOrSystemFaultType_;
    ::xsd::cxx::tree::one< faultyEquipmentOrSystemType_type > faultyEquipmentOrSystemType_;
    equipmentOrSystemFaultExtension_optional equipmentOrSystemFaultExtension_;
  };

  class EquipmentOrSystemFaultTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      notWorking,
      outOfService,
      workingIncorrectly,
      workingIntermittently
    };

    EquipmentOrSystemFaultTypeEnum (value v);

    EquipmentOrSystemFaultTypeEnum (const char* v);

    EquipmentOrSystemFaultTypeEnum (const ::std::string& v);

    EquipmentOrSystemFaultTypeEnum (const ::xml_schema::string& v);

    EquipmentOrSystemFaultTypeEnum (const xercesc::DOMElement& e,
                                    ::xml_schema::flags f = 0,
                                    ::xml_schema::container* c = 0);

    EquipmentOrSystemFaultTypeEnum (const xercesc::DOMAttr& a,
                                    ::xml_schema::flags f = 0,
                                    ::xml_schema::container* c = 0);

    EquipmentOrSystemFaultTypeEnum (const ::std::string& s,
                                    const xercesc::DOMElement* e,
                                    ::xml_schema::flags f = 0,
                                    ::xml_schema::container* c = 0);

    EquipmentOrSystemFaultTypeEnum (const EquipmentOrSystemFaultTypeEnum& x,
                                    ::xml_schema::flags f = 0,
                                    ::xml_schema::container* c = 0);

    virtual EquipmentOrSystemFaultTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    EquipmentOrSystemFaultTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_EquipmentOrSystemFaultTypeEnum_convert ();
    }

    protected:
    value
    _xsd_EquipmentOrSystemFaultTypeEnum_convert () const;

    public:
    static const char* const _xsd_EquipmentOrSystemFaultTypeEnum_literals_[4];
    static const value _xsd_EquipmentOrSystemFaultTypeEnum_indexes_[4];
  };

  class EquipmentOrSystemTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      automatedTollSystem,
      emergencyRoadsideTelephones,
      galleryLights,
      laneControlSigns,
      levelCrossing,
      matrixSigns,
      rampControls,
      roadsideCommunicationsSystem,
      roadsidePowerSystem,
      speedControlSigns,
      streetLighting,
      temporaryTrafficLights,
      tollGates,
      trafficLightSets,
      trafficSignals,
      tunnelLights,
      tunnelVentilation,
      variableMessageSigns,
      other
    };

    EquipmentOrSystemTypeEnum (value v);

    EquipmentOrSystemTypeEnum (const char* v);

    EquipmentOrSystemTypeEnum (const ::std::string& v);

    EquipmentOrSystemTypeEnum (const ::xml_schema::string& v);

    EquipmentOrSystemTypeEnum (const xercesc::DOMElement& e,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    EquipmentOrSystemTypeEnum (const xercesc::DOMAttr& a,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    EquipmentOrSystemTypeEnum (const ::std::string& s,
                               const xercesc::DOMElement* e,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    EquipmentOrSystemTypeEnum (const EquipmentOrSystemTypeEnum& x,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    virtual EquipmentOrSystemTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    EquipmentOrSystemTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_EquipmentOrSystemTypeEnum_convert ();
    }

    protected:
    value
    _xsd_EquipmentOrSystemTypeEnum_convert () const;

    public:
    static const char* const _xsd_EquipmentOrSystemTypeEnum_literals_[19];
    static const value _xsd_EquipmentOrSystemTypeEnum_indexes_[19];
  };

  class Exchange: public ::xml_schema::type
  {
    public:
    // changedFlag
    // 
    typedef ::datex2::ChangedFlagEnum changedFlag_type;
    typedef ::xsd::cxx::tree::optional< changedFlag_type > changedFlag_optional;
    typedef ::xsd::cxx::tree::traits< changedFlag_type, char > changedFlag_traits;

    const changedFlag_optional&
    changedFlag () const;

    changedFlag_optional&
    changedFlag ();

    void
    changedFlag (const changedFlag_type& x);

    void
    changedFlag (const changedFlag_optional& x);

    void
    changedFlag (::std::auto_ptr< changedFlag_type > p);

    // clientIdentification
    // 
    typedef ::datex2::String clientIdentification_type;
    typedef ::xsd::cxx::tree::optional< clientIdentification_type > clientIdentification_optional;
    typedef ::xsd::cxx::tree::traits< clientIdentification_type, char > clientIdentification_traits;

    const clientIdentification_optional&
    clientIdentification () const;

    clientIdentification_optional&
    clientIdentification ();

    void
    clientIdentification (const clientIdentification_type& x);

    void
    clientIdentification (const clientIdentification_optional& x);

    void
    clientIdentification (::std::auto_ptr< clientIdentification_type > p);

    // deliveryBreak
    // 
    typedef ::datex2::Boolean deliveryBreak_type;
    typedef ::xsd::cxx::tree::optional< deliveryBreak_type > deliveryBreak_optional;
    typedef ::xsd::cxx::tree::traits< deliveryBreak_type, char > deliveryBreak_traits;

    const deliveryBreak_optional&
    deliveryBreak () const;

    deliveryBreak_optional&
    deliveryBreak ();

    void
    deliveryBreak (const deliveryBreak_type& x);

    void
    deliveryBreak (const deliveryBreak_optional& x);

    void
    deliveryBreak (::std::auto_ptr< deliveryBreak_type > p);

    // denyReason
    // 
    typedef ::datex2::DenyReasonEnum denyReason_type;
    typedef ::xsd::cxx::tree::optional< denyReason_type > denyReason_optional;
    typedef ::xsd::cxx::tree::traits< denyReason_type, char > denyReason_traits;

    const denyReason_optional&
    denyReason () const;

    denyReason_optional&
    denyReason ();

    void
    denyReason (const denyReason_type& x);

    void
    denyReason (const denyReason_optional& x);

    void
    denyReason (::std::auto_ptr< denyReason_type > p);

    // historicalStartDate
    // 
    typedef ::datex2::DateTime historicalStartDate_type;
    typedef ::xsd::cxx::tree::optional< historicalStartDate_type > historicalStartDate_optional;
    typedef ::xsd::cxx::tree::traits< historicalStartDate_type, char > historicalStartDate_traits;

    const historicalStartDate_optional&
    historicalStartDate () const;

    historicalStartDate_optional&
    historicalStartDate ();

    void
    historicalStartDate (const historicalStartDate_type& x);

    void
    historicalStartDate (const historicalStartDate_optional& x);

    void
    historicalStartDate (::std::auto_ptr< historicalStartDate_type > p);

    // historicalStopDate
    // 
    typedef ::datex2::DateTime historicalStopDate_type;
    typedef ::xsd::cxx::tree::optional< historicalStopDate_type > historicalStopDate_optional;
    typedef ::xsd::cxx::tree::traits< historicalStopDate_type, char > historicalStopDate_traits;

    const historicalStopDate_optional&
    historicalStopDate () const;

    historicalStopDate_optional&
    historicalStopDate ();

    void
    historicalStopDate (const historicalStopDate_type& x);

    void
    historicalStopDate (const historicalStopDate_optional& x);

    void
    historicalStopDate (::std::auto_ptr< historicalStopDate_type > p);

    // keepAlive
    // 
    typedef ::datex2::Boolean keepAlive_type;
    typedef ::xsd::cxx::tree::optional< keepAlive_type > keepAlive_optional;
    typedef ::xsd::cxx::tree::traits< keepAlive_type, char > keepAlive_traits;

    const keepAlive_optional&
    keepAlive () const;

    keepAlive_optional&
    keepAlive ();

    void
    keepAlive (const keepAlive_type& x);

    void
    keepAlive (const keepAlive_optional& x);

    void
    keepAlive (::std::auto_ptr< keepAlive_type > p);

    // requestType
    // 
    typedef ::datex2::RequestTypeEnum requestType_type;
    typedef ::xsd::cxx::tree::optional< requestType_type > requestType_optional;
    typedef ::xsd::cxx::tree::traits< requestType_type, char > requestType_traits;

    const requestType_optional&
    requestType () const;

    requestType_optional&
    requestType ();

    void
    requestType (const requestType_type& x);

    void
    requestType (const requestType_optional& x);

    void
    requestType (::std::auto_ptr< requestType_type > p);

    // response
    // 
    typedef ::datex2::ResponseEnum response_type;
    typedef ::xsd::cxx::tree::optional< response_type > response_optional;
    typedef ::xsd::cxx::tree::traits< response_type, char > response_traits;

    const response_optional&
    response () const;

    response_optional&
    response ();

    void
    response (const response_type& x);

    void
    response (const response_optional& x);

    void
    response (::std::auto_ptr< response_type > p);

    // subscriptionReference
    // 
    typedef ::datex2::String subscriptionReference_type;
    typedef ::xsd::cxx::tree::optional< subscriptionReference_type > subscriptionReference_optional;
    typedef ::xsd::cxx::tree::traits< subscriptionReference_type, char > subscriptionReference_traits;

    const subscriptionReference_optional&
    subscriptionReference () const;

    subscriptionReference_optional&
    subscriptionReference ();

    void
    subscriptionReference (const subscriptionReference_type& x);

    void
    subscriptionReference (const subscriptionReference_optional& x);

    void
    subscriptionReference (::std::auto_ptr< subscriptionReference_type > p);

    // supplierIdentification
    // 
    typedef ::datex2::InternationalIdentifier supplierIdentification_type;
    typedef ::xsd::cxx::tree::traits< supplierIdentification_type, char > supplierIdentification_traits;

    const supplierIdentification_type&
    supplierIdentification () const;

    supplierIdentification_type&
    supplierIdentification ();

    void
    supplierIdentification (const supplierIdentification_type& x);

    void
    supplierIdentification (::std::auto_ptr< supplierIdentification_type > p);

    // target
    // 
    typedef ::datex2::Target target_type;
    typedef ::xsd::cxx::tree::optional< target_type > target_optional;
    typedef ::xsd::cxx::tree::traits< target_type, char > target_traits;

    const target_optional&
    target () const;

    target_optional&
    target ();

    void
    target (const target_type& x);

    void
    target (const target_optional& x);

    void
    target (::std::auto_ptr< target_type > p);

    // subscription
    // 
    typedef ::datex2::Subscription subscription_type;
    typedef ::xsd::cxx::tree::optional< subscription_type > subscription_optional;
    typedef ::xsd::cxx::tree::traits< subscription_type, char > subscription_traits;

    const subscription_optional&
    subscription () const;

    subscription_optional&
    subscription ();

    void
    subscription (const subscription_type& x);

    void
    subscription (const subscription_optional& x);

    void
    subscription (::std::auto_ptr< subscription_type > p);

    // filterReference
    // 
    typedef ::datex2::FilterReference filterReference_type;
    typedef ::xsd::cxx::tree::sequence< filterReference_type > filterReference_sequence;
    typedef xsd::cxx::tree::sequence< filterReference_type >::iterator filterReference_iterator;
    typedef xsd::cxx::tree::sequence< filterReference_type >::const_iterator filterReference_const_iterator;
    typedef ::xsd::cxx::tree::traits< filterReference_type, char > filterReference_traits;

    const filterReference_sequence&
    filterReference () const;

    filterReference_sequence&
    filterReference ();

    void
    filterReference (const filterReference_sequence& s);

    // catalogueReference
    // 
    typedef ::datex2::CatalogueReference catalogueReference_type;
    typedef ::xsd::cxx::tree::sequence< catalogueReference_type > catalogueReference_sequence;
    typedef xsd::cxx::tree::sequence< catalogueReference_type >::iterator catalogueReference_iterator;
    typedef xsd::cxx::tree::sequence< catalogueReference_type >::const_iterator catalogueReference_const_iterator;
    typedef ::xsd::cxx::tree::traits< catalogueReference_type, char > catalogueReference_traits;

    const catalogueReference_sequence&
    catalogueReference () const;

    catalogueReference_sequence&
    catalogueReference ();

    void
    catalogueReference (const catalogueReference_sequence& s);

    // exchangeExtension
    // 
    typedef ::datex2::ExtensionType exchangeExtension_type;
    typedef ::xsd::cxx::tree::optional< exchangeExtension_type > exchangeExtension_optional;
    typedef ::xsd::cxx::tree::traits< exchangeExtension_type, char > exchangeExtension_traits;

    const exchangeExtension_optional&
    exchangeExtension () const;

    exchangeExtension_optional&
    exchangeExtension ();

    void
    exchangeExtension (const exchangeExtension_type& x);

    void
    exchangeExtension (const exchangeExtension_optional& x);

    void
    exchangeExtension (::std::auto_ptr< exchangeExtension_type > p);

    // Constructors.
    //
    Exchange (const supplierIdentification_type&);

    Exchange (::std::auto_ptr< supplierIdentification_type >&);

    Exchange (const xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    Exchange (const Exchange& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual Exchange*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Exchange ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    changedFlag_optional changedFlag_;
    clientIdentification_optional clientIdentification_;
    deliveryBreak_optional deliveryBreak_;
    denyReason_optional denyReason_;
    historicalStartDate_optional historicalStartDate_;
    historicalStopDate_optional historicalStopDate_;
    keepAlive_optional keepAlive_;
    requestType_optional requestType_;
    response_optional response_;
    subscriptionReference_optional subscriptionReference_;
    ::xsd::cxx::tree::one< supplierIdentification_type > supplierIdentification_;
    target_optional target_;
    subscription_optional subscription_;
    filterReference_sequence filterReference_;
    catalogueReference_sequence catalogueReference_;
    exchangeExtension_optional exchangeExtension_;
  };

  class ExchangeEnumerations: public ::xml_schema::type
  {
    public:
    // exchangeEnumerationsExtension
    // 
    typedef ::datex2::ExtensionType exchangeEnumerationsExtension_type;
    typedef ::xsd::cxx::tree::optional< exchangeEnumerationsExtension_type > exchangeEnumerationsExtension_optional;
    typedef ::xsd::cxx::tree::traits< exchangeEnumerationsExtension_type, char > exchangeEnumerationsExtension_traits;

    const exchangeEnumerationsExtension_optional&
    exchangeEnumerationsExtension () const;

    exchangeEnumerationsExtension_optional&
    exchangeEnumerationsExtension ();

    void
    exchangeEnumerationsExtension (const exchangeEnumerationsExtension_type& x);

    void
    exchangeEnumerationsExtension (const exchangeEnumerationsExtension_optional& x);

    void
    exchangeEnumerationsExtension (::std::auto_ptr< exchangeEnumerationsExtension_type > p);

    // Constructors.
    //
    ExchangeEnumerations ();

    ExchangeEnumerations (const xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    ExchangeEnumerations (const ExchangeEnumerations& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual ExchangeEnumerations*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ExchangeEnumerations ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    exchangeEnumerationsExtension_optional exchangeEnumerationsExtension_;
  };

  class ExtensionType: public ::xml_schema::type
  {
    public:
    // Constructors.
    //
    ExtensionType ();

    ExtensionType (const xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    ExtensionType (const ExtensionType& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual ExtensionType*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ExtensionType ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
  };

  class ExternalReferencing: public ::xml_schema::type
  {
    public:
    // externalLocationCode
    // 
    typedef ::datex2::String externalLocationCode_type;
    typedef ::xsd::cxx::tree::traits< externalLocationCode_type, char > externalLocationCode_traits;

    const externalLocationCode_type&
    externalLocationCode () const;

    externalLocationCode_type&
    externalLocationCode ();

    void
    externalLocationCode (const externalLocationCode_type& x);

    void
    externalLocationCode (::std::auto_ptr< externalLocationCode_type > p);

    // externalReferencingSystem
    // 
    typedef ::datex2::String externalReferencingSystem_type;
    typedef ::xsd::cxx::tree::traits< externalReferencingSystem_type, char > externalReferencingSystem_traits;

    const externalReferencingSystem_type&
    externalReferencingSystem () const;

    externalReferencingSystem_type&
    externalReferencingSystem ();

    void
    externalReferencingSystem (const externalReferencingSystem_type& x);

    void
    externalReferencingSystem (::std::auto_ptr< externalReferencingSystem_type > p);

    // externalReferencingExtension
    // 
    typedef ::datex2::ExtensionType externalReferencingExtension_type;
    typedef ::xsd::cxx::tree::optional< externalReferencingExtension_type > externalReferencingExtension_optional;
    typedef ::xsd::cxx::tree::traits< externalReferencingExtension_type, char > externalReferencingExtension_traits;

    const externalReferencingExtension_optional&
    externalReferencingExtension () const;

    externalReferencingExtension_optional&
    externalReferencingExtension ();

    void
    externalReferencingExtension (const externalReferencingExtension_type& x);

    void
    externalReferencingExtension (const externalReferencingExtension_optional& x);

    void
    externalReferencingExtension (::std::auto_ptr< externalReferencingExtension_type > p);

    // Constructors.
    //
    ExternalReferencing (const externalLocationCode_type&,
                         const externalReferencingSystem_type&);

    ExternalReferencing (const xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    ExternalReferencing (const ExternalReferencing& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual ExternalReferencing*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ExternalReferencing ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< externalLocationCode_type > externalLocationCode_;
    ::xsd::cxx::tree::one< externalReferencingSystem_type > externalReferencingSystem_;
    externalReferencingExtension_optional externalReferencingExtension_;
  };

  class FilterExitManagement: public ::xml_schema::type
  {
    public:
    // filterEnd
    // 
    typedef ::datex2::Boolean filterEnd_type;
    typedef ::xsd::cxx::tree::traits< filterEnd_type, char > filterEnd_traits;

    const filterEnd_type&
    filterEnd () const;

    filterEnd_type&
    filterEnd ();

    void
    filterEnd (const filterEnd_type& x);

    void
    filterEnd (::std::auto_ptr< filterEnd_type > p);

    // filterOutOfRange
    // 
    typedef ::datex2::Boolean filterOutOfRange_type;
    typedef ::xsd::cxx::tree::traits< filterOutOfRange_type, char > filterOutOfRange_traits;

    const filterOutOfRange_type&
    filterOutOfRange () const;

    filterOutOfRange_type&
    filterOutOfRange ();

    void
    filterOutOfRange (const filterOutOfRange_type& x);

    void
    filterOutOfRange (::std::auto_ptr< filterOutOfRange_type > p);

    // filterExitManagementExtension
    // 
    typedef ::datex2::ExtensionType filterExitManagementExtension_type;
    typedef ::xsd::cxx::tree::optional< filterExitManagementExtension_type > filterExitManagementExtension_optional;
    typedef ::xsd::cxx::tree::traits< filterExitManagementExtension_type, char > filterExitManagementExtension_traits;

    const filterExitManagementExtension_optional&
    filterExitManagementExtension () const;

    filterExitManagementExtension_optional&
    filterExitManagementExtension ();

    void
    filterExitManagementExtension (const filterExitManagementExtension_type& x);

    void
    filterExitManagementExtension (const filterExitManagementExtension_optional& x);

    void
    filterExitManagementExtension (::std::auto_ptr< filterExitManagementExtension_type > p);

    // Constructors.
    //
    FilterExitManagement (const filterEnd_type&,
                          const filterOutOfRange_type&);

    FilterExitManagement (const xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    FilterExitManagement (const FilterExitManagement& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual FilterExitManagement*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FilterExitManagement ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< filterEnd_type > filterEnd_;
    ::xsd::cxx::tree::one< filterOutOfRange_type > filterOutOfRange_;
    filterExitManagementExtension_optional filterExitManagementExtension_;
  };

  class FilterReference: public ::xml_schema::type
  {
    public:
    // deleteFilter
    // 
    typedef ::datex2::Boolean deleteFilter_type;
    typedef ::xsd::cxx::tree::optional< deleteFilter_type > deleteFilter_optional;
    typedef ::xsd::cxx::tree::traits< deleteFilter_type, char > deleteFilter_traits;

    const deleteFilter_optional&
    deleteFilter () const;

    deleteFilter_optional&
    deleteFilter ();

    void
    deleteFilter (const deleteFilter_type& x);

    void
    deleteFilter (const deleteFilter_optional& x);

    void
    deleteFilter (::std::auto_ptr< deleteFilter_type > p);

    // filterOperationApproved
    // 
    typedef ::datex2::Boolean filterOperationApproved_type;
    typedef ::xsd::cxx::tree::optional< filterOperationApproved_type > filterOperationApproved_optional;
    typedef ::xsd::cxx::tree::traits< filterOperationApproved_type, char > filterOperationApproved_traits;

    const filterOperationApproved_optional&
    filterOperationApproved () const;

    filterOperationApproved_optional&
    filterOperationApproved ();

    void
    filterOperationApproved (const filterOperationApproved_type& x);

    void
    filterOperationApproved (const filterOperationApproved_optional& x);

    void
    filterOperationApproved (::std::auto_ptr< filterOperationApproved_type > p);

    // keyFilterReference
    // 
    typedef ::datex2::Reference keyFilterReference_type;
    typedef ::xsd::cxx::tree::traits< keyFilterReference_type, char > keyFilterReference_traits;

    const keyFilterReference_type&
    keyFilterReference () const;

    keyFilterReference_type&
    keyFilterReference ();

    void
    keyFilterReference (const keyFilterReference_type& x);

    void
    keyFilterReference (::std::auto_ptr< keyFilterReference_type > p);

    // filterReferenceExtension
    // 
    typedef ::datex2::ExtensionType filterReferenceExtension_type;
    typedef ::xsd::cxx::tree::optional< filterReferenceExtension_type > filterReferenceExtension_optional;
    typedef ::xsd::cxx::tree::traits< filterReferenceExtension_type, char > filterReferenceExtension_traits;

    const filterReferenceExtension_optional&
    filterReferenceExtension () const;

    filterReferenceExtension_optional&
    filterReferenceExtension ();

    void
    filterReferenceExtension (const filterReferenceExtension_type& x);

    void
    filterReferenceExtension (const filterReferenceExtension_optional& x);

    void
    filterReferenceExtension (::std::auto_ptr< filterReferenceExtension_type > p);

    // Constructors.
    //
    FilterReference (const keyFilterReference_type&);

    FilterReference (const xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    FilterReference (const FilterReference& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual FilterReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FilterReference ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    deleteFilter_optional deleteFilter_;
    filterOperationApproved_optional filterOperationApproved_;
    ::xsd::cxx::tree::one< keyFilterReference_type > keyFilterReference_;
    filterReferenceExtension_optional filterReferenceExtension_;
  };

  class FuelTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      battery,
      biodeisel,
      diesel,
      dieselBatteryHybrid,
      ethanol,
      hydrogen,
      liquidGas,
      lpg,
      methane,
      petrol,
      petrolBatteryHybrid
    };

    FuelTypeEnum (value v);

    FuelTypeEnum (const char* v);

    FuelTypeEnum (const ::std::string& v);

    FuelTypeEnum (const ::xml_schema::string& v);

    FuelTypeEnum (const xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    FuelTypeEnum (const xercesc::DOMAttr& a,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    FuelTypeEnum (const ::std::string& s,
                  const xercesc::DOMElement* e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    FuelTypeEnum (const FuelTypeEnum& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual FuelTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    FuelTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_FuelTypeEnum_convert ();
    }

    protected:
    value
    _xsd_FuelTypeEnum_convert () const;

    public:
    static const char* const _xsd_FuelTypeEnum_literals_[11];
    static const value _xsd_FuelTypeEnum_indexes_[11];
  };

  class NetworkManagement: public ::datex2::OperatorAction
  {
    public:
    // complianceOption
    // 
    typedef ::datex2::ComplianceOptionEnum complianceOption_type;
    typedef ::xsd::cxx::tree::traits< complianceOption_type, char > complianceOption_traits;

    const complianceOption_type&
    complianceOption () const;

    complianceOption_type&
    complianceOption ();

    void
    complianceOption (const complianceOption_type& x);

    void
    complianceOption (::std::auto_ptr< complianceOption_type > p);

    // applicableForTrafficDirection
    // 
    typedef ::datex2::DirectionEnum applicableForTrafficDirection_type;
    typedef ::xsd::cxx::tree::sequence< applicableForTrafficDirection_type > applicableForTrafficDirection_sequence;
    typedef xsd::cxx::tree::sequence< applicableForTrafficDirection_type >::iterator applicableForTrafficDirection_iterator;
    typedef xsd::cxx::tree::sequence< applicableForTrafficDirection_type >::const_iterator applicableForTrafficDirection_const_iterator;
    typedef ::xsd::cxx::tree::traits< applicableForTrafficDirection_type, char > applicableForTrafficDirection_traits;

    const applicableForTrafficDirection_sequence&
    applicableForTrafficDirection () const;

    applicableForTrafficDirection_sequence&
    applicableForTrafficDirection ();

    void
    applicableForTrafficDirection (const applicableForTrafficDirection_sequence& s);

    // applicableForTrafficType
    // 
    typedef ::datex2::TrafficTypeEnum applicableForTrafficType_type;
    typedef ::xsd::cxx::tree::sequence< applicableForTrafficType_type > applicableForTrafficType_sequence;
    typedef xsd::cxx::tree::sequence< applicableForTrafficType_type >::iterator applicableForTrafficType_iterator;
    typedef xsd::cxx::tree::sequence< applicableForTrafficType_type >::const_iterator applicableForTrafficType_const_iterator;
    typedef ::xsd::cxx::tree::traits< applicableForTrafficType_type, char > applicableForTrafficType_traits;

    const applicableForTrafficType_sequence&
    applicableForTrafficType () const;

    applicableForTrafficType_sequence&
    applicableForTrafficType ();

    void
    applicableForTrafficType (const applicableForTrafficType_sequence& s);

    // placesAtWhichApplicable
    // 
    typedef ::datex2::PlacesEnum placesAtWhichApplicable_type;
    typedef ::xsd::cxx::tree::sequence< placesAtWhichApplicable_type > placesAtWhichApplicable_sequence;
    typedef xsd::cxx::tree::sequence< placesAtWhichApplicable_type >::iterator placesAtWhichApplicable_iterator;
    typedef xsd::cxx::tree::sequence< placesAtWhichApplicable_type >::const_iterator placesAtWhichApplicable_const_iterator;
    typedef ::xsd::cxx::tree::traits< placesAtWhichApplicable_type, char > placesAtWhichApplicable_traits;

    const placesAtWhichApplicable_sequence&
    placesAtWhichApplicable () const;

    placesAtWhichApplicable_sequence&
    placesAtWhichApplicable ();

    void
    placesAtWhichApplicable (const placesAtWhichApplicable_sequence& s);

    // automaticallyInitiated
    // 
    typedef ::datex2::Boolean automaticallyInitiated_type;
    typedef ::xsd::cxx::tree::optional< automaticallyInitiated_type > automaticallyInitiated_optional;
    typedef ::xsd::cxx::tree::traits< automaticallyInitiated_type, char > automaticallyInitiated_traits;

    const automaticallyInitiated_optional&
    automaticallyInitiated () const;

    automaticallyInitiated_optional&
    automaticallyInitiated ();

    void
    automaticallyInitiated (const automaticallyInitiated_type& x);

    void
    automaticallyInitiated (const automaticallyInitiated_optional& x);

    void
    automaticallyInitiated (::std::auto_ptr< automaticallyInitiated_type > p);

    // forVehiclesWithCharacteristicsOf
    // 
    typedef ::datex2::VehicleCharacteristics forVehiclesWithCharacteristicsOf_type;
    typedef ::xsd::cxx::tree::sequence< forVehiclesWithCharacteristicsOf_type > forVehiclesWithCharacteristicsOf_sequence;
    typedef xsd::cxx::tree::sequence< forVehiclesWithCharacteristicsOf_type >::iterator forVehiclesWithCharacteristicsOf_iterator;
    typedef xsd::cxx::tree::sequence< forVehiclesWithCharacteristicsOf_type >::const_iterator forVehiclesWithCharacteristicsOf_const_iterator;
    typedef ::xsd::cxx::tree::traits< forVehiclesWithCharacteristicsOf_type, char > forVehiclesWithCharacteristicsOf_traits;

    const forVehiclesWithCharacteristicsOf_sequence&
    forVehiclesWithCharacteristicsOf () const;

    forVehiclesWithCharacteristicsOf_sequence&
    forVehiclesWithCharacteristicsOf ();

    void
    forVehiclesWithCharacteristicsOf (const forVehiclesWithCharacteristicsOf_sequence& s);

    // networkManagementExtension
    // 
    typedef ::datex2::ExtensionType networkManagementExtension_type;
    typedef ::xsd::cxx::tree::optional< networkManagementExtension_type > networkManagementExtension_optional;
    typedef ::xsd::cxx::tree::traits< networkManagementExtension_type, char > networkManagementExtension_traits;

    const networkManagementExtension_optional&
    networkManagementExtension () const;

    networkManagementExtension_optional&
    networkManagementExtension ();

    void
    networkManagementExtension (const networkManagementExtension_type& x);

    void
    networkManagementExtension (const networkManagementExtension_optional& x);

    void
    networkManagementExtension (::std::auto_ptr< networkManagementExtension_type > p);

    // Constructors.
    //
    NetworkManagement (const situationRecordCreationTime_type&,
                       const situationRecordVersion_type&,
                       const situationRecordVersionTime_type&,
                       const probabilityOfOccurrence_type&,
                       const validity_type&,
                       const groupOfLocations_type&,
                       const id_type&,
                       const complianceOption_type&);

    NetworkManagement (const situationRecordCreationTime_type&,
                       const situationRecordVersion_type&,
                       const situationRecordVersionTime_type&,
                       const probabilityOfOccurrence_type&,
                       ::std::auto_ptr< validity_type >&,
                       ::std::auto_ptr< groupOfLocations_type >&,
                       const id_type&,
                       const complianceOption_type&);

    NetworkManagement (const xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    NetworkManagement (const NetworkManagement& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual NetworkManagement*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~NetworkManagement ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< complianceOption_type > complianceOption_;
    applicableForTrafficDirection_sequence applicableForTrafficDirection_;
    applicableForTrafficType_sequence applicableForTrafficType_;
    placesAtWhichApplicable_sequence placesAtWhichApplicable_;
    automaticallyInitiated_optional automaticallyInitiated_;
    forVehiclesWithCharacteristicsOf_sequence forVehiclesWithCharacteristicsOf_;
    networkManagementExtension_optional networkManagementExtension_;
  };

  class GeneralInstructionToRoadUsers: public ::datex2::NetworkManagement
  {
    public:
    // generalInstructionToRoadUsersType
    // 
    typedef ::datex2::GeneralInstructionToRoadUsersTypeEnum generalInstructionToRoadUsersType_type;
    typedef ::xsd::cxx::tree::traits< generalInstructionToRoadUsersType_type, char > generalInstructionToRoadUsersType_traits;

    const generalInstructionToRoadUsersType_type&
    generalInstructionToRoadUsersType () const;

    generalInstructionToRoadUsersType_type&
    generalInstructionToRoadUsersType ();

    void
    generalInstructionToRoadUsersType (const generalInstructionToRoadUsersType_type& x);

    void
    generalInstructionToRoadUsersType (::std::auto_ptr< generalInstructionToRoadUsersType_type > p);

    // generalInstructionToRoadUsersExtension
    // 
    typedef ::datex2::ExtensionType generalInstructionToRoadUsersExtension_type;
    typedef ::xsd::cxx::tree::optional< generalInstructionToRoadUsersExtension_type > generalInstructionToRoadUsersExtension_optional;
    typedef ::xsd::cxx::tree::traits< generalInstructionToRoadUsersExtension_type, char > generalInstructionToRoadUsersExtension_traits;

    const generalInstructionToRoadUsersExtension_optional&
    generalInstructionToRoadUsersExtension () const;

    generalInstructionToRoadUsersExtension_optional&
    generalInstructionToRoadUsersExtension ();

    void
    generalInstructionToRoadUsersExtension (const generalInstructionToRoadUsersExtension_type& x);

    void
    generalInstructionToRoadUsersExtension (const generalInstructionToRoadUsersExtension_optional& x);

    void
    generalInstructionToRoadUsersExtension (::std::auto_ptr< generalInstructionToRoadUsersExtension_type > p);

    // Constructors.
    //
    GeneralInstructionToRoadUsers (const situationRecordCreationTime_type&,
                                   const situationRecordVersion_type&,
                                   const situationRecordVersionTime_type&,
                                   const probabilityOfOccurrence_type&,
                                   const validity_type&,
                                   const groupOfLocations_type&,
                                   const id_type&,
                                   const complianceOption_type&,
                                   const generalInstructionToRoadUsersType_type&);

    GeneralInstructionToRoadUsers (const situationRecordCreationTime_type&,
                                   const situationRecordVersion_type&,
                                   const situationRecordVersionTime_type&,
                                   const probabilityOfOccurrence_type&,
                                   ::std::auto_ptr< validity_type >&,
                                   ::std::auto_ptr< groupOfLocations_type >&,
                                   const id_type&,
                                   const complianceOption_type&,
                                   const generalInstructionToRoadUsersType_type&);

    GeneralInstructionToRoadUsers (const xercesc::DOMElement& e,
                                   ::xml_schema::flags f = 0,
                                   ::xml_schema::container* c = 0);

    GeneralInstructionToRoadUsers (const GeneralInstructionToRoadUsers& x,
                                   ::xml_schema::flags f = 0,
                                   ::xml_schema::container* c = 0);

    virtual GeneralInstructionToRoadUsers*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~GeneralInstructionToRoadUsers ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< generalInstructionToRoadUsersType_type > generalInstructionToRoadUsersType_;
    generalInstructionToRoadUsersExtension_optional generalInstructionToRoadUsersExtension_;
  };

  class GeneralInstructionToRoadUsersTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      allowEmergencyVehiclesToPass,
      approachWithCare,
      avoidTheArea,
      closeAllWindowsTurnOffHeaterAndVents,
      crossJunctionWithCare,
      doNotAllowUnnecessaryGaps,
      doNotLeaveYourVehicle,
      doNotThrowOutAnyBurningObjects,
      doNotUseNavigationSystems,
      driveCarefully,
      driveWithExtremeCaution,
      flashYourLights,
      followTheVehicleInFrontSmoothly,
      increaseNormalFollowingDistance,
      inEmergencyWaitForPatrolService,
      keepYourDistance,
      leaveYourVehicleProceedToNextSafePlace,
      noNakedFlames,
      noOvertaking,
      noSmoking,
      noStopping,
      noUturns,
      observeSignals,
      observeSigns,
      onlyTravelIfAbsolutelyNecessary,
      overtakeWithCare,
      pullOverToTheEdgeOfTheRoadway,
      stopAtNextSafePlace,
      stopAtNextServiceArea,
      switchOffEngine,
      switchOffMobilePhonesAndTwoWayRadios,
      testYourBrakes,
      useBusService,
      useFogLights,
      useHazardWarningLights,
      useHeadlights,
      useRailService,
      useTramService,
      useUndergroundService,
      waitForEscortVehicle,
      other
    };

    GeneralInstructionToRoadUsersTypeEnum (value v);

    GeneralInstructionToRoadUsersTypeEnum (const char* v);

    GeneralInstructionToRoadUsersTypeEnum (const ::std::string& v);

    GeneralInstructionToRoadUsersTypeEnum (const ::xml_schema::string& v);

    GeneralInstructionToRoadUsersTypeEnum (const xercesc::DOMElement& e,
                                           ::xml_schema::flags f = 0,
                                           ::xml_schema::container* c = 0);

    GeneralInstructionToRoadUsersTypeEnum (const xercesc::DOMAttr& a,
                                           ::xml_schema::flags f = 0,
                                           ::xml_schema::container* c = 0);

    GeneralInstructionToRoadUsersTypeEnum (const ::std::string& s,
                                           const xercesc::DOMElement* e,
                                           ::xml_schema::flags f = 0,
                                           ::xml_schema::container* c = 0);

    GeneralInstructionToRoadUsersTypeEnum (const GeneralInstructionToRoadUsersTypeEnum& x,
                                           ::xml_schema::flags f = 0,
                                           ::xml_schema::container* c = 0);

    virtual GeneralInstructionToRoadUsersTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    GeneralInstructionToRoadUsersTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_GeneralInstructionToRoadUsersTypeEnum_convert ();
    }

    protected:
    value
    _xsd_GeneralInstructionToRoadUsersTypeEnum_convert () const;

    public:
    static const char* const _xsd_GeneralInstructionToRoadUsersTypeEnum_literals_[41];
    static const value _xsd_GeneralInstructionToRoadUsersTypeEnum_indexes_[41];
  };

  class GeneralNetworkManagement: public ::datex2::NetworkManagement
  {
    public:
    // generalNetworkManagementType
    // 
    typedef ::datex2::GeneralNetworkManagementTypeEnum generalNetworkManagementType_type;
    typedef ::xsd::cxx::tree::traits< generalNetworkManagementType_type, char > generalNetworkManagementType_traits;

    const generalNetworkManagementType_type&
    generalNetworkManagementType () const;

    generalNetworkManagementType_type&
    generalNetworkManagementType ();

    void
    generalNetworkManagementType (const generalNetworkManagementType_type& x);

    void
    generalNetworkManagementType (::std::auto_ptr< generalNetworkManagementType_type > p);

    // trafficManuallyDirectedBy
    // 
    typedef ::datex2::PersonCategoryEnum trafficManuallyDirectedBy_type;
    typedef ::xsd::cxx::tree::optional< trafficManuallyDirectedBy_type > trafficManuallyDirectedBy_optional;
    typedef ::xsd::cxx::tree::traits< trafficManuallyDirectedBy_type, char > trafficManuallyDirectedBy_traits;

    const trafficManuallyDirectedBy_optional&
    trafficManuallyDirectedBy () const;

    trafficManuallyDirectedBy_optional&
    trafficManuallyDirectedBy ();

    void
    trafficManuallyDirectedBy (const trafficManuallyDirectedBy_type& x);

    void
    trafficManuallyDirectedBy (const trafficManuallyDirectedBy_optional& x);

    void
    trafficManuallyDirectedBy (::std::auto_ptr< trafficManuallyDirectedBy_type > p);

    // generalNetworkManagementExtension
    // 
    typedef ::datex2::ExtensionType generalNetworkManagementExtension_type;
    typedef ::xsd::cxx::tree::optional< generalNetworkManagementExtension_type > generalNetworkManagementExtension_optional;
    typedef ::xsd::cxx::tree::traits< generalNetworkManagementExtension_type, char > generalNetworkManagementExtension_traits;

    const generalNetworkManagementExtension_optional&
    generalNetworkManagementExtension () const;

    generalNetworkManagementExtension_optional&
    generalNetworkManagementExtension ();

    void
    generalNetworkManagementExtension (const generalNetworkManagementExtension_type& x);

    void
    generalNetworkManagementExtension (const generalNetworkManagementExtension_optional& x);

    void
    generalNetworkManagementExtension (::std::auto_ptr< generalNetworkManagementExtension_type > p);

    // Constructors.
    //
    GeneralNetworkManagement (const situationRecordCreationTime_type&,
                              const situationRecordVersion_type&,
                              const situationRecordVersionTime_type&,
                              const probabilityOfOccurrence_type&,
                              const validity_type&,
                              const groupOfLocations_type&,
                              const id_type&,
                              const complianceOption_type&,
                              const generalNetworkManagementType_type&);

    GeneralNetworkManagement (const situationRecordCreationTime_type&,
                              const situationRecordVersion_type&,
                              const situationRecordVersionTime_type&,
                              const probabilityOfOccurrence_type&,
                              ::std::auto_ptr< validity_type >&,
                              ::std::auto_ptr< groupOfLocations_type >&,
                              const id_type&,
                              const complianceOption_type&,
                              const generalNetworkManagementType_type&);

    GeneralNetworkManagement (const xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    GeneralNetworkManagement (const GeneralNetworkManagement& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual GeneralNetworkManagement*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~GeneralNetworkManagement ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< generalNetworkManagementType_type > generalNetworkManagementType_;
    trafficManuallyDirectedBy_optional trafficManuallyDirectedBy_;
    generalNetworkManagementExtension_optional generalNetworkManagementExtension_;
  };

  class GeneralNetworkManagementTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      bridgeSwingInOperation,
      convoyService,
      obstacleSignalling,
      rampMeteringInOperation,
      temporaryTrafficLights,
      tollGatesOpen,
      trafficBeingManuallyDirected,
      trafficHeld,
      other
    };

    GeneralNetworkManagementTypeEnum (value v);

    GeneralNetworkManagementTypeEnum (const char* v);

    GeneralNetworkManagementTypeEnum (const ::std::string& v);

    GeneralNetworkManagementTypeEnum (const ::xml_schema::string& v);

    GeneralNetworkManagementTypeEnum (const xercesc::DOMElement& e,
                                      ::xml_schema::flags f = 0,
                                      ::xml_schema::container* c = 0);

    GeneralNetworkManagementTypeEnum (const xercesc::DOMAttr& a,
                                      ::xml_schema::flags f = 0,
                                      ::xml_schema::container* c = 0);

    GeneralNetworkManagementTypeEnum (const ::std::string& s,
                                      const xercesc::DOMElement* e,
                                      ::xml_schema::flags f = 0,
                                      ::xml_schema::container* c = 0);

    GeneralNetworkManagementTypeEnum (const GeneralNetworkManagementTypeEnum& x,
                                      ::xml_schema::flags f = 0,
                                      ::xml_schema::container* c = 0);

    virtual GeneralNetworkManagementTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    GeneralNetworkManagementTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_GeneralNetworkManagementTypeEnum_convert ();
    }

    protected:
    value
    _xsd_GeneralNetworkManagementTypeEnum_convert () const;

    public:
    static const char* const _xsd_GeneralNetworkManagementTypeEnum_literals_[9];
    static const value _xsd_GeneralNetworkManagementTypeEnum_indexes_[9];
  };

  class GeneralObstruction: public ::datex2::Obstruction
  {
    public:
    // obstructionType
    // 
    typedef ::datex2::ObstructionTypeEnum obstructionType_type;
    typedef ::xsd::cxx::tree::sequence< obstructionType_type > obstructionType_sequence;
    typedef xsd::cxx::tree::sequence< obstructionType_type >::iterator obstructionType_iterator;
    typedef xsd::cxx::tree::sequence< obstructionType_type >::const_iterator obstructionType_const_iterator;
    typedef ::xsd::cxx::tree::traits< obstructionType_type, char > obstructionType_traits;

    const obstructionType_sequence&
    obstructionType () const;

    obstructionType_sequence&
    obstructionType ();

    void
    obstructionType (const obstructionType_sequence& s);

    // generalObstructionExtension
    // 
    typedef ::datex2::ExtensionType generalObstructionExtension_type;
    typedef ::xsd::cxx::tree::optional< generalObstructionExtension_type > generalObstructionExtension_optional;
    typedef ::xsd::cxx::tree::traits< generalObstructionExtension_type, char > generalObstructionExtension_traits;

    const generalObstructionExtension_optional&
    generalObstructionExtension () const;

    generalObstructionExtension_optional&
    generalObstructionExtension ();

    void
    generalObstructionExtension (const generalObstructionExtension_type& x);

    void
    generalObstructionExtension (const generalObstructionExtension_optional& x);

    void
    generalObstructionExtension (::std::auto_ptr< generalObstructionExtension_type > p);

    // Constructors.
    //
    GeneralObstruction (const situationRecordCreationTime_type&,
                        const situationRecordVersion_type&,
                        const situationRecordVersionTime_type&,
                        const probabilityOfOccurrence_type&,
                        const validity_type&,
                        const groupOfLocations_type&,
                        const id_type&);

    GeneralObstruction (const situationRecordCreationTime_type&,
                        const situationRecordVersion_type&,
                        const situationRecordVersionTime_type&,
                        const probabilityOfOccurrence_type&,
                        ::std::auto_ptr< validity_type >&,
                        ::std::auto_ptr< groupOfLocations_type >&,
                        const id_type&);

    GeneralObstruction (const xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    GeneralObstruction (const GeneralObstruction& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual GeneralObstruction*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~GeneralObstruction ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    obstructionType_sequence obstructionType_;
    generalObstructionExtension_optional generalObstructionExtension_;
  };

  class GenericPublication: public ::datex2::PayloadPublication
  {
    public:
    // genericPublicationName
    // 
    typedef ::datex2::String genericPublicationName_type;
    typedef ::xsd::cxx::tree::traits< genericPublicationName_type, char > genericPublicationName_traits;

    const genericPublicationName_type&
    genericPublicationName () const;

    genericPublicationName_type&
    genericPublicationName ();

    void
    genericPublicationName (const genericPublicationName_type& x);

    void
    genericPublicationName (::std::auto_ptr< genericPublicationName_type > p);

    // genericPublicationExtension
    // 
    typedef ::datex2::ExtensionType genericPublicationExtension_type;
    typedef ::xsd::cxx::tree::optional< genericPublicationExtension_type > genericPublicationExtension_optional;
    typedef ::xsd::cxx::tree::traits< genericPublicationExtension_type, char > genericPublicationExtension_traits;

    const genericPublicationExtension_optional&
    genericPublicationExtension () const;

    genericPublicationExtension_optional&
    genericPublicationExtension ();

    void
    genericPublicationExtension (const genericPublicationExtension_type& x);

    void
    genericPublicationExtension (const genericPublicationExtension_optional& x);

    void
    genericPublicationExtension (::std::auto_ptr< genericPublicationExtension_type > p);

    // Constructors.
    //
    GenericPublication (const publicationTime_type&,
                        const publicationCreator_type&,
                        const lang_type&,
                        const genericPublicationName_type&);

    GenericPublication (const publicationTime_type&,
                        ::std::auto_ptr< publicationCreator_type >&,
                        const lang_type&,
                        const genericPublicationName_type&);

    GenericPublication (const xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    GenericPublication (const GenericPublication& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual GenericPublication*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~GenericPublication ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< genericPublicationName_type > genericPublicationName_;
    genericPublicationExtension_optional genericPublicationExtension_;
  };

  class GenericSituationRecord: public ::datex2::SituationRecord
  {
    public:
    // genericSituationRecordName
    // 
    typedef ::datex2::String genericSituationRecordName_type;
    typedef ::xsd::cxx::tree::traits< genericSituationRecordName_type, char > genericSituationRecordName_traits;

    const genericSituationRecordName_type&
    genericSituationRecordName () const;

    genericSituationRecordName_type&
    genericSituationRecordName ();

    void
    genericSituationRecordName (const genericSituationRecordName_type& x);

    void
    genericSituationRecordName (::std::auto_ptr< genericSituationRecordName_type > p);

    // genericSituationRecordExtension
    // 
    typedef ::datex2::ExtensionType genericSituationRecordExtension_type;
    typedef ::xsd::cxx::tree::optional< genericSituationRecordExtension_type > genericSituationRecordExtension_optional;
    typedef ::xsd::cxx::tree::traits< genericSituationRecordExtension_type, char > genericSituationRecordExtension_traits;

    const genericSituationRecordExtension_optional&
    genericSituationRecordExtension () const;

    genericSituationRecordExtension_optional&
    genericSituationRecordExtension ();

    void
    genericSituationRecordExtension (const genericSituationRecordExtension_type& x);

    void
    genericSituationRecordExtension (const genericSituationRecordExtension_optional& x);

    void
    genericSituationRecordExtension (::std::auto_ptr< genericSituationRecordExtension_type > p);

    // Constructors.
    //
    GenericSituationRecord (const situationRecordCreationTime_type&,
                            const situationRecordVersion_type&,
                            const situationRecordVersionTime_type&,
                            const probabilityOfOccurrence_type&,
                            const validity_type&,
                            const groupOfLocations_type&,
                            const id_type&,
                            const genericSituationRecordName_type&);

    GenericSituationRecord (const situationRecordCreationTime_type&,
                            const situationRecordVersion_type&,
                            const situationRecordVersionTime_type&,
                            const probabilityOfOccurrence_type&,
                            ::std::auto_ptr< validity_type >&,
                            ::std::auto_ptr< groupOfLocations_type >&,
                            const id_type&,
                            const genericSituationRecordName_type&);

    GenericSituationRecord (const xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    GenericSituationRecord (const GenericSituationRecord& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual GenericSituationRecord*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~GenericSituationRecord ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< genericSituationRecordName_type > genericSituationRecordName_;
    genericSituationRecordExtension_optional genericSituationRecordExtension_;
  };

  class GrossWeightCharacteristic: public ::xml_schema::type
  {
    public:
    // comparisonOperator
    // 
    typedef ::datex2::ComparisonOperatorEnum comparisonOperator_type;
    typedef ::xsd::cxx::tree::traits< comparisonOperator_type, char > comparisonOperator_traits;

    const comparisonOperator_type&
    comparisonOperator () const;

    comparisonOperator_type&
    comparisonOperator ();

    void
    comparisonOperator (const comparisonOperator_type& x);

    void
    comparisonOperator (::std::auto_ptr< comparisonOperator_type > p);

    // grossVehicleWeight
    // 
    typedef ::datex2::Tonnes grossVehicleWeight_type;
    typedef ::xsd::cxx::tree::traits< grossVehicleWeight_type, char > grossVehicleWeight_traits;

    const grossVehicleWeight_type&
    grossVehicleWeight () const;

    grossVehicleWeight_type&
    grossVehicleWeight ();

    void
    grossVehicleWeight (const grossVehicleWeight_type& x);

    void
    grossVehicleWeight (::std::auto_ptr< grossVehicleWeight_type > p);

    // grossWeightCharacteristicExtension
    // 
    typedef ::datex2::ExtensionType grossWeightCharacteristicExtension_type;
    typedef ::xsd::cxx::tree::optional< grossWeightCharacteristicExtension_type > grossWeightCharacteristicExtension_optional;
    typedef ::xsd::cxx::tree::traits< grossWeightCharacteristicExtension_type, char > grossWeightCharacteristicExtension_traits;

    const grossWeightCharacteristicExtension_optional&
    grossWeightCharacteristicExtension () const;

    grossWeightCharacteristicExtension_optional&
    grossWeightCharacteristicExtension ();

    void
    grossWeightCharacteristicExtension (const grossWeightCharacteristicExtension_type& x);

    void
    grossWeightCharacteristicExtension (const grossWeightCharacteristicExtension_optional& x);

    void
    grossWeightCharacteristicExtension (::std::auto_ptr< grossWeightCharacteristicExtension_type > p);

    // Constructors.
    //
    GrossWeightCharacteristic (const comparisonOperator_type&,
                               const grossVehicleWeight_type&);

    GrossWeightCharacteristic (const xercesc::DOMElement& e,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    GrossWeightCharacteristic (const GrossWeightCharacteristic& x,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    virtual GrossWeightCharacteristic*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~GrossWeightCharacteristic ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< comparisonOperator_type > comparisonOperator_;
    ::xsd::cxx::tree::one< grossVehicleWeight_type > grossVehicleWeight_;
    grossWeightCharacteristicExtension_optional grossWeightCharacteristicExtension_;
  };

  class GroupOfLocations: public ::xml_schema::type
  {
    public:
    // groupOfLocationsExtension
    // 
    typedef ::datex2::ExtensionType groupOfLocationsExtension_type;
    typedef ::xsd::cxx::tree::optional< groupOfLocationsExtension_type > groupOfLocationsExtension_optional;
    typedef ::xsd::cxx::tree::traits< groupOfLocationsExtension_type, char > groupOfLocationsExtension_traits;

    const groupOfLocationsExtension_optional&
    groupOfLocationsExtension () const;

    groupOfLocationsExtension_optional&
    groupOfLocationsExtension ();

    void
    groupOfLocationsExtension (const groupOfLocationsExtension_type& x);

    void
    groupOfLocationsExtension (const groupOfLocationsExtension_optional& x);

    void
    groupOfLocationsExtension (::std::auto_ptr< groupOfLocationsExtension_type > p);

    // Constructors.
    //
    GroupOfLocations ();

    GroupOfLocations (const xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    GroupOfLocations (const GroupOfLocations& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual GroupOfLocations*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~GroupOfLocations ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    groupOfLocationsExtension_optional groupOfLocationsExtension_;
  };

  class GroupOfLocationsByReference: public ::datex2::GroupOfLocations
  {
    public:
    // predefinedLocationSetReference
    // 
    typedef ::datex2::Reference predefinedLocationSetReference_type;
    typedef ::xsd::cxx::tree::traits< predefinedLocationSetReference_type, char > predefinedLocationSetReference_traits;

    const predefinedLocationSetReference_type&
    predefinedLocationSetReference () const;

    predefinedLocationSetReference_type&
    predefinedLocationSetReference ();

    void
    predefinedLocationSetReference (const predefinedLocationSetReference_type& x);

    void
    predefinedLocationSetReference (::std::auto_ptr< predefinedLocationSetReference_type > p);

    // groupOfLocationsByReferenceExtension
    // 
    typedef ::datex2::ExtensionType groupOfLocationsByReferenceExtension_type;
    typedef ::xsd::cxx::tree::optional< groupOfLocationsByReferenceExtension_type > groupOfLocationsByReferenceExtension_optional;
    typedef ::xsd::cxx::tree::traits< groupOfLocationsByReferenceExtension_type, char > groupOfLocationsByReferenceExtension_traits;

    const groupOfLocationsByReferenceExtension_optional&
    groupOfLocationsByReferenceExtension () const;

    groupOfLocationsByReferenceExtension_optional&
    groupOfLocationsByReferenceExtension ();

    void
    groupOfLocationsByReferenceExtension (const groupOfLocationsByReferenceExtension_type& x);

    void
    groupOfLocationsByReferenceExtension (const groupOfLocationsByReferenceExtension_optional& x);

    void
    groupOfLocationsByReferenceExtension (::std::auto_ptr< groupOfLocationsByReferenceExtension_type > p);

    // Constructors.
    //
    GroupOfLocationsByReference (const predefinedLocationSetReference_type&);

    GroupOfLocationsByReference (const xercesc::DOMElement& e,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    GroupOfLocationsByReference (const GroupOfLocationsByReference& x,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    virtual GroupOfLocationsByReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~GroupOfLocationsByReference ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< predefinedLocationSetReference_type > predefinedLocationSetReference_;
    groupOfLocationsByReferenceExtension_optional groupOfLocationsByReferenceExtension_;
  };

  class GroupOfNonOrderedLocations: public ::datex2::GroupOfLocations
  {
    public:
    // locationContainedInGroup
    // 
    typedef ::datex2::Location locationContainedInGroup_type;
    typedef ::xsd::cxx::tree::sequence< locationContainedInGroup_type > locationContainedInGroup_sequence;
    typedef xsd::cxx::tree::sequence< locationContainedInGroup_type >::iterator locationContainedInGroup_iterator;
    typedef xsd::cxx::tree::sequence< locationContainedInGroup_type >::const_iterator locationContainedInGroup_const_iterator;
    typedef ::xsd::cxx::tree::traits< locationContainedInGroup_type, char > locationContainedInGroup_traits;

    const locationContainedInGroup_sequence&
    locationContainedInGroup () const;

    locationContainedInGroup_sequence&
    locationContainedInGroup ();

    void
    locationContainedInGroup (const locationContainedInGroup_sequence& s);

    // groupOfNonOrderedLocationsExtension
    // 
    typedef ::datex2::ExtensionType groupOfNonOrderedLocationsExtension_type;
    typedef ::xsd::cxx::tree::optional< groupOfNonOrderedLocationsExtension_type > groupOfNonOrderedLocationsExtension_optional;
    typedef ::xsd::cxx::tree::traits< groupOfNonOrderedLocationsExtension_type, char > groupOfNonOrderedLocationsExtension_traits;

    const groupOfNonOrderedLocationsExtension_optional&
    groupOfNonOrderedLocationsExtension () const;

    groupOfNonOrderedLocationsExtension_optional&
    groupOfNonOrderedLocationsExtension ();

    void
    groupOfNonOrderedLocationsExtension (const groupOfNonOrderedLocationsExtension_type& x);

    void
    groupOfNonOrderedLocationsExtension (const groupOfNonOrderedLocationsExtension_optional& x);

    void
    groupOfNonOrderedLocationsExtension (::std::auto_ptr< groupOfNonOrderedLocationsExtension_type > p);

    // Constructors.
    //
    GroupOfNonOrderedLocations ();

    GroupOfNonOrderedLocations (const xercesc::DOMElement& e,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    GroupOfNonOrderedLocations (const GroupOfNonOrderedLocations& x,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    virtual GroupOfNonOrderedLocations*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~GroupOfNonOrderedLocations ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    locationContainedInGroup_sequence locationContainedInGroup_;
    groupOfNonOrderedLocationsExtension_optional groupOfNonOrderedLocationsExtension_;
  };

  class GroupOfPeopleInvolved: public ::xml_schema::type
  {
    public:
    // numberOfPeople
    // 
    typedef ::datex2::NonNegativeInteger numberOfPeople_type;
    typedef ::xsd::cxx::tree::optional< numberOfPeople_type > numberOfPeople_optional;
    typedef ::xsd::cxx::tree::traits< numberOfPeople_type, char > numberOfPeople_traits;

    const numberOfPeople_optional&
    numberOfPeople () const;

    numberOfPeople_optional&
    numberOfPeople ();

    void
    numberOfPeople (const numberOfPeople_type& x);

    void
    numberOfPeople (const numberOfPeople_optional& x);

    void
    numberOfPeople (::std::auto_ptr< numberOfPeople_type > p);

    // injuryStatus
    // 
    typedef ::datex2::InjuryStatusTypeEnum injuryStatus_type;
    typedef ::xsd::cxx::tree::optional< injuryStatus_type > injuryStatus_optional;
    typedef ::xsd::cxx::tree::traits< injuryStatus_type, char > injuryStatus_traits;

    const injuryStatus_optional&
    injuryStatus () const;

    injuryStatus_optional&
    injuryStatus ();

    void
    injuryStatus (const injuryStatus_type& x);

    void
    injuryStatus (const injuryStatus_optional& x);

    void
    injuryStatus (::std::auto_ptr< injuryStatus_type > p);

    // involvementRole
    // 
    typedef ::datex2::InvolvementRolesEnum involvementRole_type;
    typedef ::xsd::cxx::tree::optional< involvementRole_type > involvementRole_optional;
    typedef ::xsd::cxx::tree::traits< involvementRole_type, char > involvementRole_traits;

    const involvementRole_optional&
    involvementRole () const;

    involvementRole_optional&
    involvementRole ();

    void
    involvementRole (const involvementRole_type& x);

    void
    involvementRole (const involvementRole_optional& x);

    void
    involvementRole (::std::auto_ptr< involvementRole_type > p);

    // categoryOfPeopleInvolved
    // 
    typedef ::datex2::PersonCategoryEnum categoryOfPeopleInvolved_type;
    typedef ::xsd::cxx::tree::optional< categoryOfPeopleInvolved_type > categoryOfPeopleInvolved_optional;
    typedef ::xsd::cxx::tree::traits< categoryOfPeopleInvolved_type, char > categoryOfPeopleInvolved_traits;

    const categoryOfPeopleInvolved_optional&
    categoryOfPeopleInvolved () const;

    categoryOfPeopleInvolved_optional&
    categoryOfPeopleInvolved ();

    void
    categoryOfPeopleInvolved (const categoryOfPeopleInvolved_type& x);

    void
    categoryOfPeopleInvolved (const categoryOfPeopleInvolved_optional& x);

    void
    categoryOfPeopleInvolved (::std::auto_ptr< categoryOfPeopleInvolved_type > p);

    // groupOfPeopleInvolvedExtension
    // 
    typedef ::datex2::ExtensionType groupOfPeopleInvolvedExtension_type;
    typedef ::xsd::cxx::tree::optional< groupOfPeopleInvolvedExtension_type > groupOfPeopleInvolvedExtension_optional;
    typedef ::xsd::cxx::tree::traits< groupOfPeopleInvolvedExtension_type, char > groupOfPeopleInvolvedExtension_traits;

    const groupOfPeopleInvolvedExtension_optional&
    groupOfPeopleInvolvedExtension () const;

    groupOfPeopleInvolvedExtension_optional&
    groupOfPeopleInvolvedExtension ();

    void
    groupOfPeopleInvolvedExtension (const groupOfPeopleInvolvedExtension_type& x);

    void
    groupOfPeopleInvolvedExtension (const groupOfPeopleInvolvedExtension_optional& x);

    void
    groupOfPeopleInvolvedExtension (::std::auto_ptr< groupOfPeopleInvolvedExtension_type > p);

    // Constructors.
    //
    GroupOfPeopleInvolved ();

    GroupOfPeopleInvolved (const xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    GroupOfPeopleInvolved (const GroupOfPeopleInvolved& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual GroupOfPeopleInvolved*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~GroupOfPeopleInvolved ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    numberOfPeople_optional numberOfPeople_;
    injuryStatus_optional injuryStatus_;
    involvementRole_optional involvementRole_;
    categoryOfPeopleInvolved_optional categoryOfPeopleInvolved_;
    groupOfPeopleInvolvedExtension_optional groupOfPeopleInvolvedExtension_;
  };

  class GroupOfVehiclesInvolved: public ::xml_schema::type
  {
    public:
    // numberOfVehicles
    // 
    typedef ::datex2::NonNegativeInteger numberOfVehicles_type;
    typedef ::xsd::cxx::tree::optional< numberOfVehicles_type > numberOfVehicles_optional;
    typedef ::xsd::cxx::tree::traits< numberOfVehicles_type, char > numberOfVehicles_traits;

    const numberOfVehicles_optional&
    numberOfVehicles () const;

    numberOfVehicles_optional&
    numberOfVehicles ();

    void
    numberOfVehicles (const numberOfVehicles_type& x);

    void
    numberOfVehicles (const numberOfVehicles_optional& x);

    void
    numberOfVehicles (::std::auto_ptr< numberOfVehicles_type > p);

    // vehicleStatus
    // 
    typedef ::datex2::VehicleStatusEnum vehicleStatus_type;
    typedef ::xsd::cxx::tree::optional< vehicleStatus_type > vehicleStatus_optional;
    typedef ::xsd::cxx::tree::traits< vehicleStatus_type, char > vehicleStatus_traits;

    const vehicleStatus_optional&
    vehicleStatus () const;

    vehicleStatus_optional&
    vehicleStatus ();

    void
    vehicleStatus (const vehicleStatus_type& x);

    void
    vehicleStatus (const vehicleStatus_optional& x);

    void
    vehicleStatus (::std::auto_ptr< vehicleStatus_type > p);

    // vehicleCharacteristics
    // 
    typedef ::datex2::VehicleCharacteristics vehicleCharacteristics_type;
    typedef ::xsd::cxx::tree::optional< vehicleCharacteristics_type > vehicleCharacteristics_optional;
    typedef ::xsd::cxx::tree::traits< vehicleCharacteristics_type, char > vehicleCharacteristics_traits;

    const vehicleCharacteristics_optional&
    vehicleCharacteristics () const;

    vehicleCharacteristics_optional&
    vehicleCharacteristics ();

    void
    vehicleCharacteristics (const vehicleCharacteristics_type& x);

    void
    vehicleCharacteristics (const vehicleCharacteristics_optional& x);

    void
    vehicleCharacteristics (::std::auto_ptr< vehicleCharacteristics_type > p);

    // groupOfVehiclesInvolvedExtension
    // 
    typedef ::datex2::ExtensionType groupOfVehiclesInvolvedExtension_type;
    typedef ::xsd::cxx::tree::optional< groupOfVehiclesInvolvedExtension_type > groupOfVehiclesInvolvedExtension_optional;
    typedef ::xsd::cxx::tree::traits< groupOfVehiclesInvolvedExtension_type, char > groupOfVehiclesInvolvedExtension_traits;

    const groupOfVehiclesInvolvedExtension_optional&
    groupOfVehiclesInvolvedExtension () const;

    groupOfVehiclesInvolvedExtension_optional&
    groupOfVehiclesInvolvedExtension ();

    void
    groupOfVehiclesInvolvedExtension (const groupOfVehiclesInvolvedExtension_type& x);

    void
    groupOfVehiclesInvolvedExtension (const groupOfVehiclesInvolvedExtension_optional& x);

    void
    groupOfVehiclesInvolvedExtension (::std::auto_ptr< groupOfVehiclesInvolvedExtension_type > p);

    // Constructors.
    //
    GroupOfVehiclesInvolved ();

    GroupOfVehiclesInvolved (const xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    GroupOfVehiclesInvolved (const GroupOfVehiclesInvolved& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual GroupOfVehiclesInvolved*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~GroupOfVehiclesInvolved ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    numberOfVehicles_optional numberOfVehicles_;
    vehicleStatus_optional vehicleStatus_;
    vehicleCharacteristics_optional vehicleCharacteristics_;
    groupOfVehiclesInvolvedExtension_optional groupOfVehiclesInvolvedExtension_;
  };

  class HazardousMaterials: public ::xml_schema::type
  {
    public:
    // chemicalName
    // 
    typedef ::datex2::MultilingualString chemicalName_type;
    typedef ::xsd::cxx::tree::traits< chemicalName_type, char > chemicalName_traits;

    const chemicalName_type&
    chemicalName () const;

    chemicalName_type&
    chemicalName ();

    void
    chemicalName (const chemicalName_type& x);

    void
    chemicalName (::std::auto_ptr< chemicalName_type > p);

    // dangerousGoodsFlashPoint
    // 
    typedef ::datex2::TemperatureCelsius dangerousGoodsFlashPoint_type;
    typedef ::xsd::cxx::tree::optional< dangerousGoodsFlashPoint_type > dangerousGoodsFlashPoint_optional;
    typedef ::xsd::cxx::tree::traits< dangerousGoodsFlashPoint_type, char > dangerousGoodsFlashPoint_traits;

    const dangerousGoodsFlashPoint_optional&
    dangerousGoodsFlashPoint () const;

    dangerousGoodsFlashPoint_optional&
    dangerousGoodsFlashPoint ();

    void
    dangerousGoodsFlashPoint (const dangerousGoodsFlashPoint_type& x);

    void
    dangerousGoodsFlashPoint (const dangerousGoodsFlashPoint_optional& x);

    void
    dangerousGoodsFlashPoint (::std::auto_ptr< dangerousGoodsFlashPoint_type > p);

    // dangerousGoodsRegulations
    // 
    typedef ::datex2::DangerousGoodsRegulationsEnum dangerousGoodsRegulations_type;
    typedef ::xsd::cxx::tree::optional< dangerousGoodsRegulations_type > dangerousGoodsRegulations_optional;
    typedef ::xsd::cxx::tree::traits< dangerousGoodsRegulations_type, char > dangerousGoodsRegulations_traits;

    const dangerousGoodsRegulations_optional&
    dangerousGoodsRegulations () const;

    dangerousGoodsRegulations_optional&
    dangerousGoodsRegulations ();

    void
    dangerousGoodsRegulations (const dangerousGoodsRegulations_type& x);

    void
    dangerousGoodsRegulations (const dangerousGoodsRegulations_optional& x);

    void
    dangerousGoodsRegulations (::std::auto_ptr< dangerousGoodsRegulations_type > p);

    // hazardCodeIdentification
    // 
    typedef ::datex2::String hazardCodeIdentification_type;
    typedef ::xsd::cxx::tree::optional< hazardCodeIdentification_type > hazardCodeIdentification_optional;
    typedef ::xsd::cxx::tree::traits< hazardCodeIdentification_type, char > hazardCodeIdentification_traits;

    const hazardCodeIdentification_optional&
    hazardCodeIdentification () const;

    hazardCodeIdentification_optional&
    hazardCodeIdentification ();

    void
    hazardCodeIdentification (const hazardCodeIdentification_type& x);

    void
    hazardCodeIdentification (const hazardCodeIdentification_optional& x);

    void
    hazardCodeIdentification (::std::auto_ptr< hazardCodeIdentification_type > p);

    // hazardCodeVersionNumber
    // 
    typedef ::datex2::NonNegativeInteger hazardCodeVersionNumber_type;
    typedef ::xsd::cxx::tree::optional< hazardCodeVersionNumber_type > hazardCodeVersionNumber_optional;
    typedef ::xsd::cxx::tree::traits< hazardCodeVersionNumber_type, char > hazardCodeVersionNumber_traits;

    const hazardCodeVersionNumber_optional&
    hazardCodeVersionNumber () const;

    hazardCodeVersionNumber_optional&
    hazardCodeVersionNumber ();

    void
    hazardCodeVersionNumber (const hazardCodeVersionNumber_type& x);

    void
    hazardCodeVersionNumber (const hazardCodeVersionNumber_optional& x);

    void
    hazardCodeVersionNumber (::std::auto_ptr< hazardCodeVersionNumber_type > p);

    // hazardSubstanceItemPageNumber
    // 
    typedef ::datex2::String hazardSubstanceItemPageNumber_type;
    typedef ::xsd::cxx::tree::optional< hazardSubstanceItemPageNumber_type > hazardSubstanceItemPageNumber_optional;
    typedef ::xsd::cxx::tree::traits< hazardSubstanceItemPageNumber_type, char > hazardSubstanceItemPageNumber_traits;

    const hazardSubstanceItemPageNumber_optional&
    hazardSubstanceItemPageNumber () const;

    hazardSubstanceItemPageNumber_optional&
    hazardSubstanceItemPageNumber ();

    void
    hazardSubstanceItemPageNumber (const hazardSubstanceItemPageNumber_type& x);

    void
    hazardSubstanceItemPageNumber (const hazardSubstanceItemPageNumber_optional& x);

    void
    hazardSubstanceItemPageNumber (::std::auto_ptr< hazardSubstanceItemPageNumber_type > p);

    // tremCardNumber
    // 
    typedef ::datex2::String tremCardNumber_type;
    typedef ::xsd::cxx::tree::optional< tremCardNumber_type > tremCardNumber_optional;
    typedef ::xsd::cxx::tree::traits< tremCardNumber_type, char > tremCardNumber_traits;

    const tremCardNumber_optional&
    tremCardNumber () const;

    tremCardNumber_optional&
    tremCardNumber ();

    void
    tremCardNumber (const tremCardNumber_type& x);

    void
    tremCardNumber (const tremCardNumber_optional& x);

    void
    tremCardNumber (::std::auto_ptr< tremCardNumber_type > p);

    // undgNumber
    // 
    typedef ::datex2::String undgNumber_type;
    typedef ::xsd::cxx::tree::optional< undgNumber_type > undgNumber_optional;
    typedef ::xsd::cxx::tree::traits< undgNumber_type, char > undgNumber_traits;

    const undgNumber_optional&
    undgNumber () const;

    undgNumber_optional&
    undgNumber ();

    void
    undgNumber (const undgNumber_type& x);

    void
    undgNumber (const undgNumber_optional& x);

    void
    undgNumber (::std::auto_ptr< undgNumber_type > p);

    // volumeOfDangerousGoods
    // 
    typedef ::datex2::CubicMetres volumeOfDangerousGoods_type;
    typedef ::xsd::cxx::tree::optional< volumeOfDangerousGoods_type > volumeOfDangerousGoods_optional;
    typedef ::xsd::cxx::tree::traits< volumeOfDangerousGoods_type, char > volumeOfDangerousGoods_traits;

    const volumeOfDangerousGoods_optional&
    volumeOfDangerousGoods () const;

    volumeOfDangerousGoods_optional&
    volumeOfDangerousGoods ();

    void
    volumeOfDangerousGoods (const volumeOfDangerousGoods_type& x);

    void
    volumeOfDangerousGoods (const volumeOfDangerousGoods_optional& x);

    void
    volumeOfDangerousGoods (::std::auto_ptr< volumeOfDangerousGoods_type > p);

    // weightOfDangerousGoods
    // 
    typedef ::datex2::Tonnes weightOfDangerousGoods_type;
    typedef ::xsd::cxx::tree::optional< weightOfDangerousGoods_type > weightOfDangerousGoods_optional;
    typedef ::xsd::cxx::tree::traits< weightOfDangerousGoods_type, char > weightOfDangerousGoods_traits;

    const weightOfDangerousGoods_optional&
    weightOfDangerousGoods () const;

    weightOfDangerousGoods_optional&
    weightOfDangerousGoods ();

    void
    weightOfDangerousGoods (const weightOfDangerousGoods_type& x);

    void
    weightOfDangerousGoods (const weightOfDangerousGoods_optional& x);

    void
    weightOfDangerousGoods (::std::auto_ptr< weightOfDangerousGoods_type > p);

    // hazardousMaterialsExtension
    // 
    typedef ::datex2::ExtensionType hazardousMaterialsExtension_type;
    typedef ::xsd::cxx::tree::optional< hazardousMaterialsExtension_type > hazardousMaterialsExtension_optional;
    typedef ::xsd::cxx::tree::traits< hazardousMaterialsExtension_type, char > hazardousMaterialsExtension_traits;

    const hazardousMaterialsExtension_optional&
    hazardousMaterialsExtension () const;

    hazardousMaterialsExtension_optional&
    hazardousMaterialsExtension ();

    void
    hazardousMaterialsExtension (const hazardousMaterialsExtension_type& x);

    void
    hazardousMaterialsExtension (const hazardousMaterialsExtension_optional& x);

    void
    hazardousMaterialsExtension (::std::auto_ptr< hazardousMaterialsExtension_type > p);

    // Constructors.
    //
    HazardousMaterials (const chemicalName_type&);

    HazardousMaterials (::std::auto_ptr< chemicalName_type >&);

    HazardousMaterials (const xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    HazardousMaterials (const HazardousMaterials& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual HazardousMaterials*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~HazardousMaterials ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< chemicalName_type > chemicalName_;
    dangerousGoodsFlashPoint_optional dangerousGoodsFlashPoint_;
    dangerousGoodsRegulations_optional dangerousGoodsRegulations_;
    hazardCodeIdentification_optional hazardCodeIdentification_;
    hazardCodeVersionNumber_optional hazardCodeVersionNumber_;
    hazardSubstanceItemPageNumber_optional hazardSubstanceItemPageNumber_;
    tremCardNumber_optional tremCardNumber_;
    undgNumber_optional undgNumber_;
    volumeOfDangerousGoods_optional volumeOfDangerousGoods_;
    weightOfDangerousGoods_optional weightOfDangerousGoods_;
    hazardousMaterialsExtension_optional hazardousMaterialsExtension_;
  };

  class HeaderInformation: public ::xml_schema::type
  {
    public:
    // areaOfInterest
    // 
    typedef ::datex2::AreaOfInterestEnum areaOfInterest_type;
    typedef ::xsd::cxx::tree::optional< areaOfInterest_type > areaOfInterest_optional;
    typedef ::xsd::cxx::tree::traits< areaOfInterest_type, char > areaOfInterest_traits;

    const areaOfInterest_optional&
    areaOfInterest () const;

    areaOfInterest_optional&
    areaOfInterest ();

    void
    areaOfInterest (const areaOfInterest_type& x);

    void
    areaOfInterest (const areaOfInterest_optional& x);

    void
    areaOfInterest (::std::auto_ptr< areaOfInterest_type > p);

    // confidentiality
    // 
    typedef ::datex2::ConfidentialityValueEnum confidentiality_type;
    typedef ::xsd::cxx::tree::traits< confidentiality_type, char > confidentiality_traits;

    const confidentiality_type&
    confidentiality () const;

    confidentiality_type&
    confidentiality ();

    void
    confidentiality (const confidentiality_type& x);

    void
    confidentiality (::std::auto_ptr< confidentiality_type > p);

    // informationStatus
    // 
    typedef ::datex2::InformationStatusEnum informationStatus_type;
    typedef ::xsd::cxx::tree::traits< informationStatus_type, char > informationStatus_traits;

    const informationStatus_type&
    informationStatus () const;

    informationStatus_type&
    informationStatus ();

    void
    informationStatus (const informationStatus_type& x);

    void
    informationStatus (::std::auto_ptr< informationStatus_type > p);

    // urgency
    // 
    typedef ::datex2::UrgencyEnum urgency_type;
    typedef ::xsd::cxx::tree::optional< urgency_type > urgency_optional;
    typedef ::xsd::cxx::tree::traits< urgency_type, char > urgency_traits;

    const urgency_optional&
    urgency () const;

    urgency_optional&
    urgency ();

    void
    urgency (const urgency_type& x);

    void
    urgency (const urgency_optional& x);

    void
    urgency (::std::auto_ptr< urgency_type > p);

    // headerInformationExtension
    // 
    typedef ::datex2::ExtensionType headerInformationExtension_type;
    typedef ::xsd::cxx::tree::optional< headerInformationExtension_type > headerInformationExtension_optional;
    typedef ::xsd::cxx::tree::traits< headerInformationExtension_type, char > headerInformationExtension_traits;

    const headerInformationExtension_optional&
    headerInformationExtension () const;

    headerInformationExtension_optional&
    headerInformationExtension ();

    void
    headerInformationExtension (const headerInformationExtension_type& x);

    void
    headerInformationExtension (const headerInformationExtension_optional& x);

    void
    headerInformationExtension (::std::auto_ptr< headerInformationExtension_type > p);

    // Constructors.
    //
    HeaderInformation (const confidentiality_type&,
                       const informationStatus_type&);

    HeaderInformation (const xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    HeaderInformation (const HeaderInformation& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual HeaderInformation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~HeaderInformation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    areaOfInterest_optional areaOfInterest_;
    ::xsd::cxx::tree::one< confidentiality_type > confidentiality_;
    ::xsd::cxx::tree::one< informationStatus_type > informationStatus_;
    urgency_optional urgency_;
    headerInformationExtension_optional headerInformationExtension_;
  };

  class HeaviestAxleWeightCharacteristic: public ::xml_schema::type
  {
    public:
    // comparisonOperator
    // 
    typedef ::datex2::ComparisonOperatorEnum comparisonOperator_type;
    typedef ::xsd::cxx::tree::traits< comparisonOperator_type, char > comparisonOperator_traits;

    const comparisonOperator_type&
    comparisonOperator () const;

    comparisonOperator_type&
    comparisonOperator ();

    void
    comparisonOperator (const comparisonOperator_type& x);

    void
    comparisonOperator (::std::auto_ptr< comparisonOperator_type > p);

    // heaviestAxleWeight
    // 
    typedef ::datex2::Tonnes heaviestAxleWeight_type;
    typedef ::xsd::cxx::tree::traits< heaviestAxleWeight_type, char > heaviestAxleWeight_traits;

    const heaviestAxleWeight_type&
    heaviestAxleWeight () const;

    heaviestAxleWeight_type&
    heaviestAxleWeight ();

    void
    heaviestAxleWeight (const heaviestAxleWeight_type& x);

    void
    heaviestAxleWeight (::std::auto_ptr< heaviestAxleWeight_type > p);

    // heaviestAxleWeightCharacteristicExtension
    // 
    typedef ::datex2::ExtensionType heaviestAxleWeightCharacteristicExtension_type;
    typedef ::xsd::cxx::tree::optional< heaviestAxleWeightCharacteristicExtension_type > heaviestAxleWeightCharacteristicExtension_optional;
    typedef ::xsd::cxx::tree::traits< heaviestAxleWeightCharacteristicExtension_type, char > heaviestAxleWeightCharacteristicExtension_traits;

    const heaviestAxleWeightCharacteristicExtension_optional&
    heaviestAxleWeightCharacteristicExtension () const;

    heaviestAxleWeightCharacteristicExtension_optional&
    heaviestAxleWeightCharacteristicExtension ();

    void
    heaviestAxleWeightCharacteristicExtension (const heaviestAxleWeightCharacteristicExtension_type& x);

    void
    heaviestAxleWeightCharacteristicExtension (const heaviestAxleWeightCharacteristicExtension_optional& x);

    void
    heaviestAxleWeightCharacteristicExtension (::std::auto_ptr< heaviestAxleWeightCharacteristicExtension_type > p);

    // Constructors.
    //
    HeaviestAxleWeightCharacteristic (const comparisonOperator_type&,
                                      const heaviestAxleWeight_type&);

    HeaviestAxleWeightCharacteristic (const xercesc::DOMElement& e,
                                      ::xml_schema::flags f = 0,
                                      ::xml_schema::container* c = 0);

    HeaviestAxleWeightCharacteristic (const HeaviestAxleWeightCharacteristic& x,
                                      ::xml_schema::flags f = 0,
                                      ::xml_schema::container* c = 0);

    virtual HeaviestAxleWeightCharacteristic*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~HeaviestAxleWeightCharacteristic ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< comparisonOperator_type > comparisonOperator_;
    ::xsd::cxx::tree::one< heaviestAxleWeight_type > heaviestAxleWeight_;
    heaviestAxleWeightCharacteristicExtension_optional heaviestAxleWeightCharacteristicExtension_;
  };

  class HeightCharacteristic: public ::xml_schema::type
  {
    public:
    // comparisonOperator
    // 
    typedef ::datex2::ComparisonOperatorEnum comparisonOperator_type;
    typedef ::xsd::cxx::tree::traits< comparisonOperator_type, char > comparisonOperator_traits;

    const comparisonOperator_type&
    comparisonOperator () const;

    comparisonOperator_type&
    comparisonOperator ();

    void
    comparisonOperator (const comparisonOperator_type& x);

    void
    comparisonOperator (::std::auto_ptr< comparisonOperator_type > p);

    // vehicleHeight
    // 
    typedef ::datex2::MetresAsFloat vehicleHeight_type;
    typedef ::xsd::cxx::tree::traits< vehicleHeight_type, char > vehicleHeight_traits;

    const vehicleHeight_type&
    vehicleHeight () const;

    vehicleHeight_type&
    vehicleHeight ();

    void
    vehicleHeight (const vehicleHeight_type& x);

    void
    vehicleHeight (::std::auto_ptr< vehicleHeight_type > p);

    // heightCharacteristicExtension
    // 
    typedef ::datex2::ExtensionType heightCharacteristicExtension_type;
    typedef ::xsd::cxx::tree::optional< heightCharacteristicExtension_type > heightCharacteristicExtension_optional;
    typedef ::xsd::cxx::tree::traits< heightCharacteristicExtension_type, char > heightCharacteristicExtension_traits;

    const heightCharacteristicExtension_optional&
    heightCharacteristicExtension () const;

    heightCharacteristicExtension_optional&
    heightCharacteristicExtension ();

    void
    heightCharacteristicExtension (const heightCharacteristicExtension_type& x);

    void
    heightCharacteristicExtension (const heightCharacteristicExtension_optional& x);

    void
    heightCharacteristicExtension (::std::auto_ptr< heightCharacteristicExtension_type > p);

    // Constructors.
    //
    HeightCharacteristic (const comparisonOperator_type&,
                          const vehicleHeight_type&);

    HeightCharacteristic (const xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    HeightCharacteristic (const HeightCharacteristic& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual HeightCharacteristic*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~HeightCharacteristic ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< comparisonOperator_type > comparisonOperator_;
    ::xsd::cxx::tree::one< vehicleHeight_type > vehicleHeight_;
    heightCharacteristicExtension_optional heightCharacteristicExtension_;
  };

  class Humidity: public ::xml_schema::type
  {
    public:
    // relativeHumidity
    // 
    typedef ::datex2::Percentage relativeHumidity_type;
    typedef ::xsd::cxx::tree::traits< relativeHumidity_type, char > relativeHumidity_traits;

    const relativeHumidity_type&
    relativeHumidity () const;

    relativeHumidity_type&
    relativeHumidity ();

    void
    relativeHumidity (const relativeHumidity_type& x);

    void
    relativeHumidity (::std::auto_ptr< relativeHumidity_type > p);

    // humidityExtension
    // 
    typedef ::datex2::ExtensionType humidityExtension_type;
    typedef ::xsd::cxx::tree::optional< humidityExtension_type > humidityExtension_optional;
    typedef ::xsd::cxx::tree::traits< humidityExtension_type, char > humidityExtension_traits;

    const humidityExtension_optional&
    humidityExtension () const;

    humidityExtension_optional&
    humidityExtension ();

    void
    humidityExtension (const humidityExtension_type& x);

    void
    humidityExtension (const humidityExtension_optional& x);

    void
    humidityExtension (::std::auto_ptr< humidityExtension_type > p);

    // Constructors.
    //
    Humidity (const relativeHumidity_type&);

    Humidity (const xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    Humidity (const Humidity& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual Humidity*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Humidity ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< relativeHumidity_type > relativeHumidity_;
    humidityExtension_optional humidityExtension_;
  };

  class WeatherValue: public ::datex2::BasicDataValue
  {
    public:
    // weatherValueExtension
    // 
    typedef ::datex2::ExtensionType weatherValueExtension_type;
    typedef ::xsd::cxx::tree::optional< weatherValueExtension_type > weatherValueExtension_optional;
    typedef ::xsd::cxx::tree::traits< weatherValueExtension_type, char > weatherValueExtension_traits;

    const weatherValueExtension_optional&
    weatherValueExtension () const;

    weatherValueExtension_optional&
    weatherValueExtension ();

    void
    weatherValueExtension (const weatherValueExtension_type& x);

    void
    weatherValueExtension (const weatherValueExtension_optional& x);

    void
    weatherValueExtension (::std::auto_ptr< weatherValueExtension_type > p);

    // Constructors.
    //
    WeatherValue ();

    WeatherValue (const xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    WeatherValue (const WeatherValue& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual WeatherValue*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~WeatherValue ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    weatherValueExtension_optional weatherValueExtension_;
  };

  class HumidityInformation: public ::datex2::WeatherValue
  {
    public:
    // humidity
    // 
    typedef ::datex2::Humidity humidity_type;
    typedef ::xsd::cxx::tree::traits< humidity_type, char > humidity_traits;

    const humidity_type&
    humidity () const;

    humidity_type&
    humidity ();

    void
    humidity (const humidity_type& x);

    void
    humidity (::std::auto_ptr< humidity_type > p);

    // humidityInformationExtension
    // 
    typedef ::datex2::ExtensionType humidityInformationExtension_type;
    typedef ::xsd::cxx::tree::optional< humidityInformationExtension_type > humidityInformationExtension_optional;
    typedef ::xsd::cxx::tree::traits< humidityInformationExtension_type, char > humidityInformationExtension_traits;

    const humidityInformationExtension_optional&
    humidityInformationExtension () const;

    humidityInformationExtension_optional&
    humidityInformationExtension ();

    void
    humidityInformationExtension (const humidityInformationExtension_type& x);

    void
    humidityInformationExtension (const humidityInformationExtension_optional& x);

    void
    humidityInformationExtension (::std::auto_ptr< humidityInformationExtension_type > p);

    // Constructors.
    //
    HumidityInformation (const humidity_type&);

    HumidityInformation (::std::auto_ptr< humidity_type >&);

    HumidityInformation (const xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    HumidityInformation (const HumidityInformation& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual HumidityInformation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~HumidityInformation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< humidity_type > humidity_;
    humidityInformationExtension_optional humidityInformationExtension_;
  };

  class Impact: public ::xml_schema::type
  {
    public:
    // capacityRemaining
    // 
    typedef ::datex2::Percentage capacityRemaining_type;
    typedef ::xsd::cxx::tree::optional< capacityRemaining_type > capacityRemaining_optional;
    typedef ::xsd::cxx::tree::traits< capacityRemaining_type, char > capacityRemaining_traits;

    const capacityRemaining_optional&
    capacityRemaining () const;

    capacityRemaining_optional&
    capacityRemaining ();

    void
    capacityRemaining (const capacityRemaining_type& x);

    void
    capacityRemaining (const capacityRemaining_optional& x);

    void
    capacityRemaining (::std::auto_ptr< capacityRemaining_type > p);

    // numberOfLanesRestricted
    // 
    typedef ::datex2::NonNegativeInteger numberOfLanesRestricted_type;
    typedef ::xsd::cxx::tree::optional< numberOfLanesRestricted_type > numberOfLanesRestricted_optional;
    typedef ::xsd::cxx::tree::traits< numberOfLanesRestricted_type, char > numberOfLanesRestricted_traits;

    const numberOfLanesRestricted_optional&
    numberOfLanesRestricted () const;

    numberOfLanesRestricted_optional&
    numberOfLanesRestricted ();

    void
    numberOfLanesRestricted (const numberOfLanesRestricted_type& x);

    void
    numberOfLanesRestricted (const numberOfLanesRestricted_optional& x);

    void
    numberOfLanesRestricted (::std::auto_ptr< numberOfLanesRestricted_type > p);

    // numberOfOperationalLanes
    // 
    typedef ::datex2::NonNegativeInteger numberOfOperationalLanes_type;
    typedef ::xsd::cxx::tree::optional< numberOfOperationalLanes_type > numberOfOperationalLanes_optional;
    typedef ::xsd::cxx::tree::traits< numberOfOperationalLanes_type, char > numberOfOperationalLanes_traits;

    const numberOfOperationalLanes_optional&
    numberOfOperationalLanes () const;

    numberOfOperationalLanes_optional&
    numberOfOperationalLanes ();

    void
    numberOfOperationalLanes (const numberOfOperationalLanes_type& x);

    void
    numberOfOperationalLanes (const numberOfOperationalLanes_optional& x);

    void
    numberOfOperationalLanes (::std::auto_ptr< numberOfOperationalLanes_type > p);

    // originalNumberOfLanes
    // 
    typedef ::datex2::NonNegativeInteger originalNumberOfLanes_type;
    typedef ::xsd::cxx::tree::optional< originalNumberOfLanes_type > originalNumberOfLanes_optional;
    typedef ::xsd::cxx::tree::traits< originalNumberOfLanes_type, char > originalNumberOfLanes_traits;

    const originalNumberOfLanes_optional&
    originalNumberOfLanes () const;

    originalNumberOfLanes_optional&
    originalNumberOfLanes ();

    void
    originalNumberOfLanes (const originalNumberOfLanes_type& x);

    void
    originalNumberOfLanes (const originalNumberOfLanes_optional& x);

    void
    originalNumberOfLanes (::std::auto_ptr< originalNumberOfLanes_type > p);

    // residualRoadWidth
    // 
    typedef ::datex2::MetresAsFloat residualRoadWidth_type;
    typedef ::xsd::cxx::tree::optional< residualRoadWidth_type > residualRoadWidth_optional;
    typedef ::xsd::cxx::tree::traits< residualRoadWidth_type, char > residualRoadWidth_traits;

    const residualRoadWidth_optional&
    residualRoadWidth () const;

    residualRoadWidth_optional&
    residualRoadWidth ();

    void
    residualRoadWidth (const residualRoadWidth_type& x);

    void
    residualRoadWidth (const residualRoadWidth_optional& x);

    void
    residualRoadWidth (::std::auto_ptr< residualRoadWidth_type > p);

    // trafficConstrictionType
    // 
    typedef ::datex2::TrafficConstrictionTypeEnum trafficConstrictionType_type;
    typedef ::xsd::cxx::tree::optional< trafficConstrictionType_type > trafficConstrictionType_optional;
    typedef ::xsd::cxx::tree::traits< trafficConstrictionType_type, char > trafficConstrictionType_traits;

    const trafficConstrictionType_optional&
    trafficConstrictionType () const;

    trafficConstrictionType_optional&
    trafficConstrictionType ();

    void
    trafficConstrictionType (const trafficConstrictionType_type& x);

    void
    trafficConstrictionType (const trafficConstrictionType_optional& x);

    void
    trafficConstrictionType (::std::auto_ptr< trafficConstrictionType_type > p);

    // delays
    // 
    typedef ::datex2::Delays delays_type;
    typedef ::xsd::cxx::tree::optional< delays_type > delays_optional;
    typedef ::xsd::cxx::tree::traits< delays_type, char > delays_traits;

    const delays_optional&
    delays () const;

    delays_optional&
    delays ();

    void
    delays (const delays_type& x);

    void
    delays (const delays_optional& x);

    void
    delays (::std::auto_ptr< delays_type > p);

    // impactExtension
    // 
    typedef ::datex2::ExtensionType impactExtension_type;
    typedef ::xsd::cxx::tree::optional< impactExtension_type > impactExtension_optional;
    typedef ::xsd::cxx::tree::traits< impactExtension_type, char > impactExtension_traits;

    const impactExtension_optional&
    impactExtension () const;

    impactExtension_optional&
    impactExtension ();

    void
    impactExtension (const impactExtension_type& x);

    void
    impactExtension (const impactExtension_optional& x);

    void
    impactExtension (::std::auto_ptr< impactExtension_type > p);

    // Constructors.
    //
    Impact ();

    Impact (const xercesc::DOMElement& e,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    Impact (const Impact& x,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    virtual Impact*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Impact ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    capacityRemaining_optional capacityRemaining_;
    numberOfLanesRestricted_optional numberOfLanesRestricted_;
    numberOfOperationalLanes_optional numberOfOperationalLanes_;
    originalNumberOfLanes_optional originalNumberOfLanes_;
    residualRoadWidth_optional residualRoadWidth_;
    trafficConstrictionType_optional trafficConstrictionType_;
    delays_optional delays_;
    impactExtension_optional impactExtension_;
  };

  class TrafficValue: public ::datex2::BasicDataValue
  {
    public:
    // forVehiclesWithCharacteristicsOf
    // 
    typedef ::datex2::VehicleCharacteristics forVehiclesWithCharacteristicsOf_type;
    typedef ::xsd::cxx::tree::optional< forVehiclesWithCharacteristicsOf_type > forVehiclesWithCharacteristicsOf_optional;
    typedef ::xsd::cxx::tree::traits< forVehiclesWithCharacteristicsOf_type, char > forVehiclesWithCharacteristicsOf_traits;

    const forVehiclesWithCharacteristicsOf_optional&
    forVehiclesWithCharacteristicsOf () const;

    forVehiclesWithCharacteristicsOf_optional&
    forVehiclesWithCharacteristicsOf ();

    void
    forVehiclesWithCharacteristicsOf (const forVehiclesWithCharacteristicsOf_type& x);

    void
    forVehiclesWithCharacteristicsOf (const forVehiclesWithCharacteristicsOf_optional& x);

    void
    forVehiclesWithCharacteristicsOf (::std::auto_ptr< forVehiclesWithCharacteristicsOf_type > p);

    // trafficValueExtension
    // 
    typedef ::datex2::ExtensionType trafficValueExtension_type;
    typedef ::xsd::cxx::tree::optional< trafficValueExtension_type > trafficValueExtension_optional;
    typedef ::xsd::cxx::tree::traits< trafficValueExtension_type, char > trafficValueExtension_traits;

    const trafficValueExtension_optional&
    trafficValueExtension () const;

    trafficValueExtension_optional&
    trafficValueExtension ();

    void
    trafficValueExtension (const trafficValueExtension_type& x);

    void
    trafficValueExtension (const trafficValueExtension_optional& x);

    void
    trafficValueExtension (::std::auto_ptr< trafficValueExtension_type > p);

    // Constructors.
    //
    TrafficValue ();

    TrafficValue (const xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    TrafficValue (const TrafficValue& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual TrafficValue*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TrafficValue ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    forVehiclesWithCharacteristicsOf_optional forVehiclesWithCharacteristicsOf_;
    trafficValueExtension_optional trafficValueExtension_;
  };

  class IndividualVehicleMeasurements: public ::datex2::TrafficValue
  {
    public:
    // vehicleSpeed
    // 
    typedef ::datex2::VehicleSpeed vehicleSpeed_type;
    typedef ::xsd::cxx::tree::optional< vehicleSpeed_type > vehicleSpeed_optional;
    typedef ::xsd::cxx::tree::traits< vehicleSpeed_type, char > vehicleSpeed_traits;

    const vehicleSpeed_optional&
    vehicleSpeed () const;

    vehicleSpeed_optional&
    vehicleSpeed ();

    void
    vehicleSpeed (const vehicleSpeed_type& x);

    void
    vehicleSpeed (const vehicleSpeed_optional& x);

    void
    vehicleSpeed (::std::auto_ptr< vehicleSpeed_type > p);

    // vehicleDetectionTime
    // 
    typedef ::datex2::VehicleDetectionTime vehicleDetectionTime_type;
    typedef ::xsd::cxx::tree::optional< vehicleDetectionTime_type > vehicleDetectionTime_optional;
    typedef ::xsd::cxx::tree::traits< vehicleDetectionTime_type, char > vehicleDetectionTime_traits;

    const vehicleDetectionTime_optional&
    vehicleDetectionTime () const;

    vehicleDetectionTime_optional&
    vehicleDetectionTime ();

    void
    vehicleDetectionTime (const vehicleDetectionTime_type& x);

    void
    vehicleDetectionTime (const vehicleDetectionTime_optional& x);

    void
    vehicleDetectionTime (::std::auto_ptr< vehicleDetectionTime_type > p);

    // vehicleHeadway
    // 
    typedef ::datex2::VehicleHeadway vehicleHeadway_type;
    typedef ::xsd::cxx::tree::optional< vehicleHeadway_type > vehicleHeadway_optional;
    typedef ::xsd::cxx::tree::traits< vehicleHeadway_type, char > vehicleHeadway_traits;

    const vehicleHeadway_optional&
    vehicleHeadway () const;

    vehicleHeadway_optional&
    vehicleHeadway ();

    void
    vehicleHeadway (const vehicleHeadway_type& x);

    void
    vehicleHeadway (const vehicleHeadway_optional& x);

    void
    vehicleHeadway (::std::auto_ptr< vehicleHeadway_type > p);

    // individualVehicleMeasurementsExtension
    // 
    typedef ::datex2::ExtensionType individualVehicleMeasurementsExtension_type;
    typedef ::xsd::cxx::tree::optional< individualVehicleMeasurementsExtension_type > individualVehicleMeasurementsExtension_optional;
    typedef ::xsd::cxx::tree::traits< individualVehicleMeasurementsExtension_type, char > individualVehicleMeasurementsExtension_traits;

    const individualVehicleMeasurementsExtension_optional&
    individualVehicleMeasurementsExtension () const;

    individualVehicleMeasurementsExtension_optional&
    individualVehicleMeasurementsExtension ();

    void
    individualVehicleMeasurementsExtension (const individualVehicleMeasurementsExtension_type& x);

    void
    individualVehicleMeasurementsExtension (const individualVehicleMeasurementsExtension_optional& x);

    void
    individualVehicleMeasurementsExtension (::std::auto_ptr< individualVehicleMeasurementsExtension_type > p);

    // Constructors.
    //
    IndividualVehicleMeasurements ();

    IndividualVehicleMeasurements (const xercesc::DOMElement& e,
                                   ::xml_schema::flags f = 0,
                                   ::xml_schema::container* c = 0);

    IndividualVehicleMeasurements (const IndividualVehicleMeasurements& x,
                                   ::xml_schema::flags f = 0,
                                   ::xml_schema::container* c = 0);

    virtual IndividualVehicleMeasurements*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~IndividualVehicleMeasurements ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    vehicleSpeed_optional vehicleSpeed_;
    vehicleDetectionTime_optional vehicleDetectionTime_;
    vehicleHeadway_optional vehicleHeadway_;
    individualVehicleMeasurementsExtension_optional individualVehicleMeasurementsExtension_;
  };

  class InformationStatusEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      real,
      securityExercise,
      technicalExercise,
      test
    };

    InformationStatusEnum (value v);

    InformationStatusEnum (const char* v);

    InformationStatusEnum (const ::std::string& v);

    InformationStatusEnum (const ::xml_schema::string& v);

    InformationStatusEnum (const xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    InformationStatusEnum (const xercesc::DOMAttr& a,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    InformationStatusEnum (const ::std::string& s,
                           const xercesc::DOMElement* e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    InformationStatusEnum (const InformationStatusEnum& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual InformationStatusEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    InformationStatusEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_InformationStatusEnum_convert ();
    }

    protected:
    value
    _xsd_InformationStatusEnum_convert () const;

    public:
    static const char* const _xsd_InformationStatusEnum_literals_[4];
    static const value _xsd_InformationStatusEnum_indexes_[4];
  };

  class InfrastructureDamageObstruction: public ::datex2::Obstruction
  {
    public:
    // infrastructureDamageType
    // 
    typedef ::datex2::InfrastructureDamageTypeEnum infrastructureDamageType_type;
    typedef ::xsd::cxx::tree::traits< infrastructureDamageType_type, char > infrastructureDamageType_traits;

    const infrastructureDamageType_type&
    infrastructureDamageType () const;

    infrastructureDamageType_type&
    infrastructureDamageType ();

    void
    infrastructureDamageType (const infrastructureDamageType_type& x);

    void
    infrastructureDamageType (::std::auto_ptr< infrastructureDamageType_type > p);

    // infrastructureDamageObstructionExtension
    // 
    typedef ::datex2::ExtensionType infrastructureDamageObstructionExtension_type;
    typedef ::xsd::cxx::tree::optional< infrastructureDamageObstructionExtension_type > infrastructureDamageObstructionExtension_optional;
    typedef ::xsd::cxx::tree::traits< infrastructureDamageObstructionExtension_type, char > infrastructureDamageObstructionExtension_traits;

    const infrastructureDamageObstructionExtension_optional&
    infrastructureDamageObstructionExtension () const;

    infrastructureDamageObstructionExtension_optional&
    infrastructureDamageObstructionExtension ();

    void
    infrastructureDamageObstructionExtension (const infrastructureDamageObstructionExtension_type& x);

    void
    infrastructureDamageObstructionExtension (const infrastructureDamageObstructionExtension_optional& x);

    void
    infrastructureDamageObstructionExtension (::std::auto_ptr< infrastructureDamageObstructionExtension_type > p);

    // Constructors.
    //
    InfrastructureDamageObstruction (const situationRecordCreationTime_type&,
                                     const situationRecordVersion_type&,
                                     const situationRecordVersionTime_type&,
                                     const probabilityOfOccurrence_type&,
                                     const validity_type&,
                                     const groupOfLocations_type&,
                                     const id_type&,
                                     const infrastructureDamageType_type&);

    InfrastructureDamageObstruction (const situationRecordCreationTime_type&,
                                     const situationRecordVersion_type&,
                                     const situationRecordVersionTime_type&,
                                     const probabilityOfOccurrence_type&,
                                     ::std::auto_ptr< validity_type >&,
                                     ::std::auto_ptr< groupOfLocations_type >&,
                                     const id_type&,
                                     const infrastructureDamageType_type&);

    InfrastructureDamageObstruction (const xercesc::DOMElement& e,
                                     ::xml_schema::flags f = 0,
                                     ::xml_schema::container* c = 0);

    InfrastructureDamageObstruction (const InfrastructureDamageObstruction& x,
                                     ::xml_schema::flags f = 0,
                                     ::xml_schema::container* c = 0);

    virtual InfrastructureDamageObstruction*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~InfrastructureDamageObstruction ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< infrastructureDamageType_type > infrastructureDamageType_;
    infrastructureDamageObstructionExtension_optional infrastructureDamageObstructionExtension_;
  };

  class InfrastructureDamageTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      burstPipe,
      burstWaterMain,
      collapsedSewer,
      damagedBridge,
      damagedCrashBarrier,
      damagedFlyover,
      damagedGallery,
      damagedGantry,
      damagedRoadSurface,
      damagedTunnel,
      damagedViaduct,
      fallenPowerCables,
      gasLeak,
      weakBridge,
      other
    };

    InfrastructureDamageTypeEnum (value v);

    InfrastructureDamageTypeEnum (const char* v);

    InfrastructureDamageTypeEnum (const ::std::string& v);

    InfrastructureDamageTypeEnum (const ::xml_schema::string& v);

    InfrastructureDamageTypeEnum (const xercesc::DOMElement& e,
                                  ::xml_schema::flags f = 0,
                                  ::xml_schema::container* c = 0);

    InfrastructureDamageTypeEnum (const xercesc::DOMAttr& a,
                                  ::xml_schema::flags f = 0,
                                  ::xml_schema::container* c = 0);

    InfrastructureDamageTypeEnum (const ::std::string& s,
                                  const xercesc::DOMElement* e,
                                  ::xml_schema::flags f = 0,
                                  ::xml_schema::container* c = 0);

    InfrastructureDamageTypeEnum (const InfrastructureDamageTypeEnum& x,
                                  ::xml_schema::flags f = 0,
                                  ::xml_schema::container* c = 0);

    virtual InfrastructureDamageTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    InfrastructureDamageTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_InfrastructureDamageTypeEnum_convert ();
    }

    protected:
    value
    _xsd_InfrastructureDamageTypeEnum_convert () const;

    public:
    static const char* const _xsd_InfrastructureDamageTypeEnum_literals_[15];
    static const value _xsd_InfrastructureDamageTypeEnum_indexes_[15];
  };

  class InjuryStatusTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      dead,
      injured,
      seriouslyInjured,
      slightlyInjured,
      uninjured,
      unknown
    };

    InjuryStatusTypeEnum (value v);

    InjuryStatusTypeEnum (const char* v);

    InjuryStatusTypeEnum (const ::std::string& v);

    InjuryStatusTypeEnum (const ::xml_schema::string& v);

    InjuryStatusTypeEnum (const xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    InjuryStatusTypeEnum (const xercesc::DOMAttr& a,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    InjuryStatusTypeEnum (const ::std::string& s,
                          const xercesc::DOMElement* e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    InjuryStatusTypeEnum (const InjuryStatusTypeEnum& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual InjuryStatusTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    InjuryStatusTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_InjuryStatusTypeEnum_convert ();
    }

    protected:
    value
    _xsd_InjuryStatusTypeEnum_convert () const;

    public:
    static const char* const _xsd_InjuryStatusTypeEnum_literals_[6];
    static const value _xsd_InjuryStatusTypeEnum_indexes_[6];
  };

  class IntensityKilogrammesPerSquareMetre: public ::datex2::Float
  {
    public:
    // Constructors.
    //
    IntensityKilogrammesPerSquareMetre (const ::xml_schema::float_&);

    IntensityKilogrammesPerSquareMetre (const xercesc::DOMElement& e,
                                        ::xml_schema::flags f = 0,
                                        ::xml_schema::container* c = 0);

    IntensityKilogrammesPerSquareMetre (const xercesc::DOMAttr& a,
                                        ::xml_schema::flags f = 0,
                                        ::xml_schema::container* c = 0);

    IntensityKilogrammesPerSquareMetre (const ::std::string& s,
                                        const xercesc::DOMElement* e,
                                        ::xml_schema::flags f = 0,
                                        ::xml_schema::container* c = 0);

    IntensityKilogrammesPerSquareMetre (const IntensityKilogrammesPerSquareMetre& x,
                                        ::xml_schema::flags f = 0,
                                        ::xml_schema::container* c = 0);

    virtual IntensityKilogrammesPerSquareMetre*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~IntensityKilogrammesPerSquareMetre ();
  };

  class IntensityMillimetresPerHour: public ::datex2::Float
  {
    public:
    // Constructors.
    //
    IntensityMillimetresPerHour (const ::xml_schema::float_&);

    IntensityMillimetresPerHour (const xercesc::DOMElement& e,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    IntensityMillimetresPerHour (const xercesc::DOMAttr& a,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    IntensityMillimetresPerHour (const ::std::string& s,
                                 const xercesc::DOMElement* e,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    IntensityMillimetresPerHour (const IntensityMillimetresPerHour& x,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    virtual IntensityMillimetresPerHour*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~IntensityMillimetresPerHour ();
  };

  class InternationalIdentifier: public ::xml_schema::type
  {
    public:
    // country
    // 
    typedef ::datex2::CountryEnum country_type;
    typedef ::xsd::cxx::tree::traits< country_type, char > country_traits;

    const country_type&
    country () const;

    country_type&
    country ();

    void
    country (const country_type& x);

    void
    country (::std::auto_ptr< country_type > p);

    // nationalIdentifier
    // 
    typedef ::datex2::String nationalIdentifier_type;
    typedef ::xsd::cxx::tree::traits< nationalIdentifier_type, char > nationalIdentifier_traits;

    const nationalIdentifier_type&
    nationalIdentifier () const;

    nationalIdentifier_type&
    nationalIdentifier ();

    void
    nationalIdentifier (const nationalIdentifier_type& x);

    void
    nationalIdentifier (::std::auto_ptr< nationalIdentifier_type > p);

    // internationalIdentifierExtension
    // 
    typedef ::datex2::ExtensionType internationalIdentifierExtension_type;
    typedef ::xsd::cxx::tree::optional< internationalIdentifierExtension_type > internationalIdentifierExtension_optional;
    typedef ::xsd::cxx::tree::traits< internationalIdentifierExtension_type, char > internationalIdentifierExtension_traits;

    const internationalIdentifierExtension_optional&
    internationalIdentifierExtension () const;

    internationalIdentifierExtension_optional&
    internationalIdentifierExtension ();

    void
    internationalIdentifierExtension (const internationalIdentifierExtension_type& x);

    void
    internationalIdentifierExtension (const internationalIdentifierExtension_optional& x);

    void
    internationalIdentifierExtension (::std::auto_ptr< internationalIdentifierExtension_type > p);

    // Constructors.
    //
    InternationalIdentifier (const country_type&,
                             const nationalIdentifier_type&);

    InternationalIdentifier (const xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    InternationalIdentifier (const InternationalIdentifier& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual InternationalIdentifier*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~InternationalIdentifier ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< country_type > country_;
    ::xsd::cxx::tree::one< nationalIdentifier_type > nationalIdentifier_;
    internationalIdentifierExtension_optional internationalIdentifierExtension_;
  };

  class InvolvementRolesEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      cyclist,
      pedestrian,
      unknown,
      vehicleDriver,
      vehicleOccupant,
      vehiclePassenger,
      witness
    };

    InvolvementRolesEnum (value v);

    InvolvementRolesEnum (const char* v);

    InvolvementRolesEnum (const ::std::string& v);

    InvolvementRolesEnum (const ::xml_schema::string& v);

    InvolvementRolesEnum (const xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    InvolvementRolesEnum (const xercesc::DOMAttr& a,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    InvolvementRolesEnum (const ::std::string& s,
                          const xercesc::DOMElement* e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    InvolvementRolesEnum (const InvolvementRolesEnum& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual InvolvementRolesEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    InvolvementRolesEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_InvolvementRolesEnum_convert ();
    }

    protected:
    value
    _xsd_InvolvementRolesEnum_convert () const;

    public:
    static const char* const _xsd_InvolvementRolesEnum_literals_[7];
    static const value _xsd_InvolvementRolesEnum_indexes_[7];
  };

  class Itinerary: public ::datex2::GroupOfLocations
  {
    public:
    // routeDestination
    // 
    typedef ::datex2::Destination routeDestination_type;
    typedef ::xsd::cxx::tree::sequence< routeDestination_type > routeDestination_sequence;
    typedef xsd::cxx::tree::sequence< routeDestination_type >::iterator routeDestination_iterator;
    typedef xsd::cxx::tree::sequence< routeDestination_type >::const_iterator routeDestination_const_iterator;
    typedef ::xsd::cxx::tree::traits< routeDestination_type, char > routeDestination_traits;

    const routeDestination_sequence&
    routeDestination () const;

    routeDestination_sequence&
    routeDestination ();

    void
    routeDestination (const routeDestination_sequence& s);

    // itineraryExtension
    // 
    typedef ::datex2::ExtensionType itineraryExtension_type;
    typedef ::xsd::cxx::tree::optional< itineraryExtension_type > itineraryExtension_optional;
    typedef ::xsd::cxx::tree::traits< itineraryExtension_type, char > itineraryExtension_traits;

    const itineraryExtension_optional&
    itineraryExtension () const;

    itineraryExtension_optional&
    itineraryExtension ();

    void
    itineraryExtension (const itineraryExtension_type& x);

    void
    itineraryExtension (const itineraryExtension_optional& x);

    void
    itineraryExtension (::std::auto_ptr< itineraryExtension_type > p);

    // Constructors.
    //
    Itinerary ();

    Itinerary (const xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    Itinerary (const Itinerary& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual Itinerary*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Itinerary ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    routeDestination_sequence routeDestination_;
    itineraryExtension_optional itineraryExtension_;
  };

  class KilometresPerHour: public ::datex2::Float
  {
    public:
    // Constructors.
    //
    KilometresPerHour (const ::xml_schema::float_&);

    KilometresPerHour (const xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    KilometresPerHour (const xercesc::DOMAttr& a,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    KilometresPerHour (const ::std::string& s,
                       const xercesc::DOMElement* e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    KilometresPerHour (const KilometresPerHour& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual KilometresPerHour*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~KilometresPerHour ();
  };

  class LaneEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      allLanesCompleteCarriageway,
      busLane,
      busStop,
      carPoolLane,
      centralReservation,
      crawlerLane,
      emergencyLane,
      escapeLane,
      expressLane,
      hardShoulder,
      heavyVehicleLane,
      lane1,
      lane2,
      lane3,
      lane4,
      lane5,
      lane6,
      lane7,
      lane8,
      lane9,
      layBy,
      leftHandTurningLane,
      leftLane,
      localTrafficLane,
      middleLane,
      opposingLanes,
      overtakingLane,
      rightHandTurningLane,
      rightLane,
      rushHourLane,
      setDownArea,
      slowVehicleLane,
      throughTrafficLane,
      tidalFlowLane,
      turningLane,
      verge
    };

    LaneEnum (value v);

    LaneEnum (const char* v);

    LaneEnum (const ::std::string& v);

    LaneEnum (const ::xml_schema::string& v);

    LaneEnum (const xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    LaneEnum (const xercesc::DOMAttr& a,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    LaneEnum (const ::std::string& s,
              const xercesc::DOMElement* e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    LaneEnum (const LaneEnum& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual LaneEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    LaneEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_LaneEnum_convert ();
    }

    protected:
    value
    _xsd_LaneEnum_convert () const;

    public:
    static const char* const _xsd_LaneEnum_literals_[36];
    static const value _xsd_LaneEnum_indexes_[36];
  };

  class Language: public ::xml_schema::language
  {
    public:
    // Constructors.
    //
    Language (const char*);

    Language (const ::std::string&);

    Language (const ::xml_schema::language&);

    Language (const xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    Language (const xercesc::DOMAttr& a,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    Language (const ::std::string& s,
              const xercesc::DOMElement* e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    Language (const Language& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual Language*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Language ();
  };

  class LengthCharacteristic: public ::xml_schema::type
  {
    public:
    // comparisonOperator
    // 
    typedef ::datex2::ComparisonOperatorEnum comparisonOperator_type;
    typedef ::xsd::cxx::tree::traits< comparisonOperator_type, char > comparisonOperator_traits;

    const comparisonOperator_type&
    comparisonOperator () const;

    comparisonOperator_type&
    comparisonOperator ();

    void
    comparisonOperator (const comparisonOperator_type& x);

    void
    comparisonOperator (::std::auto_ptr< comparisonOperator_type > p);

    // vehicleLength
    // 
    typedef ::datex2::MetresAsFloat vehicleLength_type;
    typedef ::xsd::cxx::tree::traits< vehicleLength_type, char > vehicleLength_traits;

    const vehicleLength_type&
    vehicleLength () const;

    vehicleLength_type&
    vehicleLength ();

    void
    vehicleLength (const vehicleLength_type& x);

    void
    vehicleLength (::std::auto_ptr< vehicleLength_type > p);

    // lengthCharacteristicExtension
    // 
    typedef ::datex2::ExtensionType lengthCharacteristicExtension_type;
    typedef ::xsd::cxx::tree::optional< lengthCharacteristicExtension_type > lengthCharacteristicExtension_optional;
    typedef ::xsd::cxx::tree::traits< lengthCharacteristicExtension_type, char > lengthCharacteristicExtension_traits;

    const lengthCharacteristicExtension_optional&
    lengthCharacteristicExtension () const;

    lengthCharacteristicExtension_optional&
    lengthCharacteristicExtension ();

    void
    lengthCharacteristicExtension (const lengthCharacteristicExtension_type& x);

    void
    lengthCharacteristicExtension (const lengthCharacteristicExtension_optional& x);

    void
    lengthCharacteristicExtension (::std::auto_ptr< lengthCharacteristicExtension_type > p);

    // Constructors.
    //
    LengthCharacteristic (const comparisonOperator_type&,
                          const vehicleLength_type&);

    LengthCharacteristic (const xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    LengthCharacteristic (const LengthCharacteristic& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual LengthCharacteristic*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~LengthCharacteristic ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< comparisonOperator_type > comparisonOperator_;
    ::xsd::cxx::tree::one< vehicleLength_type > vehicleLength_;
    lengthCharacteristicExtension_optional lengthCharacteristicExtension_;
  };

  class LifeCycleManagement: public ::xml_schema::type
  {
    public:
    // cancel
    // 
    typedef ::datex2::Boolean cancel_type;
    typedef ::xsd::cxx::tree::optional< cancel_type > cancel_optional;
    typedef ::xsd::cxx::tree::traits< cancel_type, char > cancel_traits;

    const cancel_optional&
    cancel () const;

    cancel_optional&
    cancel ();

    void
    cancel (const cancel_type& x);

    void
    cancel (const cancel_optional& x);

    void
    cancel (::std::auto_ptr< cancel_type > p);

    // end
    // 
    typedef ::datex2::Boolean end_type;
    typedef ::xsd::cxx::tree::optional< end_type > end_optional;
    typedef ::xsd::cxx::tree::traits< end_type, char > end_traits;

    const end_optional&
    end () const;

    end_optional&
    end ();

    void
    end (const end_type& x);

    void
    end (const end_optional& x);

    void
    end (::std::auto_ptr< end_type > p);

    // lifeCycleManagementExtension
    // 
    typedef ::datex2::ExtensionType lifeCycleManagementExtension_type;
    typedef ::xsd::cxx::tree::optional< lifeCycleManagementExtension_type > lifeCycleManagementExtension_optional;
    typedef ::xsd::cxx::tree::traits< lifeCycleManagementExtension_type, char > lifeCycleManagementExtension_traits;

    const lifeCycleManagementExtension_optional&
    lifeCycleManagementExtension () const;

    lifeCycleManagementExtension_optional&
    lifeCycleManagementExtension ();

    void
    lifeCycleManagementExtension (const lifeCycleManagementExtension_type& x);

    void
    lifeCycleManagementExtension (const lifeCycleManagementExtension_optional& x);

    void
    lifeCycleManagementExtension (::std::auto_ptr< lifeCycleManagementExtension_type > p);

    // Constructors.
    //
    LifeCycleManagement ();

    LifeCycleManagement (const xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    LifeCycleManagement (const LifeCycleManagement& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual LifeCycleManagement*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~LifeCycleManagement ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    cancel_optional cancel_;
    end_optional end_;
    lifeCycleManagementExtension_optional lifeCycleManagementExtension_;
  };

  class NetworkLocation: public ::datex2::Location
  {
    public:
    // supplementaryPositionalDescription
    // 
    typedef ::datex2::SupplementaryPositionalDescription supplementaryPositionalDescription_type;
    typedef ::xsd::cxx::tree::optional< supplementaryPositionalDescription_type > supplementaryPositionalDescription_optional;
    typedef ::xsd::cxx::tree::traits< supplementaryPositionalDescription_type, char > supplementaryPositionalDescription_traits;

    const supplementaryPositionalDescription_optional&
    supplementaryPositionalDescription () const;

    supplementaryPositionalDescription_optional&
    supplementaryPositionalDescription ();

    void
    supplementaryPositionalDescription (const supplementaryPositionalDescription_type& x);

    void
    supplementaryPositionalDescription (const supplementaryPositionalDescription_optional& x);

    void
    supplementaryPositionalDescription (::std::auto_ptr< supplementaryPositionalDescription_type > p);

    // destination
    // 
    typedef ::datex2::Destination destination_type;
    typedef ::xsd::cxx::tree::optional< destination_type > destination_optional;
    typedef ::xsd::cxx::tree::traits< destination_type, char > destination_traits;

    const destination_optional&
    destination () const;

    destination_optional&
    destination ();

    void
    destination (const destination_type& x);

    void
    destination (const destination_optional& x);

    void
    destination (::std::auto_ptr< destination_type > p);

    // networkLocationExtension
    // 
    typedef ::datex2::ExtensionType networkLocationExtension_type;
    typedef ::xsd::cxx::tree::optional< networkLocationExtension_type > networkLocationExtension_optional;
    typedef ::xsd::cxx::tree::traits< networkLocationExtension_type, char > networkLocationExtension_traits;

    const networkLocationExtension_optional&
    networkLocationExtension () const;

    networkLocationExtension_optional&
    networkLocationExtension ();

    void
    networkLocationExtension (const networkLocationExtension_type& x);

    void
    networkLocationExtension (const networkLocationExtension_optional& x);

    void
    networkLocationExtension (::std::auto_ptr< networkLocationExtension_type > p);

    // Constructors.
    //
    NetworkLocation ();

    NetworkLocation (const xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    NetworkLocation (const NetworkLocation& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual NetworkLocation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~NetworkLocation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    supplementaryPositionalDescription_optional supplementaryPositionalDescription_;
    destination_optional destination_;
    networkLocationExtension_optional networkLocationExtension_;
  };

  class Linear: public ::datex2::NetworkLocation
  {
    public:
    // tpegLinearLocation
    // 
    typedef ::datex2::TpegLinearLocation tpegLinearLocation_type;
    typedef ::xsd::cxx::tree::optional< tpegLinearLocation_type > tpegLinearLocation_optional;
    typedef ::xsd::cxx::tree::traits< tpegLinearLocation_type, char > tpegLinearLocation_traits;

    const tpegLinearLocation_optional&
    tpegLinearLocation () const;

    tpegLinearLocation_optional&
    tpegLinearLocation ();

    void
    tpegLinearLocation (const tpegLinearLocation_type& x);

    void
    tpegLinearLocation (const tpegLinearLocation_optional& x);

    void
    tpegLinearLocation (::std::auto_ptr< tpegLinearLocation_type > p);

    // alertCLinear
    // 
    typedef ::datex2::AlertCLinear alertCLinear_type;
    typedef ::xsd::cxx::tree::optional< alertCLinear_type > alertCLinear_optional;
    typedef ::xsd::cxx::tree::traits< alertCLinear_type, char > alertCLinear_traits;

    const alertCLinear_optional&
    alertCLinear () const;

    alertCLinear_optional&
    alertCLinear ();

    void
    alertCLinear (const alertCLinear_type& x);

    void
    alertCLinear (const alertCLinear_optional& x);

    void
    alertCLinear (::std::auto_ptr< alertCLinear_type > p);

    // roadsideReferencePointLinear
    // 
    typedef ::datex2::RoadsideReferencePointLinear roadsideReferencePointLinear_type;
    typedef ::xsd::cxx::tree::optional< roadsideReferencePointLinear_type > roadsideReferencePointLinear_optional;
    typedef ::xsd::cxx::tree::traits< roadsideReferencePointLinear_type, char > roadsideReferencePointLinear_traits;

    const roadsideReferencePointLinear_optional&
    roadsideReferencePointLinear () const;

    roadsideReferencePointLinear_optional&
    roadsideReferencePointLinear ();

    void
    roadsideReferencePointLinear (const roadsideReferencePointLinear_type& x);

    void
    roadsideReferencePointLinear (const roadsideReferencePointLinear_optional& x);

    void
    roadsideReferencePointLinear (::std::auto_ptr< roadsideReferencePointLinear_type > p);

    // linearExtension
    // 
    typedef ::datex2::ExtensionType linearExtension_type;
    typedef ::xsd::cxx::tree::optional< linearExtension_type > linearExtension_optional;
    typedef ::xsd::cxx::tree::traits< linearExtension_type, char > linearExtension_traits;

    const linearExtension_optional&
    linearExtension () const;

    linearExtension_optional&
    linearExtension ();

    void
    linearExtension (const linearExtension_type& x);

    void
    linearExtension (const linearExtension_optional& x);

    void
    linearExtension (::std::auto_ptr< linearExtension_type > p);

    // Constructors.
    //
    Linear ();

    Linear (const xercesc::DOMElement& e,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    Linear (const Linear& x,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    virtual Linear*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Linear ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    tpegLinearLocation_optional tpegLinearLocation_;
    alertCLinear_optional alertCLinear_;
    roadsideReferencePointLinear_optional roadsideReferencePointLinear_;
    linearExtension_optional linearExtension_;
  };

  class LinearTrafficView: public ::xml_schema::type
  {
    public:
    // linearPredefinedLocationReference
    // 
    typedef ::datex2::Reference linearPredefinedLocationReference_type;
    typedef ::xsd::cxx::tree::traits< linearPredefinedLocationReference_type, char > linearPredefinedLocationReference_traits;

    const linearPredefinedLocationReference_type&
    linearPredefinedLocationReference () const;

    linearPredefinedLocationReference_type&
    linearPredefinedLocationReference ();

    void
    linearPredefinedLocationReference (const linearPredefinedLocationReference_type& x);

    void
    linearPredefinedLocationReference (::std::auto_ptr< linearPredefinedLocationReference_type > p);

    // trafficViewRecord
    // 
    typedef ::datex2::TrafficViewRecord trafficViewRecord_type;
    typedef ::xsd::cxx::tree::sequence< trafficViewRecord_type > trafficViewRecord_sequence;
    typedef xsd::cxx::tree::sequence< trafficViewRecord_type >::iterator trafficViewRecord_iterator;
    typedef xsd::cxx::tree::sequence< trafficViewRecord_type >::const_iterator trafficViewRecord_const_iterator;
    typedef ::xsd::cxx::tree::traits< trafficViewRecord_type, char > trafficViewRecord_traits;

    const trafficViewRecord_sequence&
    trafficViewRecord () const;

    trafficViewRecord_sequence&
    trafficViewRecord ();

    void
    trafficViewRecord (const trafficViewRecord_sequence& s);

    // linearTrafficViewExtension
    // 
    typedef ::datex2::ExtensionType linearTrafficViewExtension_type;
    typedef ::xsd::cxx::tree::optional< linearTrafficViewExtension_type > linearTrafficViewExtension_optional;
    typedef ::xsd::cxx::tree::traits< linearTrafficViewExtension_type, char > linearTrafficViewExtension_traits;

    const linearTrafficViewExtension_optional&
    linearTrafficViewExtension () const;

    linearTrafficViewExtension_optional&
    linearTrafficViewExtension ();

    void
    linearTrafficViewExtension (const linearTrafficViewExtension_type& x);

    void
    linearTrafficViewExtension (const linearTrafficViewExtension_optional& x);

    void
    linearTrafficViewExtension (::std::auto_ptr< linearTrafficViewExtension_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_type&
    id () const;

    id_type&
    id ();

    void
    id (const id_type& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    LinearTrafficView (const linearPredefinedLocationReference_type&,
                       const id_type&);

    LinearTrafficView (const xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    LinearTrafficView (const LinearTrafficView& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual LinearTrafficView*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~LinearTrafficView ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< linearPredefinedLocationReference_type > linearPredefinedLocationReference_;
    trafficViewRecord_sequence trafficViewRecord_;
    linearTrafficViewExtension_optional linearTrafficViewExtension_;
    ::xsd::cxx::tree::one< id_type > id_;
  };

  class LoadTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      abnormalLoad,
      ammunition,
      chemicals,
      combustibleMaterials,
      corrosiveMaterials,
      debris,
      empty,
      explosiveMaterials,
      extraHighLoad,
      extraLongLoad,
      extraWideLoad,
      fuel,
      glass,
      goods,
      hazardousMaterials,
      liquid,
      livestock,
      materials,
      materialsDangerousForPeople,
      materialsDangerousForTheEnvironment,
      materialsDangerousForWater,
      oil,
      ordinary,
      perishableProducts,
      petrol,
      pharmaceuticalMaterials,
      radioactiveMaterials,
      refuse,
      toxicMaterials,
      vehicles,
      other
    };

    LoadTypeEnum (value v);

    LoadTypeEnum (const char* v);

    LoadTypeEnum (const ::std::string& v);

    LoadTypeEnum (const ::xml_schema::string& v);

    LoadTypeEnum (const xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    LoadTypeEnum (const xercesc::DOMAttr& a,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    LoadTypeEnum (const ::std::string& s,
                  const xercesc::DOMElement* e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    LoadTypeEnum (const LoadTypeEnum& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual LoadTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    LoadTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_LoadTypeEnum_convert ();
    }

    protected:
    value
    _xsd_LoadTypeEnum_convert () const;

    public:
    static const char* const _xsd_LoadTypeEnum_literals_[31];
    static const value _xsd_LoadTypeEnum_indexes_[31];
  };

  class LocationByReference: public ::datex2::Location
  {
    public:
    // predefinedLocationReference
    // 
    typedef ::datex2::Reference predefinedLocationReference_type;
    typedef ::xsd::cxx::tree::traits< predefinedLocationReference_type, char > predefinedLocationReference_traits;

    const predefinedLocationReference_type&
    predefinedLocationReference () const;

    predefinedLocationReference_type&
    predefinedLocationReference ();

    void
    predefinedLocationReference (const predefinedLocationReference_type& x);

    void
    predefinedLocationReference (::std::auto_ptr< predefinedLocationReference_type > p);

    // locationByReferenceExtension
    // 
    typedef ::datex2::ExtensionType locationByReferenceExtension_type;
    typedef ::xsd::cxx::tree::optional< locationByReferenceExtension_type > locationByReferenceExtension_optional;
    typedef ::xsd::cxx::tree::traits< locationByReferenceExtension_type, char > locationByReferenceExtension_traits;

    const locationByReferenceExtension_optional&
    locationByReferenceExtension () const;

    locationByReferenceExtension_optional&
    locationByReferenceExtension ();

    void
    locationByReferenceExtension (const locationByReferenceExtension_type& x);

    void
    locationByReferenceExtension (const locationByReferenceExtension_optional& x);

    void
    locationByReferenceExtension (::std::auto_ptr< locationByReferenceExtension_type > p);

    // Constructors.
    //
    LocationByReference (const predefinedLocationReference_type&);

    LocationByReference (const xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    LocationByReference (const LocationByReference& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual LocationByReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~LocationByReference ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< predefinedLocationReference_type > predefinedLocationReference_;
    locationByReferenceExtension_optional locationByReferenceExtension_;
  };

  class LocationCharacteristicsOverride: public ::xml_schema::type
  {
    public:
    // measurementLanesOverride
    // 
    typedef ::datex2::LaneEnum measurementLanesOverride_type;
    typedef ::xsd::cxx::tree::optional< measurementLanesOverride_type > measurementLanesOverride_optional;
    typedef ::xsd::cxx::tree::traits< measurementLanesOverride_type, char > measurementLanesOverride_traits;

    const measurementLanesOverride_optional&
    measurementLanesOverride () const;

    measurementLanesOverride_optional&
    measurementLanesOverride ();

    void
    measurementLanesOverride (const measurementLanesOverride_type& x);

    void
    measurementLanesOverride (const measurementLanesOverride_optional& x);

    void
    measurementLanesOverride (::std::auto_ptr< measurementLanesOverride_type > p);

    // reversedFlow
    // 
    typedef ::datex2::Boolean reversedFlow_type;
    typedef ::xsd::cxx::tree::optional< reversedFlow_type > reversedFlow_optional;
    typedef ::xsd::cxx::tree::traits< reversedFlow_type, char > reversedFlow_traits;

    const reversedFlow_optional&
    reversedFlow () const;

    reversedFlow_optional&
    reversedFlow ();

    void
    reversedFlow (const reversedFlow_type& x);

    void
    reversedFlow (const reversedFlow_optional& x);

    void
    reversedFlow (::std::auto_ptr< reversedFlow_type > p);

    // locationCharacteristicsOverrideExtension
    // 
    typedef ::datex2::ExtensionType locationCharacteristicsOverrideExtension_type;
    typedef ::xsd::cxx::tree::optional< locationCharacteristicsOverrideExtension_type > locationCharacteristicsOverrideExtension_optional;
    typedef ::xsd::cxx::tree::traits< locationCharacteristicsOverrideExtension_type, char > locationCharacteristicsOverrideExtension_traits;

    const locationCharacteristicsOverrideExtension_optional&
    locationCharacteristicsOverrideExtension () const;

    locationCharacteristicsOverrideExtension_optional&
    locationCharacteristicsOverrideExtension ();

    void
    locationCharacteristicsOverrideExtension (const locationCharacteristicsOverrideExtension_type& x);

    void
    locationCharacteristicsOverrideExtension (const locationCharacteristicsOverrideExtension_optional& x);

    void
    locationCharacteristicsOverrideExtension (::std::auto_ptr< locationCharacteristicsOverrideExtension_type > p);

    // Constructors.
    //
    LocationCharacteristicsOverride ();

    LocationCharacteristicsOverride (const xercesc::DOMElement& e,
                                     ::xml_schema::flags f = 0,
                                     ::xml_schema::container* c = 0);

    LocationCharacteristicsOverride (const LocationCharacteristicsOverride& x,
                                     ::xml_schema::flags f = 0,
                                     ::xml_schema::container* c = 0);

    virtual LocationCharacteristicsOverride*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~LocationCharacteristicsOverride ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    measurementLanesOverride_optional measurementLanesOverride_;
    reversedFlow_optional reversedFlow_;
    locationCharacteristicsOverrideExtension_optional locationCharacteristicsOverrideExtension_;
  };

  class LocationDescriptorEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      aroundABendInRoad,
      atMotorwayInterchange,
      atRestArea,
      atServiceArea,
      atTollPlaza,
      atTunnelEntryOrExit,
      inbound,
      inGallery,
      inTheCentre,
      inTheOppositeDirection,
      inTunnel,
      onBorder,
      onBridge,
      onConnector,
      onElevatedSection,
      onFlyover,
      onIceRoad,
      onLevelCrossing,
      onLinkRoad,
      onPass,
      onRoundabout,
      onTheLeft,
      onTheRight,
      onTheRoadway,
      onUndergroundSection,
      onUnderpass,
      outbound,
      overCrestOfHill,
      withinJunction
    };

    LocationDescriptorEnum (value v);

    LocationDescriptorEnum (const char* v);

    LocationDescriptorEnum (const ::std::string& v);

    LocationDescriptorEnum (const ::xml_schema::string& v);

    LocationDescriptorEnum (const xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    LocationDescriptorEnum (const xercesc::DOMAttr& a,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    LocationDescriptorEnum (const ::std::string& s,
                            const xercesc::DOMElement* e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    LocationDescriptorEnum (const LocationDescriptorEnum& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual LocationDescriptorEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    LocationDescriptorEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_LocationDescriptorEnum_convert ();
    }

    protected:
    value
    _xsd_LocationDescriptorEnum_convert () const;

    public:
    static const char* const _xsd_LocationDescriptorEnum_literals_[29];
    static const value _xsd_LocationDescriptorEnum_indexes_[29];
  };

  class MaintenanceVehicleActionsEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      maintenanceVehiclesMergingIntoTrafficFlow,
      saltAndGritSpreading,
      slowMoving,
      snowClearing,
      stoppingToServiceEquipments
    };

    MaintenanceVehicleActionsEnum (value v);

    MaintenanceVehicleActionsEnum (const char* v);

    MaintenanceVehicleActionsEnum (const ::std::string& v);

    MaintenanceVehicleActionsEnum (const ::xml_schema::string& v);

    MaintenanceVehicleActionsEnum (const xercesc::DOMElement& e,
                                   ::xml_schema::flags f = 0,
                                   ::xml_schema::container* c = 0);

    MaintenanceVehicleActionsEnum (const xercesc::DOMAttr& a,
                                   ::xml_schema::flags f = 0,
                                   ::xml_schema::container* c = 0);

    MaintenanceVehicleActionsEnum (const ::std::string& s,
                                   const xercesc::DOMElement* e,
                                   ::xml_schema::flags f = 0,
                                   ::xml_schema::container* c = 0);

    MaintenanceVehicleActionsEnum (const MaintenanceVehicleActionsEnum& x,
                                   ::xml_schema::flags f = 0,
                                   ::xml_schema::container* c = 0);

    virtual MaintenanceVehicleActionsEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    MaintenanceVehicleActionsEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_MaintenanceVehicleActionsEnum_convert ();
    }

    protected:
    value
    _xsd_MaintenanceVehicleActionsEnum_convert () const;

    public:
    static const char* const _xsd_MaintenanceVehicleActionsEnum_literals_[5];
    static const value _xsd_MaintenanceVehicleActionsEnum_indexes_[5];
  };

  class MaintenanceVehicles: public ::xml_schema::type
  {
    public:
    // numberOfMaintenanceVehicles
    // 
    typedef ::datex2::NonNegativeInteger numberOfMaintenanceVehicles_type;
    typedef ::xsd::cxx::tree::optional< numberOfMaintenanceVehicles_type > numberOfMaintenanceVehicles_optional;
    typedef ::xsd::cxx::tree::traits< numberOfMaintenanceVehicles_type, char > numberOfMaintenanceVehicles_traits;

    const numberOfMaintenanceVehicles_optional&
    numberOfMaintenanceVehicles () const;

    numberOfMaintenanceVehicles_optional&
    numberOfMaintenanceVehicles ();

    void
    numberOfMaintenanceVehicles (const numberOfMaintenanceVehicles_type& x);

    void
    numberOfMaintenanceVehicles (const numberOfMaintenanceVehicles_optional& x);

    void
    numberOfMaintenanceVehicles (::std::auto_ptr< numberOfMaintenanceVehicles_type > p);

    // maintenanceVehicleActions
    // 
    typedef ::datex2::MaintenanceVehicleActionsEnum maintenanceVehicleActions_type;
    typedef ::xsd::cxx::tree::sequence< maintenanceVehicleActions_type > maintenanceVehicleActions_sequence;
    typedef xsd::cxx::tree::sequence< maintenanceVehicleActions_type >::iterator maintenanceVehicleActions_iterator;
    typedef xsd::cxx::tree::sequence< maintenanceVehicleActions_type >::const_iterator maintenanceVehicleActions_const_iterator;
    typedef ::xsd::cxx::tree::traits< maintenanceVehicleActions_type, char > maintenanceVehicleActions_traits;

    const maintenanceVehicleActions_sequence&
    maintenanceVehicleActions () const;

    maintenanceVehicleActions_sequence&
    maintenanceVehicleActions ();

    void
    maintenanceVehicleActions (const maintenanceVehicleActions_sequence& s);

    // maintenanceVehiclesExtension
    // 
    typedef ::datex2::ExtensionType maintenanceVehiclesExtension_type;
    typedef ::xsd::cxx::tree::optional< maintenanceVehiclesExtension_type > maintenanceVehiclesExtension_optional;
    typedef ::xsd::cxx::tree::traits< maintenanceVehiclesExtension_type, char > maintenanceVehiclesExtension_traits;

    const maintenanceVehiclesExtension_optional&
    maintenanceVehiclesExtension () const;

    maintenanceVehiclesExtension_optional&
    maintenanceVehiclesExtension ();

    void
    maintenanceVehiclesExtension (const maintenanceVehiclesExtension_type& x);

    void
    maintenanceVehiclesExtension (const maintenanceVehiclesExtension_optional& x);

    void
    maintenanceVehiclesExtension (::std::auto_ptr< maintenanceVehiclesExtension_type > p);

    // Constructors.
    //
    MaintenanceVehicles ();

    MaintenanceVehicles (const xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    MaintenanceVehicles (const MaintenanceVehicles& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual MaintenanceVehicles*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MaintenanceVehicles ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    numberOfMaintenanceVehicles_optional numberOfMaintenanceVehicles_;
    maintenanceVehicleActions_sequence maintenanceVehicleActions_;
    maintenanceVehiclesExtension_optional maintenanceVehiclesExtension_;
  };

  class MaintenanceWorks: public ::datex2::Roadworks
  {
    public:
    // roadMaintenanceType
    // 
    typedef ::datex2::RoadMaintenanceTypeEnum roadMaintenanceType_type;
    typedef ::xsd::cxx::tree::sequence< roadMaintenanceType_type > roadMaintenanceType_sequence;
    typedef xsd::cxx::tree::sequence< roadMaintenanceType_type >::iterator roadMaintenanceType_iterator;
    typedef xsd::cxx::tree::sequence< roadMaintenanceType_type >::const_iterator roadMaintenanceType_const_iterator;
    typedef ::xsd::cxx::tree::traits< roadMaintenanceType_type, char > roadMaintenanceType_traits;

    const roadMaintenanceType_sequence&
    roadMaintenanceType () const;

    roadMaintenanceType_sequence&
    roadMaintenanceType ();

    void
    roadMaintenanceType (const roadMaintenanceType_sequence& s);

    // maintenanceWorksExtension
    // 
    typedef ::datex2::ExtensionType maintenanceWorksExtension_type;
    typedef ::xsd::cxx::tree::optional< maintenanceWorksExtension_type > maintenanceWorksExtension_optional;
    typedef ::xsd::cxx::tree::traits< maintenanceWorksExtension_type, char > maintenanceWorksExtension_traits;

    const maintenanceWorksExtension_optional&
    maintenanceWorksExtension () const;

    maintenanceWorksExtension_optional&
    maintenanceWorksExtension ();

    void
    maintenanceWorksExtension (const maintenanceWorksExtension_type& x);

    void
    maintenanceWorksExtension (const maintenanceWorksExtension_optional& x);

    void
    maintenanceWorksExtension (::std::auto_ptr< maintenanceWorksExtension_type > p);

    // Constructors.
    //
    MaintenanceWorks (const situationRecordCreationTime_type&,
                      const situationRecordVersion_type&,
                      const situationRecordVersionTime_type&,
                      const probabilityOfOccurrence_type&,
                      const validity_type&,
                      const groupOfLocations_type&,
                      const id_type&);

    MaintenanceWorks (const situationRecordCreationTime_type&,
                      const situationRecordVersion_type&,
                      const situationRecordVersionTime_type&,
                      const probabilityOfOccurrence_type&,
                      ::std::auto_ptr< validity_type >&,
                      ::std::auto_ptr< groupOfLocations_type >&,
                      const id_type&);

    MaintenanceWorks (const xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    MaintenanceWorks (const MaintenanceWorks& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual MaintenanceWorks*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MaintenanceWorks ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    roadMaintenanceType_sequence roadMaintenanceType_;
    maintenanceWorksExtension_optional maintenanceWorksExtension_;
  };

  class ManagedCause: public ::datex2::Cause
  {
    public:
    // managedCause
    // 
    typedef ::datex2::Reference managedCause_type;
    typedef ::xsd::cxx::tree::optional< managedCause_type > managedCause_optional;
    typedef ::xsd::cxx::tree::traits< managedCause_type, char > managedCause_traits;

    const managedCause_optional&
    managedCause () const;

    managedCause_optional&
    managedCause ();

    void
    managedCause (const managedCause_type& x);

    void
    managedCause (const managedCause_optional& x);

    void
    managedCause (::std::auto_ptr< managedCause_type > p);

    // managedCauseExtension
    // 
    typedef ::datex2::ExtensionType managedCauseExtension_type;
    typedef ::xsd::cxx::tree::optional< managedCauseExtension_type > managedCauseExtension_optional;
    typedef ::xsd::cxx::tree::traits< managedCauseExtension_type, char > managedCauseExtension_traits;

    const managedCauseExtension_optional&
    managedCauseExtension () const;

    managedCauseExtension_optional&
    managedCauseExtension ();

    void
    managedCauseExtension (const managedCauseExtension_type& x);

    void
    managedCauseExtension (const managedCauseExtension_optional& x);

    void
    managedCauseExtension (::std::auto_ptr< managedCauseExtension_type > p);

    // Constructors.
    //
    ManagedCause ();

    ManagedCause (const xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    ManagedCause (const ManagedCause& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual ManagedCause*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ManagedCause ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    managedCause_optional managedCause_;
    managedCauseExtension_optional managedCauseExtension_;
  };

  class Management: public ::xml_schema::type
  {
    public:
    // lifeCycleManagement
    // 
    typedef ::datex2::LifeCycleManagement lifeCycleManagement_type;
    typedef ::xsd::cxx::tree::optional< lifeCycleManagement_type > lifeCycleManagement_optional;
    typedef ::xsd::cxx::tree::traits< lifeCycleManagement_type, char > lifeCycleManagement_traits;

    const lifeCycleManagement_optional&
    lifeCycleManagement () const;

    lifeCycleManagement_optional&
    lifeCycleManagement ();

    void
    lifeCycleManagement (const lifeCycleManagement_type& x);

    void
    lifeCycleManagement (const lifeCycleManagement_optional& x);

    void
    lifeCycleManagement (::std::auto_ptr< lifeCycleManagement_type > p);

    // filterExitManagement
    // 
    typedef ::datex2::FilterExitManagement filterExitManagement_type;
    typedef ::xsd::cxx::tree::optional< filterExitManagement_type > filterExitManagement_optional;
    typedef ::xsd::cxx::tree::traits< filterExitManagement_type, char > filterExitManagement_traits;

    const filterExitManagement_optional&
    filterExitManagement () const;

    filterExitManagement_optional&
    filterExitManagement ();

    void
    filterExitManagement (const filterExitManagement_type& x);

    void
    filterExitManagement (const filterExitManagement_optional& x);

    void
    filterExitManagement (::std::auto_ptr< filterExitManagement_type > p);

    // managementExtension
    // 
    typedef ::datex2::ExtensionType managementExtension_type;
    typedef ::xsd::cxx::tree::optional< managementExtension_type > managementExtension_optional;
    typedef ::xsd::cxx::tree::traits< managementExtension_type, char > managementExtension_traits;

    const managementExtension_optional&
    managementExtension () const;

    managementExtension_optional&
    managementExtension ();

    void
    managementExtension (const managementExtension_type& x);

    void
    managementExtension (const managementExtension_optional& x);

    void
    managementExtension (::std::auto_ptr< managementExtension_type > p);

    // Constructors.
    //
    Management ();

    Management (const xercesc::DOMElement& e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    Management (const Management& x,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    virtual Management*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Management ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    lifeCycleManagement_optional lifeCycleManagement_;
    filterExitManagement_optional filterExitManagement_;
    managementExtension_optional managementExtension_;
  };

  class MatrixFaultEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      communicationsFailure,
      incorrectAspectDisplayed,
      outOfService,
      powerFailure,
      unableToClearDown,
      unknown,
      other
    };

    MatrixFaultEnum (value v);

    MatrixFaultEnum (const char* v);

    MatrixFaultEnum (const ::std::string& v);

    MatrixFaultEnum (const ::xml_schema::string& v);

    MatrixFaultEnum (const xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    MatrixFaultEnum (const xercesc::DOMAttr& a,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    MatrixFaultEnum (const ::std::string& s,
                     const xercesc::DOMElement* e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    MatrixFaultEnum (const MatrixFaultEnum& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual MatrixFaultEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    MatrixFaultEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_MatrixFaultEnum_convert ();
    }

    protected:
    value
    _xsd_MatrixFaultEnum_convert () const;

    public:
    static const char* const _xsd_MatrixFaultEnum_literals_[7];
    static const value _xsd_MatrixFaultEnum_indexes_[7];
  };

  class SignSetting: public ::datex2::OperatorAction
  {
    public:
    // datexPictogram
    // 
    typedef ::datex2::DatexPictogramEnum datexPictogram_type;
    typedef ::xsd::cxx::tree::sequence< datexPictogram_type > datexPictogram_sequence;
    typedef xsd::cxx::tree::sequence< datexPictogram_type >::iterator datexPictogram_iterator;
    typedef xsd::cxx::tree::sequence< datexPictogram_type >::const_iterator datexPictogram_const_iterator;
    typedef ::xsd::cxx::tree::traits< datexPictogram_type, char > datexPictogram_traits;

    const datexPictogram_sequence&
    datexPictogram () const;

    datexPictogram_sequence&
    datexPictogram ();

    void
    datexPictogram (const datexPictogram_sequence& s);

    // pictogramList
    // 
    typedef ::datex2::String pictogramList_type;
    typedef ::xsd::cxx::tree::optional< pictogramList_type > pictogramList_optional;
    typedef ::xsd::cxx::tree::traits< pictogramList_type, char > pictogramList_traits;

    const pictogramList_optional&
    pictogramList () const;

    pictogramList_optional&
    pictogramList ();

    void
    pictogramList (const pictogramList_type& x);

    void
    pictogramList (const pictogramList_optional& x);

    void
    pictogramList (::std::auto_ptr< pictogramList_type > p);

    // pictogramListEntry
    // 
    typedef ::datex2::String pictogramListEntry_type;
    typedef ::xsd::cxx::tree::sequence< pictogramListEntry_type > pictogramListEntry_sequence;
    typedef xsd::cxx::tree::sequence< pictogramListEntry_type >::iterator pictogramListEntry_iterator;
    typedef xsd::cxx::tree::sequence< pictogramListEntry_type >::const_iterator pictogramListEntry_const_iterator;
    typedef ::xsd::cxx::tree::traits< pictogramListEntry_type, char > pictogramListEntry_traits;

    const pictogramListEntry_sequence&
    pictogramListEntry () const;

    pictogramListEntry_sequence&
    pictogramListEntry ();

    void
    pictogramListEntry (const pictogramListEntry_sequence& s);

    // reasonForSetting
    // 
    typedef ::datex2::MultilingualString reasonForSetting_type;
    typedef ::xsd::cxx::tree::optional< reasonForSetting_type > reasonForSetting_optional;
    typedef ::xsd::cxx::tree::traits< reasonForSetting_type, char > reasonForSetting_traits;

    const reasonForSetting_optional&
    reasonForSetting () const;

    reasonForSetting_optional&
    reasonForSetting ();

    void
    reasonForSetting (const reasonForSetting_type& x);

    void
    reasonForSetting (const reasonForSetting_optional& x);

    void
    reasonForSetting (::std::auto_ptr< reasonForSetting_type > p);

    // setBy
    // 
    typedef ::datex2::MultilingualString setBy_type;
    typedef ::xsd::cxx::tree::optional< setBy_type > setBy_optional;
    typedef ::xsd::cxx::tree::traits< setBy_type, char > setBy_traits;

    const setBy_optional&
    setBy () const;

    setBy_optional&
    setBy ();

    void
    setBy (const setBy_type& x);

    void
    setBy (const setBy_optional& x);

    void
    setBy (::std::auto_ptr< setBy_type > p);

    // signAddress
    // 
    typedef ::datex2::String signAddress_type;
    typedef ::xsd::cxx::tree::optional< signAddress_type > signAddress_optional;
    typedef ::xsd::cxx::tree::traits< signAddress_type, char > signAddress_traits;

    const signAddress_optional&
    signAddress () const;

    signAddress_optional&
    signAddress ();

    void
    signAddress (const signAddress_type& x);

    void
    signAddress (const signAddress_optional& x);

    void
    signAddress (::std::auto_ptr< signAddress_type > p);

    // timeLastSet
    // 
    typedef ::datex2::DateTime timeLastSet_type;
    typedef ::xsd::cxx::tree::optional< timeLastSet_type > timeLastSet_optional;
    typedef ::xsd::cxx::tree::traits< timeLastSet_type, char > timeLastSet_traits;

    const timeLastSet_optional&
    timeLastSet () const;

    timeLastSet_optional&
    timeLastSet ();

    void
    timeLastSet (const timeLastSet_type& x);

    void
    timeLastSet (const timeLastSet_optional& x);

    void
    timeLastSet (::std::auto_ptr< timeLastSet_type > p);

    // signSettingExtension
    // 
    typedef ::datex2::ExtensionType signSettingExtension_type;
    typedef ::xsd::cxx::tree::optional< signSettingExtension_type > signSettingExtension_optional;
    typedef ::xsd::cxx::tree::traits< signSettingExtension_type, char > signSettingExtension_traits;

    const signSettingExtension_optional&
    signSettingExtension () const;

    signSettingExtension_optional&
    signSettingExtension ();

    void
    signSettingExtension (const signSettingExtension_type& x);

    void
    signSettingExtension (const signSettingExtension_optional& x);

    void
    signSettingExtension (::std::auto_ptr< signSettingExtension_type > p);

    // Constructors.
    //
    SignSetting (const situationRecordCreationTime_type&,
                 const situationRecordVersion_type&,
                 const situationRecordVersionTime_type&,
                 const probabilityOfOccurrence_type&,
                 const validity_type&,
                 const groupOfLocations_type&,
                 const id_type&);

    SignSetting (const situationRecordCreationTime_type&,
                 const situationRecordVersion_type&,
                 const situationRecordVersionTime_type&,
                 const probabilityOfOccurrence_type&,
                 ::std::auto_ptr< validity_type >&,
                 ::std::auto_ptr< groupOfLocations_type >&,
                 const id_type&);

    SignSetting (const xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    SignSetting (const SignSetting& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual SignSetting*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SignSetting ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    datexPictogram_sequence datexPictogram_;
    pictogramList_optional pictogramList_;
    pictogramListEntry_sequence pictogramListEntry_;
    reasonForSetting_optional reasonForSetting_;
    setBy_optional setBy_;
    signAddress_optional signAddress_;
    timeLastSet_optional timeLastSet_;
    signSettingExtension_optional signSettingExtension_;
  };

  class MatrixSignSetting: public ::datex2::SignSetting
  {
    public:
    // aspectDisplayed
    // 
    typedef ::datex2::String aspectDisplayed_type;
    typedef ::xsd::cxx::tree::traits< aspectDisplayed_type, char > aspectDisplayed_traits;

    const aspectDisplayed_type&
    aspectDisplayed () const;

    aspectDisplayed_type&
    aspectDisplayed ();

    void
    aspectDisplayed (const aspectDisplayed_type& x);

    void
    aspectDisplayed (::std::auto_ptr< aspectDisplayed_type > p);

    // matrixFault
    // 
    typedef ::datex2::MatrixFaultEnum matrixFault_type;
    typedef ::xsd::cxx::tree::sequence< matrixFault_type > matrixFault_sequence;
    typedef xsd::cxx::tree::sequence< matrixFault_type >::iterator matrixFault_iterator;
    typedef xsd::cxx::tree::sequence< matrixFault_type >::const_iterator matrixFault_const_iterator;
    typedef ::xsd::cxx::tree::traits< matrixFault_type, char > matrixFault_traits;

    const matrixFault_sequence&
    matrixFault () const;

    matrixFault_sequence&
    matrixFault ();

    void
    matrixFault (const matrixFault_sequence& s);

    // matrixIdentifier
    // 
    typedef ::datex2::String matrixIdentifier_type;
    typedef ::xsd::cxx::tree::traits< matrixIdentifier_type, char > matrixIdentifier_traits;

    const matrixIdentifier_type&
    matrixIdentifier () const;

    matrixIdentifier_type&
    matrixIdentifier ();

    void
    matrixIdentifier (const matrixIdentifier_type& x);

    void
    matrixIdentifier (::std::auto_ptr< matrixIdentifier_type > p);

    // matrixSignSettingExtension
    // 
    typedef ::datex2::ExtensionType matrixSignSettingExtension_type;
    typedef ::xsd::cxx::tree::optional< matrixSignSettingExtension_type > matrixSignSettingExtension_optional;
    typedef ::xsd::cxx::tree::traits< matrixSignSettingExtension_type, char > matrixSignSettingExtension_traits;

    const matrixSignSettingExtension_optional&
    matrixSignSettingExtension () const;

    matrixSignSettingExtension_optional&
    matrixSignSettingExtension ();

    void
    matrixSignSettingExtension (const matrixSignSettingExtension_type& x);

    void
    matrixSignSettingExtension (const matrixSignSettingExtension_optional& x);

    void
    matrixSignSettingExtension (::std::auto_ptr< matrixSignSettingExtension_type > p);

    // Constructors.
    //
    MatrixSignSetting (const situationRecordCreationTime_type&,
                       const situationRecordVersion_type&,
                       const situationRecordVersionTime_type&,
                       const probabilityOfOccurrence_type&,
                       const validity_type&,
                       const groupOfLocations_type&,
                       const id_type&,
                       const aspectDisplayed_type&,
                       const matrixIdentifier_type&);

    MatrixSignSetting (const situationRecordCreationTime_type&,
                       const situationRecordVersion_type&,
                       const situationRecordVersionTime_type&,
                       const probabilityOfOccurrence_type&,
                       ::std::auto_ptr< validity_type >&,
                       ::std::auto_ptr< groupOfLocations_type >&,
                       const id_type&,
                       const aspectDisplayed_type&,
                       const matrixIdentifier_type&);

    MatrixSignSetting (const xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    MatrixSignSetting (const MatrixSignSetting& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual MatrixSignSetting*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MatrixSignSetting ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< aspectDisplayed_type > aspectDisplayed_;
    matrixFault_sequence matrixFault_;
    ::xsd::cxx::tree::one< matrixIdentifier_type > matrixIdentifier_;
    matrixSignSettingExtension_optional matrixSignSettingExtension_;
  };

  class MeasuredDataPublication: public ::datex2::PayloadPublication
  {
    public:
    // measurementSiteTableReference
    // 
    typedef ::datex2::Reference measurementSiteTableReference_type;
    typedef ::xsd::cxx::tree::traits< measurementSiteTableReference_type, char > measurementSiteTableReference_traits;

    const measurementSiteTableReference_type&
    measurementSiteTableReference () const;

    measurementSiteTableReference_type&
    measurementSiteTableReference ();

    void
    measurementSiteTableReference (const measurementSiteTableReference_type& x);

    void
    measurementSiteTableReference (::std::auto_ptr< measurementSiteTableReference_type > p);

    // headerInformation
    // 
    typedef ::datex2::HeaderInformation headerInformation_type;
    typedef ::xsd::cxx::tree::traits< headerInformation_type, char > headerInformation_traits;

    const headerInformation_type&
    headerInformation () const;

    headerInformation_type&
    headerInformation ();

    void
    headerInformation (const headerInformation_type& x);

    void
    headerInformation (::std::auto_ptr< headerInformation_type > p);

    // siteMeasurements
    // 
    typedef ::datex2::SiteMeasurements siteMeasurements_type;
    typedef ::xsd::cxx::tree::sequence< siteMeasurements_type > siteMeasurements_sequence;
    typedef xsd::cxx::tree::sequence< siteMeasurements_type >::iterator siteMeasurements_iterator;
    typedef xsd::cxx::tree::sequence< siteMeasurements_type >::const_iterator siteMeasurements_const_iterator;
    typedef ::xsd::cxx::tree::traits< siteMeasurements_type, char > siteMeasurements_traits;

    const siteMeasurements_sequence&
    siteMeasurements () const;

    siteMeasurements_sequence&
    siteMeasurements ();

    void
    siteMeasurements (const siteMeasurements_sequence& s);

    // measuredDataPublicationExtension
    // 
    typedef ::datex2::ExtensionType measuredDataPublicationExtension_type;
    typedef ::xsd::cxx::tree::optional< measuredDataPublicationExtension_type > measuredDataPublicationExtension_optional;
    typedef ::xsd::cxx::tree::traits< measuredDataPublicationExtension_type, char > measuredDataPublicationExtension_traits;

    const measuredDataPublicationExtension_optional&
    measuredDataPublicationExtension () const;

    measuredDataPublicationExtension_optional&
    measuredDataPublicationExtension ();

    void
    measuredDataPublicationExtension (const measuredDataPublicationExtension_type& x);

    void
    measuredDataPublicationExtension (const measuredDataPublicationExtension_optional& x);

    void
    measuredDataPublicationExtension (::std::auto_ptr< measuredDataPublicationExtension_type > p);

    // Constructors.
    //
    MeasuredDataPublication (const publicationTime_type&,
                             const publicationCreator_type&,
                             const lang_type&,
                             const measurementSiteTableReference_type&,
                             const headerInformation_type&);

    MeasuredDataPublication (const publicationTime_type&,
                             ::std::auto_ptr< publicationCreator_type >&,
                             const lang_type&,
                             const measurementSiteTableReference_type&,
                             ::std::auto_ptr< headerInformation_type >&);

    MeasuredDataPublication (const xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    MeasuredDataPublication (const MeasuredDataPublication& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual MeasuredDataPublication*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MeasuredDataPublication ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< measurementSiteTableReference_type > measurementSiteTableReference_;
    ::xsd::cxx::tree::one< headerInformation_type > headerInformation_;
    siteMeasurements_sequence siteMeasurements_;
    measuredDataPublicationExtension_optional measuredDataPublicationExtension_;
  };

  class MeasuredOrDerivedDataTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      humidityInformation,
      individualVehicleMeasurements,
      pollutionInformation,
      precipitationInformation,
      pressureInformation,
      radiationInformation,
      roadSurfaceConditionInformation,
      temperatureInformation,
      trafficConcentration,
      trafficFlow,
      trafficHeadway,
      trafficSpeed,
      trafficStatusInformation,
      travelTimeInformation,
      visibilityInformation,
      windInformation
    };

    MeasuredOrDerivedDataTypeEnum (value v);

    MeasuredOrDerivedDataTypeEnum (const char* v);

    MeasuredOrDerivedDataTypeEnum (const ::std::string& v);

    MeasuredOrDerivedDataTypeEnum (const ::xml_schema::string& v);

    MeasuredOrDerivedDataTypeEnum (const xercesc::DOMElement& e,
                                   ::xml_schema::flags f = 0,
                                   ::xml_schema::container* c = 0);

    MeasuredOrDerivedDataTypeEnum (const xercesc::DOMAttr& a,
                                   ::xml_schema::flags f = 0,
                                   ::xml_schema::container* c = 0);

    MeasuredOrDerivedDataTypeEnum (const ::std::string& s,
                                   const xercesc::DOMElement* e,
                                   ::xml_schema::flags f = 0,
                                   ::xml_schema::container* c = 0);

    MeasuredOrDerivedDataTypeEnum (const MeasuredOrDerivedDataTypeEnum& x,
                                   ::xml_schema::flags f = 0,
                                   ::xml_schema::container* c = 0);

    virtual MeasuredOrDerivedDataTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    MeasuredOrDerivedDataTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_MeasuredOrDerivedDataTypeEnum_convert ();
    }

    protected:
    value
    _xsd_MeasuredOrDerivedDataTypeEnum_convert () const;

    public:
    static const char* const _xsd_MeasuredOrDerivedDataTypeEnum_literals_[16];
    static const value _xsd_MeasuredOrDerivedDataTypeEnum_indexes_[16];
  };

  class MeasuredValue: public ::xml_schema::type
  {
    public:
    // measurementEquipmentTypeUsed
    // 
    typedef ::datex2::MultilingualString measurementEquipmentTypeUsed_type;
    typedef ::xsd::cxx::tree::optional< measurementEquipmentTypeUsed_type > measurementEquipmentTypeUsed_optional;
    typedef ::xsd::cxx::tree::traits< measurementEquipmentTypeUsed_type, char > measurementEquipmentTypeUsed_traits;

    const measurementEquipmentTypeUsed_optional&
    measurementEquipmentTypeUsed () const;

    measurementEquipmentTypeUsed_optional&
    measurementEquipmentTypeUsed ();

    void
    measurementEquipmentTypeUsed (const measurementEquipmentTypeUsed_type& x);

    void
    measurementEquipmentTypeUsed (const measurementEquipmentTypeUsed_optional& x);

    void
    measurementEquipmentTypeUsed (::std::auto_ptr< measurementEquipmentTypeUsed_type > p);

    // locationCharacteristicsOverride
    // 
    typedef ::datex2::LocationCharacteristicsOverride locationCharacteristicsOverride_type;
    typedef ::xsd::cxx::tree::optional< locationCharacteristicsOverride_type > locationCharacteristicsOverride_optional;
    typedef ::xsd::cxx::tree::traits< locationCharacteristicsOverride_type, char > locationCharacteristicsOverride_traits;

    const locationCharacteristicsOverride_optional&
    locationCharacteristicsOverride () const;

    locationCharacteristicsOverride_optional&
    locationCharacteristicsOverride ();

    void
    locationCharacteristicsOverride (const locationCharacteristicsOverride_type& x);

    void
    locationCharacteristicsOverride (const locationCharacteristicsOverride_optional& x);

    void
    locationCharacteristicsOverride (::std::auto_ptr< locationCharacteristicsOverride_type > p);

    // basicDataValue
    // 
    typedef ::datex2::BasicDataValue basicDataValue_type;
    typedef ::xsd::cxx::tree::traits< basicDataValue_type, char > basicDataValue_traits;

    const basicDataValue_type&
    basicDataValue () const;

    basicDataValue_type&
    basicDataValue ();

    void
    basicDataValue (const basicDataValue_type& x);

    void
    basicDataValue (::std::auto_ptr< basicDataValue_type > p);

    // measuredValueExtension
    // 
    typedef ::datex2::ExtensionType measuredValueExtension_type;
    typedef ::xsd::cxx::tree::optional< measuredValueExtension_type > measuredValueExtension_optional;
    typedef ::xsd::cxx::tree::traits< measuredValueExtension_type, char > measuredValueExtension_traits;

    const measuredValueExtension_optional&
    measuredValueExtension () const;

    measuredValueExtension_optional&
    measuredValueExtension ();

    void
    measuredValueExtension (const measuredValueExtension_type& x);

    void
    measuredValueExtension (const measuredValueExtension_optional& x);

    void
    measuredValueExtension (::std::auto_ptr< measuredValueExtension_type > p);

    // Constructors.
    //
    MeasuredValue (const basicDataValue_type&);

    MeasuredValue (::std::auto_ptr< basicDataValue_type >&);

    MeasuredValue (const xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    MeasuredValue (const MeasuredValue& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual MeasuredValue*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MeasuredValue ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    measurementEquipmentTypeUsed_optional measurementEquipmentTypeUsed_;
    locationCharacteristicsOverride_optional locationCharacteristicsOverride_;
    ::xsd::cxx::tree::one< basicDataValue_type > basicDataValue_;
    measuredValueExtension_optional measuredValueExtension_;
  };

  class MeasurementSiteRecord: public ::xml_schema::type
  {
    public:
    // measurementSiteRecordVersion
    // 
    typedef ::datex2::NonNegativeInteger measurementSiteRecordVersion_type;
    typedef ::xsd::cxx::tree::optional< measurementSiteRecordVersion_type > measurementSiteRecordVersion_optional;
    typedef ::xsd::cxx::tree::traits< measurementSiteRecordVersion_type, char > measurementSiteRecordVersion_traits;

    const measurementSiteRecordVersion_optional&
    measurementSiteRecordVersion () const;

    measurementSiteRecordVersion_optional&
    measurementSiteRecordVersion ();

    void
    measurementSiteRecordVersion (const measurementSiteRecordVersion_type& x);

    void
    measurementSiteRecordVersion (const measurementSiteRecordVersion_optional& x);

    void
    measurementSiteRecordVersion (::std::auto_ptr< measurementSiteRecordVersion_type > p);

    // measurementSiteRecordVersionTime
    // 
    typedef ::datex2::DateTime measurementSiteRecordVersionTime_type;
    typedef ::xsd::cxx::tree::optional< measurementSiteRecordVersionTime_type > measurementSiteRecordVersionTime_optional;
    typedef ::xsd::cxx::tree::traits< measurementSiteRecordVersionTime_type, char > measurementSiteRecordVersionTime_traits;

    const measurementSiteRecordVersionTime_optional&
    measurementSiteRecordVersionTime () const;

    measurementSiteRecordVersionTime_optional&
    measurementSiteRecordVersionTime ();

    void
    measurementSiteRecordVersionTime (const measurementSiteRecordVersionTime_type& x);

    void
    measurementSiteRecordVersionTime (const measurementSiteRecordVersionTime_optional& x);

    void
    measurementSiteRecordVersionTime (::std::auto_ptr< measurementSiteRecordVersionTime_type > p);

    // computationMethod
    // 
    typedef ::datex2::ComputationMethodEnum computationMethod_type;
    typedef ::xsd::cxx::tree::optional< computationMethod_type > computationMethod_optional;
    typedef ::xsd::cxx::tree::traits< computationMethod_type, char > computationMethod_traits;

    const computationMethod_optional&
    computationMethod () const;

    computationMethod_optional&
    computationMethod ();

    void
    computationMethod (const computationMethod_type& x);

    void
    computationMethod (const computationMethod_optional& x);

    void
    computationMethod (::std::auto_ptr< computationMethod_type > p);

    // measurementEquipmentReference
    // 
    typedef ::datex2::String measurementEquipmentReference_type;
    typedef ::xsd::cxx::tree::optional< measurementEquipmentReference_type > measurementEquipmentReference_optional;
    typedef ::xsd::cxx::tree::traits< measurementEquipmentReference_type, char > measurementEquipmentReference_traits;

    const measurementEquipmentReference_optional&
    measurementEquipmentReference () const;

    measurementEquipmentReference_optional&
    measurementEquipmentReference ();

    void
    measurementEquipmentReference (const measurementEquipmentReference_type& x);

    void
    measurementEquipmentReference (const measurementEquipmentReference_optional& x);

    void
    measurementEquipmentReference (::std::auto_ptr< measurementEquipmentReference_type > p);

    // measurementEquipmentTypeUsed
    // 
    typedef ::datex2::MultilingualString measurementEquipmentTypeUsed_type;
    typedef ::xsd::cxx::tree::optional< measurementEquipmentTypeUsed_type > measurementEquipmentTypeUsed_optional;
    typedef ::xsd::cxx::tree::traits< measurementEquipmentTypeUsed_type, char > measurementEquipmentTypeUsed_traits;

    const measurementEquipmentTypeUsed_optional&
    measurementEquipmentTypeUsed () const;

    measurementEquipmentTypeUsed_optional&
    measurementEquipmentTypeUsed ();

    void
    measurementEquipmentTypeUsed (const measurementEquipmentTypeUsed_type& x);

    void
    measurementEquipmentTypeUsed (const measurementEquipmentTypeUsed_optional& x);

    void
    measurementEquipmentTypeUsed (::std::auto_ptr< measurementEquipmentTypeUsed_type > p);

    // measurementSiteName
    // 
    typedef ::datex2::MultilingualString measurementSiteName_type;
    typedef ::xsd::cxx::tree::optional< measurementSiteName_type > measurementSiteName_optional;
    typedef ::xsd::cxx::tree::traits< measurementSiteName_type, char > measurementSiteName_traits;

    const measurementSiteName_optional&
    measurementSiteName () const;

    measurementSiteName_optional&
    measurementSiteName ();

    void
    measurementSiteName (const measurementSiteName_type& x);

    void
    measurementSiteName (const measurementSiteName_optional& x);

    void
    measurementSiteName (::std::auto_ptr< measurementSiteName_type > p);

    // measurementSiteNumberOfLanes
    // 
    typedef ::datex2::NonNegativeInteger measurementSiteNumberOfLanes_type;
    typedef ::xsd::cxx::tree::optional< measurementSiteNumberOfLanes_type > measurementSiteNumberOfLanes_optional;
    typedef ::xsd::cxx::tree::traits< measurementSiteNumberOfLanes_type, char > measurementSiteNumberOfLanes_traits;

    const measurementSiteNumberOfLanes_optional&
    measurementSiteNumberOfLanes () const;

    measurementSiteNumberOfLanes_optional&
    measurementSiteNumberOfLanes ();

    void
    measurementSiteNumberOfLanes (const measurementSiteNumberOfLanes_type& x);

    void
    measurementSiteNumberOfLanes (const measurementSiteNumberOfLanes_optional& x);

    void
    measurementSiteNumberOfLanes (::std::auto_ptr< measurementSiteNumberOfLanes_type > p);

    // measurementSiteIdentification
    // 
    typedef ::datex2::String measurementSiteIdentification_type;
    typedef ::xsd::cxx::tree::optional< measurementSiteIdentification_type > measurementSiteIdentification_optional;
    typedef ::xsd::cxx::tree::traits< measurementSiteIdentification_type, char > measurementSiteIdentification_traits;

    const measurementSiteIdentification_optional&
    measurementSiteIdentification () const;

    measurementSiteIdentification_optional&
    measurementSiteIdentification ();

    void
    measurementSiteIdentification (const measurementSiteIdentification_type& x);

    void
    measurementSiteIdentification (const measurementSiteIdentification_optional& x);

    void
    measurementSiteIdentification (::std::auto_ptr< measurementSiteIdentification_type > p);

    // measurementSide
    // 
    typedef ::datex2::DirectionEnum measurementSide_type;
    typedef ::xsd::cxx::tree::optional< measurementSide_type > measurementSide_optional;
    typedef ::xsd::cxx::tree::traits< measurementSide_type, char > measurementSide_traits;

    const measurementSide_optional&
    measurementSide () const;

    measurementSide_optional&
    measurementSide ();

    void
    measurementSide (const measurementSide_type& x);

    void
    measurementSide (const measurementSide_optional& x);

    void
    measurementSide (::std::auto_ptr< measurementSide_type > p);

    // measurementSpecificCharacteristics
    // 
    typedef ::datex2::measurementSpecificCharacteristics measurementSpecificCharacteristics_type;
    typedef ::xsd::cxx::tree::sequence< measurementSpecificCharacteristics_type > measurementSpecificCharacteristics_sequence;
    typedef xsd::cxx::tree::sequence< measurementSpecificCharacteristics_type >::iterator measurementSpecificCharacteristics_iterator;
    typedef xsd::cxx::tree::sequence< measurementSpecificCharacteristics_type >::const_iterator measurementSpecificCharacteristics_const_iterator;
    typedef ::xsd::cxx::tree::traits< measurementSpecificCharacteristics_type, char > measurementSpecificCharacteristics_traits;

    const measurementSpecificCharacteristics_sequence&
    measurementSpecificCharacteristics () const;

    measurementSpecificCharacteristics_sequence&
    measurementSpecificCharacteristics ();

    void
    measurementSpecificCharacteristics (const measurementSpecificCharacteristics_sequence& s);

    // measurementSiteLocation
    // 
    typedef ::datex2::Location measurementSiteLocation_type;
    typedef ::xsd::cxx::tree::traits< measurementSiteLocation_type, char > measurementSiteLocation_traits;

    const measurementSiteLocation_type&
    measurementSiteLocation () const;

    measurementSiteLocation_type&
    measurementSiteLocation ();

    void
    measurementSiteLocation (const measurementSiteLocation_type& x);

    void
    measurementSiteLocation (::std::auto_ptr< measurementSiteLocation_type > p);

    // measurementSiteRecordExtension
    // 
    typedef ::datex2::ExtensionType measurementSiteRecordExtension_type;
    typedef ::xsd::cxx::tree::optional< measurementSiteRecordExtension_type > measurementSiteRecordExtension_optional;
    typedef ::xsd::cxx::tree::traits< measurementSiteRecordExtension_type, char > measurementSiteRecordExtension_traits;

    const measurementSiteRecordExtension_optional&
    measurementSiteRecordExtension () const;

    measurementSiteRecordExtension_optional&
    measurementSiteRecordExtension ();

    void
    measurementSiteRecordExtension (const measurementSiteRecordExtension_type& x);

    void
    measurementSiteRecordExtension (const measurementSiteRecordExtension_optional& x);

    void
    measurementSiteRecordExtension (::std::auto_ptr< measurementSiteRecordExtension_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_type&
    id () const;

    id_type&
    id ();

    void
    id (const id_type& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    MeasurementSiteRecord (const measurementSiteLocation_type&,
                           const id_type&);

    MeasurementSiteRecord (::std::auto_ptr< measurementSiteLocation_type >&,
                           const id_type&);

    MeasurementSiteRecord (const xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    MeasurementSiteRecord (const MeasurementSiteRecord& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual MeasurementSiteRecord*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MeasurementSiteRecord ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    measurementSiteRecordVersion_optional measurementSiteRecordVersion_;
    measurementSiteRecordVersionTime_optional measurementSiteRecordVersionTime_;
    computationMethod_optional computationMethod_;
    measurementEquipmentReference_optional measurementEquipmentReference_;
    measurementEquipmentTypeUsed_optional measurementEquipmentTypeUsed_;
    measurementSiteName_optional measurementSiteName_;
    measurementSiteNumberOfLanes_optional measurementSiteNumberOfLanes_;
    measurementSiteIdentification_optional measurementSiteIdentification_;
    measurementSide_optional measurementSide_;
    measurementSpecificCharacteristics_sequence measurementSpecificCharacteristics_;
    ::xsd::cxx::tree::one< measurementSiteLocation_type > measurementSiteLocation_;
    measurementSiteRecordExtension_optional measurementSiteRecordExtension_;
    ::xsd::cxx::tree::one< id_type > id_;
  };

  class MeasurementSiteTable: public ::xml_schema::type
  {
    public:
    // measurementSiteTableIdentification
    // 
    typedef ::datex2::String measurementSiteTableIdentification_type;
    typedef ::xsd::cxx::tree::optional< measurementSiteTableIdentification_type > measurementSiteTableIdentification_optional;
    typedef ::xsd::cxx::tree::traits< measurementSiteTableIdentification_type, char > measurementSiteTableIdentification_traits;

    const measurementSiteTableIdentification_optional&
    measurementSiteTableIdentification () const;

    measurementSiteTableIdentification_optional&
    measurementSiteTableIdentification ();

    void
    measurementSiteTableIdentification (const measurementSiteTableIdentification_type& x);

    void
    measurementSiteTableIdentification (const measurementSiteTableIdentification_optional& x);

    void
    measurementSiteTableIdentification (::std::auto_ptr< measurementSiteTableIdentification_type > p);

    // measurementSiteTableVersion
    // 
    typedef ::datex2::NonNegativeInteger measurementSiteTableVersion_type;
    typedef ::xsd::cxx::tree::optional< measurementSiteTableVersion_type > measurementSiteTableVersion_optional;
    typedef ::xsd::cxx::tree::traits< measurementSiteTableVersion_type, char > measurementSiteTableVersion_traits;

    const measurementSiteTableVersion_optional&
    measurementSiteTableVersion () const;

    measurementSiteTableVersion_optional&
    measurementSiteTableVersion ();

    void
    measurementSiteTableVersion (const measurementSiteTableVersion_type& x);

    void
    measurementSiteTableVersion (const measurementSiteTableVersion_optional& x);

    void
    measurementSiteTableVersion (::std::auto_ptr< measurementSiteTableVersion_type > p);

    // measurementSiteRecord
    // 
    typedef ::datex2::MeasurementSiteRecord measurementSiteRecord_type;
    typedef ::xsd::cxx::tree::sequence< measurementSiteRecord_type > measurementSiteRecord_sequence;
    typedef xsd::cxx::tree::sequence< measurementSiteRecord_type >::iterator measurementSiteRecord_iterator;
    typedef xsd::cxx::tree::sequence< measurementSiteRecord_type >::const_iterator measurementSiteRecord_const_iterator;
    typedef ::xsd::cxx::tree::traits< measurementSiteRecord_type, char > measurementSiteRecord_traits;

    const measurementSiteRecord_sequence&
    measurementSiteRecord () const;

    measurementSiteRecord_sequence&
    measurementSiteRecord ();

    void
    measurementSiteRecord (const measurementSiteRecord_sequence& s);

    // measurementSiteTableExtension
    // 
    typedef ::datex2::ExtensionType measurementSiteTableExtension_type;
    typedef ::xsd::cxx::tree::optional< measurementSiteTableExtension_type > measurementSiteTableExtension_optional;
    typedef ::xsd::cxx::tree::traits< measurementSiteTableExtension_type, char > measurementSiteTableExtension_traits;

    const measurementSiteTableExtension_optional&
    measurementSiteTableExtension () const;

    measurementSiteTableExtension_optional&
    measurementSiteTableExtension ();

    void
    measurementSiteTableExtension (const measurementSiteTableExtension_type& x);

    void
    measurementSiteTableExtension (const measurementSiteTableExtension_optional& x);

    void
    measurementSiteTableExtension (::std::auto_ptr< measurementSiteTableExtension_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_type&
    id () const;

    id_type&
    id ();

    void
    id (const id_type& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    MeasurementSiteTable (const id_type&);

    MeasurementSiteTable (const xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    MeasurementSiteTable (const MeasurementSiteTable& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual MeasurementSiteTable*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MeasurementSiteTable ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    measurementSiteTableIdentification_optional measurementSiteTableIdentification_;
    measurementSiteTableVersion_optional measurementSiteTableVersion_;
    measurementSiteRecord_sequence measurementSiteRecord_;
    measurementSiteTableExtension_optional measurementSiteTableExtension_;
    ::xsd::cxx::tree::one< id_type > id_;
  };

  class MeasurementSiteTablePublication: public ::datex2::PayloadPublication
  {
    public:
    // headerInformation
    // 
    typedef ::datex2::HeaderInformation headerInformation_type;
    typedef ::xsd::cxx::tree::traits< headerInformation_type, char > headerInformation_traits;

    const headerInformation_type&
    headerInformation () const;

    headerInformation_type&
    headerInformation ();

    void
    headerInformation (const headerInformation_type& x);

    void
    headerInformation (::std::auto_ptr< headerInformation_type > p);

    // measurementSiteTable
    // 
    typedef ::datex2::MeasurementSiteTable measurementSiteTable_type;
    typedef ::xsd::cxx::tree::sequence< measurementSiteTable_type > measurementSiteTable_sequence;
    typedef xsd::cxx::tree::sequence< measurementSiteTable_type >::iterator measurementSiteTable_iterator;
    typedef xsd::cxx::tree::sequence< measurementSiteTable_type >::const_iterator measurementSiteTable_const_iterator;
    typedef ::xsd::cxx::tree::traits< measurementSiteTable_type, char > measurementSiteTable_traits;

    const measurementSiteTable_sequence&
    measurementSiteTable () const;

    measurementSiteTable_sequence&
    measurementSiteTable ();

    void
    measurementSiteTable (const measurementSiteTable_sequence& s);

    // measurementSiteTablePublicationExtension
    // 
    typedef ::datex2::ExtensionType measurementSiteTablePublicationExtension_type;
    typedef ::xsd::cxx::tree::optional< measurementSiteTablePublicationExtension_type > measurementSiteTablePublicationExtension_optional;
    typedef ::xsd::cxx::tree::traits< measurementSiteTablePublicationExtension_type, char > measurementSiteTablePublicationExtension_traits;

    const measurementSiteTablePublicationExtension_optional&
    measurementSiteTablePublicationExtension () const;

    measurementSiteTablePublicationExtension_optional&
    measurementSiteTablePublicationExtension ();

    void
    measurementSiteTablePublicationExtension (const measurementSiteTablePublicationExtension_type& x);

    void
    measurementSiteTablePublicationExtension (const measurementSiteTablePublicationExtension_optional& x);

    void
    measurementSiteTablePublicationExtension (::std::auto_ptr< measurementSiteTablePublicationExtension_type > p);

    // Constructors.
    //
    MeasurementSiteTablePublication (const publicationTime_type&,
                                     const publicationCreator_type&,
                                     const lang_type&,
                                     const headerInformation_type&);

    MeasurementSiteTablePublication (const publicationTime_type&,
                                     ::std::auto_ptr< publicationCreator_type >&,
                                     const lang_type&,
                                     ::std::auto_ptr< headerInformation_type >&);

    MeasurementSiteTablePublication (const xercesc::DOMElement& e,
                                     ::xml_schema::flags f = 0,
                                     ::xml_schema::container* c = 0);

    MeasurementSiteTablePublication (const MeasurementSiteTablePublication& x,
                                     ::xml_schema::flags f = 0,
                                     ::xml_schema::container* c = 0);

    virtual MeasurementSiteTablePublication*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MeasurementSiteTablePublication ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< headerInformation_type > headerInformation_;
    measurementSiteTable_sequence measurementSiteTable_;
    measurementSiteTablePublicationExtension_optional measurementSiteTablePublicationExtension_;
  };

  class MeasurementSpecificCharacteristics: public ::xml_schema::type
  {
    public:
    // accuracy
    // 
    typedef ::datex2::Percentage accuracy_type;
    typedef ::xsd::cxx::tree::optional< accuracy_type > accuracy_optional;
    typedef ::xsd::cxx::tree::traits< accuracy_type, char > accuracy_traits;

    const accuracy_optional&
    accuracy () const;

    accuracy_optional&
    accuracy ();

    void
    accuracy (const accuracy_type& x);

    void
    accuracy (const accuracy_optional& x);

    void
    accuracy (::std::auto_ptr< accuracy_type > p);

    // period
    // 
    typedef ::datex2::Seconds period_type;
    typedef ::xsd::cxx::tree::optional< period_type > period_optional;
    typedef ::xsd::cxx::tree::traits< period_type, char > period_traits;

    const period_optional&
    period () const;

    period_optional&
    period ();

    void
    period (const period_type& x);

    void
    period (const period_optional& x);

    void
    period (::std::auto_ptr< period_type > p);

    // smoothingFactor
    // 
    typedef ::datex2::Float smoothingFactor_type;
    typedef ::xsd::cxx::tree::optional< smoothingFactor_type > smoothingFactor_optional;
    typedef ::xsd::cxx::tree::traits< smoothingFactor_type, char > smoothingFactor_traits;

    const smoothingFactor_optional&
    smoothingFactor () const;

    smoothingFactor_optional&
    smoothingFactor ();

    void
    smoothingFactor (const smoothingFactor_type& x);

    void
    smoothingFactor (const smoothingFactor_optional& x);

    void
    smoothingFactor (::std::auto_ptr< smoothingFactor_type > p);

    // specificLane
    // 
    typedef ::datex2::LaneEnum specificLane_type;
    typedef ::xsd::cxx::tree::optional< specificLane_type > specificLane_optional;
    typedef ::xsd::cxx::tree::traits< specificLane_type, char > specificLane_traits;

    const specificLane_optional&
    specificLane () const;

    specificLane_optional&
    specificLane ();

    void
    specificLane (const specificLane_type& x);

    void
    specificLane (const specificLane_optional& x);

    void
    specificLane (::std::auto_ptr< specificLane_type > p);

    // specificMeasurementValueType
    // 
    typedef ::datex2::MeasuredOrDerivedDataTypeEnum specificMeasurementValueType_type;
    typedef ::xsd::cxx::tree::traits< specificMeasurementValueType_type, char > specificMeasurementValueType_traits;

    const specificMeasurementValueType_type&
    specificMeasurementValueType () const;

    specificMeasurementValueType_type&
    specificMeasurementValueType ();

    void
    specificMeasurementValueType (const specificMeasurementValueType_type& x);

    void
    specificMeasurementValueType (::std::auto_ptr< specificMeasurementValueType_type > p);

    // specificVehicleCharacteristics
    // 
    typedef ::datex2::VehicleCharacteristics specificVehicleCharacteristics_type;
    typedef ::xsd::cxx::tree::optional< specificVehicleCharacteristics_type > specificVehicleCharacteristics_optional;
    typedef ::xsd::cxx::tree::traits< specificVehicleCharacteristics_type, char > specificVehicleCharacteristics_traits;

    const specificVehicleCharacteristics_optional&
    specificVehicleCharacteristics () const;

    specificVehicleCharacteristics_optional&
    specificVehicleCharacteristics ();

    void
    specificVehicleCharacteristics (const specificVehicleCharacteristics_type& x);

    void
    specificVehicleCharacteristics (const specificVehicleCharacteristics_optional& x);

    void
    specificVehicleCharacteristics (::std::auto_ptr< specificVehicleCharacteristics_type > p);

    // measurementSpecificCharacteristicsExtension
    // 
    typedef ::datex2::ExtensionType measurementSpecificCharacteristicsExtension_type;
    typedef ::xsd::cxx::tree::optional< measurementSpecificCharacteristicsExtension_type > measurementSpecificCharacteristicsExtension_optional;
    typedef ::xsd::cxx::tree::traits< measurementSpecificCharacteristicsExtension_type, char > measurementSpecificCharacteristicsExtension_traits;

    const measurementSpecificCharacteristicsExtension_optional&
    measurementSpecificCharacteristicsExtension () const;

    measurementSpecificCharacteristicsExtension_optional&
    measurementSpecificCharacteristicsExtension ();

    void
    measurementSpecificCharacteristicsExtension (const measurementSpecificCharacteristicsExtension_type& x);

    void
    measurementSpecificCharacteristicsExtension (const measurementSpecificCharacteristicsExtension_optional& x);

    void
    measurementSpecificCharacteristicsExtension (::std::auto_ptr< measurementSpecificCharacteristicsExtension_type > p);

    // Constructors.
    //
    MeasurementSpecificCharacteristics (const specificMeasurementValueType_type&);

    MeasurementSpecificCharacteristics (const xercesc::DOMElement& e,
                                        ::xml_schema::flags f = 0,
                                        ::xml_schema::container* c = 0);

    MeasurementSpecificCharacteristics (const MeasurementSpecificCharacteristics& x,
                                        ::xml_schema::flags f = 0,
                                        ::xml_schema::container* c = 0);

    virtual MeasurementSpecificCharacteristics*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MeasurementSpecificCharacteristics ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    accuracy_optional accuracy_;
    period_optional period_;
    smoothingFactor_optional smoothingFactor_;
    specificLane_optional specificLane_;
    ::xsd::cxx::tree::one< specificMeasurementValueType_type > specificMeasurementValueType_;
    specificVehicleCharacteristics_optional specificVehicleCharacteristics_;
    measurementSpecificCharacteristicsExtension_optional measurementSpecificCharacteristicsExtension_;
  };

  class MetresAsFloat: public ::datex2::Float
  {
    public:
    // Constructors.
    //
    MetresAsFloat (const ::xml_schema::float_&);

    MetresAsFloat (const xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    MetresAsFloat (const xercesc::DOMAttr& a,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    MetresAsFloat (const ::std::string& s,
                   const xercesc::DOMElement* e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    MetresAsFloat (const MetresAsFloat& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual MetresAsFloat*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MetresAsFloat ();
  };

  class MetresAsNonNegativeInteger: public ::datex2::NonNegativeInteger
  {
    public:
    // Constructors.
    //
    MetresAsNonNegativeInteger (const ::xml_schema::non_negative_integer&);

    MetresAsNonNegativeInteger (const xercesc::DOMElement& e,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    MetresAsNonNegativeInteger (const xercesc::DOMAttr& a,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    MetresAsNonNegativeInteger (const ::std::string& s,
                                const xercesc::DOMElement* e,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    MetresAsNonNegativeInteger (const MetresAsNonNegativeInteger& x,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    virtual MetresAsNonNegativeInteger*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MetresAsNonNegativeInteger ();
  };

  class Mobility: public ::xml_schema::type
  {
    public:
    // mobilityType
    // 
    typedef ::datex2::MobilityEnum mobilityType_type;
    typedef ::xsd::cxx::tree::traits< mobilityType_type, char > mobilityType_traits;

    const mobilityType_type&
    mobilityType () const;

    mobilityType_type&
    mobilityType ();

    void
    mobilityType (const mobilityType_type& x);

    void
    mobilityType (::std::auto_ptr< mobilityType_type > p);

    // mobilityExtension
    // 
    typedef ::datex2::ExtensionType mobilityExtension_type;
    typedef ::xsd::cxx::tree::optional< mobilityExtension_type > mobilityExtension_optional;
    typedef ::xsd::cxx::tree::traits< mobilityExtension_type, char > mobilityExtension_traits;

    const mobilityExtension_optional&
    mobilityExtension () const;

    mobilityExtension_optional&
    mobilityExtension ();

    void
    mobilityExtension (const mobilityExtension_type& x);

    void
    mobilityExtension (const mobilityExtension_optional& x);

    void
    mobilityExtension (::std::auto_ptr< mobilityExtension_type > p);

    // Constructors.
    //
    Mobility (const mobilityType_type&);

    Mobility (const xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    Mobility (const Mobility& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual Mobility*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Mobility ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< mobilityType_type > mobilityType_;
    mobilityExtension_optional mobilityExtension_;
  };

  class MobilityEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      mobile,
      stationary,
      unknown
    };

    MobilityEnum (value v);

    MobilityEnum (const char* v);

    MobilityEnum (const ::std::string& v);

    MobilityEnum (const ::xml_schema::string& v);

    MobilityEnum (const xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    MobilityEnum (const xercesc::DOMAttr& a,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    MobilityEnum (const ::std::string& s,
                  const xercesc::DOMElement* e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    MobilityEnum (const MobilityEnum& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual MobilityEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    MobilityEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_MobilityEnum_convert ();
    }

    protected:
    value
    _xsd_MobilityEnum_convert () const;

    public:
    static const char* const _xsd_MobilityEnum_literals_[3];
    static const value _xsd_MobilityEnum_indexes_[3];
  };

  class MonthOfYearEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      january,
      february,
      march,
      april,
      may,
      june,
      july,
      august,
      september,
      october,
      november,
      december
    };

    MonthOfYearEnum (value v);

    MonthOfYearEnum (const char* v);

    MonthOfYearEnum (const ::std::string& v);

    MonthOfYearEnum (const ::xml_schema::string& v);

    MonthOfYearEnum (const xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    MonthOfYearEnum (const xercesc::DOMAttr& a,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    MonthOfYearEnum (const ::std::string& s,
                     const xercesc::DOMElement* e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    MonthOfYearEnum (const MonthOfYearEnum& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual MonthOfYearEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    MonthOfYearEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_MonthOfYearEnum_convert ();
    }

    protected:
    value
    _xsd_MonthOfYearEnum_convert () const;

    public:
    static const char* const _xsd_MonthOfYearEnum_literals_[12];
    static const value _xsd_MonthOfYearEnum_indexes_[12];
  };

  class MultilingualString: public ::xml_schema::type
  {
    public:
    // value
    // 
    typedef ::datex2::MultilingualStringValue value_type;
    typedef ::xsd::cxx::tree::sequence< value_type > value_sequence;
    typedef xsd::cxx::tree::sequence< value_type >::iterator value_iterator;
    typedef xsd::cxx::tree::sequence< value_type >::const_iterator value_const_iterator;
    typedef ::xsd::cxx::tree::traits< value_type, char > value_traits;

    const value_sequence&
    value () const;

    value_sequence&
    value ();

    void
    value (const value_sequence& s);

    // Constructors.
    //
    MultilingualString ();

    MultilingualString (const xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    MultilingualString (const MultilingualString& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual MultilingualString*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MultilingualString ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    value_sequence value_;
  };

  class MultilingualStringValueType: public ::xml_schema::string
  {
    public:
    // Constructors.
    //
    MultilingualStringValueType ();

    MultilingualStringValueType (const char*);

    MultilingualStringValueType (const ::std::string&);

    MultilingualStringValueType (const ::xml_schema::string&);

    MultilingualStringValueType (const xercesc::DOMElement& e,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    MultilingualStringValueType (const xercesc::DOMAttr& a,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    MultilingualStringValueType (const ::std::string& s,
                                 const xercesc::DOMElement* e,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    MultilingualStringValueType (const MultilingualStringValueType& x,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    virtual MultilingualStringValueType*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MultilingualStringValueType ();
  };

  class MultilingualStringValue: public ::datex2::MultilingualStringValueType
  {
    public:
    // lang
    // 
    typedef ::xml_schema::language lang_type;
    typedef ::xsd::cxx::tree::optional< lang_type > lang_optional;
    typedef ::xsd::cxx::tree::traits< lang_type, char > lang_traits;

    const lang_optional&
    lang () const;

    lang_optional&
    lang ();

    void
    lang (const lang_type& x);

    void
    lang (const lang_optional& x);

    void
    lang (::std::auto_ptr< lang_type > p);

    // Constructors.
    //
    MultilingualStringValue ();

    MultilingualStringValue (const char*);

    MultilingualStringValue (const ::std::string&);

    MultilingualStringValue (const ::xml_schema::string&);

    MultilingualStringValue (const xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    MultilingualStringValue (const MultilingualStringValue& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual MultilingualStringValue*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MultilingualStringValue ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    lang_optional lang_;
  };

  class NonManagedCause: public ::datex2::Cause
  {
    public:
    // causeDescription
    // 
    typedef ::datex2::MultilingualString causeDescription_type;
    typedef ::xsd::cxx::tree::optional< causeDescription_type > causeDescription_optional;
    typedef ::xsd::cxx::tree::traits< causeDescription_type, char > causeDescription_traits;

    const causeDescription_optional&
    causeDescription () const;

    causeDescription_optional&
    causeDescription ();

    void
    causeDescription (const causeDescription_type& x);

    void
    causeDescription (const causeDescription_optional& x);

    void
    causeDescription (::std::auto_ptr< causeDescription_type > p);

    // causeType
    // 
    typedef ::datex2::CauseTypeEnum causeType_type;
    typedef ::xsd::cxx::tree::optional< causeType_type > causeType_optional;
    typedef ::xsd::cxx::tree::traits< causeType_type, char > causeType_traits;

    const causeType_optional&
    causeType () const;

    causeType_optional&
    causeType ();

    void
    causeType (const causeType_type& x);

    void
    causeType (const causeType_optional& x);

    void
    causeType (::std::auto_ptr< causeType_type > p);

    // nonManagedCauseExtension
    // 
    typedef ::datex2::ExtensionType nonManagedCauseExtension_type;
    typedef ::xsd::cxx::tree::optional< nonManagedCauseExtension_type > nonManagedCauseExtension_optional;
    typedef ::xsd::cxx::tree::traits< nonManagedCauseExtension_type, char > nonManagedCauseExtension_traits;

    const nonManagedCauseExtension_optional&
    nonManagedCauseExtension () const;

    nonManagedCauseExtension_optional&
    nonManagedCauseExtension ();

    void
    nonManagedCauseExtension (const nonManagedCauseExtension_type& x);

    void
    nonManagedCauseExtension (const nonManagedCauseExtension_optional& x);

    void
    nonManagedCauseExtension (::std::auto_ptr< nonManagedCauseExtension_type > p);

    // Constructors.
    //
    NonManagedCause ();

    NonManagedCause (const xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    NonManagedCause (const NonManagedCause& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual NonManagedCause*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~NonManagedCause ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    causeDescription_optional causeDescription_;
    causeType_optional causeType_;
    nonManagedCauseExtension_optional nonManagedCauseExtension_;
  };

  class RoadConditions: public ::datex2::Conditions
  {
    public:
    // roadConditionsExtension
    // 
    typedef ::datex2::ExtensionType roadConditionsExtension_type;
    typedef ::xsd::cxx::tree::optional< roadConditionsExtension_type > roadConditionsExtension_optional;
    typedef ::xsd::cxx::tree::traits< roadConditionsExtension_type, char > roadConditionsExtension_traits;

    const roadConditionsExtension_optional&
    roadConditionsExtension () const;

    roadConditionsExtension_optional&
    roadConditionsExtension ();

    void
    roadConditionsExtension (const roadConditionsExtension_type& x);

    void
    roadConditionsExtension (const roadConditionsExtension_optional& x);

    void
    roadConditionsExtension (::std::auto_ptr< roadConditionsExtension_type > p);

    // Constructors.
    //
    RoadConditions (const situationRecordCreationTime_type&,
                    const situationRecordVersion_type&,
                    const situationRecordVersionTime_type&,
                    const probabilityOfOccurrence_type&,
                    const validity_type&,
                    const groupOfLocations_type&,
                    const id_type&);

    RoadConditions (const situationRecordCreationTime_type&,
                    const situationRecordVersion_type&,
                    const situationRecordVersionTime_type&,
                    const probabilityOfOccurrence_type&,
                    ::std::auto_ptr< validity_type >&,
                    ::std::auto_ptr< groupOfLocations_type >&,
                    const id_type&);

    RoadConditions (const xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    RoadConditions (const RoadConditions& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual RoadConditions*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RoadConditions ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    roadConditionsExtension_optional roadConditionsExtension_;
  };

  class NonWeatherRelatedRoadConditions: public ::datex2::RoadConditions
  {
    public:
    // nonWeatherRelatedRoadConditionType
    // 
    typedef ::datex2::NonWeatherRelatedRoadConditionTypeEnum nonWeatherRelatedRoadConditionType_type;
    typedef ::xsd::cxx::tree::sequence< nonWeatherRelatedRoadConditionType_type > nonWeatherRelatedRoadConditionType_sequence;
    typedef xsd::cxx::tree::sequence< nonWeatherRelatedRoadConditionType_type >::iterator nonWeatherRelatedRoadConditionType_iterator;
    typedef xsd::cxx::tree::sequence< nonWeatherRelatedRoadConditionType_type >::const_iterator nonWeatherRelatedRoadConditionType_const_iterator;
    typedef ::xsd::cxx::tree::traits< nonWeatherRelatedRoadConditionType_type, char > nonWeatherRelatedRoadConditionType_traits;

    const nonWeatherRelatedRoadConditionType_sequence&
    nonWeatherRelatedRoadConditionType () const;

    nonWeatherRelatedRoadConditionType_sequence&
    nonWeatherRelatedRoadConditionType ();

    void
    nonWeatherRelatedRoadConditionType (const nonWeatherRelatedRoadConditionType_sequence& s);

    // nonWeatherRelatedRoadConditionsExtension
    // 
    typedef ::datex2::ExtensionType nonWeatherRelatedRoadConditionsExtension_type;
    typedef ::xsd::cxx::tree::optional< nonWeatherRelatedRoadConditionsExtension_type > nonWeatherRelatedRoadConditionsExtension_optional;
    typedef ::xsd::cxx::tree::traits< nonWeatherRelatedRoadConditionsExtension_type, char > nonWeatherRelatedRoadConditionsExtension_traits;

    const nonWeatherRelatedRoadConditionsExtension_optional&
    nonWeatherRelatedRoadConditionsExtension () const;

    nonWeatherRelatedRoadConditionsExtension_optional&
    nonWeatherRelatedRoadConditionsExtension ();

    void
    nonWeatherRelatedRoadConditionsExtension (const nonWeatherRelatedRoadConditionsExtension_type& x);

    void
    nonWeatherRelatedRoadConditionsExtension (const nonWeatherRelatedRoadConditionsExtension_optional& x);

    void
    nonWeatherRelatedRoadConditionsExtension (::std::auto_ptr< nonWeatherRelatedRoadConditionsExtension_type > p);

    // Constructors.
    //
    NonWeatherRelatedRoadConditions (const situationRecordCreationTime_type&,
                                     const situationRecordVersion_type&,
                                     const situationRecordVersionTime_type&,
                                     const probabilityOfOccurrence_type&,
                                     const validity_type&,
                                     const groupOfLocations_type&,
                                     const id_type&);

    NonWeatherRelatedRoadConditions (const situationRecordCreationTime_type&,
                                     const situationRecordVersion_type&,
                                     const situationRecordVersionTime_type&,
                                     const probabilityOfOccurrence_type&,
                                     ::std::auto_ptr< validity_type >&,
                                     ::std::auto_ptr< groupOfLocations_type >&,
                                     const id_type&);

    NonWeatherRelatedRoadConditions (const xercesc::DOMElement& e,
                                     ::xml_schema::flags f = 0,
                                     ::xml_schema::container* c = 0);

    NonWeatherRelatedRoadConditions (const NonWeatherRelatedRoadConditions& x,
                                     ::xml_schema::flags f = 0,
                                     ::xml_schema::container* c = 0);

    virtual NonWeatherRelatedRoadConditions*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~NonWeatherRelatedRoadConditions ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    nonWeatherRelatedRoadConditionType_sequence nonWeatherRelatedRoadConditionType_;
    nonWeatherRelatedRoadConditionsExtension_optional nonWeatherRelatedRoadConditionsExtension_;
  };

  class NonWeatherRelatedRoadConditionTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      dieselOnRoad,
      leavesOnRoad,
      looseChippings,
      looseSandOnRoad,
      mudOnRoad,
      oilOnRoad,
      petrolOnRoad,
      roadSurfaceInPoorCondition,
      slipperyRoad,
      other
    };

    NonWeatherRelatedRoadConditionTypeEnum (value v);

    NonWeatherRelatedRoadConditionTypeEnum (const char* v);

    NonWeatherRelatedRoadConditionTypeEnum (const ::std::string& v);

    NonWeatherRelatedRoadConditionTypeEnum (const ::xml_schema::string& v);

    NonWeatherRelatedRoadConditionTypeEnum (const xercesc::DOMElement& e,
                                            ::xml_schema::flags f = 0,
                                            ::xml_schema::container* c = 0);

    NonWeatherRelatedRoadConditionTypeEnum (const xercesc::DOMAttr& a,
                                            ::xml_schema::flags f = 0,
                                            ::xml_schema::container* c = 0);

    NonWeatherRelatedRoadConditionTypeEnum (const ::std::string& s,
                                            const xercesc::DOMElement* e,
                                            ::xml_schema::flags f = 0,
                                            ::xml_schema::container* c = 0);

    NonWeatherRelatedRoadConditionTypeEnum (const NonWeatherRelatedRoadConditionTypeEnum& x,
                                            ::xml_schema::flags f = 0,
                                            ::xml_schema::container* c = 0);

    virtual NonWeatherRelatedRoadConditionTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    NonWeatherRelatedRoadConditionTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_NonWeatherRelatedRoadConditionTypeEnum_convert ();
    }

    protected:
    value
    _xsd_NonWeatherRelatedRoadConditionTypeEnum_convert () const;

    public:
    static const char* const _xsd_NonWeatherRelatedRoadConditionTypeEnum_literals_[10];
    static const value _xsd_NonWeatherRelatedRoadConditionTypeEnum_indexes_[10];
  };

  class NumberOfAxlesCharacteristic: public ::xml_schema::type
  {
    public:
    // comparisonOperator
    // 
    typedef ::datex2::ComparisonOperatorEnum comparisonOperator_type;
    typedef ::xsd::cxx::tree::traits< comparisonOperator_type, char > comparisonOperator_traits;

    const comparisonOperator_type&
    comparisonOperator () const;

    comparisonOperator_type&
    comparisonOperator ();

    void
    comparisonOperator (const comparisonOperator_type& x);

    void
    comparisonOperator (::std::auto_ptr< comparisonOperator_type > p);

    // numberOfAxles
    // 
    typedef ::datex2::NonNegativeInteger numberOfAxles_type;
    typedef ::xsd::cxx::tree::traits< numberOfAxles_type, char > numberOfAxles_traits;

    const numberOfAxles_type&
    numberOfAxles () const;

    numberOfAxles_type&
    numberOfAxles ();

    void
    numberOfAxles (const numberOfAxles_type& x);

    void
    numberOfAxles (::std::auto_ptr< numberOfAxles_type > p);

    // numberOfAxlesCharacteristicExtension
    // 
    typedef ::datex2::ExtensionType numberOfAxlesCharacteristicExtension_type;
    typedef ::xsd::cxx::tree::optional< numberOfAxlesCharacteristicExtension_type > numberOfAxlesCharacteristicExtension_optional;
    typedef ::xsd::cxx::tree::traits< numberOfAxlesCharacteristicExtension_type, char > numberOfAxlesCharacteristicExtension_traits;

    const numberOfAxlesCharacteristicExtension_optional&
    numberOfAxlesCharacteristicExtension () const;

    numberOfAxlesCharacteristicExtension_optional&
    numberOfAxlesCharacteristicExtension ();

    void
    numberOfAxlesCharacteristicExtension (const numberOfAxlesCharacteristicExtension_type& x);

    void
    numberOfAxlesCharacteristicExtension (const numberOfAxlesCharacteristicExtension_optional& x);

    void
    numberOfAxlesCharacteristicExtension (::std::auto_ptr< numberOfAxlesCharacteristicExtension_type > p);

    // Constructors.
    //
    NumberOfAxlesCharacteristic (const comparisonOperator_type&,
                                 const numberOfAxles_type&);

    NumberOfAxlesCharacteristic (const xercesc::DOMElement& e,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    NumberOfAxlesCharacteristic (const NumberOfAxlesCharacteristic& x,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    virtual NumberOfAxlesCharacteristic*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~NumberOfAxlesCharacteristic ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< comparisonOperator_type > comparisonOperator_;
    ::xsd::cxx::tree::one< numberOfAxles_type > numberOfAxles_;
    numberOfAxlesCharacteristicExtension_optional numberOfAxlesCharacteristicExtension_;
  };

  class ObstructionTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      airCrash,
      childrenOnRoadway,
      clearanceWork,
      craneOperating,
      cyclistsOnRoadway,
      debris,
      explosion,
      explosionHazard,
      hazardsOnTheRoad,
      highSpeedChase,
      houseFire,
      incident,
      industrialAccident,
      objectOnTheRoad,
      objectsFallingFromMovingVehicle,
      obstructionOnTheRoad,
      peopleOnRoadway,
      railCrash,
      recklessDriver,
      rescueAndRecoveryWork,
      severeFrostDamagedRoadway,
      shedLoad,
      snowAndIceDebris,
      spillageOccurringFromMovingVehicle,
      spillageOnTheRoad,
      unprotectedAccidentArea,
      other
    };

    ObstructionTypeEnum (value v);

    ObstructionTypeEnum (const char* v);

    ObstructionTypeEnum (const ::std::string& v);

    ObstructionTypeEnum (const ::xml_schema::string& v);

    ObstructionTypeEnum (const xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    ObstructionTypeEnum (const xercesc::DOMAttr& a,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    ObstructionTypeEnum (const ::std::string& s,
                         const xercesc::DOMElement* e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    ObstructionTypeEnum (const ObstructionTypeEnum& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual ObstructionTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    ObstructionTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_ObstructionTypeEnum_convert ();
    }

    protected:
    value
    _xsd_ObstructionTypeEnum_convert () const;

    public:
    static const char* const _xsd_ObstructionTypeEnum_literals_[27];
    static const value _xsd_ObstructionTypeEnum_indexes_[27];
  };

  class OffsetDistance: public ::xml_schema::type
  {
    public:
    // offsetDistance
    // 
    typedef ::datex2::MetresAsNonNegativeInteger offsetDistance_type;
    typedef ::xsd::cxx::tree::traits< offsetDistance_type, char > offsetDistance_traits;

    const offsetDistance_type&
    offsetDistance () const;

    offsetDistance_type&
    offsetDistance ();

    void
    offsetDistance (const offsetDistance_type& x);

    void
    offsetDistance (::std::auto_ptr< offsetDistance_type > p);

    // offsetDistanceExtension
    // 
    typedef ::datex2::ExtensionType offsetDistanceExtension_type;
    typedef ::xsd::cxx::tree::optional< offsetDistanceExtension_type > offsetDistanceExtension_optional;
    typedef ::xsd::cxx::tree::traits< offsetDistanceExtension_type, char > offsetDistanceExtension_traits;

    const offsetDistanceExtension_optional&
    offsetDistanceExtension () const;

    offsetDistanceExtension_optional&
    offsetDistanceExtension ();

    void
    offsetDistanceExtension (const offsetDistanceExtension_type& x);

    void
    offsetDistanceExtension (const offsetDistanceExtension_optional& x);

    void
    offsetDistanceExtension (::std::auto_ptr< offsetDistanceExtension_type > p);

    // Constructors.
    //
    OffsetDistance (const offsetDistance_type&);

    OffsetDistance (const xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    OffsetDistance (const OffsetDistance& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual OffsetDistance*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~OffsetDistance ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< offsetDistance_type > offsetDistance_;
    offsetDistanceExtension_optional offsetDistanceExtension_;
  };

  class OperatingModeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      operatingMode0,
      operatingMode1,
      operatingMode2,
      operatingMode3
    };

    OperatingModeEnum (value v);

    OperatingModeEnum (const char* v);

    OperatingModeEnum (const ::std::string& v);

    OperatingModeEnum (const ::xml_schema::string& v);

    OperatingModeEnum (const xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    OperatingModeEnum (const xercesc::DOMAttr& a,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    OperatingModeEnum (const ::std::string& s,
                       const xercesc::DOMElement* e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    OperatingModeEnum (const OperatingModeEnum& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual OperatingModeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    OperatingModeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_OperatingModeEnum_convert ();
    }

    protected:
    value
    _xsd_OperatingModeEnum_convert () const;

    public:
    static const char* const _xsd_OperatingModeEnum_literals_[4];
    static const value _xsd_OperatingModeEnum_indexes_[4];
  };

  class OperatorActionOriginEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      external,
      internal
    };

    OperatorActionOriginEnum (value v);

    OperatorActionOriginEnum (const char* v);

    OperatorActionOriginEnum (const ::std::string& v);

    OperatorActionOriginEnum (const ::xml_schema::string& v);

    OperatorActionOriginEnum (const xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    OperatorActionOriginEnum (const xercesc::DOMAttr& a,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    OperatorActionOriginEnum (const ::std::string& s,
                              const xercesc::DOMElement* e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    OperatorActionOriginEnum (const OperatorActionOriginEnum& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual OperatorActionOriginEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    OperatorActionOriginEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_OperatorActionOriginEnum_convert ();
    }

    protected:
    value
    _xsd_OperatorActionOriginEnum_convert () const;

    public:
    static const char* const _xsd_OperatorActionOriginEnum_literals_[2];
    static const value _xsd_OperatorActionOriginEnum_indexes_[2];
  };

  class OperatorActionStatusEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      approved,
      implemented,
      inProgress,
      over,
      rejected,
      requested
    };

    OperatorActionStatusEnum (value v);

    OperatorActionStatusEnum (const char* v);

    OperatorActionStatusEnum (const ::std::string& v);

    OperatorActionStatusEnum (const ::xml_schema::string& v);

    OperatorActionStatusEnum (const xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    OperatorActionStatusEnum (const xercesc::DOMAttr& a,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    OperatorActionStatusEnum (const ::std::string& s,
                              const xercesc::DOMElement* e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    OperatorActionStatusEnum (const OperatorActionStatusEnum& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual OperatorActionStatusEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    OperatorActionStatusEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_OperatorActionStatusEnum_convert ();
    }

    protected:
    value
    _xsd_OperatorActionStatusEnum_convert () const;

    public:
    static const char* const _xsd_OperatorActionStatusEnum_literals_[6];
    static const value _xsd_OperatorActionStatusEnum_indexes_[6];
  };

  class OverallPeriod: public ::xml_schema::type
  {
    public:
    // overallStartTime
    // 
    typedef ::datex2::DateTime overallStartTime_type;
    typedef ::xsd::cxx::tree::traits< overallStartTime_type, char > overallStartTime_traits;

    const overallStartTime_type&
    overallStartTime () const;

    overallStartTime_type&
    overallStartTime ();

    void
    overallStartTime (const overallStartTime_type& x);

    void
    overallStartTime (::std::auto_ptr< overallStartTime_type > p);

    // overallEndTime
    // 
    typedef ::datex2::DateTime overallEndTime_type;
    typedef ::xsd::cxx::tree::optional< overallEndTime_type > overallEndTime_optional;
    typedef ::xsd::cxx::tree::traits< overallEndTime_type, char > overallEndTime_traits;

    const overallEndTime_optional&
    overallEndTime () const;

    overallEndTime_optional&
    overallEndTime ();

    void
    overallEndTime (const overallEndTime_type& x);

    void
    overallEndTime (const overallEndTime_optional& x);

    void
    overallEndTime (::std::auto_ptr< overallEndTime_type > p);

    // validPeriod
    // 
    typedef ::datex2::Period validPeriod_type;
    typedef ::xsd::cxx::tree::sequence< validPeriod_type > validPeriod_sequence;
    typedef xsd::cxx::tree::sequence< validPeriod_type >::iterator validPeriod_iterator;
    typedef xsd::cxx::tree::sequence< validPeriod_type >::const_iterator validPeriod_const_iterator;
    typedef ::xsd::cxx::tree::traits< validPeriod_type, char > validPeriod_traits;

    const validPeriod_sequence&
    validPeriod () const;

    validPeriod_sequence&
    validPeriod ();

    void
    validPeriod (const validPeriod_sequence& s);

    // exceptionPeriod
    // 
    typedef ::datex2::Period exceptionPeriod_type;
    typedef ::xsd::cxx::tree::sequence< exceptionPeriod_type > exceptionPeriod_sequence;
    typedef xsd::cxx::tree::sequence< exceptionPeriod_type >::iterator exceptionPeriod_iterator;
    typedef xsd::cxx::tree::sequence< exceptionPeriod_type >::const_iterator exceptionPeriod_const_iterator;
    typedef ::xsd::cxx::tree::traits< exceptionPeriod_type, char > exceptionPeriod_traits;

    const exceptionPeriod_sequence&
    exceptionPeriod () const;

    exceptionPeriod_sequence&
    exceptionPeriod ();

    void
    exceptionPeriod (const exceptionPeriod_sequence& s);

    // overallPeriodExtension
    // 
    typedef ::datex2::ExtensionType overallPeriodExtension_type;
    typedef ::xsd::cxx::tree::optional< overallPeriodExtension_type > overallPeriodExtension_optional;
    typedef ::xsd::cxx::tree::traits< overallPeriodExtension_type, char > overallPeriodExtension_traits;

    const overallPeriodExtension_optional&
    overallPeriodExtension () const;

    overallPeriodExtension_optional&
    overallPeriodExtension ();

    void
    overallPeriodExtension (const overallPeriodExtension_type& x);

    void
    overallPeriodExtension (const overallPeriodExtension_optional& x);

    void
    overallPeriodExtension (::std::auto_ptr< overallPeriodExtension_type > p);

    // Constructors.
    //
    OverallPeriod (const overallStartTime_type&);

    OverallPeriod (const xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    OverallPeriod (const OverallPeriod& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual OverallPeriod*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~OverallPeriod ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< overallStartTime_type > overallStartTime_;
    overallEndTime_optional overallEndTime_;
    validPeriod_sequence validPeriod_;
    exceptionPeriod_sequence exceptionPeriod_;
    overallPeriodExtension_optional overallPeriodExtension_;
  };

  class OverallSeverityEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      highest,
      high,
      medium,
      low,
      lowest,
      none,
      unknown
    };

    OverallSeverityEnum (value v);

    OverallSeverityEnum (const char* v);

    OverallSeverityEnum (const ::std::string& v);

    OverallSeverityEnum (const ::xml_schema::string& v);

    OverallSeverityEnum (const xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    OverallSeverityEnum (const xercesc::DOMAttr& a,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    OverallSeverityEnum (const ::std::string& s,
                         const xercesc::DOMElement* e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    OverallSeverityEnum (const OverallSeverityEnum& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual OverallSeverityEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    OverallSeverityEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_OverallSeverityEnum_convert ();
    }

    protected:
    value
    _xsd_OverallSeverityEnum_convert () const;

    public:
    static const char* const _xsd_OverallSeverityEnum_literals_[7];
    static const value _xsd_OverallSeverityEnum_indexes_[7];
  };

  class PassengerCarUnitsPerHour: public ::datex2::NonNegativeInteger
  {
    public:
    // Constructors.
    //
    PassengerCarUnitsPerHour (const ::xml_schema::non_negative_integer&);

    PassengerCarUnitsPerHour (const xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    PassengerCarUnitsPerHour (const xercesc::DOMAttr& a,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    PassengerCarUnitsPerHour (const ::std::string& s,
                              const xercesc::DOMElement* e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    PassengerCarUnitsPerHour (const PassengerCarUnitsPerHour& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual PassengerCarUnitsPerHour*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PassengerCarUnitsPerHour ();
  };

  class Percentage: public ::datex2::Float
  {
    public:
    // Constructors.
    //
    Percentage (const ::xml_schema::float_&);

    Percentage (const xercesc::DOMElement& e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    Percentage (const xercesc::DOMAttr& a,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    Percentage (const ::std::string& s,
                const xercesc::DOMElement* e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    Percentage (const Percentage& x,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    virtual Percentage*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Percentage ();
  };

  class Period: public ::xml_schema::type
  {
    public:
    // startOfPeriod
    // 
    typedef ::datex2::DateTime startOfPeriod_type;
    typedef ::xsd::cxx::tree::optional< startOfPeriod_type > startOfPeriod_optional;
    typedef ::xsd::cxx::tree::traits< startOfPeriod_type, char > startOfPeriod_traits;

    const startOfPeriod_optional&
    startOfPeriod () const;

    startOfPeriod_optional&
    startOfPeriod ();

    void
    startOfPeriod (const startOfPeriod_type& x);

    void
    startOfPeriod (const startOfPeriod_optional& x);

    void
    startOfPeriod (::std::auto_ptr< startOfPeriod_type > p);

    // endOfPeriod
    // 
    typedef ::datex2::DateTime endOfPeriod_type;
    typedef ::xsd::cxx::tree::optional< endOfPeriod_type > endOfPeriod_optional;
    typedef ::xsd::cxx::tree::traits< endOfPeriod_type, char > endOfPeriod_traits;

    const endOfPeriod_optional&
    endOfPeriod () const;

    endOfPeriod_optional&
    endOfPeriod ();

    void
    endOfPeriod (const endOfPeriod_type& x);

    void
    endOfPeriod (const endOfPeriod_optional& x);

    void
    endOfPeriod (::std::auto_ptr< endOfPeriod_type > p);

    // periodName
    // 
    typedef ::datex2::MultilingualString periodName_type;
    typedef ::xsd::cxx::tree::optional< periodName_type > periodName_optional;
    typedef ::xsd::cxx::tree::traits< periodName_type, char > periodName_traits;

    const periodName_optional&
    periodName () const;

    periodName_optional&
    periodName ();

    void
    periodName (const periodName_type& x);

    void
    periodName (const periodName_optional& x);

    void
    periodName (::std::auto_ptr< periodName_type > p);

    // recurringTimePeriodOfDay
    // 
    typedef ::datex2::TimePeriodOfDay recurringTimePeriodOfDay_type;
    typedef ::xsd::cxx::tree::sequence< recurringTimePeriodOfDay_type > recurringTimePeriodOfDay_sequence;
    typedef xsd::cxx::tree::sequence< recurringTimePeriodOfDay_type >::iterator recurringTimePeriodOfDay_iterator;
    typedef xsd::cxx::tree::sequence< recurringTimePeriodOfDay_type >::const_iterator recurringTimePeriodOfDay_const_iterator;
    typedef ::xsd::cxx::tree::traits< recurringTimePeriodOfDay_type, char > recurringTimePeriodOfDay_traits;

    const recurringTimePeriodOfDay_sequence&
    recurringTimePeriodOfDay () const;

    recurringTimePeriodOfDay_sequence&
    recurringTimePeriodOfDay ();

    void
    recurringTimePeriodOfDay (const recurringTimePeriodOfDay_sequence& s);

    // recurringDayWeekMonthPeriod
    // 
    typedef ::datex2::DayWeekMonth recurringDayWeekMonthPeriod_type;
    typedef ::xsd::cxx::tree::sequence< recurringDayWeekMonthPeriod_type > recurringDayWeekMonthPeriod_sequence;
    typedef xsd::cxx::tree::sequence< recurringDayWeekMonthPeriod_type >::iterator recurringDayWeekMonthPeriod_iterator;
    typedef xsd::cxx::tree::sequence< recurringDayWeekMonthPeriod_type >::const_iterator recurringDayWeekMonthPeriod_const_iterator;
    typedef ::xsd::cxx::tree::traits< recurringDayWeekMonthPeriod_type, char > recurringDayWeekMonthPeriod_traits;

    const recurringDayWeekMonthPeriod_sequence&
    recurringDayWeekMonthPeriod () const;

    recurringDayWeekMonthPeriod_sequence&
    recurringDayWeekMonthPeriod ();

    void
    recurringDayWeekMonthPeriod (const recurringDayWeekMonthPeriod_sequence& s);

    // periodExtension
    // 
    typedef ::datex2::ExtensionType periodExtension_type;
    typedef ::xsd::cxx::tree::optional< periodExtension_type > periodExtension_optional;
    typedef ::xsd::cxx::tree::traits< periodExtension_type, char > periodExtension_traits;

    const periodExtension_optional&
    periodExtension () const;

    periodExtension_optional&
    periodExtension ();

    void
    periodExtension (const periodExtension_type& x);

    void
    periodExtension (const periodExtension_optional& x);

    void
    periodExtension (::std::auto_ptr< periodExtension_type > p);

    // Constructors.
    //
    Period ();

    Period (const xercesc::DOMElement& e,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    Period (const Period& x,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    virtual Period*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Period ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    startOfPeriod_optional startOfPeriod_;
    endOfPeriod_optional endOfPeriod_;
    periodName_optional periodName_;
    recurringTimePeriodOfDay_sequence recurringTimePeriodOfDay_;
    recurringDayWeekMonthPeriod_sequence recurringDayWeekMonthPeriod_;
    periodExtension_optional periodExtension_;
  };

  class PersonCategoryEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      adult,
      child,
      emergencyServicesPerson,
      fireman,
      infant,
      medicalStaff,
      memberOfThePublic,
      policeman,
      politician,
      publicTransportPassenger,
      sickPerson,
      trafficOfficer,
      trafficWarden,
      veryImportantPerson
    };

    PersonCategoryEnum (value v);

    PersonCategoryEnum (const char* v);

    PersonCategoryEnum (const ::std::string& v);

    PersonCategoryEnum (const ::xml_schema::string& v);

    PersonCategoryEnum (const xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    PersonCategoryEnum (const xercesc::DOMAttr& a,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    PersonCategoryEnum (const ::std::string& s,
                        const xercesc::DOMElement* e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    PersonCategoryEnum (const PersonCategoryEnum& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual PersonCategoryEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    PersonCategoryEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_PersonCategoryEnum_convert ();
    }

    protected:
    value
    _xsd_PersonCategoryEnum_convert () const;

    public:
    static const char* const _xsd_PersonCategoryEnum_literals_[14];
    static const value _xsd_PersonCategoryEnum_indexes_[14];
  };

  class PlacesEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      aroundBendsInTheRoad,
      atCustomsPosts,
      atHighAltitudes,
      atTollPlazas,
      inGalleries,
      inLowLyingAreas,
      inRoadworksAreas,
      inShadedAreas,
      inTheCityCentre,
      inTheInnerCityAreas,
      inTunnels,
      onBridges,
      onElevatedSections,
      onEnteringOrLeavingTunnels,
      onEnteringTheCountry,
      onFlyovers,
      onLeavingTheCountry,
      onMotorways,
      onNonMotorways,
      onRoundabouts,
      onSlipRoads,
      onUndergroundSections,
      onUnderpasses,
      overTheCrestOfHills,
      other
    };

    PlacesEnum (value v);

    PlacesEnum (const char* v);

    PlacesEnum (const ::std::string& v);

    PlacesEnum (const ::xml_schema::string& v);

    PlacesEnum (const xercesc::DOMElement& e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    PlacesEnum (const xercesc::DOMAttr& a,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    PlacesEnum (const ::std::string& s,
                const xercesc::DOMElement* e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    PlacesEnum (const PlacesEnum& x,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    virtual PlacesEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    PlacesEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_PlacesEnum_convert ();
    }

    protected:
    value
    _xsd_PlacesEnum_convert () const;

    public:
    static const char* const _xsd_PlacesEnum_literals_[25];
    static const value _xsd_PlacesEnum_indexes_[25];
  };

  class Point: public ::datex2::NetworkLocation
  {
    public:
    // tpegPointLocation
    // 
    typedef ::datex2::TpegPointLocation tpegPointLocation_type;
    typedef ::xsd::cxx::tree::optional< tpegPointLocation_type > tpegPointLocation_optional;
    typedef ::xsd::cxx::tree::traits< tpegPointLocation_type, char > tpegPointLocation_traits;

    const tpegPointLocation_optional&
    tpegPointLocation () const;

    tpegPointLocation_optional&
    tpegPointLocation ();

    void
    tpegPointLocation (const tpegPointLocation_type& x);

    void
    tpegPointLocation (const tpegPointLocation_optional& x);

    void
    tpegPointLocation (::std::auto_ptr< tpegPointLocation_type > p);

    // alertCPoint
    // 
    typedef ::datex2::AlertCPoint alertCPoint_type;
    typedef ::xsd::cxx::tree::optional< alertCPoint_type > alertCPoint_optional;
    typedef ::xsd::cxx::tree::traits< alertCPoint_type, char > alertCPoint_traits;

    const alertCPoint_optional&
    alertCPoint () const;

    alertCPoint_optional&
    alertCPoint ();

    void
    alertCPoint (const alertCPoint_type& x);

    void
    alertCPoint (const alertCPoint_optional& x);

    void
    alertCPoint (::std::auto_ptr< alertCPoint_type > p);

    // roadsideReferencePoint
    // 
    typedef ::datex2::RoadsideReferencePoint roadsideReferencePoint_type;
    typedef ::xsd::cxx::tree::optional< roadsideReferencePoint_type > roadsideReferencePoint_optional;
    typedef ::xsd::cxx::tree::traits< roadsideReferencePoint_type, char > roadsideReferencePoint_traits;

    const roadsideReferencePoint_optional&
    roadsideReferencePoint () const;

    roadsideReferencePoint_optional&
    roadsideReferencePoint ();

    void
    roadsideReferencePoint (const roadsideReferencePoint_type& x);

    void
    roadsideReferencePoint (const roadsideReferencePoint_optional& x);

    void
    roadsideReferencePoint (::std::auto_ptr< roadsideReferencePoint_type > p);

    // pointByCoordinates
    // 
    typedef ::datex2::PointByCoordinates pointByCoordinates_type;
    typedef ::xsd::cxx::tree::optional< pointByCoordinates_type > pointByCoordinates_optional;
    typedef ::xsd::cxx::tree::traits< pointByCoordinates_type, char > pointByCoordinates_traits;

    const pointByCoordinates_optional&
    pointByCoordinates () const;

    pointByCoordinates_optional&
    pointByCoordinates ();

    void
    pointByCoordinates (const pointByCoordinates_type& x);

    void
    pointByCoordinates (const pointByCoordinates_optional& x);

    void
    pointByCoordinates (::std::auto_ptr< pointByCoordinates_type > p);

    // pointExtension
    // 
    typedef ::datex2::ExtensionType pointExtension_type;
    typedef ::xsd::cxx::tree::optional< pointExtension_type > pointExtension_optional;
    typedef ::xsd::cxx::tree::traits< pointExtension_type, char > pointExtension_traits;

    const pointExtension_optional&
    pointExtension () const;

    pointExtension_optional&
    pointExtension ();

    void
    pointExtension (const pointExtension_type& x);

    void
    pointExtension (const pointExtension_optional& x);

    void
    pointExtension (::std::auto_ptr< pointExtension_type > p);

    // Constructors.
    //
    Point ();

    Point (const xercesc::DOMElement& e,
           ::xml_schema::flags f = 0,
           ::xml_schema::container* c = 0);

    Point (const Point& x,
           ::xml_schema::flags f = 0,
           ::xml_schema::container* c = 0);

    virtual Point*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Point ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    tpegPointLocation_optional tpegPointLocation_;
    alertCPoint_optional alertCPoint_;
    roadsideReferencePoint_optional roadsideReferencePoint_;
    pointByCoordinates_optional pointByCoordinates_;
    pointExtension_optional pointExtension_;
  };

  class PointByCoordinates: public ::xml_schema::type
  {
    public:
    // bearing
    // 
    typedef ::datex2::NonNegativeInteger bearing_type;
    typedef ::xsd::cxx::tree::optional< bearing_type > bearing_optional;
    typedef ::xsd::cxx::tree::traits< bearing_type, char > bearing_traits;

    const bearing_optional&
    bearing () const;

    bearing_optional&
    bearing ();

    void
    bearing (const bearing_type& x);

    void
    bearing (const bearing_optional& x);

    void
    bearing (::std::auto_ptr< bearing_type > p);

    // pointCoordinates
    // 
    typedef ::datex2::PointCoordinates pointCoordinates_type;
    typedef ::xsd::cxx::tree::traits< pointCoordinates_type, char > pointCoordinates_traits;

    const pointCoordinates_type&
    pointCoordinates () const;

    pointCoordinates_type&
    pointCoordinates ();

    void
    pointCoordinates (const pointCoordinates_type& x);

    void
    pointCoordinates (::std::auto_ptr< pointCoordinates_type > p);

    // pointByCoordinatesExtension
    // 
    typedef ::datex2::ExtensionType pointByCoordinatesExtension_type;
    typedef ::xsd::cxx::tree::optional< pointByCoordinatesExtension_type > pointByCoordinatesExtension_optional;
    typedef ::xsd::cxx::tree::traits< pointByCoordinatesExtension_type, char > pointByCoordinatesExtension_traits;

    const pointByCoordinatesExtension_optional&
    pointByCoordinatesExtension () const;

    pointByCoordinatesExtension_optional&
    pointByCoordinatesExtension ();

    void
    pointByCoordinatesExtension (const pointByCoordinatesExtension_type& x);

    void
    pointByCoordinatesExtension (const pointByCoordinatesExtension_optional& x);

    void
    pointByCoordinatesExtension (::std::auto_ptr< pointByCoordinatesExtension_type > p);

    // Constructors.
    //
    PointByCoordinates (const pointCoordinates_type&);

    PointByCoordinates (::std::auto_ptr< pointCoordinates_type >&);

    PointByCoordinates (const xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    PointByCoordinates (const PointByCoordinates& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual PointByCoordinates*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PointByCoordinates ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    bearing_optional bearing_;
    ::xsd::cxx::tree::one< pointCoordinates_type > pointCoordinates_;
    pointByCoordinatesExtension_optional pointByCoordinatesExtension_;
  };

  class PointCoordinates: public ::xml_schema::type
  {
    public:
    // latitude
    // 
    typedef ::datex2::Float latitude_type;
    typedef ::xsd::cxx::tree::traits< latitude_type, char > latitude_traits;

    const latitude_type&
    latitude () const;

    latitude_type&
    latitude ();

    void
    latitude (const latitude_type& x);

    void
    latitude (::std::auto_ptr< latitude_type > p);

    // longitude
    // 
    typedef ::datex2::Float longitude_type;
    typedef ::xsd::cxx::tree::traits< longitude_type, char > longitude_traits;

    const longitude_type&
    longitude () const;

    longitude_type&
    longitude ();

    void
    longitude (const longitude_type& x);

    void
    longitude (::std::auto_ptr< longitude_type > p);

    // pointCoordinatesExtension
    // 
    typedef ::datex2::ExtensionType pointCoordinatesExtension_type;
    typedef ::xsd::cxx::tree::optional< pointCoordinatesExtension_type > pointCoordinatesExtension_optional;
    typedef ::xsd::cxx::tree::traits< pointCoordinatesExtension_type, char > pointCoordinatesExtension_traits;

    const pointCoordinatesExtension_optional&
    pointCoordinatesExtension () const;

    pointCoordinatesExtension_optional&
    pointCoordinatesExtension ();

    void
    pointCoordinatesExtension (const pointCoordinatesExtension_type& x);

    void
    pointCoordinatesExtension (const pointCoordinatesExtension_optional& x);

    void
    pointCoordinatesExtension (::std::auto_ptr< pointCoordinatesExtension_type > p);

    // Constructors.
    //
    PointCoordinates (const latitude_type&,
                      const longitude_type&);

    PointCoordinates (const xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    PointCoordinates (const PointCoordinates& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual PointCoordinates*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PointCoordinates ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< latitude_type > latitude_;
    ::xsd::cxx::tree::one< longitude_type > longitude_;
    pointCoordinatesExtension_optional pointCoordinatesExtension_;
  };

  class PointDestination: public ::datex2::Destination
  {
    public:
    // point
    // 
    typedef ::datex2::Point point_type;
    typedef ::xsd::cxx::tree::traits< point_type, char > point_traits;

    const point_type&
    point () const;

    point_type&
    point ();

    void
    point (const point_type& x);

    void
    point (::std::auto_ptr< point_type > p);

    // pointDestinationExtension
    // 
    typedef ::datex2::ExtensionType pointDestinationExtension_type;
    typedef ::xsd::cxx::tree::optional< pointDestinationExtension_type > pointDestinationExtension_optional;
    typedef ::xsd::cxx::tree::traits< pointDestinationExtension_type, char > pointDestinationExtension_traits;

    const pointDestinationExtension_optional&
    pointDestinationExtension () const;

    pointDestinationExtension_optional&
    pointDestinationExtension ();

    void
    pointDestinationExtension (const pointDestinationExtension_type& x);

    void
    pointDestinationExtension (const pointDestinationExtension_optional& x);

    void
    pointDestinationExtension (::std::auto_ptr< pointDestinationExtension_type > p);

    // Constructors.
    //
    PointDestination (const point_type&);

    PointDestination (::std::auto_ptr< point_type >&);

    PointDestination (const xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    PointDestination (const PointDestination& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual PointDestination*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PointDestination ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< point_type > point_;
    pointDestinationExtension_optional pointDestinationExtension_;
  };

  class PollutantTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      benzeneTolueneXylene,
      carbonMonoxide,
      lead,
      methane,
      nitricOxide,
      nitrogenDioxide,
      nitrogenMonoxide,
      nitrogenOxides,
      nonMethaneHydrocarbons,
      ozone,
      particulates10,
      polycyclicAromaticHydrocarbons,
      primaryParticulate,
      sulphurDioxide,
      totalHydrocarbons
    };

    PollutantTypeEnum (value v);

    PollutantTypeEnum (const char* v);

    PollutantTypeEnum (const ::std::string& v);

    PollutantTypeEnum (const ::xml_schema::string& v);

    PollutantTypeEnum (const xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    PollutantTypeEnum (const xercesc::DOMAttr& a,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    PollutantTypeEnum (const ::std::string& s,
                       const xercesc::DOMElement* e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    PollutantTypeEnum (const PollutantTypeEnum& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual PollutantTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    PollutantTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_PollutantTypeEnum_convert ();
    }

    protected:
    value
    _xsd_PollutantTypeEnum_convert () const;

    public:
    static const char* const _xsd_PollutantTypeEnum_literals_[15];
    static const value _xsd_PollutantTypeEnum_indexes_[15];
  };

  class PollutionInformation: public ::datex2::WeatherValue
  {
    public:
    // pollutionMeasurement
    // 
    typedef ::datex2::PollutionMeasurement pollutionMeasurement_type;
    typedef ::xsd::cxx::tree::sequence< pollutionMeasurement_type > pollutionMeasurement_sequence;
    typedef xsd::cxx::tree::sequence< pollutionMeasurement_type >::iterator pollutionMeasurement_iterator;
    typedef xsd::cxx::tree::sequence< pollutionMeasurement_type >::const_iterator pollutionMeasurement_const_iterator;
    typedef ::xsd::cxx::tree::traits< pollutionMeasurement_type, char > pollutionMeasurement_traits;

    const pollutionMeasurement_sequence&
    pollutionMeasurement () const;

    pollutionMeasurement_sequence&
    pollutionMeasurement ();

    void
    pollutionMeasurement (const pollutionMeasurement_sequence& s);

    // pollutionInformationExtension
    // 
    typedef ::datex2::ExtensionType pollutionInformationExtension_type;
    typedef ::xsd::cxx::tree::optional< pollutionInformationExtension_type > pollutionInformationExtension_optional;
    typedef ::xsd::cxx::tree::traits< pollutionInformationExtension_type, char > pollutionInformationExtension_traits;

    const pollutionInformationExtension_optional&
    pollutionInformationExtension () const;

    pollutionInformationExtension_optional&
    pollutionInformationExtension ();

    void
    pollutionInformationExtension (const pollutionInformationExtension_type& x);

    void
    pollutionInformationExtension (const pollutionInformationExtension_optional& x);

    void
    pollutionInformationExtension (::std::auto_ptr< pollutionInformationExtension_type > p);

    // Constructors.
    //
    PollutionInformation ();

    PollutionInformation (const xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    PollutionInformation (const PollutionInformation& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual PollutionInformation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PollutionInformation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    pollutionMeasurement_sequence pollutionMeasurement_;
    pollutionInformationExtension_optional pollutionInformationExtension_;
  };

  class PollutionMeasurement: public ::xml_schema::type
  {
    public:
    // pollutantConcentration
    // 
    typedef ::datex2::ConcentrationMicrogramsPerCubicMetre pollutantConcentration_type;
    typedef ::xsd::cxx::tree::traits< pollutantConcentration_type, char > pollutantConcentration_traits;

    const pollutantConcentration_type&
    pollutantConcentration () const;

    pollutantConcentration_type&
    pollutantConcentration ();

    void
    pollutantConcentration (const pollutantConcentration_type& x);

    void
    pollutantConcentration (::std::auto_ptr< pollutantConcentration_type > p);

    // pollutantType
    // 
    typedef ::datex2::PollutantTypeEnum pollutantType_type;
    typedef ::xsd::cxx::tree::traits< pollutantType_type, char > pollutantType_traits;

    const pollutantType_type&
    pollutantType () const;

    pollutantType_type&
    pollutantType ();

    void
    pollutantType (const pollutantType_type& x);

    void
    pollutantType (::std::auto_ptr< pollutantType_type > p);

    // pollutionMeasurementExtension
    // 
    typedef ::datex2::ExtensionType pollutionMeasurementExtension_type;
    typedef ::xsd::cxx::tree::optional< pollutionMeasurementExtension_type > pollutionMeasurementExtension_optional;
    typedef ::xsd::cxx::tree::traits< pollutionMeasurementExtension_type, char > pollutionMeasurementExtension_traits;

    const pollutionMeasurementExtension_optional&
    pollutionMeasurementExtension () const;

    pollutionMeasurementExtension_optional&
    pollutionMeasurementExtension ();

    void
    pollutionMeasurementExtension (const pollutionMeasurementExtension_type& x);

    void
    pollutionMeasurementExtension (const pollutionMeasurementExtension_optional& x);

    void
    pollutionMeasurementExtension (::std::auto_ptr< pollutionMeasurementExtension_type > p);

    // Constructors.
    //
    PollutionMeasurement (const pollutantConcentration_type&,
                          const pollutantType_type&);

    PollutionMeasurement (const xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    PollutionMeasurement (const PollutionMeasurement& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual PollutionMeasurement*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PollutionMeasurement ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< pollutantConcentration_type > pollutantConcentration_;
    ::xsd::cxx::tree::one< pollutantType_type > pollutantType_;
    pollutionMeasurementExtension_optional pollutionMeasurementExtension_;
  };

  class PoorEnvironmentConditions: public ::datex2::Conditions
  {
    public:
    // poorEnvironmentType
    // 
    typedef ::datex2::PoorEnvironmentTypeEnum poorEnvironmentType_type;
    typedef ::xsd::cxx::tree::sequence< poorEnvironmentType_type > poorEnvironmentType_sequence;
    typedef xsd::cxx::tree::sequence< poorEnvironmentType_type >::iterator poorEnvironmentType_iterator;
    typedef xsd::cxx::tree::sequence< poorEnvironmentType_type >::const_iterator poorEnvironmentType_const_iterator;
    typedef ::xsd::cxx::tree::traits< poorEnvironmentType_type, char > poorEnvironmentType_traits;

    const poorEnvironmentType_sequence&
    poorEnvironmentType () const;

    poorEnvironmentType_sequence&
    poorEnvironmentType ();

    void
    poorEnvironmentType (const poorEnvironmentType_sequence& s);

    // precipitationDetail
    // 
    typedef ::datex2::PrecipitationDetail precipitationDetail_type;
    typedef ::xsd::cxx::tree::optional< precipitationDetail_type > precipitationDetail_optional;
    typedef ::xsd::cxx::tree::traits< precipitationDetail_type, char > precipitationDetail_traits;

    const precipitationDetail_optional&
    precipitationDetail () const;

    precipitationDetail_optional&
    precipitationDetail ();

    void
    precipitationDetail (const precipitationDetail_type& x);

    void
    precipitationDetail (const precipitationDetail_optional& x);

    void
    precipitationDetail (::std::auto_ptr< precipitationDetail_type > p);

    // visibility
    // 
    typedef ::datex2::Visibility visibility_type;
    typedef ::xsd::cxx::tree::optional< visibility_type > visibility_optional;
    typedef ::xsd::cxx::tree::traits< visibility_type, char > visibility_traits;

    const visibility_optional&
    visibility () const;

    visibility_optional&
    visibility ();

    void
    visibility (const visibility_type& x);

    void
    visibility (const visibility_optional& x);

    void
    visibility (::std::auto_ptr< visibility_type > p);

    // pollutionMeasurement
    // 
    typedef ::datex2::PollutionMeasurement pollutionMeasurement_type;
    typedef ::xsd::cxx::tree::sequence< pollutionMeasurement_type > pollutionMeasurement_sequence;
    typedef xsd::cxx::tree::sequence< pollutionMeasurement_type >::iterator pollutionMeasurement_iterator;
    typedef xsd::cxx::tree::sequence< pollutionMeasurement_type >::const_iterator pollutionMeasurement_const_iterator;
    typedef ::xsd::cxx::tree::traits< pollutionMeasurement_type, char > pollutionMeasurement_traits;

    const pollutionMeasurement_sequence&
    pollutionMeasurement () const;

    pollutionMeasurement_sequence&
    pollutionMeasurement ();

    void
    pollutionMeasurement (const pollutionMeasurement_sequence& s);

    // temperature
    // 
    typedef ::datex2::Temperature temperature_type;
    typedef ::xsd::cxx::tree::optional< temperature_type > temperature_optional;
    typedef ::xsd::cxx::tree::traits< temperature_type, char > temperature_traits;

    const temperature_optional&
    temperature () const;

    temperature_optional&
    temperature ();

    void
    temperature (const temperature_type& x);

    void
    temperature (const temperature_optional& x);

    void
    temperature (::std::auto_ptr< temperature_type > p);

    // wind
    // 
    typedef ::datex2::Wind wind_type;
    typedef ::xsd::cxx::tree::optional< wind_type > wind_optional;
    typedef ::xsd::cxx::tree::traits< wind_type, char > wind_traits;

    const wind_optional&
    wind () const;

    wind_optional&
    wind ();

    void
    wind (const wind_type& x);

    void
    wind (const wind_optional& x);

    void
    wind (::std::auto_ptr< wind_type > p);

    // humidity
    // 
    typedef ::datex2::Humidity humidity_type;
    typedef ::xsd::cxx::tree::optional< humidity_type > humidity_optional;
    typedef ::xsd::cxx::tree::traits< humidity_type, char > humidity_traits;

    const humidity_optional&
    humidity () const;

    humidity_optional&
    humidity ();

    void
    humidity (const humidity_type& x);

    void
    humidity (const humidity_optional& x);

    void
    humidity (::std::auto_ptr< humidity_type > p);

    // poorEnvironmentConditionsExtension
    // 
    typedef ::datex2::ExtensionType poorEnvironmentConditionsExtension_type;
    typedef ::xsd::cxx::tree::optional< poorEnvironmentConditionsExtension_type > poorEnvironmentConditionsExtension_optional;
    typedef ::xsd::cxx::tree::traits< poorEnvironmentConditionsExtension_type, char > poorEnvironmentConditionsExtension_traits;

    const poorEnvironmentConditionsExtension_optional&
    poorEnvironmentConditionsExtension () const;

    poorEnvironmentConditionsExtension_optional&
    poorEnvironmentConditionsExtension ();

    void
    poorEnvironmentConditionsExtension (const poorEnvironmentConditionsExtension_type& x);

    void
    poorEnvironmentConditionsExtension (const poorEnvironmentConditionsExtension_optional& x);

    void
    poorEnvironmentConditionsExtension (::std::auto_ptr< poorEnvironmentConditionsExtension_type > p);

    // Constructors.
    //
    PoorEnvironmentConditions (const situationRecordCreationTime_type&,
                               const situationRecordVersion_type&,
                               const situationRecordVersionTime_type&,
                               const probabilityOfOccurrence_type&,
                               const validity_type&,
                               const groupOfLocations_type&,
                               const id_type&);

    PoorEnvironmentConditions (const situationRecordCreationTime_type&,
                               const situationRecordVersion_type&,
                               const situationRecordVersionTime_type&,
                               const probabilityOfOccurrence_type&,
                               ::std::auto_ptr< validity_type >&,
                               ::std::auto_ptr< groupOfLocations_type >&,
                               const id_type&);

    PoorEnvironmentConditions (const xercesc::DOMElement& e,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    PoorEnvironmentConditions (const PoorEnvironmentConditions& x,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    virtual PoorEnvironmentConditions*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PoorEnvironmentConditions ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    poorEnvironmentType_sequence poorEnvironmentType_;
    precipitationDetail_optional precipitationDetail_;
    visibility_optional visibility_;
    pollutionMeasurement_sequence pollutionMeasurement_;
    temperature_optional temperature_;
    wind_optional wind_;
    humidity_optional humidity_;
    poorEnvironmentConditionsExtension_optional poorEnvironmentConditionsExtension_;
  };

  class PoorEnvironmentTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      badWeather,
      blizzard,
      blowingDust,
      blowingSnow,
      crosswinds,
      damagingHail,
      denseFog,
      eclipse,
      extremeCold,
      extremeHeat,
      fog,
      freezingFog,
      frost,
      gales,
      gustyWinds,
      hail,
      heavyFrost,
      heavyRain,
      heavySnowfall,
      hurricaneForceWinds,
      lowSunGlare,
      moderateFog,
      ozonePollution,
      pollution,
      patchyFog,
      precipitationInTheArea,
      rain,
      rainChangingToSnow,
      sandStorms,
      severeExhaustPollution,
      severeSmog,
      showers,
      sleet,
      smogAlert,
      smokeHazard,
      snowChangingToRain,
      snowfall,
      sprayHazard,
      stormForceWinds,
      strongGustsOfWind,
      strongWinds,
      swarmsOfInsects,
      temperatureFalling,
      thunderstorms,
      tornadoes,
      veryStrongGustsOfWind,
      visibilityReduced,
      whiteOut,
      winterStorm
    };

    PoorEnvironmentTypeEnum (value v);

    PoorEnvironmentTypeEnum (const char* v);

    PoorEnvironmentTypeEnum (const ::std::string& v);

    PoorEnvironmentTypeEnum (const ::xml_schema::string& v);

    PoorEnvironmentTypeEnum (const xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    PoorEnvironmentTypeEnum (const xercesc::DOMAttr& a,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    PoorEnvironmentTypeEnum (const ::std::string& s,
                             const xercesc::DOMElement* e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    PoorEnvironmentTypeEnum (const PoorEnvironmentTypeEnum& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual PoorEnvironmentTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    PoorEnvironmentTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_PoorEnvironmentTypeEnum_convert ();
    }

    protected:
    value
    _xsd_PoorEnvironmentTypeEnum_convert () const;

    public:
    static const char* const _xsd_PoorEnvironmentTypeEnum_literals_[49];
    static const value _xsd_PoorEnvironmentTypeEnum_indexes_[49];
  };

  class PrecipitationDetail: public ::xml_schema::type
  {
    public:
    // depositionDepth
    // 
    typedef ::datex2::MetresAsFloat depositionDepth_type;
    typedef ::xsd::cxx::tree::optional< depositionDepth_type > depositionDepth_optional;
    typedef ::xsd::cxx::tree::traits< depositionDepth_type, char > depositionDepth_traits;

    const depositionDepth_optional&
    depositionDepth () const;

    depositionDepth_optional&
    depositionDepth ();

    void
    depositionDepth (const depositionDepth_type& x);

    void
    depositionDepth (const depositionDepth_optional& x);

    void
    depositionDepth (::std::auto_ptr< depositionDepth_type > p);

    // precipitationIntensity
    // 
    typedef ::datex2::IntensityMillimetresPerHour precipitationIntensity_type;
    typedef ::xsd::cxx::tree::optional< precipitationIntensity_type > precipitationIntensity_optional;
    typedef ::xsd::cxx::tree::traits< precipitationIntensity_type, char > precipitationIntensity_traits;

    const precipitationIntensity_optional&
    precipitationIntensity () const;

    precipitationIntensity_optional&
    precipitationIntensity ();

    void
    precipitationIntensity (const precipitationIntensity_type& x);

    void
    precipitationIntensity (const precipitationIntensity_optional& x);

    void
    precipitationIntensity (::std::auto_ptr< precipitationIntensity_type > p);

    // precipitationType
    // 
    typedef ::datex2::PrecipitationTypeEnum precipitationType_type;
    typedef ::xsd::cxx::tree::optional< precipitationType_type > precipitationType_optional;
    typedef ::xsd::cxx::tree::traits< precipitationType_type, char > precipitationType_traits;

    const precipitationType_optional&
    precipitationType () const;

    precipitationType_optional&
    precipitationType ();

    void
    precipitationType (const precipitationType_type& x);

    void
    precipitationType (const precipitationType_optional& x);

    void
    precipitationType (::std::auto_ptr< precipitationType_type > p);

    // precipitationDetailExtension
    // 
    typedef ::datex2::ExtensionType precipitationDetailExtension_type;
    typedef ::xsd::cxx::tree::optional< precipitationDetailExtension_type > precipitationDetailExtension_optional;
    typedef ::xsd::cxx::tree::traits< precipitationDetailExtension_type, char > precipitationDetailExtension_traits;

    const precipitationDetailExtension_optional&
    precipitationDetailExtension () const;

    precipitationDetailExtension_optional&
    precipitationDetailExtension ();

    void
    precipitationDetailExtension (const precipitationDetailExtension_type& x);

    void
    precipitationDetailExtension (const precipitationDetailExtension_optional& x);

    void
    precipitationDetailExtension (::std::auto_ptr< precipitationDetailExtension_type > p);

    // Constructors.
    //
    PrecipitationDetail ();

    PrecipitationDetail (const xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    PrecipitationDetail (const PrecipitationDetail& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual PrecipitationDetail*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PrecipitationDetail ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    depositionDepth_optional depositionDepth_;
    precipitationIntensity_optional precipitationIntensity_;
    precipitationType_optional precipitationType_;
    precipitationDetailExtension_optional precipitationDetailExtension_;
  };

  class PrecipitationInformation: public ::datex2::WeatherValue
  {
    public:
    // noPrecipitation
    // 
    typedef ::datex2::Boolean noPrecipitation_type;
    typedef ::xsd::cxx::tree::optional< noPrecipitation_type > noPrecipitation_optional;
    typedef ::xsd::cxx::tree::traits< noPrecipitation_type, char > noPrecipitation_traits;

    const noPrecipitation_optional&
    noPrecipitation () const;

    noPrecipitation_optional&
    noPrecipitation ();

    void
    noPrecipitation (const noPrecipitation_type& x);

    void
    noPrecipitation (const noPrecipitation_optional& x);

    void
    noPrecipitation (::std::auto_ptr< noPrecipitation_type > p);

    // precipitationDetail
    // 
    typedef ::datex2::PrecipitationDetail precipitationDetail_type;
    typedef ::xsd::cxx::tree::optional< precipitationDetail_type > precipitationDetail_optional;
    typedef ::xsd::cxx::tree::traits< precipitationDetail_type, char > precipitationDetail_traits;

    const precipitationDetail_optional&
    precipitationDetail () const;

    precipitationDetail_optional&
    precipitationDetail ();

    void
    precipitationDetail (const precipitationDetail_type& x);

    void
    precipitationDetail (const precipitationDetail_optional& x);

    void
    precipitationDetail (::std::auto_ptr< precipitationDetail_type > p);

    // precipitationInformationExtension
    // 
    typedef ::datex2::ExtensionType precipitationInformationExtension_type;
    typedef ::xsd::cxx::tree::optional< precipitationInformationExtension_type > precipitationInformationExtension_optional;
    typedef ::xsd::cxx::tree::traits< precipitationInformationExtension_type, char > precipitationInformationExtension_traits;

    const precipitationInformationExtension_optional&
    precipitationInformationExtension () const;

    precipitationInformationExtension_optional&
    precipitationInformationExtension ();

    void
    precipitationInformationExtension (const precipitationInformationExtension_type& x);

    void
    precipitationInformationExtension (const precipitationInformationExtension_optional& x);

    void
    precipitationInformationExtension (::std::auto_ptr< precipitationInformationExtension_type > p);

    // Constructors.
    //
    PrecipitationInformation ();

    PrecipitationInformation (const xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    PrecipitationInformation (const PrecipitationInformation& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual PrecipitationInformation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PrecipitationInformation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    noPrecipitation_optional noPrecipitation_;
    precipitationDetail_optional precipitationDetail_;
    precipitationInformationExtension_optional precipitationInformationExtension_;
  };

  class PrecipitationTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      drizzle,
      freezingRain,
      hail,
      rain,
      sleet,
      snow
    };

    PrecipitationTypeEnum (value v);

    PrecipitationTypeEnum (const char* v);

    PrecipitationTypeEnum (const ::std::string& v);

    PrecipitationTypeEnum (const ::xml_schema::string& v);

    PrecipitationTypeEnum (const xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    PrecipitationTypeEnum (const xercesc::DOMAttr& a,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    PrecipitationTypeEnum (const ::std::string& s,
                           const xercesc::DOMElement* e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    PrecipitationTypeEnum (const PrecipitationTypeEnum& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual PrecipitationTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    PrecipitationTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_PrecipitationTypeEnum_convert ();
    }

    protected:
    value
    _xsd_PrecipitationTypeEnum_convert () const;

    public:
    static const char* const _xsd_PrecipitationTypeEnum_literals_[6];
    static const value _xsd_PrecipitationTypeEnum_indexes_[6];
  };

  class PredefinedLocation: public ::xml_schema::type
  {
    public:
    // predefinedLocationName
    // 
    typedef ::datex2::MultilingualString predefinedLocationName_type;
    typedef ::xsd::cxx::tree::optional< predefinedLocationName_type > predefinedLocationName_optional;
    typedef ::xsd::cxx::tree::traits< predefinedLocationName_type, char > predefinedLocationName_traits;

    const predefinedLocationName_optional&
    predefinedLocationName () const;

    predefinedLocationName_optional&
    predefinedLocationName ();

    void
    predefinedLocationName (const predefinedLocationName_type& x);

    void
    predefinedLocationName (const predefinedLocationName_optional& x);

    void
    predefinedLocationName (::std::auto_ptr< predefinedLocationName_type > p);

    // predefinedLocation
    // 
    typedef ::datex2::Location predefinedLocation_type;
    typedef ::xsd::cxx::tree::traits< predefinedLocation_type, char > predefinedLocation_traits;

    const predefinedLocation_type&
    predefinedLocation () const;

    predefinedLocation_type&
    predefinedLocation ();

    void
    predefinedLocation (const predefinedLocation_type& x);

    void
    predefinedLocation (::std::auto_ptr< predefinedLocation_type > p);

    // predefinedLocationExtension
    // 
    typedef ::datex2::ExtensionType predefinedLocationExtension_type;
    typedef ::xsd::cxx::tree::optional< predefinedLocationExtension_type > predefinedLocationExtension_optional;
    typedef ::xsd::cxx::tree::traits< predefinedLocationExtension_type, char > predefinedLocationExtension_traits;

    const predefinedLocationExtension_optional&
    predefinedLocationExtension () const;

    predefinedLocationExtension_optional&
    predefinedLocationExtension ();

    void
    predefinedLocationExtension (const predefinedLocationExtension_type& x);

    void
    predefinedLocationExtension (const predefinedLocationExtension_optional& x);

    void
    predefinedLocationExtension (::std::auto_ptr< predefinedLocationExtension_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_type&
    id () const;

    id_type&
    id ();

    void
    id (const id_type& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    PredefinedLocation (const predefinedLocation_type&,
                        const id_type&);

    PredefinedLocation (::std::auto_ptr< predefinedLocation_type >&,
                        const id_type&);

    PredefinedLocation (const xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    PredefinedLocation (const PredefinedLocation& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual PredefinedLocation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PredefinedLocation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    predefinedLocationName_optional predefinedLocationName_;
    ::xsd::cxx::tree::one< predefinedLocation_type > predefinedLocation_;
    predefinedLocationExtension_optional predefinedLocationExtension_;
    ::xsd::cxx::tree::one< id_type > id_;
  };

  class PredefinedLocationSet: public ::xml_schema::type
  {
    public:
    // predefinedLocationSetName
    // 
    typedef ::datex2::MultilingualString predefinedLocationSetName_type;
    typedef ::xsd::cxx::tree::optional< predefinedLocationSetName_type > predefinedLocationSetName_optional;
    typedef ::xsd::cxx::tree::traits< predefinedLocationSetName_type, char > predefinedLocationSetName_traits;

    const predefinedLocationSetName_optional&
    predefinedLocationSetName () const;

    predefinedLocationSetName_optional&
    predefinedLocationSetName ();

    void
    predefinedLocationSetName (const predefinedLocationSetName_type& x);

    void
    predefinedLocationSetName (const predefinedLocationSetName_optional& x);

    void
    predefinedLocationSetName (::std::auto_ptr< predefinedLocationSetName_type > p);

    // predefinedLocationSetVersion
    // 
    typedef ::datex2::NonNegativeInteger predefinedLocationSetVersion_type;
    typedef ::xsd::cxx::tree::optional< predefinedLocationSetVersion_type > predefinedLocationSetVersion_optional;
    typedef ::xsd::cxx::tree::traits< predefinedLocationSetVersion_type, char > predefinedLocationSetVersion_traits;

    const predefinedLocationSetVersion_optional&
    predefinedLocationSetVersion () const;

    predefinedLocationSetVersion_optional&
    predefinedLocationSetVersion ();

    void
    predefinedLocationSetVersion (const predefinedLocationSetVersion_type& x);

    void
    predefinedLocationSetVersion (const predefinedLocationSetVersion_optional& x);

    void
    predefinedLocationSetVersion (::std::auto_ptr< predefinedLocationSetVersion_type > p);

    // predefinedLocation
    // 
    typedef ::datex2::PredefinedLocation predefinedLocation_type;
    typedef ::xsd::cxx::tree::sequence< predefinedLocation_type > predefinedLocation_sequence;
    typedef xsd::cxx::tree::sequence< predefinedLocation_type >::iterator predefinedLocation_iterator;
    typedef xsd::cxx::tree::sequence< predefinedLocation_type >::const_iterator predefinedLocation_const_iterator;
    typedef ::xsd::cxx::tree::traits< predefinedLocation_type, char > predefinedLocation_traits;

    const predefinedLocation_sequence&
    predefinedLocation () const;

    predefinedLocation_sequence&
    predefinedLocation ();

    void
    predefinedLocation (const predefinedLocation_sequence& s);

    // predefinedLocationSetExtension
    // 
    typedef ::datex2::ExtensionType predefinedLocationSetExtension_type;
    typedef ::xsd::cxx::tree::optional< predefinedLocationSetExtension_type > predefinedLocationSetExtension_optional;
    typedef ::xsd::cxx::tree::traits< predefinedLocationSetExtension_type, char > predefinedLocationSetExtension_traits;

    const predefinedLocationSetExtension_optional&
    predefinedLocationSetExtension () const;

    predefinedLocationSetExtension_optional&
    predefinedLocationSetExtension ();

    void
    predefinedLocationSetExtension (const predefinedLocationSetExtension_type& x);

    void
    predefinedLocationSetExtension (const predefinedLocationSetExtension_optional& x);

    void
    predefinedLocationSetExtension (::std::auto_ptr< predefinedLocationSetExtension_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_type&
    id () const;

    id_type&
    id ();

    void
    id (const id_type& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    PredefinedLocationSet (const id_type&);

    PredefinedLocationSet (const xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    PredefinedLocationSet (const PredefinedLocationSet& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual PredefinedLocationSet*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PredefinedLocationSet ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    predefinedLocationSetName_optional predefinedLocationSetName_;
    predefinedLocationSetVersion_optional predefinedLocationSetVersion_;
    predefinedLocation_sequence predefinedLocation_;
    predefinedLocationSetExtension_optional predefinedLocationSetExtension_;
    ::xsd::cxx::tree::one< id_type > id_;
  };

  class PredefinedLocationsPublication: public ::datex2::PayloadPublication
  {
    public:
    // headerInformation
    // 
    typedef ::datex2::HeaderInformation headerInformation_type;
    typedef ::xsd::cxx::tree::traits< headerInformation_type, char > headerInformation_traits;

    const headerInformation_type&
    headerInformation () const;

    headerInformation_type&
    headerInformation ();

    void
    headerInformation (const headerInformation_type& x);

    void
    headerInformation (::std::auto_ptr< headerInformation_type > p);

    // predefinedLocationSet
    // 
    typedef ::datex2::PredefinedLocationSet predefinedLocationSet_type;
    typedef ::xsd::cxx::tree::sequence< predefinedLocationSet_type > predefinedLocationSet_sequence;
    typedef xsd::cxx::tree::sequence< predefinedLocationSet_type >::iterator predefinedLocationSet_iterator;
    typedef xsd::cxx::tree::sequence< predefinedLocationSet_type >::const_iterator predefinedLocationSet_const_iterator;
    typedef ::xsd::cxx::tree::traits< predefinedLocationSet_type, char > predefinedLocationSet_traits;

    const predefinedLocationSet_sequence&
    predefinedLocationSet () const;

    predefinedLocationSet_sequence&
    predefinedLocationSet ();

    void
    predefinedLocationSet (const predefinedLocationSet_sequence& s);

    // predefinedLocationsPublicationExtension
    // 
    typedef ::datex2::ExtensionType predefinedLocationsPublicationExtension_type;
    typedef ::xsd::cxx::tree::optional< predefinedLocationsPublicationExtension_type > predefinedLocationsPublicationExtension_optional;
    typedef ::xsd::cxx::tree::traits< predefinedLocationsPublicationExtension_type, char > predefinedLocationsPublicationExtension_traits;

    const predefinedLocationsPublicationExtension_optional&
    predefinedLocationsPublicationExtension () const;

    predefinedLocationsPublicationExtension_optional&
    predefinedLocationsPublicationExtension ();

    void
    predefinedLocationsPublicationExtension (const predefinedLocationsPublicationExtension_type& x);

    void
    predefinedLocationsPublicationExtension (const predefinedLocationsPublicationExtension_optional& x);

    void
    predefinedLocationsPublicationExtension (::std::auto_ptr< predefinedLocationsPublicationExtension_type > p);

    // Constructors.
    //
    PredefinedLocationsPublication (const publicationTime_type&,
                                    const publicationCreator_type&,
                                    const lang_type&,
                                    const headerInformation_type&);

    PredefinedLocationsPublication (const publicationTime_type&,
                                    ::std::auto_ptr< publicationCreator_type >&,
                                    const lang_type&,
                                    ::std::auto_ptr< headerInformation_type >&);

    PredefinedLocationsPublication (const xercesc::DOMElement& e,
                                    ::xml_schema::flags f = 0,
                                    ::xml_schema::container* c = 0);

    PredefinedLocationsPublication (const PredefinedLocationsPublication& x,
                                    ::xml_schema::flags f = 0,
                                    ::xml_schema::container* c = 0);

    virtual PredefinedLocationsPublication*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PredefinedLocationsPublication ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< headerInformation_type > headerInformation_;
    predefinedLocationSet_sequence predefinedLocationSet_;
    predefinedLocationsPublicationExtension_optional predefinedLocationsPublicationExtension_;
  };

  class ProbabilityOfOccurrenceEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      certain,
      probable,
      riskOf
    };

    ProbabilityOfOccurrenceEnum (value v);

    ProbabilityOfOccurrenceEnum (const char* v);

    ProbabilityOfOccurrenceEnum (const ::std::string& v);

    ProbabilityOfOccurrenceEnum (const ::xml_schema::string& v);

    ProbabilityOfOccurrenceEnum (const xercesc::DOMElement& e,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    ProbabilityOfOccurrenceEnum (const xercesc::DOMAttr& a,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    ProbabilityOfOccurrenceEnum (const ::std::string& s,
                                 const xercesc::DOMElement* e,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    ProbabilityOfOccurrenceEnum (const ProbabilityOfOccurrenceEnum& x,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    virtual ProbabilityOfOccurrenceEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    ProbabilityOfOccurrenceEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_ProbabilityOfOccurrenceEnum_convert ();
    }

    protected:
    value
    _xsd_ProbabilityOfOccurrenceEnum_convert () const;

    public:
    static const char* const _xsd_ProbabilityOfOccurrenceEnum_literals_[3];
    static const value _xsd_ProbabilityOfOccurrenceEnum_indexes_[3];
  };

  class PublicEvent: public ::datex2::Activity
  {
    public:
    // publicEventType
    // 
    typedef ::datex2::PublicEventTypeEnum publicEventType_type;
    typedef ::xsd::cxx::tree::traits< publicEventType_type, char > publicEventType_traits;

    const publicEventType_type&
    publicEventType () const;

    publicEventType_type&
    publicEventType ();

    void
    publicEventType (const publicEventType_type& x);

    void
    publicEventType (::std::auto_ptr< publicEventType_type > p);

    // publicEventExtension
    // 
    typedef ::datex2::ExtensionType publicEventExtension_type;
    typedef ::xsd::cxx::tree::optional< publicEventExtension_type > publicEventExtension_optional;
    typedef ::xsd::cxx::tree::traits< publicEventExtension_type, char > publicEventExtension_traits;

    const publicEventExtension_optional&
    publicEventExtension () const;

    publicEventExtension_optional&
    publicEventExtension ();

    void
    publicEventExtension (const publicEventExtension_type& x);

    void
    publicEventExtension (const publicEventExtension_optional& x);

    void
    publicEventExtension (::std::auto_ptr< publicEventExtension_type > p);

    // Constructors.
    //
    PublicEvent (const situationRecordCreationTime_type&,
                 const situationRecordVersion_type&,
                 const situationRecordVersionTime_type&,
                 const probabilityOfOccurrence_type&,
                 const validity_type&,
                 const groupOfLocations_type&,
                 const id_type&,
                 const publicEventType_type&);

    PublicEvent (const situationRecordCreationTime_type&,
                 const situationRecordVersion_type&,
                 const situationRecordVersionTime_type&,
                 const probabilityOfOccurrence_type&,
                 ::std::auto_ptr< validity_type >&,
                 ::std::auto_ptr< groupOfLocations_type >&,
                 const id_type&,
                 const publicEventType_type&);

    PublicEvent (const xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    PublicEvent (const PublicEvent& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual PublicEvent*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PublicEvent ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< publicEventType_type > publicEventType_;
    publicEventExtension_optional publicEventExtension_;
  };

  class PublicEventTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      agriculturalShow,
      airShow,
      athleticsMeeting,
      commercialEvent,
      culturalEvent,
      ballGame,
      baseballGame,
      basketballGame,
      bicycleRace,
      boatRace,
      boatShow,
      boxingTournament,
      bullFight,
      ceremonialEvent,
      concert,
      cricketMatch,
      exhibition,
      fair,
      festival,
      filmTVMaking,
      footballMatch,
      funfair,
      gardeningOrFlowerShow,
      golfTournament,
      hockeyGame,
      horseRaceMeeting,
      internationalSportsMeeting,
      majorEvent,
      marathon,
      market,
      match,
      motorShow,
      motorSportRaceMeeting,
      parade,
      procession,
      raceMeeting,
      rugbyMatch,
      severalMajorEvents,
      show,
      showJumping,
      sportsMeeting,
      stateOccasion,
      tennisTournament,
      tournament,
      tradeFair,
      waterSportsMeeting,
      winterSportsMeeting,
      other
    };

    PublicEventTypeEnum (value v);

    PublicEventTypeEnum (const char* v);

    PublicEventTypeEnum (const ::std::string& v);

    PublicEventTypeEnum (const ::xml_schema::string& v);

    PublicEventTypeEnum (const xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    PublicEventTypeEnum (const xercesc::DOMAttr& a,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    PublicEventTypeEnum (const ::std::string& s,
                         const xercesc::DOMElement* e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    PublicEventTypeEnum (const PublicEventTypeEnum& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual PublicEventTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    PublicEventTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_PublicEventTypeEnum_convert ();
    }

    protected:
    value
    _xsd_PublicEventTypeEnum_convert () const;

    public:
    static const char* const _xsd_PublicEventTypeEnum_literals_[48];
    static const value _xsd_PublicEventTypeEnum_indexes_[48];
  };

  class String: public ::xml_schema::string
  {
    public:
    // Constructors.
    //
    String ();

    String (const char*);

    String (const ::std::string&);

    String (const ::xml_schema::string&);

    String (const xercesc::DOMElement& e,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    String (const xercesc::DOMAttr& a,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    String (const ::std::string& s,
            const xercesc::DOMElement* e,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    String (const String& x,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    virtual String*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~String ();
  };

  class Reference: public ::datex2::String
  {
    public:
    // Constructors.
    //
    Reference ();

    Reference (const char*);

    Reference (const ::std::string&);

    Reference (const ::xml_schema::string&);

    Reference (const xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    Reference (const xercesc::DOMAttr& a,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    Reference (const ::std::string& s,
               const xercesc::DOMElement* e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    Reference (const Reference& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual Reference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Reference ();
  };

  class ReferencePointDirectionEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      both,
      negative,
      positive,
      unknown
    };

    ReferencePointDirectionEnum (value v);

    ReferencePointDirectionEnum (const char* v);

    ReferencePointDirectionEnum (const ::std::string& v);

    ReferencePointDirectionEnum (const ::xml_schema::string& v);

    ReferencePointDirectionEnum (const xercesc::DOMElement& e,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    ReferencePointDirectionEnum (const xercesc::DOMAttr& a,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    ReferencePointDirectionEnum (const ::std::string& s,
                                 const xercesc::DOMElement* e,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    ReferencePointDirectionEnum (const ReferencePointDirectionEnum& x,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    virtual ReferencePointDirectionEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    ReferencePointDirectionEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_ReferencePointDirectionEnum_convert ();
    }

    protected:
    value
    _xsd_ReferencePointDirectionEnum_convert () const;

    public:
    static const char* const _xsd_ReferencePointDirectionEnum_literals_[4];
    static const value _xsd_ReferencePointDirectionEnum_indexes_[4];
  };

  class ReferenceSettings: public ::xml_schema::type
  {
    public:
    // predefinedLocationSetReference
    // 
    typedef ::datex2::Reference predefinedLocationSetReference_type;
    typedef ::xsd::cxx::tree::optional< predefinedLocationSetReference_type > predefinedLocationSetReference_optional;
    typedef ::xsd::cxx::tree::traits< predefinedLocationSetReference_type, char > predefinedLocationSetReference_traits;

    const predefinedLocationSetReference_optional&
    predefinedLocationSetReference () const;

    predefinedLocationSetReference_optional&
    predefinedLocationSetReference ();

    void
    predefinedLocationSetReference (const predefinedLocationSetReference_type& x);

    void
    predefinedLocationSetReference (const predefinedLocationSetReference_optional& x);

    void
    predefinedLocationSetReference (::std::auto_ptr< predefinedLocationSetReference_type > p);

    // trafficStatusDefault
    // 
    typedef ::datex2::TrafficStatusEnum trafficStatusDefault_type;
    typedef ::xsd::cxx::tree::optional< trafficStatusDefault_type > trafficStatusDefault_optional;
    typedef ::xsd::cxx::tree::traits< trafficStatusDefault_type, char > trafficStatusDefault_traits;

    const trafficStatusDefault_optional&
    trafficStatusDefault () const;

    trafficStatusDefault_optional&
    trafficStatusDefault ();

    void
    trafficStatusDefault (const trafficStatusDefault_type& x);

    void
    trafficStatusDefault (const trafficStatusDefault_optional& x);

    void
    trafficStatusDefault (::std::auto_ptr< trafficStatusDefault_type > p);

    // referenceSettingsExtension
    // 
    typedef ::datex2::ExtensionType referenceSettingsExtension_type;
    typedef ::xsd::cxx::tree::optional< referenceSettingsExtension_type > referenceSettingsExtension_optional;
    typedef ::xsd::cxx::tree::traits< referenceSettingsExtension_type, char > referenceSettingsExtension_traits;

    const referenceSettingsExtension_optional&
    referenceSettingsExtension () const;

    referenceSettingsExtension_optional&
    referenceSettingsExtension ();

    void
    referenceSettingsExtension (const referenceSettingsExtension_type& x);

    void
    referenceSettingsExtension (const referenceSettingsExtension_optional& x);

    void
    referenceSettingsExtension (::std::auto_ptr< referenceSettingsExtension_type > p);

    // Constructors.
    //
    ReferenceSettings ();

    ReferenceSettings (const xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    ReferenceSettings (const ReferenceSettings& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual ReferenceSettings*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ReferenceSettings ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    predefinedLocationSetReference_optional predefinedLocationSetReference_;
    trafficStatusDefault_optional trafficStatusDefault_;
    referenceSettingsExtension_optional referenceSettingsExtension_;
  };

  class RelativeTrafficFlowEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      trafficVeryMuchHeavierThanNormal,
      trafficHeavierThanNormal,
      trafficFlowNormal,
      trafficLighterThanNormal,
      trafficVeryMuchLighterThanNormal
    };

    RelativeTrafficFlowEnum (value v);

    RelativeTrafficFlowEnum (const char* v);

    RelativeTrafficFlowEnum (const ::std::string& v);

    RelativeTrafficFlowEnum (const ::xml_schema::string& v);

    RelativeTrafficFlowEnum (const xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    RelativeTrafficFlowEnum (const xercesc::DOMAttr& a,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    RelativeTrafficFlowEnum (const ::std::string& s,
                             const xercesc::DOMElement* e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    RelativeTrafficFlowEnum (const RelativeTrafficFlowEnum& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual RelativeTrafficFlowEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    RelativeTrafficFlowEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_RelativeTrafficFlowEnum_convert ();
    }

    protected:
    value
    _xsd_RelativeTrafficFlowEnum_convert () const;

    public:
    static const char* const _xsd_RelativeTrafficFlowEnum_literals_[5];
    static const value _xsd_RelativeTrafficFlowEnum_indexes_[5];
  };

  class RequestTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      catalogue,
      filter,
      requestData,
      requestHistoricalData,
      subscription
    };

    RequestTypeEnum (value v);

    RequestTypeEnum (const char* v);

    RequestTypeEnum (const ::std::string& v);

    RequestTypeEnum (const ::xml_schema::string& v);

    RequestTypeEnum (const xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    RequestTypeEnum (const xercesc::DOMAttr& a,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    RequestTypeEnum (const ::std::string& s,
                     const xercesc::DOMElement* e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    RequestTypeEnum (const RequestTypeEnum& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual RequestTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    RequestTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_RequestTypeEnum_convert ();
    }

    protected:
    value
    _xsd_RequestTypeEnum_convert () const;

    public:
    static const char* const _xsd_RequestTypeEnum_literals_[5];
    static const value _xsd_RequestTypeEnum_indexes_[5];
  };

  class ReroutingManagement: public ::datex2::NetworkManagement
  {
    public:
    // reroutingManagementType
    // 
    typedef ::datex2::ReroutingManagementTypeEnum reroutingManagementType_type;
    typedef ::xsd::cxx::tree::sequence< reroutingManagementType_type > reroutingManagementType_sequence;
    typedef xsd::cxx::tree::sequence< reroutingManagementType_type >::iterator reroutingManagementType_iterator;
    typedef xsd::cxx::tree::sequence< reroutingManagementType_type >::const_iterator reroutingManagementType_const_iterator;
    typedef ::xsd::cxx::tree::traits< reroutingManagementType_type, char > reroutingManagementType_traits;

    const reroutingManagementType_sequence&
    reroutingManagementType () const;

    reroutingManagementType_sequence&
    reroutingManagementType ();

    void
    reroutingManagementType (const reroutingManagementType_sequence& s);

    // reroutingItineraryDescription
    // 
    typedef ::datex2::MultilingualString reroutingItineraryDescription_type;
    typedef ::xsd::cxx::tree::optional< reroutingItineraryDescription_type > reroutingItineraryDescription_optional;
    typedef ::xsd::cxx::tree::traits< reroutingItineraryDescription_type, char > reroutingItineraryDescription_traits;

    const reroutingItineraryDescription_optional&
    reroutingItineraryDescription () const;

    reroutingItineraryDescription_optional&
    reroutingItineraryDescription ();

    void
    reroutingItineraryDescription (const reroutingItineraryDescription_type& x);

    void
    reroutingItineraryDescription (const reroutingItineraryDescription_optional& x);

    void
    reroutingItineraryDescription (::std::auto_ptr< reroutingItineraryDescription_type > p);

    // signedRerouting
    // 
    typedef ::datex2::Boolean signedRerouting_type;
    typedef ::xsd::cxx::tree::optional< signedRerouting_type > signedRerouting_optional;
    typedef ::xsd::cxx::tree::traits< signedRerouting_type, char > signedRerouting_traits;

    const signedRerouting_optional&
    signedRerouting () const;

    signedRerouting_optional&
    signedRerouting ();

    void
    signedRerouting (const signedRerouting_type& x);

    void
    signedRerouting (const signedRerouting_optional& x);

    void
    signedRerouting (::std::auto_ptr< signedRerouting_type > p);

    // entry
    // 
    typedef ::datex2::String entry_type;
    typedef ::xsd::cxx::tree::optional< entry_type > entry_optional;
    typedef ::xsd::cxx::tree::traits< entry_type, char > entry_traits;

    const entry_optional&
    entry () const;

    entry_optional&
    entry ();

    void
    entry (const entry_type& x);

    void
    entry (const entry_optional& x);

    void
    entry (::std::auto_ptr< entry_type > p);

    // exit
    // 
    typedef ::datex2::String exit_type;
    typedef ::xsd::cxx::tree::optional< exit_type > exit_optional;
    typedef ::xsd::cxx::tree::traits< exit_type, char > exit_traits;

    const exit_optional&
    exit () const;

    exit_optional&
    exit ();

    void
    exit (const exit_type& x);

    void
    exit (const exit_optional& x);

    void
    exit (::std::auto_ptr< exit_type > p);

    // roadOrJunctionNumber
    // 
    typedef ::datex2::String roadOrJunctionNumber_type;
    typedef ::xsd::cxx::tree::optional< roadOrJunctionNumber_type > roadOrJunctionNumber_optional;
    typedef ::xsd::cxx::tree::traits< roadOrJunctionNumber_type, char > roadOrJunctionNumber_traits;

    const roadOrJunctionNumber_optional&
    roadOrJunctionNumber () const;

    roadOrJunctionNumber_optional&
    roadOrJunctionNumber ();

    void
    roadOrJunctionNumber (const roadOrJunctionNumber_type& x);

    void
    roadOrJunctionNumber (const roadOrJunctionNumber_optional& x);

    void
    roadOrJunctionNumber (::std::auto_ptr< roadOrJunctionNumber_type > p);

    // alternativeRoute
    // 
    typedef ::datex2::Itinerary alternativeRoute_type;
    typedef ::xsd::cxx::tree::sequence< alternativeRoute_type > alternativeRoute_sequence;
    typedef xsd::cxx::tree::sequence< alternativeRoute_type >::iterator alternativeRoute_iterator;
    typedef xsd::cxx::tree::sequence< alternativeRoute_type >::const_iterator alternativeRoute_const_iterator;
    typedef ::xsd::cxx::tree::traits< alternativeRoute_type, char > alternativeRoute_traits;

    const alternativeRoute_sequence&
    alternativeRoute () const;

    alternativeRoute_sequence&
    alternativeRoute ();

    void
    alternativeRoute (const alternativeRoute_sequence& s);

    // reroutingManagementExtension
    // 
    typedef ::datex2::ExtensionType reroutingManagementExtension_type;
    typedef ::xsd::cxx::tree::optional< reroutingManagementExtension_type > reroutingManagementExtension_optional;
    typedef ::xsd::cxx::tree::traits< reroutingManagementExtension_type, char > reroutingManagementExtension_traits;

    const reroutingManagementExtension_optional&
    reroutingManagementExtension () const;

    reroutingManagementExtension_optional&
    reroutingManagementExtension ();

    void
    reroutingManagementExtension (const reroutingManagementExtension_type& x);

    void
    reroutingManagementExtension (const reroutingManagementExtension_optional& x);

    void
    reroutingManagementExtension (::std::auto_ptr< reroutingManagementExtension_type > p);

    // Constructors.
    //
    ReroutingManagement (const situationRecordCreationTime_type&,
                         const situationRecordVersion_type&,
                         const situationRecordVersionTime_type&,
                         const probabilityOfOccurrence_type&,
                         const validity_type&,
                         const groupOfLocations_type&,
                         const id_type&,
                         const complianceOption_type&);

    ReroutingManagement (const situationRecordCreationTime_type&,
                         const situationRecordVersion_type&,
                         const situationRecordVersionTime_type&,
                         const probabilityOfOccurrence_type&,
                         ::std::auto_ptr< validity_type >&,
                         ::std::auto_ptr< groupOfLocations_type >&,
                         const id_type&,
                         const complianceOption_type&);

    ReroutingManagement (const xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    ReroutingManagement (const ReroutingManagement& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual ReroutingManagement*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ReroutingManagement ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    reroutingManagementType_sequence reroutingManagementType_;
    reroutingItineraryDescription_optional reroutingItineraryDescription_;
    signedRerouting_optional signedRerouting_;
    entry_optional entry_;
    exit_optional exit_;
    roadOrJunctionNumber_optional roadOrJunctionNumber_;
    alternativeRoute_sequence alternativeRoute_;
    reroutingManagementExtension_optional reroutingManagementExtension_;
  };

  class ReroutingManagementTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      doNotFollowDiversionSigns,
      doNotUseEntry,
      doNotUseExit,
      doNotUseIntersectionOrJunction,
      followDiversionSigns,
      followLocalDiversion,
      followSpecialMarkers,
      useEntry,
      useExit,
      useIntersectionOrJunction
    };

    ReroutingManagementTypeEnum (value v);

    ReroutingManagementTypeEnum (const char* v);

    ReroutingManagementTypeEnum (const ::std::string& v);

    ReroutingManagementTypeEnum (const ::xml_schema::string& v);

    ReroutingManagementTypeEnum (const xercesc::DOMElement& e,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    ReroutingManagementTypeEnum (const xercesc::DOMAttr& a,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    ReroutingManagementTypeEnum (const ::std::string& s,
                                 const xercesc::DOMElement* e,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    ReroutingManagementTypeEnum (const ReroutingManagementTypeEnum& x,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    virtual ReroutingManagementTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    ReroutingManagementTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_ReroutingManagementTypeEnum_convert ();
    }

    protected:
    value
    _xsd_ReroutingManagementTypeEnum_convert () const;

    public:
    static const char* const _xsd_ReroutingManagementTypeEnum_literals_[10];
    static const value _xsd_ReroutingManagementTypeEnum_indexes_[10];
  };

  class ResponseEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      acknowledge,
      catalogueRequestDenied,
      filterRequestDenied,
      requestDenied,
      subscriptionRequestDenied
    };

    ResponseEnum (value v);

    ResponseEnum (const char* v);

    ResponseEnum (const ::std::string& v);

    ResponseEnum (const ::xml_schema::string& v);

    ResponseEnum (const xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    ResponseEnum (const xercesc::DOMAttr& a,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    ResponseEnum (const ::std::string& s,
                  const xercesc::DOMElement* e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    ResponseEnum (const ResponseEnum& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual ResponseEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    ResponseEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_ResponseEnum_convert ();
    }

    protected:
    value
    _xsd_ResponseEnum_convert () const;

    public:
    static const char* const _xsd_ResponseEnum_literals_[5];
    static const value _xsd_ResponseEnum_indexes_[5];
  };

  class RoadMaintenanceTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      clearanceWork,
      controlledAvalanche,
      installationWork,
      grassCuttingWork,
      maintenanceWork,
      overheadWorks,
      repairWork,
      resurfacingWork,
      roadMarkingWork,
      roadsideWork,
      roadworksClearance,
      roadworks,
      rockFallPreventativeMaintenance,
      saltingInProgress,
      snowploughsInUse,
      treeAndVegetationCuttingWork,
      other
    };

    RoadMaintenanceTypeEnum (value v);

    RoadMaintenanceTypeEnum (const char* v);

    RoadMaintenanceTypeEnum (const ::std::string& v);

    RoadMaintenanceTypeEnum (const ::xml_schema::string& v);

    RoadMaintenanceTypeEnum (const xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    RoadMaintenanceTypeEnum (const xercesc::DOMAttr& a,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    RoadMaintenanceTypeEnum (const ::std::string& s,
                             const xercesc::DOMElement* e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    RoadMaintenanceTypeEnum (const RoadMaintenanceTypeEnum& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual RoadMaintenanceTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    RoadMaintenanceTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_RoadMaintenanceTypeEnum_convert ();
    }

    protected:
    value
    _xsd_RoadMaintenanceTypeEnum_convert () const;

    public:
    static const char* const _xsd_RoadMaintenanceTypeEnum_literals_[17];
    static const value _xsd_RoadMaintenanceTypeEnum_indexes_[17];
  };

  class RoadOperatorServiceDisruption: public ::datex2::NonRoadEventInformation
  {
    public:
    // roadOperatorServiceDisruptionType
    // 
    typedef ::datex2::RoadOperatorServiceDisruptionTypeEnum roadOperatorServiceDisruptionType_type;
    typedef ::xsd::cxx::tree::sequence< roadOperatorServiceDisruptionType_type > roadOperatorServiceDisruptionType_sequence;
    typedef xsd::cxx::tree::sequence< roadOperatorServiceDisruptionType_type >::iterator roadOperatorServiceDisruptionType_iterator;
    typedef xsd::cxx::tree::sequence< roadOperatorServiceDisruptionType_type >::const_iterator roadOperatorServiceDisruptionType_const_iterator;
    typedef ::xsd::cxx::tree::traits< roadOperatorServiceDisruptionType_type, char > roadOperatorServiceDisruptionType_traits;

    const roadOperatorServiceDisruptionType_sequence&
    roadOperatorServiceDisruptionType () const;

    roadOperatorServiceDisruptionType_sequence&
    roadOperatorServiceDisruptionType ();

    void
    roadOperatorServiceDisruptionType (const roadOperatorServiceDisruptionType_sequence& s);

    // roadOperatorServiceDisruptionExtension
    // 
    typedef ::datex2::ExtensionType roadOperatorServiceDisruptionExtension_type;
    typedef ::xsd::cxx::tree::optional< roadOperatorServiceDisruptionExtension_type > roadOperatorServiceDisruptionExtension_optional;
    typedef ::xsd::cxx::tree::traits< roadOperatorServiceDisruptionExtension_type, char > roadOperatorServiceDisruptionExtension_traits;

    const roadOperatorServiceDisruptionExtension_optional&
    roadOperatorServiceDisruptionExtension () const;

    roadOperatorServiceDisruptionExtension_optional&
    roadOperatorServiceDisruptionExtension ();

    void
    roadOperatorServiceDisruptionExtension (const roadOperatorServiceDisruptionExtension_type& x);

    void
    roadOperatorServiceDisruptionExtension (const roadOperatorServiceDisruptionExtension_optional& x);

    void
    roadOperatorServiceDisruptionExtension (::std::auto_ptr< roadOperatorServiceDisruptionExtension_type > p);

    // Constructors.
    //
    RoadOperatorServiceDisruption (const situationRecordCreationTime_type&,
                                   const situationRecordVersion_type&,
                                   const situationRecordVersionTime_type&,
                                   const probabilityOfOccurrence_type&,
                                   const validity_type&,
                                   const groupOfLocations_type&,
                                   const id_type&);

    RoadOperatorServiceDisruption (const situationRecordCreationTime_type&,
                                   const situationRecordVersion_type&,
                                   const situationRecordVersionTime_type&,
                                   const probabilityOfOccurrence_type&,
                                   ::std::auto_ptr< validity_type >&,
                                   ::std::auto_ptr< groupOfLocations_type >&,
                                   const id_type&);

    RoadOperatorServiceDisruption (const xercesc::DOMElement& e,
                                   ::xml_schema::flags f = 0,
                                   ::xml_schema::container* c = 0);

    RoadOperatorServiceDisruption (const RoadOperatorServiceDisruption& x,
                                   ::xml_schema::flags f = 0,
                                   ::xml_schema::container* c = 0);

    virtual RoadOperatorServiceDisruption*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RoadOperatorServiceDisruption ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    roadOperatorServiceDisruptionType_sequence roadOperatorServiceDisruptionType_;
    roadOperatorServiceDisruptionExtension_optional roadOperatorServiceDisruptionExtension_;
  };

  class RoadOperatorServiceDisruptionTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      emergencyTelephoneNumberOutOfService,
      informationServiceTelephoneNumberOutOfService,
      noTrafficOfficerPatrolService
    };

    RoadOperatorServiceDisruptionTypeEnum (value v);

    RoadOperatorServiceDisruptionTypeEnum (const char* v);

    RoadOperatorServiceDisruptionTypeEnum (const ::std::string& v);

    RoadOperatorServiceDisruptionTypeEnum (const ::xml_schema::string& v);

    RoadOperatorServiceDisruptionTypeEnum (const xercesc::DOMElement& e,
                                           ::xml_schema::flags f = 0,
                                           ::xml_schema::container* c = 0);

    RoadOperatorServiceDisruptionTypeEnum (const xercesc::DOMAttr& a,
                                           ::xml_schema::flags f = 0,
                                           ::xml_schema::container* c = 0);

    RoadOperatorServiceDisruptionTypeEnum (const ::std::string& s,
                                           const xercesc::DOMElement* e,
                                           ::xml_schema::flags f = 0,
                                           ::xml_schema::container* c = 0);

    RoadOperatorServiceDisruptionTypeEnum (const RoadOperatorServiceDisruptionTypeEnum& x,
                                           ::xml_schema::flags f = 0,
                                           ::xml_schema::container* c = 0);

    virtual RoadOperatorServiceDisruptionTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    RoadOperatorServiceDisruptionTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_RoadOperatorServiceDisruptionTypeEnum_convert ();
    }

    protected:
    value
    _xsd_RoadOperatorServiceDisruptionTypeEnum_convert () const;

    public:
    static const char* const _xsd_RoadOperatorServiceDisruptionTypeEnum_literals_[3];
    static const value _xsd_RoadOperatorServiceDisruptionTypeEnum_indexes_[3];
  };

  class RoadOrCarriagewayOrLaneManagement: public ::datex2::NetworkManagement
  {
    public:
    // roadOrCarriagewayOrLaneManagementType
    // 
    typedef ::datex2::RoadOrCarriagewayOrLaneManagementTypeEnum roadOrCarriagewayOrLaneManagementType_type;
    typedef ::xsd::cxx::tree::traits< roadOrCarriagewayOrLaneManagementType_type, char > roadOrCarriagewayOrLaneManagementType_traits;

    const roadOrCarriagewayOrLaneManagementType_type&
    roadOrCarriagewayOrLaneManagementType () const;

    roadOrCarriagewayOrLaneManagementType_type&
    roadOrCarriagewayOrLaneManagementType ();

    void
    roadOrCarriagewayOrLaneManagementType (const roadOrCarriagewayOrLaneManagementType_type& x);

    void
    roadOrCarriagewayOrLaneManagementType (::std::auto_ptr< roadOrCarriagewayOrLaneManagementType_type > p);

    // minimumCarOccupancy
    // 
    typedef ::datex2::NonNegativeInteger minimumCarOccupancy_type;
    typedef ::xsd::cxx::tree::optional< minimumCarOccupancy_type > minimumCarOccupancy_optional;
    typedef ::xsd::cxx::tree::traits< minimumCarOccupancy_type, char > minimumCarOccupancy_traits;

    const minimumCarOccupancy_optional&
    minimumCarOccupancy () const;

    minimumCarOccupancy_optional&
    minimumCarOccupancy ();

    void
    minimumCarOccupancy (const minimumCarOccupancy_type& x);

    void
    minimumCarOccupancy (const minimumCarOccupancy_optional& x);

    void
    minimumCarOccupancy (::std::auto_ptr< minimumCarOccupancy_type > p);

    // specifiedCarriageway
    // 
    typedef ::datex2::CarriagewayEnum specifiedCarriageway_type;
    typedef ::xsd::cxx::tree::sequence< specifiedCarriageway_type > specifiedCarriageway_sequence;
    typedef xsd::cxx::tree::sequence< specifiedCarriageway_type >::iterator specifiedCarriageway_iterator;
    typedef xsd::cxx::tree::sequence< specifiedCarriageway_type >::const_iterator specifiedCarriageway_const_iterator;
    typedef ::xsd::cxx::tree::traits< specifiedCarriageway_type, char > specifiedCarriageway_traits;

    const specifiedCarriageway_sequence&
    specifiedCarriageway () const;

    specifiedCarriageway_sequence&
    specifiedCarriageway ();

    void
    specifiedCarriageway (const specifiedCarriageway_sequence& s);

    // specifiedLane
    // 
    typedef ::datex2::LaneEnum specifiedLane_type;
    typedef ::xsd::cxx::tree::sequence< specifiedLane_type > specifiedLane_sequence;
    typedef xsd::cxx::tree::sequence< specifiedLane_type >::iterator specifiedLane_iterator;
    typedef xsd::cxx::tree::sequence< specifiedLane_type >::const_iterator specifiedLane_const_iterator;
    typedef ::xsd::cxx::tree::traits< specifiedLane_type, char > specifiedLane_traits;

    const specifiedLane_sequence&
    specifiedLane () const;

    specifiedLane_sequence&
    specifiedLane ();

    void
    specifiedLane (const specifiedLane_sequence& s);

    // roadOrCarriagewayOrLaneManagementExtension
    // 
    typedef ::datex2::ExtensionType roadOrCarriagewayOrLaneManagementExtension_type;
    typedef ::xsd::cxx::tree::optional< roadOrCarriagewayOrLaneManagementExtension_type > roadOrCarriagewayOrLaneManagementExtension_optional;
    typedef ::xsd::cxx::tree::traits< roadOrCarriagewayOrLaneManagementExtension_type, char > roadOrCarriagewayOrLaneManagementExtension_traits;

    const roadOrCarriagewayOrLaneManagementExtension_optional&
    roadOrCarriagewayOrLaneManagementExtension () const;

    roadOrCarriagewayOrLaneManagementExtension_optional&
    roadOrCarriagewayOrLaneManagementExtension ();

    void
    roadOrCarriagewayOrLaneManagementExtension (const roadOrCarriagewayOrLaneManagementExtension_type& x);

    void
    roadOrCarriagewayOrLaneManagementExtension (const roadOrCarriagewayOrLaneManagementExtension_optional& x);

    void
    roadOrCarriagewayOrLaneManagementExtension (::std::auto_ptr< roadOrCarriagewayOrLaneManagementExtension_type > p);

    // Constructors.
    //
    RoadOrCarriagewayOrLaneManagement (const situationRecordCreationTime_type&,
                                       const situationRecordVersion_type&,
                                       const situationRecordVersionTime_type&,
                                       const probabilityOfOccurrence_type&,
                                       const validity_type&,
                                       const groupOfLocations_type&,
                                       const id_type&,
                                       const complianceOption_type&,
                                       const roadOrCarriagewayOrLaneManagementType_type&);

    RoadOrCarriagewayOrLaneManagement (const situationRecordCreationTime_type&,
                                       const situationRecordVersion_type&,
                                       const situationRecordVersionTime_type&,
                                       const probabilityOfOccurrence_type&,
                                       ::std::auto_ptr< validity_type >&,
                                       ::std::auto_ptr< groupOfLocations_type >&,
                                       const id_type&,
                                       const complianceOption_type&,
                                       const roadOrCarriagewayOrLaneManagementType_type&);

    RoadOrCarriagewayOrLaneManagement (const xercesc::DOMElement& e,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    RoadOrCarriagewayOrLaneManagement (const RoadOrCarriagewayOrLaneManagement& x,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    virtual RoadOrCarriagewayOrLaneManagement*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RoadOrCarriagewayOrLaneManagement ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< roadOrCarriagewayOrLaneManagementType_type > roadOrCarriagewayOrLaneManagementType_;
    minimumCarOccupancy_optional minimumCarOccupancy_;
    specifiedCarriageway_sequence specifiedCarriageway_;
    specifiedLane_sequence specifiedLane_;
    roadOrCarriagewayOrLaneManagementExtension_optional roadOrCarriagewayOrLaneManagementExtension_;
  };

  class RoadOrCarriagewayOrLaneManagementTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      carPoolLaneInOperation,
      carriagewayClosures,
      clearALaneForEmergencyVehicles,
      clearALaneForSnowploughsAndGrittingVehicles,
      closedPermanentlyForTheWinter,
      contraflow,
      doNotUseSpecifiedLanesOrCarriageways,
      hardShoulderRunningInOperation,
      intermittentShortTermClosures,
      keepToTheLeft,
      keepToTheRight,
      laneClosures,
      lanesDeviated,
      narrowLanes,
      newRoadworksLayout,
      overnightClosures,
      roadCleared,
      roadClosed,
      rollingRoadBlock,
      rushHourLaneInOperation,
      singleAlternateLineTraffic,
      tidalFlowLaneInOperation,
      turnAroundInOperation,
      useOfSpecifiedLanesOrCarriagewaysAllowed,
      useSpecifiedLanesOrCarriageways,
      vehicleStorageInOperation,
      other
    };

    RoadOrCarriagewayOrLaneManagementTypeEnum (value v);

    RoadOrCarriagewayOrLaneManagementTypeEnum (const char* v);

    RoadOrCarriagewayOrLaneManagementTypeEnum (const ::std::string& v);

    RoadOrCarriagewayOrLaneManagementTypeEnum (const ::xml_schema::string& v);

    RoadOrCarriagewayOrLaneManagementTypeEnum (const xercesc::DOMElement& e,
                                               ::xml_schema::flags f = 0,
                                               ::xml_schema::container* c = 0);

    RoadOrCarriagewayOrLaneManagementTypeEnum (const xercesc::DOMAttr& a,
                                               ::xml_schema::flags f = 0,
                                               ::xml_schema::container* c = 0);

    RoadOrCarriagewayOrLaneManagementTypeEnum (const ::std::string& s,
                                               const xercesc::DOMElement* e,
                                               ::xml_schema::flags f = 0,
                                               ::xml_schema::container* c = 0);

    RoadOrCarriagewayOrLaneManagementTypeEnum (const RoadOrCarriagewayOrLaneManagementTypeEnum& x,
                                               ::xml_schema::flags f = 0,
                                               ::xml_schema::container* c = 0);

    virtual RoadOrCarriagewayOrLaneManagementTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    RoadOrCarriagewayOrLaneManagementTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_RoadOrCarriagewayOrLaneManagementTypeEnum_convert ();
    }

    protected:
    value
    _xsd_RoadOrCarriagewayOrLaneManagementTypeEnum_convert () const;

    public:
    static const char* const _xsd_RoadOrCarriagewayOrLaneManagementTypeEnum_literals_[27];
    static const value _xsd_RoadOrCarriagewayOrLaneManagementTypeEnum_indexes_[27];
  };

  class RoadsideAssistance: public ::datex2::OperatorAction
  {
    public:
    // roadsideAssistanceType
    // 
    typedef ::datex2::RoadsideAssistanceTypeEnum roadsideAssistanceType_type;
    typedef ::xsd::cxx::tree::traits< roadsideAssistanceType_type, char > roadsideAssistanceType_traits;

    const roadsideAssistanceType_type&
    roadsideAssistanceType () const;

    roadsideAssistanceType_type&
    roadsideAssistanceType ();

    void
    roadsideAssistanceType (const roadsideAssistanceType_type& x);

    void
    roadsideAssistanceType (::std::auto_ptr< roadsideAssistanceType_type > p);

    // roadsideAssistanceExtension
    // 
    typedef ::datex2::ExtensionType roadsideAssistanceExtension_type;
    typedef ::xsd::cxx::tree::optional< roadsideAssistanceExtension_type > roadsideAssistanceExtension_optional;
    typedef ::xsd::cxx::tree::traits< roadsideAssistanceExtension_type, char > roadsideAssistanceExtension_traits;

    const roadsideAssistanceExtension_optional&
    roadsideAssistanceExtension () const;

    roadsideAssistanceExtension_optional&
    roadsideAssistanceExtension ();

    void
    roadsideAssistanceExtension (const roadsideAssistanceExtension_type& x);

    void
    roadsideAssistanceExtension (const roadsideAssistanceExtension_optional& x);

    void
    roadsideAssistanceExtension (::std::auto_ptr< roadsideAssistanceExtension_type > p);

    // Constructors.
    //
    RoadsideAssistance (const situationRecordCreationTime_type&,
                        const situationRecordVersion_type&,
                        const situationRecordVersionTime_type&,
                        const probabilityOfOccurrence_type&,
                        const validity_type&,
                        const groupOfLocations_type&,
                        const id_type&,
                        const roadsideAssistanceType_type&);

    RoadsideAssistance (const situationRecordCreationTime_type&,
                        const situationRecordVersion_type&,
                        const situationRecordVersionTime_type&,
                        const probabilityOfOccurrence_type&,
                        ::std::auto_ptr< validity_type >&,
                        ::std::auto_ptr< groupOfLocations_type >&,
                        const id_type&,
                        const roadsideAssistanceType_type&);

    RoadsideAssistance (const xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    RoadsideAssistance (const RoadsideAssistance& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual RoadsideAssistance*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RoadsideAssistance ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< roadsideAssistanceType_type > roadsideAssistanceType_;
    roadsideAssistanceExtension_optional roadsideAssistanceExtension_;
  };

  class RoadsideAssistanceTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      airAmbulance,
      busPassengerAssistance,
      emergencyServices,
      firstAid,
      foodDelivery,
      helicopterRescue,
      vehicleRepair,
      vehicleRecovery,
      other
    };

    RoadsideAssistanceTypeEnum (value v);

    RoadsideAssistanceTypeEnum (const char* v);

    RoadsideAssistanceTypeEnum (const ::std::string& v);

    RoadsideAssistanceTypeEnum (const ::xml_schema::string& v);

    RoadsideAssistanceTypeEnum (const xercesc::DOMElement& e,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    RoadsideAssistanceTypeEnum (const xercesc::DOMAttr& a,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    RoadsideAssistanceTypeEnum (const ::std::string& s,
                                const xercesc::DOMElement* e,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    RoadsideAssistanceTypeEnum (const RoadsideAssistanceTypeEnum& x,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    virtual RoadsideAssistanceTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    RoadsideAssistanceTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_RoadsideAssistanceTypeEnum_convert ();
    }

    protected:
    value
    _xsd_RoadsideAssistanceTypeEnum_convert () const;

    public:
    static const char* const _xsd_RoadsideAssistanceTypeEnum_literals_[9];
    static const value _xsd_RoadsideAssistanceTypeEnum_indexes_[9];
  };

  class RoadsideReferencePoint: public ::xml_schema::type
  {
    public:
    // roadsideReferencePointIdentifier
    // 
    typedef ::datex2::String roadsideReferencePointIdentifier_type;
    typedef ::xsd::cxx::tree::traits< roadsideReferencePointIdentifier_type, char > roadsideReferencePointIdentifier_traits;

    const roadsideReferencePointIdentifier_type&
    roadsideReferencePointIdentifier () const;

    roadsideReferencePointIdentifier_type&
    roadsideReferencePointIdentifier ();

    void
    roadsideReferencePointIdentifier (const roadsideReferencePointIdentifier_type& x);

    void
    roadsideReferencePointIdentifier (::std::auto_ptr< roadsideReferencePointIdentifier_type > p);

    // administrativeArea
    // 
    typedef ::datex2::MultilingualString administrativeArea_type;
    typedef ::xsd::cxx::tree::optional< administrativeArea_type > administrativeArea_optional;
    typedef ::xsd::cxx::tree::traits< administrativeArea_type, char > administrativeArea_traits;

    const administrativeArea_optional&
    administrativeArea () const;

    administrativeArea_optional&
    administrativeArea ();

    void
    administrativeArea (const administrativeArea_type& x);

    void
    administrativeArea (const administrativeArea_optional& x);

    void
    administrativeArea (::std::auto_ptr< administrativeArea_type > p);

    // roadName
    // 
    typedef ::datex2::MultilingualString roadName_type;
    typedef ::xsd::cxx::tree::optional< roadName_type > roadName_optional;
    typedef ::xsd::cxx::tree::traits< roadName_type, char > roadName_traits;

    const roadName_optional&
    roadName () const;

    roadName_optional&
    roadName ();

    void
    roadName (const roadName_type& x);

    void
    roadName (const roadName_optional& x);

    void
    roadName (::std::auto_ptr< roadName_type > p);

    // roadNumber
    // 
    typedef ::datex2::String roadNumber_type;
    typedef ::xsd::cxx::tree::optional< roadNumber_type > roadNumber_optional;
    typedef ::xsd::cxx::tree::traits< roadNumber_type, char > roadNumber_traits;

    const roadNumber_optional&
    roadNumber () const;

    roadNumber_optional&
    roadNumber ();

    void
    roadNumber (const roadNumber_type& x);

    void
    roadNumber (const roadNumber_optional& x);

    void
    roadNumber (::std::auto_ptr< roadNumber_type > p);

    // directionBound
    // 
    typedef ::datex2::DirectionEnum directionBound_type;
    typedef ::xsd::cxx::tree::optional< directionBound_type > directionBound_optional;
    typedef ::xsd::cxx::tree::traits< directionBound_type, char > directionBound_traits;

    const directionBound_optional&
    directionBound () const;

    directionBound_optional&
    directionBound ();

    void
    directionBound (const directionBound_type& x);

    void
    directionBound (const directionBound_optional& x);

    void
    directionBound (::std::auto_ptr< directionBound_type > p);

    // directionRelative
    // 
    typedef ::datex2::ReferencePointDirectionEnum directionRelative_type;
    typedef ::xsd::cxx::tree::optional< directionRelative_type > directionRelative_optional;
    typedef ::xsd::cxx::tree::traits< directionRelative_type, char > directionRelative_traits;

    const directionRelative_optional&
    directionRelative () const;

    directionRelative_optional&
    directionRelative ();

    void
    directionRelative (const directionRelative_type& x);

    void
    directionRelative (const directionRelative_optional& x);

    void
    directionRelative (::std::auto_ptr< directionRelative_type > p);

    // distanceFromPrevious
    // 
    typedef ::datex2::MetresAsFloat distanceFromPrevious_type;
    typedef ::xsd::cxx::tree::optional< distanceFromPrevious_type > distanceFromPrevious_optional;
    typedef ::xsd::cxx::tree::traits< distanceFromPrevious_type, char > distanceFromPrevious_traits;

    const distanceFromPrevious_optional&
    distanceFromPrevious () const;

    distanceFromPrevious_optional&
    distanceFromPrevious ();

    void
    distanceFromPrevious (const distanceFromPrevious_type& x);

    void
    distanceFromPrevious (const distanceFromPrevious_optional& x);

    void
    distanceFromPrevious (::std::auto_ptr< distanceFromPrevious_type > p);

    // distanceToNext
    // 
    typedef ::datex2::MetresAsFloat distanceToNext_type;
    typedef ::xsd::cxx::tree::optional< distanceToNext_type > distanceToNext_optional;
    typedef ::xsd::cxx::tree::traits< distanceToNext_type, char > distanceToNext_traits;

    const distanceToNext_optional&
    distanceToNext () const;

    distanceToNext_optional&
    distanceToNext ();

    void
    distanceToNext (const distanceToNext_type& x);

    void
    distanceToNext (const distanceToNext_optional& x);

    void
    distanceToNext (::std::auto_ptr< distanceToNext_type > p);

    // elevatedRoadSection
    // 
    typedef ::datex2::Boolean elevatedRoadSection_type;
    typedef ::xsd::cxx::tree::optional< elevatedRoadSection_type > elevatedRoadSection_optional;
    typedef ::xsd::cxx::tree::traits< elevatedRoadSection_type, char > elevatedRoadSection_traits;

    const elevatedRoadSection_optional&
    elevatedRoadSection () const;

    elevatedRoadSection_optional&
    elevatedRoadSection ();

    void
    elevatedRoadSection (const elevatedRoadSection_type& x);

    void
    elevatedRoadSection (const elevatedRoadSection_optional& x);

    void
    elevatedRoadSection (::std::auto_ptr< elevatedRoadSection_type > p);

    // roadsideReferencePointDescription
    // 
    typedef ::datex2::MultilingualString roadsideReferencePointDescription_type;
    typedef ::xsd::cxx::tree::optional< roadsideReferencePointDescription_type > roadsideReferencePointDescription_optional;
    typedef ::xsd::cxx::tree::traits< roadsideReferencePointDescription_type, char > roadsideReferencePointDescription_traits;

    const roadsideReferencePointDescription_optional&
    roadsideReferencePointDescription () const;

    roadsideReferencePointDescription_optional&
    roadsideReferencePointDescription ();

    void
    roadsideReferencePointDescription (const roadsideReferencePointDescription_type& x);

    void
    roadsideReferencePointDescription (const roadsideReferencePointDescription_optional& x);

    void
    roadsideReferencePointDescription (::std::auto_ptr< roadsideReferencePointDescription_type > p);

    // roadsideReferencePointDistance
    // 
    typedef ::datex2::MetresAsFloat roadsideReferencePointDistance_type;
    typedef ::xsd::cxx::tree::optional< roadsideReferencePointDistance_type > roadsideReferencePointDistance_optional;
    typedef ::xsd::cxx::tree::traits< roadsideReferencePointDistance_type, char > roadsideReferencePointDistance_traits;

    const roadsideReferencePointDistance_optional&
    roadsideReferencePointDistance () const;

    roadsideReferencePointDistance_optional&
    roadsideReferencePointDistance ();

    void
    roadsideReferencePointDistance (const roadsideReferencePointDistance_type& x);

    void
    roadsideReferencePointDistance (const roadsideReferencePointDistance_optional& x);

    void
    roadsideReferencePointDistance (::std::auto_ptr< roadsideReferencePointDistance_type > p);

    // roadsideReferencePointExtension
    // 
    typedef ::datex2::ExtensionType roadsideReferencePointExtension_type;
    typedef ::xsd::cxx::tree::optional< roadsideReferencePointExtension_type > roadsideReferencePointExtension_optional;
    typedef ::xsd::cxx::tree::traits< roadsideReferencePointExtension_type, char > roadsideReferencePointExtension_traits;

    const roadsideReferencePointExtension_optional&
    roadsideReferencePointExtension () const;

    roadsideReferencePointExtension_optional&
    roadsideReferencePointExtension ();

    void
    roadsideReferencePointExtension (const roadsideReferencePointExtension_type& x);

    void
    roadsideReferencePointExtension (const roadsideReferencePointExtension_optional& x);

    void
    roadsideReferencePointExtension (::std::auto_ptr< roadsideReferencePointExtension_type > p);

    // Constructors.
    //
    RoadsideReferencePoint (const roadsideReferencePointIdentifier_type&);

    RoadsideReferencePoint (const xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    RoadsideReferencePoint (const RoadsideReferencePoint& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual RoadsideReferencePoint*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RoadsideReferencePoint ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< roadsideReferencePointIdentifier_type > roadsideReferencePointIdentifier_;
    administrativeArea_optional administrativeArea_;
    roadName_optional roadName_;
    roadNumber_optional roadNumber_;
    directionBound_optional directionBound_;
    directionRelative_optional directionRelative_;
    distanceFromPrevious_optional distanceFromPrevious_;
    distanceToNext_optional distanceToNext_;
    elevatedRoadSection_optional elevatedRoadSection_;
    roadsideReferencePointDescription_optional roadsideReferencePointDescription_;
    roadsideReferencePointDistance_optional roadsideReferencePointDistance_;
    roadsideReferencePointExtension_optional roadsideReferencePointExtension_;
  };

  class RoadsideReferencePointLinear: public ::xml_schema::type
  {
    public:
    // roadsideReferencePointPrimaryLocation
    // 
    typedef ::datex2::RoadsideReferencePointPrimaryLocation roadsideReferencePointPrimaryLocation_type;
    typedef ::xsd::cxx::tree::traits< roadsideReferencePointPrimaryLocation_type, char > roadsideReferencePointPrimaryLocation_traits;

    const roadsideReferencePointPrimaryLocation_type&
    roadsideReferencePointPrimaryLocation () const;

    roadsideReferencePointPrimaryLocation_type&
    roadsideReferencePointPrimaryLocation ();

    void
    roadsideReferencePointPrimaryLocation (const roadsideReferencePointPrimaryLocation_type& x);

    void
    roadsideReferencePointPrimaryLocation (::std::auto_ptr< roadsideReferencePointPrimaryLocation_type > p);

    // roadsideReferencePointSecondaryLocation
    // 
    typedef ::datex2::RoadsideReferencePointSecondaryLocation roadsideReferencePointSecondaryLocation_type;
    typedef ::xsd::cxx::tree::traits< roadsideReferencePointSecondaryLocation_type, char > roadsideReferencePointSecondaryLocation_traits;

    const roadsideReferencePointSecondaryLocation_type&
    roadsideReferencePointSecondaryLocation () const;

    roadsideReferencePointSecondaryLocation_type&
    roadsideReferencePointSecondaryLocation ();

    void
    roadsideReferencePointSecondaryLocation (const roadsideReferencePointSecondaryLocation_type& x);

    void
    roadsideReferencePointSecondaryLocation (::std::auto_ptr< roadsideReferencePointSecondaryLocation_type > p);

    // roadsideReferencePointLinearExtension
    // 
    typedef ::datex2::ExtensionType roadsideReferencePointLinearExtension_type;
    typedef ::xsd::cxx::tree::optional< roadsideReferencePointLinearExtension_type > roadsideReferencePointLinearExtension_optional;
    typedef ::xsd::cxx::tree::traits< roadsideReferencePointLinearExtension_type, char > roadsideReferencePointLinearExtension_traits;

    const roadsideReferencePointLinearExtension_optional&
    roadsideReferencePointLinearExtension () const;

    roadsideReferencePointLinearExtension_optional&
    roadsideReferencePointLinearExtension ();

    void
    roadsideReferencePointLinearExtension (const roadsideReferencePointLinearExtension_type& x);

    void
    roadsideReferencePointLinearExtension (const roadsideReferencePointLinearExtension_optional& x);

    void
    roadsideReferencePointLinearExtension (::std::auto_ptr< roadsideReferencePointLinearExtension_type > p);

    // Constructors.
    //
    RoadsideReferencePointLinear (const roadsideReferencePointPrimaryLocation_type&,
                                  const roadsideReferencePointSecondaryLocation_type&);

    RoadsideReferencePointLinear (::std::auto_ptr< roadsideReferencePointPrimaryLocation_type >&,
                                  ::std::auto_ptr< roadsideReferencePointSecondaryLocation_type >&);

    RoadsideReferencePointLinear (const xercesc::DOMElement& e,
                                  ::xml_schema::flags f = 0,
                                  ::xml_schema::container* c = 0);

    RoadsideReferencePointLinear (const RoadsideReferencePointLinear& x,
                                  ::xml_schema::flags f = 0,
                                  ::xml_schema::container* c = 0);

    virtual RoadsideReferencePointLinear*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RoadsideReferencePointLinear ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< roadsideReferencePointPrimaryLocation_type > roadsideReferencePointPrimaryLocation_;
    ::xsd::cxx::tree::one< roadsideReferencePointSecondaryLocation_type > roadsideReferencePointSecondaryLocation_;
    roadsideReferencePointLinearExtension_optional roadsideReferencePointLinearExtension_;
  };

  class RoadsideReferencePointPrimaryLocation: public ::xml_schema::type
  {
    public:
    // roadsideReferencePoint
    // 
    typedef ::datex2::RoadsideReferencePoint roadsideReferencePoint_type;
    typedef ::xsd::cxx::tree::traits< roadsideReferencePoint_type, char > roadsideReferencePoint_traits;

    const roadsideReferencePoint_type&
    roadsideReferencePoint () const;

    roadsideReferencePoint_type&
    roadsideReferencePoint ();

    void
    roadsideReferencePoint (const roadsideReferencePoint_type& x);

    void
    roadsideReferencePoint (::std::auto_ptr< roadsideReferencePoint_type > p);

    // roadsideReferencePointPrimaryLocationExtension
    // 
    typedef ::datex2::ExtensionType roadsideReferencePointPrimaryLocationExtension_type;
    typedef ::xsd::cxx::tree::optional< roadsideReferencePointPrimaryLocationExtension_type > roadsideReferencePointPrimaryLocationExtension_optional;
    typedef ::xsd::cxx::tree::traits< roadsideReferencePointPrimaryLocationExtension_type, char > roadsideReferencePointPrimaryLocationExtension_traits;

    const roadsideReferencePointPrimaryLocationExtension_optional&
    roadsideReferencePointPrimaryLocationExtension () const;

    roadsideReferencePointPrimaryLocationExtension_optional&
    roadsideReferencePointPrimaryLocationExtension ();

    void
    roadsideReferencePointPrimaryLocationExtension (const roadsideReferencePointPrimaryLocationExtension_type& x);

    void
    roadsideReferencePointPrimaryLocationExtension (const roadsideReferencePointPrimaryLocationExtension_optional& x);

    void
    roadsideReferencePointPrimaryLocationExtension (::std::auto_ptr< roadsideReferencePointPrimaryLocationExtension_type > p);

    // Constructors.
    //
    RoadsideReferencePointPrimaryLocation (const roadsideReferencePoint_type&);

    RoadsideReferencePointPrimaryLocation (::std::auto_ptr< roadsideReferencePoint_type >&);

    RoadsideReferencePointPrimaryLocation (const xercesc::DOMElement& e,
                                           ::xml_schema::flags f = 0,
                                           ::xml_schema::container* c = 0);

    RoadsideReferencePointPrimaryLocation (const RoadsideReferencePointPrimaryLocation& x,
                                           ::xml_schema::flags f = 0,
                                           ::xml_schema::container* c = 0);

    virtual RoadsideReferencePointPrimaryLocation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RoadsideReferencePointPrimaryLocation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< roadsideReferencePoint_type > roadsideReferencePoint_;
    roadsideReferencePointPrimaryLocationExtension_optional roadsideReferencePointPrimaryLocationExtension_;
  };

  class RoadsideReferencePointSecondaryLocation: public ::xml_schema::type
  {
    public:
    // roadsideReferencePoint
    // 
    typedef ::datex2::RoadsideReferencePoint roadsideReferencePoint_type;
    typedef ::xsd::cxx::tree::traits< roadsideReferencePoint_type, char > roadsideReferencePoint_traits;

    const roadsideReferencePoint_type&
    roadsideReferencePoint () const;

    roadsideReferencePoint_type&
    roadsideReferencePoint ();

    void
    roadsideReferencePoint (const roadsideReferencePoint_type& x);

    void
    roadsideReferencePoint (::std::auto_ptr< roadsideReferencePoint_type > p);

    // roadsideReferencePointSecondaryLocationExtension
    // 
    typedef ::datex2::ExtensionType roadsideReferencePointSecondaryLocationExtension_type;
    typedef ::xsd::cxx::tree::optional< roadsideReferencePointSecondaryLocationExtension_type > roadsideReferencePointSecondaryLocationExtension_optional;
    typedef ::xsd::cxx::tree::traits< roadsideReferencePointSecondaryLocationExtension_type, char > roadsideReferencePointSecondaryLocationExtension_traits;

    const roadsideReferencePointSecondaryLocationExtension_optional&
    roadsideReferencePointSecondaryLocationExtension () const;

    roadsideReferencePointSecondaryLocationExtension_optional&
    roadsideReferencePointSecondaryLocationExtension ();

    void
    roadsideReferencePointSecondaryLocationExtension (const roadsideReferencePointSecondaryLocationExtension_type& x);

    void
    roadsideReferencePointSecondaryLocationExtension (const roadsideReferencePointSecondaryLocationExtension_optional& x);

    void
    roadsideReferencePointSecondaryLocationExtension (::std::auto_ptr< roadsideReferencePointSecondaryLocationExtension_type > p);

    // Constructors.
    //
    RoadsideReferencePointSecondaryLocation (const roadsideReferencePoint_type&);

    RoadsideReferencePointSecondaryLocation (::std::auto_ptr< roadsideReferencePoint_type >&);

    RoadsideReferencePointSecondaryLocation (const xercesc::DOMElement& e,
                                             ::xml_schema::flags f = 0,
                                             ::xml_schema::container* c = 0);

    RoadsideReferencePointSecondaryLocation (const RoadsideReferencePointSecondaryLocation& x,
                                             ::xml_schema::flags f = 0,
                                             ::xml_schema::container* c = 0);

    virtual RoadsideReferencePointSecondaryLocation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RoadsideReferencePointSecondaryLocation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< roadsideReferencePoint_type > roadsideReferencePoint_;
    roadsideReferencePointSecondaryLocationExtension_optional roadsideReferencePointSecondaryLocationExtension_;
  };

  class RoadsideServiceDisruption: public ::datex2::NonRoadEventInformation
  {
    public:
    // roadsideServiceDisruptionType
    // 
    typedef ::datex2::RoadsideServiceDisruptionTypeEnum roadsideServiceDisruptionType_type;
    typedef ::xsd::cxx::tree::sequence< roadsideServiceDisruptionType_type > roadsideServiceDisruptionType_sequence;
    typedef xsd::cxx::tree::sequence< roadsideServiceDisruptionType_type >::iterator roadsideServiceDisruptionType_iterator;
    typedef xsd::cxx::tree::sequence< roadsideServiceDisruptionType_type >::const_iterator roadsideServiceDisruptionType_const_iterator;
    typedef ::xsd::cxx::tree::traits< roadsideServiceDisruptionType_type, char > roadsideServiceDisruptionType_traits;

    const roadsideServiceDisruptionType_sequence&
    roadsideServiceDisruptionType () const;

    roadsideServiceDisruptionType_sequence&
    roadsideServiceDisruptionType ();

    void
    roadsideServiceDisruptionType (const roadsideServiceDisruptionType_sequence& s);

    // roadsideServiceDisruptionExtension
    // 
    typedef ::datex2::ExtensionType roadsideServiceDisruptionExtension_type;
    typedef ::xsd::cxx::tree::optional< roadsideServiceDisruptionExtension_type > roadsideServiceDisruptionExtension_optional;
    typedef ::xsd::cxx::tree::traits< roadsideServiceDisruptionExtension_type, char > roadsideServiceDisruptionExtension_traits;

    const roadsideServiceDisruptionExtension_optional&
    roadsideServiceDisruptionExtension () const;

    roadsideServiceDisruptionExtension_optional&
    roadsideServiceDisruptionExtension ();

    void
    roadsideServiceDisruptionExtension (const roadsideServiceDisruptionExtension_type& x);

    void
    roadsideServiceDisruptionExtension (const roadsideServiceDisruptionExtension_optional& x);

    void
    roadsideServiceDisruptionExtension (::std::auto_ptr< roadsideServiceDisruptionExtension_type > p);

    // Constructors.
    //
    RoadsideServiceDisruption (const situationRecordCreationTime_type&,
                               const situationRecordVersion_type&,
                               const situationRecordVersionTime_type&,
                               const probabilityOfOccurrence_type&,
                               const validity_type&,
                               const groupOfLocations_type&,
                               const id_type&);

    RoadsideServiceDisruption (const situationRecordCreationTime_type&,
                               const situationRecordVersion_type&,
                               const situationRecordVersionTime_type&,
                               const probabilityOfOccurrence_type&,
                               ::std::auto_ptr< validity_type >&,
                               ::std::auto_ptr< groupOfLocations_type >&,
                               const id_type&);

    RoadsideServiceDisruption (const xercesc::DOMElement& e,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    RoadsideServiceDisruption (const RoadsideServiceDisruption& x,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    virtual RoadsideServiceDisruption*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RoadsideServiceDisruption ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    roadsideServiceDisruptionType_sequence roadsideServiceDisruptionType_;
    roadsideServiceDisruptionExtension_optional roadsideServiceDisruptionExtension_;
  };

  class RoadsideServiceDisruptionTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      barClosed,
      dieselShortage,
      fuelShortage,
      lpgShortage,
      methaneShortage,
      noDieselForHeavyVehicles,
      noDieselForLightVehicles,
      noPublicTelephones,
      noToiletFacilities,
      noVehicleRepairFacilities,
      petrolShortage,
      restAreaBusy,
      restAreaClosed,
      restAreaOvercrowdedDriveToAnotherRestArea,
      serviceAreaBusy,
      serviceAreaClosed,
      serviceAreaFuelStationClosed,
      serviceAreaOvercrowdedDriveToAnotherServiceArea,
      serviceAreaRestaurantClosed,
      someCommercialServicesClosed,
      waterShortage
    };

    RoadsideServiceDisruptionTypeEnum (value v);

    RoadsideServiceDisruptionTypeEnum (const char* v);

    RoadsideServiceDisruptionTypeEnum (const ::std::string& v);

    RoadsideServiceDisruptionTypeEnum (const ::xml_schema::string& v);

    RoadsideServiceDisruptionTypeEnum (const xercesc::DOMElement& e,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    RoadsideServiceDisruptionTypeEnum (const xercesc::DOMAttr& a,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    RoadsideServiceDisruptionTypeEnum (const ::std::string& s,
                                       const xercesc::DOMElement* e,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    RoadsideServiceDisruptionTypeEnum (const RoadsideServiceDisruptionTypeEnum& x,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    virtual RoadsideServiceDisruptionTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    RoadsideServiceDisruptionTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_RoadsideServiceDisruptionTypeEnum_convert ();
    }

    protected:
    value
    _xsd_RoadsideServiceDisruptionTypeEnum_convert () const;

    public:
    static const char* const _xsd_RoadsideServiceDisruptionTypeEnum_literals_[21];
    static const value _xsd_RoadsideServiceDisruptionTypeEnum_indexes_[21];
  };

  class RoadSurfaceConditionInformation: public ::datex2::WeatherValue
  {
    public:
    // roadSurfaceConditionMeasurements
    // 
    typedef ::datex2::RoadSurfaceConditionMeasurements roadSurfaceConditionMeasurements_type;
    typedef ::xsd::cxx::tree::traits< roadSurfaceConditionMeasurements_type, char > roadSurfaceConditionMeasurements_traits;

    const roadSurfaceConditionMeasurements_type&
    roadSurfaceConditionMeasurements () const;

    roadSurfaceConditionMeasurements_type&
    roadSurfaceConditionMeasurements ();

    void
    roadSurfaceConditionMeasurements (const roadSurfaceConditionMeasurements_type& x);

    void
    roadSurfaceConditionMeasurements (::std::auto_ptr< roadSurfaceConditionMeasurements_type > p);

    // roadSurfaceConditionInformationExtension
    // 
    typedef ::datex2::ExtensionType roadSurfaceConditionInformationExtension_type;
    typedef ::xsd::cxx::tree::optional< roadSurfaceConditionInformationExtension_type > roadSurfaceConditionInformationExtension_optional;
    typedef ::xsd::cxx::tree::traits< roadSurfaceConditionInformationExtension_type, char > roadSurfaceConditionInformationExtension_traits;

    const roadSurfaceConditionInformationExtension_optional&
    roadSurfaceConditionInformationExtension () const;

    roadSurfaceConditionInformationExtension_optional&
    roadSurfaceConditionInformationExtension ();

    void
    roadSurfaceConditionInformationExtension (const roadSurfaceConditionInformationExtension_type& x);

    void
    roadSurfaceConditionInformationExtension (const roadSurfaceConditionInformationExtension_optional& x);

    void
    roadSurfaceConditionInformationExtension (::std::auto_ptr< roadSurfaceConditionInformationExtension_type > p);

    // Constructors.
    //
    RoadSurfaceConditionInformation (const roadSurfaceConditionMeasurements_type&);

    RoadSurfaceConditionInformation (::std::auto_ptr< roadSurfaceConditionMeasurements_type >&);

    RoadSurfaceConditionInformation (const xercesc::DOMElement& e,
                                     ::xml_schema::flags f = 0,
                                     ::xml_schema::container* c = 0);

    RoadSurfaceConditionInformation (const RoadSurfaceConditionInformation& x,
                                     ::xml_schema::flags f = 0,
                                     ::xml_schema::container* c = 0);

    virtual RoadSurfaceConditionInformation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RoadSurfaceConditionInformation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< roadSurfaceConditionMeasurements_type > roadSurfaceConditionMeasurements_;
    roadSurfaceConditionInformationExtension_optional roadSurfaceConditionInformationExtension_;
  };

  class RoadSurfaceConditionMeasurements: public ::xml_schema::type
  {
    public:
    // deIcingApplicationRate
    // 
    typedef ::datex2::IntensityKilogrammesPerSquareMetre deIcingApplicationRate_type;
    typedef ::xsd::cxx::tree::optional< deIcingApplicationRate_type > deIcingApplicationRate_optional;
    typedef ::xsd::cxx::tree::traits< deIcingApplicationRate_type, char > deIcingApplicationRate_traits;

    const deIcingApplicationRate_optional&
    deIcingApplicationRate () const;

    deIcingApplicationRate_optional&
    deIcingApplicationRate ();

    void
    deIcingApplicationRate (const deIcingApplicationRate_type& x);

    void
    deIcingApplicationRate (const deIcingApplicationRate_optional& x);

    void
    deIcingApplicationRate (::std::auto_ptr< deIcingApplicationRate_type > p);

    // deIcingConcentration
    // 
    typedef ::datex2::ConcentrationGramsPerCubicCentimetre deIcingConcentration_type;
    typedef ::xsd::cxx::tree::optional< deIcingConcentration_type > deIcingConcentration_optional;
    typedef ::xsd::cxx::tree::traits< deIcingConcentration_type, char > deIcingConcentration_traits;

    const deIcingConcentration_optional&
    deIcingConcentration () const;

    deIcingConcentration_optional&
    deIcingConcentration ();

    void
    deIcingConcentration (const deIcingConcentration_type& x);

    void
    deIcingConcentration (const deIcingConcentration_optional& x);

    void
    deIcingConcentration (::std::auto_ptr< deIcingConcentration_type > p);

    // depthOfSnow
    // 
    typedef ::datex2::MetresAsFloat depthOfSnow_type;
    typedef ::xsd::cxx::tree::optional< depthOfSnow_type > depthOfSnow_optional;
    typedef ::xsd::cxx::tree::traits< depthOfSnow_type, char > depthOfSnow_traits;

    const depthOfSnow_optional&
    depthOfSnow () const;

    depthOfSnow_optional&
    depthOfSnow ();

    void
    depthOfSnow (const depthOfSnow_type& x);

    void
    depthOfSnow (const depthOfSnow_optional& x);

    void
    depthOfSnow (::std::auto_ptr< depthOfSnow_type > p);

    // protectionTemperature
    // 
    typedef ::datex2::TemperatureCelsius protectionTemperature_type;
    typedef ::xsd::cxx::tree::optional< protectionTemperature_type > protectionTemperature_optional;
    typedef ::xsd::cxx::tree::traits< protectionTemperature_type, char > protectionTemperature_traits;

    const protectionTemperature_optional&
    protectionTemperature () const;

    protectionTemperature_optional&
    protectionTemperature ();

    void
    protectionTemperature (const protectionTemperature_type& x);

    void
    protectionTemperature (const protectionTemperature_optional& x);

    void
    protectionTemperature (::std::auto_ptr< protectionTemperature_type > p);

    // roadSurfaceTemperature
    // 
    typedef ::datex2::TemperatureCelsius roadSurfaceTemperature_type;
    typedef ::xsd::cxx::tree::optional< roadSurfaceTemperature_type > roadSurfaceTemperature_optional;
    typedef ::xsd::cxx::tree::traits< roadSurfaceTemperature_type, char > roadSurfaceTemperature_traits;

    const roadSurfaceTemperature_optional&
    roadSurfaceTemperature () const;

    roadSurfaceTemperature_optional&
    roadSurfaceTemperature ();

    void
    roadSurfaceTemperature (const roadSurfaceTemperature_type& x);

    void
    roadSurfaceTemperature (const roadSurfaceTemperature_optional& x);

    void
    roadSurfaceTemperature (::std::auto_ptr< roadSurfaceTemperature_type > p);

    // waterFilmThickness
    // 
    typedef ::datex2::MetresAsFloat waterFilmThickness_type;
    typedef ::xsd::cxx::tree::optional< waterFilmThickness_type > waterFilmThickness_optional;
    typedef ::xsd::cxx::tree::traits< waterFilmThickness_type, char > waterFilmThickness_traits;

    const waterFilmThickness_optional&
    waterFilmThickness () const;

    waterFilmThickness_optional&
    waterFilmThickness ();

    void
    waterFilmThickness (const waterFilmThickness_type& x);

    void
    waterFilmThickness (const waterFilmThickness_optional& x);

    void
    waterFilmThickness (::std::auto_ptr< waterFilmThickness_type > p);

    // roadSurfaceConditionMeasurementsExtension
    // 
    typedef ::datex2::ExtensionType roadSurfaceConditionMeasurementsExtension_type;
    typedef ::xsd::cxx::tree::optional< roadSurfaceConditionMeasurementsExtension_type > roadSurfaceConditionMeasurementsExtension_optional;
    typedef ::xsd::cxx::tree::traits< roadSurfaceConditionMeasurementsExtension_type, char > roadSurfaceConditionMeasurementsExtension_traits;

    const roadSurfaceConditionMeasurementsExtension_optional&
    roadSurfaceConditionMeasurementsExtension () const;

    roadSurfaceConditionMeasurementsExtension_optional&
    roadSurfaceConditionMeasurementsExtension ();

    void
    roadSurfaceConditionMeasurementsExtension (const roadSurfaceConditionMeasurementsExtension_type& x);

    void
    roadSurfaceConditionMeasurementsExtension (const roadSurfaceConditionMeasurementsExtension_optional& x);

    void
    roadSurfaceConditionMeasurementsExtension (::std::auto_ptr< roadSurfaceConditionMeasurementsExtension_type > p);

    // Constructors.
    //
    RoadSurfaceConditionMeasurements ();

    RoadSurfaceConditionMeasurements (const xercesc::DOMElement& e,
                                      ::xml_schema::flags f = 0,
                                      ::xml_schema::container* c = 0);

    RoadSurfaceConditionMeasurements (const RoadSurfaceConditionMeasurements& x,
                                      ::xml_schema::flags f = 0,
                                      ::xml_schema::container* c = 0);

    virtual RoadSurfaceConditionMeasurements*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RoadSurfaceConditionMeasurements ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    deIcingApplicationRate_optional deIcingApplicationRate_;
    deIcingConcentration_optional deIcingConcentration_;
    depthOfSnow_optional depthOfSnow_;
    protectionTemperature_optional protectionTemperature_;
    roadSurfaceTemperature_optional roadSurfaceTemperature_;
    waterFilmThickness_optional waterFilmThickness_;
    roadSurfaceConditionMeasurementsExtension_optional roadSurfaceConditionMeasurementsExtension_;
  };

  class RoadworksDurationEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      longTerm,
      mediumTerm,
      shortTerm
    };

    RoadworksDurationEnum (value v);

    RoadworksDurationEnum (const char* v);

    RoadworksDurationEnum (const ::std::string& v);

    RoadworksDurationEnum (const ::xml_schema::string& v);

    RoadworksDurationEnum (const xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    RoadworksDurationEnum (const xercesc::DOMAttr& a,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    RoadworksDurationEnum (const ::std::string& s,
                           const xercesc::DOMElement* e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    RoadworksDurationEnum (const RoadworksDurationEnum& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual RoadworksDurationEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    RoadworksDurationEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_RoadworksDurationEnum_convert ();
    }

    protected:
    value
    _xsd_RoadworksDurationEnum_convert () const;

    public:
    static const char* const _xsd_RoadworksDurationEnum_literals_[3];
    static const value _xsd_RoadworksDurationEnum_indexes_[3];
  };

  class RoadworksScaleEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      major,
      medium,
      minor
    };

    RoadworksScaleEnum (value v);

    RoadworksScaleEnum (const char* v);

    RoadworksScaleEnum (const ::std::string& v);

    RoadworksScaleEnum (const ::xml_schema::string& v);

    RoadworksScaleEnum (const xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    RoadworksScaleEnum (const xercesc::DOMAttr& a,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    RoadworksScaleEnum (const ::std::string& s,
                        const xercesc::DOMElement* e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    RoadworksScaleEnum (const RoadworksScaleEnum& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual RoadworksScaleEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    RoadworksScaleEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_RoadworksScaleEnum_convert ();
    }

    protected:
    value
    _xsd_RoadworksScaleEnum_convert () const;

    public:
    static const char* const _xsd_RoadworksScaleEnum_literals_[3];
    static const value _xsd_RoadworksScaleEnum_indexes_[3];
  };

  class Seconds: public ::datex2::Float
  {
    public:
    // Constructors.
    //
    Seconds (const ::xml_schema::float_&);

    Seconds (const xercesc::DOMElement& e,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    Seconds (const xercesc::DOMAttr& a,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    Seconds (const ::std::string& s,
             const xercesc::DOMElement* e,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    Seconds (const Seconds& x,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    virtual Seconds*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Seconds ();
  };

  class SiteMeasurements: public ::xml_schema::type
  {
    public:
    // measurementSiteReference
    // 
    typedef ::datex2::Reference measurementSiteReference_type;
    typedef ::xsd::cxx::tree::traits< measurementSiteReference_type, char > measurementSiteReference_traits;

    const measurementSiteReference_type&
    measurementSiteReference () const;

    measurementSiteReference_type&
    measurementSiteReference ();

    void
    measurementSiteReference (const measurementSiteReference_type& x);

    void
    measurementSiteReference (::std::auto_ptr< measurementSiteReference_type > p);

    // measurementTimeDefault
    // 
    typedef ::datex2::DateTime measurementTimeDefault_type;
    typedef ::xsd::cxx::tree::traits< measurementTimeDefault_type, char > measurementTimeDefault_traits;

    const measurementTimeDefault_type&
    measurementTimeDefault () const;

    measurementTimeDefault_type&
    measurementTimeDefault ();

    void
    measurementTimeDefault (const measurementTimeDefault_type& x);

    void
    measurementTimeDefault (::std::auto_ptr< measurementTimeDefault_type > p);

    // measuredValue
    // 
    typedef ::datex2::measuredValue measuredValue_type;
    typedef ::xsd::cxx::tree::sequence< measuredValue_type > measuredValue_sequence;
    typedef xsd::cxx::tree::sequence< measuredValue_type >::iterator measuredValue_iterator;
    typedef xsd::cxx::tree::sequence< measuredValue_type >::const_iterator measuredValue_const_iterator;
    typedef ::xsd::cxx::tree::traits< measuredValue_type, char > measuredValue_traits;

    const measuredValue_sequence&
    measuredValue () const;

    measuredValue_sequence&
    measuredValue ();

    void
    measuredValue (const measuredValue_sequence& s);

    // siteMeasurementsExtension
    // 
    typedef ::datex2::ExtensionType siteMeasurementsExtension_type;
    typedef ::xsd::cxx::tree::optional< siteMeasurementsExtension_type > siteMeasurementsExtension_optional;
    typedef ::xsd::cxx::tree::traits< siteMeasurementsExtension_type, char > siteMeasurementsExtension_traits;

    const siteMeasurementsExtension_optional&
    siteMeasurementsExtension () const;

    siteMeasurementsExtension_optional&
    siteMeasurementsExtension ();

    void
    siteMeasurementsExtension (const siteMeasurementsExtension_type& x);

    void
    siteMeasurementsExtension (const siteMeasurementsExtension_optional& x);

    void
    siteMeasurementsExtension (::std::auto_ptr< siteMeasurementsExtension_type > p);

    // Constructors.
    //
    SiteMeasurements (const measurementSiteReference_type&,
                      const measurementTimeDefault_type&);

    SiteMeasurements (const xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    SiteMeasurements (const SiteMeasurements& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual SiteMeasurements*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SiteMeasurements ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< measurementSiteReference_type > measurementSiteReference_;
    ::xsd::cxx::tree::one< measurementTimeDefault_type > measurementTimeDefault_;
    measuredValue_sequence measuredValue_;
    siteMeasurementsExtension_optional siteMeasurementsExtension_;
  };

  class Situation: public ::xml_schema::type
  {
    public:
    // overallSeverity
    // 
    typedef ::datex2::OverallSeverityEnum overallSeverity_type;
    typedef ::xsd::cxx::tree::optional< overallSeverity_type > overallSeverity_optional;
    typedef ::xsd::cxx::tree::traits< overallSeverity_type, char > overallSeverity_traits;

    const overallSeverity_optional&
    overallSeverity () const;

    overallSeverity_optional&
    overallSeverity ();

    void
    overallSeverity (const overallSeverity_type& x);

    void
    overallSeverity (const overallSeverity_optional& x);

    void
    overallSeverity (::std::auto_ptr< overallSeverity_type > p);

    // relatedSituation
    // 
    typedef ::datex2::Reference relatedSituation_type;
    typedef ::xsd::cxx::tree::sequence< relatedSituation_type > relatedSituation_sequence;
    typedef xsd::cxx::tree::sequence< relatedSituation_type >::iterator relatedSituation_iterator;
    typedef xsd::cxx::tree::sequence< relatedSituation_type >::const_iterator relatedSituation_const_iterator;
    typedef ::xsd::cxx::tree::traits< relatedSituation_type, char > relatedSituation_traits;

    const relatedSituation_sequence&
    relatedSituation () const;

    relatedSituation_sequence&
    relatedSituation ();

    void
    relatedSituation (const relatedSituation_sequence& s);

    // situationVersion
    // 
    typedef ::datex2::NonNegativeInteger situationVersion_type;
    typedef ::xsd::cxx::tree::optional< situationVersion_type > situationVersion_optional;
    typedef ::xsd::cxx::tree::traits< situationVersion_type, char > situationVersion_traits;

    const situationVersion_optional&
    situationVersion () const;

    situationVersion_optional&
    situationVersion ();

    void
    situationVersion (const situationVersion_type& x);

    void
    situationVersion (const situationVersion_optional& x);

    void
    situationVersion (::std::auto_ptr< situationVersion_type > p);

    // situationVersionTime
    // 
    typedef ::datex2::DateTime situationVersionTime_type;
    typedef ::xsd::cxx::tree::optional< situationVersionTime_type > situationVersionTime_optional;
    typedef ::xsd::cxx::tree::traits< situationVersionTime_type, char > situationVersionTime_traits;

    const situationVersionTime_optional&
    situationVersionTime () const;

    situationVersionTime_optional&
    situationVersionTime ();

    void
    situationVersionTime (const situationVersionTime_type& x);

    void
    situationVersionTime (const situationVersionTime_optional& x);

    void
    situationVersionTime (::std::auto_ptr< situationVersionTime_type > p);

    // headerInformation
    // 
    typedef ::datex2::HeaderInformation headerInformation_type;
    typedef ::xsd::cxx::tree::traits< headerInformation_type, char > headerInformation_traits;

    const headerInformation_type&
    headerInformation () const;

    headerInformation_type&
    headerInformation ();

    void
    headerInformation (const headerInformation_type& x);

    void
    headerInformation (::std::auto_ptr< headerInformation_type > p);

    // situationRecord
    // 
    typedef ::datex2::SituationRecord situationRecord_type;
    typedef ::xsd::cxx::tree::sequence< situationRecord_type > situationRecord_sequence;
    typedef xsd::cxx::tree::sequence< situationRecord_type >::iterator situationRecord_iterator;
    typedef xsd::cxx::tree::sequence< situationRecord_type >::const_iterator situationRecord_const_iterator;
    typedef ::xsd::cxx::tree::traits< situationRecord_type, char > situationRecord_traits;

    const situationRecord_sequence&
    situationRecord () const;

    situationRecord_sequence&
    situationRecord ();

    void
    situationRecord (const situationRecord_sequence& s);

    // situationExtension
    // 
    typedef ::datex2::ExtensionType situationExtension_type;
    typedef ::xsd::cxx::tree::optional< situationExtension_type > situationExtension_optional;
    typedef ::xsd::cxx::tree::traits< situationExtension_type, char > situationExtension_traits;

    const situationExtension_optional&
    situationExtension () const;

    situationExtension_optional&
    situationExtension ();

    void
    situationExtension (const situationExtension_type& x);

    void
    situationExtension (const situationExtension_optional& x);

    void
    situationExtension (::std::auto_ptr< situationExtension_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_type&
    id () const;

    id_type&
    id ();

    void
    id (const id_type& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    Situation (const headerInformation_type&,
               const id_type&);

    Situation (::std::auto_ptr< headerInformation_type >&,
               const id_type&);

    Situation (const xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    Situation (const Situation& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual Situation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Situation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    overallSeverity_optional overallSeverity_;
    relatedSituation_sequence relatedSituation_;
    situationVersion_optional situationVersion_;
    situationVersionTime_optional situationVersionTime_;
    ::xsd::cxx::tree::one< headerInformation_type > headerInformation_;
    situationRecord_sequence situationRecord_;
    situationExtension_optional situationExtension_;
    ::xsd::cxx::tree::one< id_type > id_;
  };

  class SituationPublication: public ::datex2::PayloadPublication
  {
    public:
    // situation
    // 
    typedef ::datex2::Situation situation_type;
    typedef ::xsd::cxx::tree::sequence< situation_type > situation_sequence;
    typedef xsd::cxx::tree::sequence< situation_type >::iterator situation_iterator;
    typedef xsd::cxx::tree::sequence< situation_type >::const_iterator situation_const_iterator;
    typedef ::xsd::cxx::tree::traits< situation_type, char > situation_traits;

    const situation_sequence&
    situation () const;

    situation_sequence&
    situation ();

    void
    situation (const situation_sequence& s);

    // situationPublicationExtension
    // 
    typedef ::datex2::ExtensionType situationPublicationExtension_type;
    typedef ::xsd::cxx::tree::optional< situationPublicationExtension_type > situationPublicationExtension_optional;
    typedef ::xsd::cxx::tree::traits< situationPublicationExtension_type, char > situationPublicationExtension_traits;

    const situationPublicationExtension_optional&
    situationPublicationExtension () const;

    situationPublicationExtension_optional&
    situationPublicationExtension ();

    void
    situationPublicationExtension (const situationPublicationExtension_type& x);

    void
    situationPublicationExtension (const situationPublicationExtension_optional& x);

    void
    situationPublicationExtension (::std::auto_ptr< situationPublicationExtension_type > p);

    // Constructors.
    //
    SituationPublication (const publicationTime_type&,
                          const publicationCreator_type&,
                          const lang_type&);

    SituationPublication (const publicationTime_type&,
                          ::std::auto_ptr< publicationCreator_type >&,
                          const lang_type&);

    SituationPublication (const xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    SituationPublication (const SituationPublication& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual SituationPublication*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SituationPublication ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    situation_sequence situation_;
    situationPublicationExtension_optional situationPublicationExtension_;
  };

  class Source: public ::xml_schema::type
  {
    public:
    // sourceCountry
    // 
    typedef ::datex2::CountryEnum sourceCountry_type;
    typedef ::xsd::cxx::tree::optional< sourceCountry_type > sourceCountry_optional;
    typedef ::xsd::cxx::tree::traits< sourceCountry_type, char > sourceCountry_traits;

    const sourceCountry_optional&
    sourceCountry () const;

    sourceCountry_optional&
    sourceCountry ();

    void
    sourceCountry (const sourceCountry_type& x);

    void
    sourceCountry (const sourceCountry_optional& x);

    void
    sourceCountry (::std::auto_ptr< sourceCountry_type > p);

    // sourceIdentification
    // 
    typedef ::datex2::String sourceIdentification_type;
    typedef ::xsd::cxx::tree::optional< sourceIdentification_type > sourceIdentification_optional;
    typedef ::xsd::cxx::tree::traits< sourceIdentification_type, char > sourceIdentification_traits;

    const sourceIdentification_optional&
    sourceIdentification () const;

    sourceIdentification_optional&
    sourceIdentification ();

    void
    sourceIdentification (const sourceIdentification_type& x);

    void
    sourceIdentification (const sourceIdentification_optional& x);

    void
    sourceIdentification (::std::auto_ptr< sourceIdentification_type > p);

    // sourceName
    // 
    typedef ::datex2::MultilingualString sourceName_type;
    typedef ::xsd::cxx::tree::optional< sourceName_type > sourceName_optional;
    typedef ::xsd::cxx::tree::traits< sourceName_type, char > sourceName_traits;

    const sourceName_optional&
    sourceName () const;

    sourceName_optional&
    sourceName ();

    void
    sourceName (const sourceName_type& x);

    void
    sourceName (const sourceName_optional& x);

    void
    sourceName (::std::auto_ptr< sourceName_type > p);

    // sourceType
    // 
    typedef ::datex2::SourceTypeEnum sourceType_type;
    typedef ::xsd::cxx::tree::optional< sourceType_type > sourceType_optional;
    typedef ::xsd::cxx::tree::traits< sourceType_type, char > sourceType_traits;

    const sourceType_optional&
    sourceType () const;

    sourceType_optional&
    sourceType ();

    void
    sourceType (const sourceType_type& x);

    void
    sourceType (const sourceType_optional& x);

    void
    sourceType (::std::auto_ptr< sourceType_type > p);

    // reliable
    // 
    typedef ::datex2::Boolean reliable_type;
    typedef ::xsd::cxx::tree::optional< reliable_type > reliable_optional;
    typedef ::xsd::cxx::tree::traits< reliable_type, char > reliable_traits;

    const reliable_optional&
    reliable () const;

    reliable_optional&
    reliable ();

    void
    reliable (const reliable_type& x);

    void
    reliable (const reliable_optional& x);

    void
    reliable (::std::auto_ptr< reliable_type > p);

    // sourceExtension
    // 
    typedef ::datex2::ExtensionType sourceExtension_type;
    typedef ::xsd::cxx::tree::optional< sourceExtension_type > sourceExtension_optional;
    typedef ::xsd::cxx::tree::traits< sourceExtension_type, char > sourceExtension_traits;

    const sourceExtension_optional&
    sourceExtension () const;

    sourceExtension_optional&
    sourceExtension ();

    void
    sourceExtension (const sourceExtension_type& x);

    void
    sourceExtension (const sourceExtension_optional& x);

    void
    sourceExtension (::std::auto_ptr< sourceExtension_type > p);

    // Constructors.
    //
    Source ();

    Source (const xercesc::DOMElement& e,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    Source (const Source& x,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    virtual Source*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Source ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    sourceCountry_optional sourceCountry_;
    sourceIdentification_optional sourceIdentification_;
    sourceName_optional sourceName_;
    sourceType_optional sourceType_;
    reliable_optional reliable_;
    sourceExtension_optional sourceExtension_;
  };

  class SourceTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      automobileClubPatrol,
      cameraObservation,
      freightVehicleOperator,
      inductionLoopMonitoringStation,
      infraredMonitoringStation,
      microwaveMonitoringStation,
      mobileTelephoneCaller,
      nonPoliceEmergencyServicePatrol,
      otherInformation,
      otherOfficialVehicle,
      policePatrol,
      privateBreakdownService,
      publicAndPrivateUtilities,
      registeredMotoristObserver,
      roadAuthorities,
      roadOperatorPatrol,
      roadsideTelephoneCaller,
      spotterAircraft,
      trafficMonitoringStation,
      transitOperator,
      vehicleProbeMeasurement,
      videoProcessingMonitoringStation
    };

    SourceTypeEnum (value v);

    SourceTypeEnum (const char* v);

    SourceTypeEnum (const ::std::string& v);

    SourceTypeEnum (const ::xml_schema::string& v);

    SourceTypeEnum (const xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    SourceTypeEnum (const xercesc::DOMAttr& a,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    SourceTypeEnum (const ::std::string& s,
                    const xercesc::DOMElement* e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    SourceTypeEnum (const SourceTypeEnum& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual SourceTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    SourceTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_SourceTypeEnum_convert ();
    }

    protected:
    value
    _xsd_SourceTypeEnum_convert () const;

    public:
    static const char* const _xsd_SourceTypeEnum_literals_[22];
    static const value _xsd_SourceTypeEnum_indexes_[22];
  };

  class SpeedManagement: public ::datex2::NetworkManagement
  {
    public:
    // speedManagementType
    // 
    typedef ::datex2::SpeedManagementTypeEnum speedManagementType_type;
    typedef ::xsd::cxx::tree::optional< speedManagementType_type > speedManagementType_optional;
    typedef ::xsd::cxx::tree::traits< speedManagementType_type, char > speedManagementType_traits;

    const speedManagementType_optional&
    speedManagementType () const;

    speedManagementType_optional&
    speedManagementType ();

    void
    speedManagementType (const speedManagementType_type& x);

    void
    speedManagementType (const speedManagementType_optional& x);

    void
    speedManagementType (::std::auto_ptr< speedManagementType_type > p);

    // temporarySpeedLimit
    // 
    typedef ::datex2::KilometresPerHour temporarySpeedLimit_type;
    typedef ::xsd::cxx::tree::optional< temporarySpeedLimit_type > temporarySpeedLimit_optional;
    typedef ::xsd::cxx::tree::traits< temporarySpeedLimit_type, char > temporarySpeedLimit_traits;

    const temporarySpeedLimit_optional&
    temporarySpeedLimit () const;

    temporarySpeedLimit_optional&
    temporarySpeedLimit ();

    void
    temporarySpeedLimit (const temporarySpeedLimit_type& x);

    void
    temporarySpeedLimit (const temporarySpeedLimit_optional& x);

    void
    temporarySpeedLimit (::std::auto_ptr< temporarySpeedLimit_type > p);

    // speedManagementExtension
    // 
    typedef ::datex2::ExtensionType speedManagementExtension_type;
    typedef ::xsd::cxx::tree::optional< speedManagementExtension_type > speedManagementExtension_optional;
    typedef ::xsd::cxx::tree::traits< speedManagementExtension_type, char > speedManagementExtension_traits;

    const speedManagementExtension_optional&
    speedManagementExtension () const;

    speedManagementExtension_optional&
    speedManagementExtension ();

    void
    speedManagementExtension (const speedManagementExtension_type& x);

    void
    speedManagementExtension (const speedManagementExtension_optional& x);

    void
    speedManagementExtension (::std::auto_ptr< speedManagementExtension_type > p);

    // Constructors.
    //
    SpeedManagement (const situationRecordCreationTime_type&,
                     const situationRecordVersion_type&,
                     const situationRecordVersionTime_type&,
                     const probabilityOfOccurrence_type&,
                     const validity_type&,
                     const groupOfLocations_type&,
                     const id_type&,
                     const complianceOption_type&);

    SpeedManagement (const situationRecordCreationTime_type&,
                     const situationRecordVersion_type&,
                     const situationRecordVersionTime_type&,
                     const probabilityOfOccurrence_type&,
                     ::std::auto_ptr< validity_type >&,
                     ::std::auto_ptr< groupOfLocations_type >&,
                     const id_type&,
                     const complianceOption_type&);

    SpeedManagement (const xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    SpeedManagement (const SpeedManagement& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual SpeedManagement*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SpeedManagement ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    speedManagementType_optional speedManagementType_;
    temporarySpeedLimit_optional temporarySpeedLimit_;
    speedManagementExtension_optional speedManagementExtension_;
  };

  class SpeedManagementTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      activeSpeedControlInOperation,
      doNotSlowdownUnnecessarily,
      observeSpeedLimit,
      policeSpeedChecksInOperation,
      reduceYourSpeed,
      other
    };

    SpeedManagementTypeEnum (value v);

    SpeedManagementTypeEnum (const char* v);

    SpeedManagementTypeEnum (const ::std::string& v);

    SpeedManagementTypeEnum (const ::xml_schema::string& v);

    SpeedManagementTypeEnum (const xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    SpeedManagementTypeEnum (const xercesc::DOMAttr& a,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    SpeedManagementTypeEnum (const ::std::string& s,
                             const xercesc::DOMElement* e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    SpeedManagementTypeEnum (const SpeedManagementTypeEnum& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual SpeedManagementTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    SpeedManagementTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_SpeedManagementTypeEnum_convert ();
    }

    protected:
    value
    _xsd_SpeedManagementTypeEnum_convert () const;

    public:
    static const char* const _xsd_SpeedManagementTypeEnum_literals_[6];
    static const value _xsd_SpeedManagementTypeEnum_indexes_[6];
  };

  class SpeedPercentile: public ::xml_schema::type
  {
    public:
    // vehiclePercentage
    // 
    typedef ::datex2::Percentage vehiclePercentage_type;
    typedef ::xsd::cxx::tree::traits< vehiclePercentage_type, char > vehiclePercentage_traits;

    const vehiclePercentage_type&
    vehiclePercentage () const;

    vehiclePercentage_type&
    vehiclePercentage ();

    void
    vehiclePercentage (const vehiclePercentage_type& x);

    void
    vehiclePercentage (::std::auto_ptr< vehiclePercentage_type > p);

    // speedPercentile
    // 
    typedef ::datex2::KilometresPerHour speedPercentile_type;
    typedef ::xsd::cxx::tree::traits< speedPercentile_type, char > speedPercentile_traits;

    const speedPercentile_type&
    speedPercentile () const;

    speedPercentile_type&
    speedPercentile ();

    void
    speedPercentile (const speedPercentile_type& x);

    void
    speedPercentile (::std::auto_ptr< speedPercentile_type > p);

    // speedPercentileExtension
    // 
    typedef ::datex2::ExtensionType speedPercentileExtension_type;
    typedef ::xsd::cxx::tree::optional< speedPercentileExtension_type > speedPercentileExtension_optional;
    typedef ::xsd::cxx::tree::traits< speedPercentileExtension_type, char > speedPercentileExtension_traits;

    const speedPercentileExtension_optional&
    speedPercentileExtension () const;

    speedPercentileExtension_optional&
    speedPercentileExtension ();

    void
    speedPercentileExtension (const speedPercentileExtension_type& x);

    void
    speedPercentileExtension (const speedPercentileExtension_optional& x);

    void
    speedPercentileExtension (::std::auto_ptr< speedPercentileExtension_type > p);

    // Constructors.
    //
    SpeedPercentile (const vehiclePercentage_type&,
                     const speedPercentile_type&);

    SpeedPercentile (const xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    SpeedPercentile (const SpeedPercentile& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual SpeedPercentile*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SpeedPercentile ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< vehiclePercentage_type > vehiclePercentage_;
    ::xsd::cxx::tree::one< speedPercentile_type > speedPercentile_;
    speedPercentileExtension_optional speedPercentileExtension_;
  };

  class Subjects: public ::xml_schema::type
  {
    public:
    // subjectTypeOfWorks
    // 
    typedef ::datex2::SubjectTypeOfWorksEnum subjectTypeOfWorks_type;
    typedef ::xsd::cxx::tree::traits< subjectTypeOfWorks_type, char > subjectTypeOfWorks_traits;

    const subjectTypeOfWorks_type&
    subjectTypeOfWorks () const;

    subjectTypeOfWorks_type&
    subjectTypeOfWorks ();

    void
    subjectTypeOfWorks (const subjectTypeOfWorks_type& x);

    void
    subjectTypeOfWorks (::std::auto_ptr< subjectTypeOfWorks_type > p);

    // numberOfSubjects
    // 
    typedef ::datex2::NonNegativeInteger numberOfSubjects_type;
    typedef ::xsd::cxx::tree::optional< numberOfSubjects_type > numberOfSubjects_optional;
    typedef ::xsd::cxx::tree::traits< numberOfSubjects_type, char > numberOfSubjects_traits;

    const numberOfSubjects_optional&
    numberOfSubjects () const;

    numberOfSubjects_optional&
    numberOfSubjects ();

    void
    numberOfSubjects (const numberOfSubjects_type& x);

    void
    numberOfSubjects (const numberOfSubjects_optional& x);

    void
    numberOfSubjects (::std::auto_ptr< numberOfSubjects_type > p);

    // subjectsExtension
    // 
    typedef ::datex2::ExtensionType subjectsExtension_type;
    typedef ::xsd::cxx::tree::optional< subjectsExtension_type > subjectsExtension_optional;
    typedef ::xsd::cxx::tree::traits< subjectsExtension_type, char > subjectsExtension_traits;

    const subjectsExtension_optional&
    subjectsExtension () const;

    subjectsExtension_optional&
    subjectsExtension ();

    void
    subjectsExtension (const subjectsExtension_type& x);

    void
    subjectsExtension (const subjectsExtension_optional& x);

    void
    subjectsExtension (::std::auto_ptr< subjectsExtension_type > p);

    // Constructors.
    //
    Subjects (const subjectTypeOfWorks_type&);

    Subjects (const xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    Subjects (const Subjects& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual Subjects*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Subjects ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< subjectTypeOfWorks_type > subjectTypeOfWorks_;
    numberOfSubjects_optional numberOfSubjects_;
    subjectsExtension_optional subjectsExtension_;
  };

  class SubjectTypeOfWorksEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      bridge,
      buriedCables,
      buriedServices,
      crashBarrier,
      gallery,
      gantry,
      gasMainWork,
      interchange,
      junction,
      levelCrossing,
      lightingSystem,
      measurementEquipment,
      noiseProtection,
      road,
      roadsideDrains,
      roadsideEmbankment,
      roadsideEquipment,
      roadSigns,
      roundabout,
      tollGate,
      tunnel,
      waterMain,
      other
    };

    SubjectTypeOfWorksEnum (value v);

    SubjectTypeOfWorksEnum (const char* v);

    SubjectTypeOfWorksEnum (const ::std::string& v);

    SubjectTypeOfWorksEnum (const ::xml_schema::string& v);

    SubjectTypeOfWorksEnum (const xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    SubjectTypeOfWorksEnum (const xercesc::DOMAttr& a,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    SubjectTypeOfWorksEnum (const ::std::string& s,
                            const xercesc::DOMElement* e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    SubjectTypeOfWorksEnum (const SubjectTypeOfWorksEnum& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual SubjectTypeOfWorksEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    SubjectTypeOfWorksEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_SubjectTypeOfWorksEnum_convert ();
    }

    protected:
    value
    _xsd_SubjectTypeOfWorksEnum_convert () const;

    public:
    static const char* const _xsd_SubjectTypeOfWorksEnum_literals_[23];
    static const value _xsd_SubjectTypeOfWorksEnum_indexes_[23];
  };

  class Subscription: public ::xml_schema::type
  {
    public:
    // deleteSubscription
    // 
    typedef ::datex2::Boolean deleteSubscription_type;
    typedef ::xsd::cxx::tree::optional< deleteSubscription_type > deleteSubscription_optional;
    typedef ::xsd::cxx::tree::traits< deleteSubscription_type, char > deleteSubscription_traits;

    const deleteSubscription_optional&
    deleteSubscription () const;

    deleteSubscription_optional&
    deleteSubscription ();

    void
    deleteSubscription (const deleteSubscription_type& x);

    void
    deleteSubscription (const deleteSubscription_optional& x);

    void
    deleteSubscription (::std::auto_ptr< deleteSubscription_type > p);

    // deliveryInterval
    // 
    typedef ::datex2::Seconds deliveryInterval_type;
    typedef ::xsd::cxx::tree::optional< deliveryInterval_type > deliveryInterval_optional;
    typedef ::xsd::cxx::tree::traits< deliveryInterval_type, char > deliveryInterval_traits;

    const deliveryInterval_optional&
    deliveryInterval () const;

    deliveryInterval_optional&
    deliveryInterval ();

    void
    deliveryInterval (const deliveryInterval_type& x);

    void
    deliveryInterval (const deliveryInterval_optional& x);

    void
    deliveryInterval (::std::auto_ptr< deliveryInterval_type > p);

    // operatingMode
    // 
    typedef ::datex2::OperatingModeEnum operatingMode_type;
    typedef ::xsd::cxx::tree::traits< operatingMode_type, char > operatingMode_traits;

    const operatingMode_type&
    operatingMode () const;

    operatingMode_type&
    operatingMode ();

    void
    operatingMode (const operatingMode_type& x);

    void
    operatingMode (::std::auto_ptr< operatingMode_type > p);

    // subscriptionStartTime
    // 
    typedef ::datex2::DateTime subscriptionStartTime_type;
    typedef ::xsd::cxx::tree::traits< subscriptionStartTime_type, char > subscriptionStartTime_traits;

    const subscriptionStartTime_type&
    subscriptionStartTime () const;

    subscriptionStartTime_type&
    subscriptionStartTime ();

    void
    subscriptionStartTime (const subscriptionStartTime_type& x);

    void
    subscriptionStartTime (::std::auto_ptr< subscriptionStartTime_type > p);

    // subscriptionState
    // 
    typedef ::datex2::SubscriptionStateEnum subscriptionState_type;
    typedef ::xsd::cxx::tree::traits< subscriptionState_type, char > subscriptionState_traits;

    const subscriptionState_type&
    subscriptionState () const;

    subscriptionState_type&
    subscriptionState ();

    void
    subscriptionState (const subscriptionState_type& x);

    void
    subscriptionState (::std::auto_ptr< subscriptionState_type > p);

    // subscriptionStopTime
    // 
    typedef ::datex2::DateTime subscriptionStopTime_type;
    typedef ::xsd::cxx::tree::optional< subscriptionStopTime_type > subscriptionStopTime_optional;
    typedef ::xsd::cxx::tree::traits< subscriptionStopTime_type, char > subscriptionStopTime_traits;

    const subscriptionStopTime_optional&
    subscriptionStopTime () const;

    subscriptionStopTime_optional&
    subscriptionStopTime ();

    void
    subscriptionStopTime (const subscriptionStopTime_type& x);

    void
    subscriptionStopTime (const subscriptionStopTime_optional& x);

    void
    subscriptionStopTime (::std::auto_ptr< subscriptionStopTime_type > p);

    // updateMethod
    // 
    typedef ::datex2::UpdateMethodEnum updateMethod_type;
    typedef ::xsd::cxx::tree::traits< updateMethod_type, char > updateMethod_traits;

    const updateMethod_type&
    updateMethod () const;

    updateMethod_type&
    updateMethod ();

    void
    updateMethod (const updateMethod_type& x);

    void
    updateMethod (::std::auto_ptr< updateMethod_type > p);

    // target
    // 
    typedef ::datex2::Target target_type;
    typedef ::xsd::cxx::tree::sequence< target_type > target_sequence;
    typedef xsd::cxx::tree::sequence< target_type >::iterator target_iterator;
    typedef xsd::cxx::tree::sequence< target_type >::const_iterator target_const_iterator;
    typedef ::xsd::cxx::tree::traits< target_type, char > target_traits;

    const target_sequence&
    target () const;

    target_sequence&
    target ();

    void
    target (const target_sequence& s);

    // filterReference
    // 
    typedef ::datex2::FilterReference filterReference_type;
    typedef ::xsd::cxx::tree::optional< filterReference_type > filterReference_optional;
    typedef ::xsd::cxx::tree::traits< filterReference_type, char > filterReference_traits;

    const filterReference_optional&
    filterReference () const;

    filterReference_optional&
    filterReference ();

    void
    filterReference (const filterReference_type& x);

    void
    filterReference (const filterReference_optional& x);

    void
    filterReference (::std::auto_ptr< filterReference_type > p);

    // catalogueReference
    // 
    typedef ::datex2::CatalogueReference catalogueReference_type;
    typedef ::xsd::cxx::tree::optional< catalogueReference_type > catalogueReference_optional;
    typedef ::xsd::cxx::tree::traits< catalogueReference_type, char > catalogueReference_traits;

    const catalogueReference_optional&
    catalogueReference () const;

    catalogueReference_optional&
    catalogueReference ();

    void
    catalogueReference (const catalogueReference_type& x);

    void
    catalogueReference (const catalogueReference_optional& x);

    void
    catalogueReference (::std::auto_ptr< catalogueReference_type > p);

    // subscriptionExtension
    // 
    typedef ::datex2::ExtensionType subscriptionExtension_type;
    typedef ::xsd::cxx::tree::optional< subscriptionExtension_type > subscriptionExtension_optional;
    typedef ::xsd::cxx::tree::traits< subscriptionExtension_type, char > subscriptionExtension_traits;

    const subscriptionExtension_optional&
    subscriptionExtension () const;

    subscriptionExtension_optional&
    subscriptionExtension ();

    void
    subscriptionExtension (const subscriptionExtension_type& x);

    void
    subscriptionExtension (const subscriptionExtension_optional& x);

    void
    subscriptionExtension (::std::auto_ptr< subscriptionExtension_type > p);

    // Constructors.
    //
    Subscription (const operatingMode_type&,
                  const subscriptionStartTime_type&,
                  const subscriptionState_type&,
                  const updateMethod_type&);

    Subscription (const xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    Subscription (const Subscription& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual Subscription*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Subscription ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    deleteSubscription_optional deleteSubscription_;
    deliveryInterval_optional deliveryInterval_;
    ::xsd::cxx::tree::one< operatingMode_type > operatingMode_;
    ::xsd::cxx::tree::one< subscriptionStartTime_type > subscriptionStartTime_;
    ::xsd::cxx::tree::one< subscriptionState_type > subscriptionState_;
    subscriptionStopTime_optional subscriptionStopTime_;
    ::xsd::cxx::tree::one< updateMethod_type > updateMethod_;
    target_sequence target_;
    filterReference_optional filterReference_;
    catalogueReference_optional catalogueReference_;
    subscriptionExtension_optional subscriptionExtension_;
  };

  class SubscriptionStateEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      active,
      suspended
    };

    SubscriptionStateEnum (value v);

    SubscriptionStateEnum (const char* v);

    SubscriptionStateEnum (const ::std::string& v);

    SubscriptionStateEnum (const ::xml_schema::string& v);

    SubscriptionStateEnum (const xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    SubscriptionStateEnum (const xercesc::DOMAttr& a,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    SubscriptionStateEnum (const ::std::string& s,
                           const xercesc::DOMElement* e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    SubscriptionStateEnum (const SubscriptionStateEnum& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual SubscriptionStateEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    SubscriptionStateEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_SubscriptionStateEnum_convert ();
    }

    protected:
    value
    _xsd_SubscriptionStateEnum_convert () const;

    public:
    static const char* const _xsd_SubscriptionStateEnum_literals_[2];
    static const value _xsd_SubscriptionStateEnum_indexes_[2];
  };

  class SupplementaryPositionalDescription: public ::xml_schema::type
  {
    public:
    // carriageway
    // 
    typedef ::datex2::CarriagewayEnum carriageway_type;
    typedef ::xsd::cxx::tree::sequence< carriageway_type > carriageway_sequence;
    typedef xsd::cxx::tree::sequence< carriageway_type >::iterator carriageway_iterator;
    typedef xsd::cxx::tree::sequence< carriageway_type >::const_iterator carriageway_const_iterator;
    typedef ::xsd::cxx::tree::traits< carriageway_type, char > carriageway_traits;

    const carriageway_sequence&
    carriageway () const;

    carriageway_sequence&
    carriageway ();

    void
    carriageway (const carriageway_sequence& s);

    // footpath
    // 
    typedef ::datex2::Boolean footpath_type;
    typedef ::xsd::cxx::tree::optional< footpath_type > footpath_optional;
    typedef ::xsd::cxx::tree::traits< footpath_type, char > footpath_traits;

    const footpath_optional&
    footpath () const;

    footpath_optional&
    footpath ();

    void
    footpath (const footpath_type& x);

    void
    footpath (const footpath_optional& x);

    void
    footpath (::std::auto_ptr< footpath_type > p);

    // lane
    // 
    typedef ::datex2::LaneEnum lane_type;
    typedef ::xsd::cxx::tree::sequence< lane_type > lane_sequence;
    typedef xsd::cxx::tree::sequence< lane_type >::iterator lane_iterator;
    typedef xsd::cxx::tree::sequence< lane_type >::const_iterator lane_const_iterator;
    typedef ::xsd::cxx::tree::traits< lane_type, char > lane_traits;

    const lane_sequence&
    lane () const;

    lane_sequence&
    lane ();

    void
    lane (const lane_sequence& s);

    // lengthAffected
    // 
    typedef ::datex2::MetresAsFloat lengthAffected_type;
    typedef ::xsd::cxx::tree::optional< lengthAffected_type > lengthAffected_optional;
    typedef ::xsd::cxx::tree::traits< lengthAffected_type, char > lengthAffected_traits;

    const lengthAffected_optional&
    lengthAffected () const;

    lengthAffected_optional&
    lengthAffected ();

    void
    lengthAffected (const lengthAffected_type& x);

    void
    lengthAffected (const lengthAffected_optional& x);

    void
    lengthAffected (::std::auto_ptr< lengthAffected_type > p);

    // locationDescriptor
    // 
    typedef ::datex2::LocationDescriptorEnum locationDescriptor_type;
    typedef ::xsd::cxx::tree::sequence< locationDescriptor_type > locationDescriptor_sequence;
    typedef xsd::cxx::tree::sequence< locationDescriptor_type >::iterator locationDescriptor_iterator;
    typedef xsd::cxx::tree::sequence< locationDescriptor_type >::const_iterator locationDescriptor_const_iterator;
    typedef ::xsd::cxx::tree::traits< locationDescriptor_type, char > locationDescriptor_traits;

    const locationDescriptor_sequence&
    locationDescriptor () const;

    locationDescriptor_sequence&
    locationDescriptor ();

    void
    locationDescriptor (const locationDescriptor_sequence& s);

    // locationPrecision
    // 
    typedef ::datex2::MetresAsNonNegativeInteger locationPrecision_type;
    typedef ::xsd::cxx::tree::optional< locationPrecision_type > locationPrecision_optional;
    typedef ::xsd::cxx::tree::traits< locationPrecision_type, char > locationPrecision_traits;

    const locationPrecision_optional&
    locationPrecision () const;

    locationPrecision_optional&
    locationPrecision ();

    void
    locationPrecision (const locationPrecision_type& x);

    void
    locationPrecision (const locationPrecision_optional& x);

    void
    locationPrecision (::std::auto_ptr< locationPrecision_type > p);

    // sequentialRampNumber
    // 
    typedef ::datex2::NonNegativeInteger sequentialRampNumber_type;
    typedef ::xsd::cxx::tree::optional< sequentialRampNumber_type > sequentialRampNumber_optional;
    typedef ::xsd::cxx::tree::traits< sequentialRampNumber_type, char > sequentialRampNumber_traits;

    const sequentialRampNumber_optional&
    sequentialRampNumber () const;

    sequentialRampNumber_optional&
    sequentialRampNumber ();

    void
    sequentialRampNumber (const sequentialRampNumber_type& x);

    void
    sequentialRampNumber (const sequentialRampNumber_optional& x);

    void
    sequentialRampNumber (::std::auto_ptr< sequentialRampNumber_type > p);

    // supplementaryPositionalDescriptionExtension
    // 
    typedef ::datex2::ExtensionType supplementaryPositionalDescriptionExtension_type;
    typedef ::xsd::cxx::tree::optional< supplementaryPositionalDescriptionExtension_type > supplementaryPositionalDescriptionExtension_optional;
    typedef ::xsd::cxx::tree::traits< supplementaryPositionalDescriptionExtension_type, char > supplementaryPositionalDescriptionExtension_traits;

    const supplementaryPositionalDescriptionExtension_optional&
    supplementaryPositionalDescriptionExtension () const;

    supplementaryPositionalDescriptionExtension_optional&
    supplementaryPositionalDescriptionExtension ();

    void
    supplementaryPositionalDescriptionExtension (const supplementaryPositionalDescriptionExtension_type& x);

    void
    supplementaryPositionalDescriptionExtension (const supplementaryPositionalDescriptionExtension_optional& x);

    void
    supplementaryPositionalDescriptionExtension (::std::auto_ptr< supplementaryPositionalDescriptionExtension_type > p);

    // Constructors.
    //
    SupplementaryPositionalDescription ();

    SupplementaryPositionalDescription (const xercesc::DOMElement& e,
                                        ::xml_schema::flags f = 0,
                                        ::xml_schema::container* c = 0);

    SupplementaryPositionalDescription (const SupplementaryPositionalDescription& x,
                                        ::xml_schema::flags f = 0,
                                        ::xml_schema::container* c = 0);

    virtual SupplementaryPositionalDescription*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SupplementaryPositionalDescription ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    carriageway_sequence carriageway_;
    footpath_optional footpath_;
    lane_sequence lane_;
    lengthAffected_optional lengthAffected_;
    locationDescriptor_sequence locationDescriptor_;
    locationPrecision_optional locationPrecision_;
    sequentialRampNumber_optional sequentialRampNumber_;
    supplementaryPositionalDescriptionExtension_optional supplementaryPositionalDescriptionExtension_;
  };

  class Target: public ::xml_schema::type
  {
    public:
    // address
    // 
    typedef ::datex2::String address_type;
    typedef ::xsd::cxx::tree::traits< address_type, char > address_traits;

    const address_type&
    address () const;

    address_type&
    address ();

    void
    address (const address_type& x);

    void
    address (::std::auto_ptr< address_type > p);

    // protocol
    // 
    typedef ::datex2::String protocol_type;
    typedef ::xsd::cxx::tree::traits< protocol_type, char > protocol_traits;

    const protocol_type&
    protocol () const;

    protocol_type&
    protocol ();

    void
    protocol (const protocol_type& x);

    void
    protocol (::std::auto_ptr< protocol_type > p);

    // targetExtension
    // 
    typedef ::datex2::ExtensionType targetExtension_type;
    typedef ::xsd::cxx::tree::optional< targetExtension_type > targetExtension_optional;
    typedef ::xsd::cxx::tree::traits< targetExtension_type, char > targetExtension_traits;

    const targetExtension_optional&
    targetExtension () const;

    targetExtension_optional&
    targetExtension ();

    void
    targetExtension (const targetExtension_type& x);

    void
    targetExtension (const targetExtension_optional& x);

    void
    targetExtension (::std::auto_ptr< targetExtension_type > p);

    // Constructors.
    //
    Target (const address_type&,
            const protocol_type&);

    Target (const xercesc::DOMElement& e,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    Target (const Target& x,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    virtual Target*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Target ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< address_type > address_;
    ::xsd::cxx::tree::one< protocol_type > protocol_;
    targetExtension_optional targetExtension_;
  };

  class Temperature: public ::xml_schema::type
  {
    public:
    // airTemperature
    // 
    typedef ::datex2::TemperatureCelsius airTemperature_type;
    typedef ::xsd::cxx::tree::optional< airTemperature_type > airTemperature_optional;
    typedef ::xsd::cxx::tree::traits< airTemperature_type, char > airTemperature_traits;

    const airTemperature_optional&
    airTemperature () const;

    airTemperature_optional&
    airTemperature ();

    void
    airTemperature (const airTemperature_type& x);

    void
    airTemperature (const airTemperature_optional& x);

    void
    airTemperature (::std::auto_ptr< airTemperature_type > p);

    // dewPointTemperature
    // 
    typedef ::datex2::TemperatureCelsius dewPointTemperature_type;
    typedef ::xsd::cxx::tree::optional< dewPointTemperature_type > dewPointTemperature_optional;
    typedef ::xsd::cxx::tree::traits< dewPointTemperature_type, char > dewPointTemperature_traits;

    const dewPointTemperature_optional&
    dewPointTemperature () const;

    dewPointTemperature_optional&
    dewPointTemperature ();

    void
    dewPointTemperature (const dewPointTemperature_type& x);

    void
    dewPointTemperature (const dewPointTemperature_optional& x);

    void
    dewPointTemperature (::std::auto_ptr< dewPointTemperature_type > p);

    // maximumTemperature
    // 
    typedef ::datex2::TemperatureCelsius maximumTemperature_type;
    typedef ::xsd::cxx::tree::optional< maximumTemperature_type > maximumTemperature_optional;
    typedef ::xsd::cxx::tree::traits< maximumTemperature_type, char > maximumTemperature_traits;

    const maximumTemperature_optional&
    maximumTemperature () const;

    maximumTemperature_optional&
    maximumTemperature ();

    void
    maximumTemperature (const maximumTemperature_type& x);

    void
    maximumTemperature (const maximumTemperature_optional& x);

    void
    maximumTemperature (::std::auto_ptr< maximumTemperature_type > p);

    // minimumTemperature
    // 
    typedef ::datex2::TemperatureCelsius minimumTemperature_type;
    typedef ::xsd::cxx::tree::optional< minimumTemperature_type > minimumTemperature_optional;
    typedef ::xsd::cxx::tree::traits< minimumTemperature_type, char > minimumTemperature_traits;

    const minimumTemperature_optional&
    minimumTemperature () const;

    minimumTemperature_optional&
    minimumTemperature ();

    void
    minimumTemperature (const minimumTemperature_type& x);

    void
    minimumTemperature (const minimumTemperature_optional& x);

    void
    minimumTemperature (::std::auto_ptr< minimumTemperature_type > p);

    // temperatureExtension
    // 
    typedef ::datex2::ExtensionType temperatureExtension_type;
    typedef ::xsd::cxx::tree::optional< temperatureExtension_type > temperatureExtension_optional;
    typedef ::xsd::cxx::tree::traits< temperatureExtension_type, char > temperatureExtension_traits;

    const temperatureExtension_optional&
    temperatureExtension () const;

    temperatureExtension_optional&
    temperatureExtension ();

    void
    temperatureExtension (const temperatureExtension_type& x);

    void
    temperatureExtension (const temperatureExtension_optional& x);

    void
    temperatureExtension (::std::auto_ptr< temperatureExtension_type > p);

    // Constructors.
    //
    Temperature ();

    Temperature (const xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    Temperature (const Temperature& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual Temperature*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Temperature ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    airTemperature_optional airTemperature_;
    dewPointTemperature_optional dewPointTemperature_;
    maximumTemperature_optional maximumTemperature_;
    minimumTemperature_optional minimumTemperature_;
    temperatureExtension_optional temperatureExtension_;
  };

  class TemperatureCelsius: public ::datex2::Float
  {
    public:
    // Constructors.
    //
    TemperatureCelsius (const ::xml_schema::float_&);

    TemperatureCelsius (const xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    TemperatureCelsius (const xercesc::DOMAttr& a,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    TemperatureCelsius (const ::std::string& s,
                        const xercesc::DOMElement* e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    TemperatureCelsius (const TemperatureCelsius& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual TemperatureCelsius*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TemperatureCelsius ();
  };

  class TemperatureInformation: public ::datex2::WeatherValue
  {
    public:
    // temperature
    // 
    typedef ::datex2::Temperature temperature_type;
    typedef ::xsd::cxx::tree::traits< temperature_type, char > temperature_traits;

    const temperature_type&
    temperature () const;

    temperature_type&
    temperature ();

    void
    temperature (const temperature_type& x);

    void
    temperature (::std::auto_ptr< temperature_type > p);

    // temperatureInformationExtension
    // 
    typedef ::datex2::ExtensionType temperatureInformationExtension_type;
    typedef ::xsd::cxx::tree::optional< temperatureInformationExtension_type > temperatureInformationExtension_optional;
    typedef ::xsd::cxx::tree::traits< temperatureInformationExtension_type, char > temperatureInformationExtension_traits;

    const temperatureInformationExtension_optional&
    temperatureInformationExtension () const;

    temperatureInformationExtension_optional&
    temperatureInformationExtension ();

    void
    temperatureInformationExtension (const temperatureInformationExtension_type& x);

    void
    temperatureInformationExtension (const temperatureInformationExtension_optional& x);

    void
    temperatureInformationExtension (::std::auto_ptr< temperatureInformationExtension_type > p);

    // Constructors.
    //
    TemperatureInformation (const temperature_type&);

    TemperatureInformation (::std::auto_ptr< temperature_type >&);

    TemperatureInformation (const xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    TemperatureInformation (const TemperatureInformation& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual TemperatureInformation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TemperatureInformation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< temperature_type > temperature_;
    temperatureInformationExtension_optional temperatureInformationExtension_;
  };

  class Time: public ::xml_schema::time
  {
    public:
    // Constructors.
    //
    Time (const ::xml_schema::time&);

    Time (const xercesc::DOMElement& e,
          ::xml_schema::flags f = 0,
          ::xml_schema::container* c = 0);

    Time (const xercesc::DOMAttr& a,
          ::xml_schema::flags f = 0,
          ::xml_schema::container* c = 0);

    Time (const ::std::string& s,
          const xercesc::DOMElement* e,
          ::xml_schema::flags f = 0,
          ::xml_schema::container* c = 0);

    Time (const Time& x,
          ::xml_schema::flags f = 0,
          ::xml_schema::container* c = 0);

    virtual Time*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Time ();
  };

  class TimePeriodOfDay: public ::xml_schema::type
  {
    public:
    // timePeriodOfDayExtension
    // 
    typedef ::datex2::ExtensionType timePeriodOfDayExtension_type;
    typedef ::xsd::cxx::tree::optional< timePeriodOfDayExtension_type > timePeriodOfDayExtension_optional;
    typedef ::xsd::cxx::tree::traits< timePeriodOfDayExtension_type, char > timePeriodOfDayExtension_traits;

    const timePeriodOfDayExtension_optional&
    timePeriodOfDayExtension () const;

    timePeriodOfDayExtension_optional&
    timePeriodOfDayExtension ();

    void
    timePeriodOfDayExtension (const timePeriodOfDayExtension_type& x);

    void
    timePeriodOfDayExtension (const timePeriodOfDayExtension_optional& x);

    void
    timePeriodOfDayExtension (::std::auto_ptr< timePeriodOfDayExtension_type > p);

    // Constructors.
    //
    TimePeriodOfDay ();

    TimePeriodOfDay (const xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    TimePeriodOfDay (const TimePeriodOfDay& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual TimePeriodOfDay*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TimePeriodOfDay ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    timePeriodOfDayExtension_optional timePeriodOfDayExtension_;
  };

  class TimePeriodByHour: public ::datex2::TimePeriodOfDay
  {
    public:
    // startTimeOfPeriod
    // 
    typedef ::datex2::Time startTimeOfPeriod_type;
    typedef ::xsd::cxx::tree::traits< startTimeOfPeriod_type, char > startTimeOfPeriod_traits;

    const startTimeOfPeriod_type&
    startTimeOfPeriod () const;

    startTimeOfPeriod_type&
    startTimeOfPeriod ();

    void
    startTimeOfPeriod (const startTimeOfPeriod_type& x);

    void
    startTimeOfPeriod (::std::auto_ptr< startTimeOfPeriod_type > p);

    // endTimeOfPeriod
    // 
    typedef ::datex2::Time endTimeOfPeriod_type;
    typedef ::xsd::cxx::tree::traits< endTimeOfPeriod_type, char > endTimeOfPeriod_traits;

    const endTimeOfPeriod_type&
    endTimeOfPeriod () const;

    endTimeOfPeriod_type&
    endTimeOfPeriod ();

    void
    endTimeOfPeriod (const endTimeOfPeriod_type& x);

    void
    endTimeOfPeriod (::std::auto_ptr< endTimeOfPeriod_type > p);

    // timePeriodByHourExtension
    // 
    typedef ::datex2::ExtensionType timePeriodByHourExtension_type;
    typedef ::xsd::cxx::tree::optional< timePeriodByHourExtension_type > timePeriodByHourExtension_optional;
    typedef ::xsd::cxx::tree::traits< timePeriodByHourExtension_type, char > timePeriodByHourExtension_traits;

    const timePeriodByHourExtension_optional&
    timePeriodByHourExtension () const;

    timePeriodByHourExtension_optional&
    timePeriodByHourExtension ();

    void
    timePeriodByHourExtension (const timePeriodByHourExtension_type& x);

    void
    timePeriodByHourExtension (const timePeriodByHourExtension_optional& x);

    void
    timePeriodByHourExtension (::std::auto_ptr< timePeriodByHourExtension_type > p);

    // Constructors.
    //
    TimePeriodByHour (const startTimeOfPeriod_type&,
                      const endTimeOfPeriod_type&);

    TimePeriodByHour (const xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    TimePeriodByHour (const TimePeriodByHour& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual TimePeriodByHour*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TimePeriodByHour ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< startTimeOfPeriod_type > startTimeOfPeriod_;
    ::xsd::cxx::tree::one< endTimeOfPeriod_type > endTimeOfPeriod_;
    timePeriodByHourExtension_optional timePeriodByHourExtension_;
  };

  class Tonnes: public ::datex2::Float
  {
    public:
    // Constructors.
    //
    Tonnes (const ::xml_schema::float_&);

    Tonnes (const xercesc::DOMElement& e,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    Tonnes (const xercesc::DOMAttr& a,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    Tonnes (const ::std::string& s,
            const xercesc::DOMElement* e,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    Tonnes (const Tonnes& x,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    virtual Tonnes*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Tonnes ();
  };

  class TpegDescriptor: public ::xml_schema::type
  {
    public:
    // descriptor
    // 
    typedef ::datex2::MultilingualString descriptor_type;
    typedef ::xsd::cxx::tree::traits< descriptor_type, char > descriptor_traits;

    const descriptor_type&
    descriptor () const;

    descriptor_type&
    descriptor ();

    void
    descriptor (const descriptor_type& x);

    void
    descriptor (::std::auto_ptr< descriptor_type > p);

    // tpegDescriptorExtension
    // 
    typedef ::datex2::ExtensionType tpegDescriptorExtension_type;
    typedef ::xsd::cxx::tree::optional< tpegDescriptorExtension_type > tpegDescriptorExtension_optional;
    typedef ::xsd::cxx::tree::traits< tpegDescriptorExtension_type, char > tpegDescriptorExtension_traits;

    const tpegDescriptorExtension_optional&
    tpegDescriptorExtension () const;

    tpegDescriptorExtension_optional&
    tpegDescriptorExtension ();

    void
    tpegDescriptorExtension (const tpegDescriptorExtension_type& x);

    void
    tpegDescriptorExtension (const tpegDescriptorExtension_optional& x);

    void
    tpegDescriptorExtension (::std::auto_ptr< tpegDescriptorExtension_type > p);

    // Constructors.
    //
    TpegDescriptor (const descriptor_type&);

    TpegDescriptor (::std::auto_ptr< descriptor_type >&);

    TpegDescriptor (const xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    TpegDescriptor (const TpegDescriptor& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual TpegDescriptor*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TpegDescriptor ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< descriptor_type > descriptor_;
    tpegDescriptorExtension_optional tpegDescriptorExtension_;
  };

  class TpegAreaDescriptor: public ::datex2::TpegDescriptor
  {
    public:
    // tpegAreaDescriptorType
    // 
    typedef ::datex2::TpegLoc03AreaDescriptorSubtypeEnum tpegAreaDescriptorType_type;
    typedef ::xsd::cxx::tree::traits< tpegAreaDescriptorType_type, char > tpegAreaDescriptorType_traits;

    const tpegAreaDescriptorType_type&
    tpegAreaDescriptorType () const;

    tpegAreaDescriptorType_type&
    tpegAreaDescriptorType ();

    void
    tpegAreaDescriptorType (const tpegAreaDescriptorType_type& x);

    void
    tpegAreaDescriptorType (::std::auto_ptr< tpegAreaDescriptorType_type > p);

    // tpegAreaDescriptorExtension
    // 
    typedef ::datex2::ExtensionType tpegAreaDescriptorExtension_type;
    typedef ::xsd::cxx::tree::optional< tpegAreaDescriptorExtension_type > tpegAreaDescriptorExtension_optional;
    typedef ::xsd::cxx::tree::traits< tpegAreaDescriptorExtension_type, char > tpegAreaDescriptorExtension_traits;

    const tpegAreaDescriptorExtension_optional&
    tpegAreaDescriptorExtension () const;

    tpegAreaDescriptorExtension_optional&
    tpegAreaDescriptorExtension ();

    void
    tpegAreaDescriptorExtension (const tpegAreaDescriptorExtension_type& x);

    void
    tpegAreaDescriptorExtension (const tpegAreaDescriptorExtension_optional& x);

    void
    tpegAreaDescriptorExtension (::std::auto_ptr< tpegAreaDescriptorExtension_type > p);

    // Constructors.
    //
    TpegAreaDescriptor (const descriptor_type&,
                        const tpegAreaDescriptorType_type&);

    TpegAreaDescriptor (::std::auto_ptr< descriptor_type >&,
                        const tpegAreaDescriptorType_type&);

    TpegAreaDescriptor (const xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    TpegAreaDescriptor (const TpegAreaDescriptor& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual TpegAreaDescriptor*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TpegAreaDescriptor ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< tpegAreaDescriptorType_type > tpegAreaDescriptorType_;
    tpegAreaDescriptorExtension_optional tpegAreaDescriptorExtension_;
  };

  class TpegAreaLocation: public ::xml_schema::type
  {
    public:
    // tpegAreaLocationType
    // 
    typedef ::datex2::TpegLoc01AreaLocationSubtypeEnum tpegAreaLocationType_type;
    typedef ::xsd::cxx::tree::traits< tpegAreaLocationType_type, char > tpegAreaLocationType_traits;

    const tpegAreaLocationType_type&
    tpegAreaLocationType () const;

    tpegAreaLocationType_type&
    tpegAreaLocationType ();

    void
    tpegAreaLocationType (const tpegAreaLocationType_type& x);

    void
    tpegAreaLocationType (::std::auto_ptr< tpegAreaLocationType_type > p);

    // tpegHeight
    // 
    typedef ::datex2::TpegHeight tpegHeight_type;
    typedef ::xsd::cxx::tree::optional< tpegHeight_type > tpegHeight_optional;
    typedef ::xsd::cxx::tree::traits< tpegHeight_type, char > tpegHeight_traits;

    const tpegHeight_optional&
    tpegHeight () const;

    tpegHeight_optional&
    tpegHeight ();

    void
    tpegHeight (const tpegHeight_type& x);

    void
    tpegHeight (const tpegHeight_optional& x);

    void
    tpegHeight (::std::auto_ptr< tpegHeight_type > p);

    // tpegAreaLocationExtension
    // 
    typedef ::datex2::ExtensionType tpegAreaLocationExtension_type;
    typedef ::xsd::cxx::tree::optional< tpegAreaLocationExtension_type > tpegAreaLocationExtension_optional;
    typedef ::xsd::cxx::tree::traits< tpegAreaLocationExtension_type, char > tpegAreaLocationExtension_traits;

    const tpegAreaLocationExtension_optional&
    tpegAreaLocationExtension () const;

    tpegAreaLocationExtension_optional&
    tpegAreaLocationExtension ();

    void
    tpegAreaLocationExtension (const tpegAreaLocationExtension_type& x);

    void
    tpegAreaLocationExtension (const tpegAreaLocationExtension_optional& x);

    void
    tpegAreaLocationExtension (::std::auto_ptr< tpegAreaLocationExtension_type > p);

    // Constructors.
    //
    TpegAreaLocation (const tpegAreaLocationType_type&);

    TpegAreaLocation (const xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    TpegAreaLocation (const TpegAreaLocation& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual TpegAreaLocation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TpegAreaLocation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< tpegAreaLocationType_type > tpegAreaLocationType_;
    tpegHeight_optional tpegHeight_;
    tpegAreaLocationExtension_optional tpegAreaLocationExtension_;
  };

  class TpegPointLocation: public ::xml_schema::type
  {
    public:
    // tpegDirection
    // 
    typedef ::datex2::TpegLoc02DirectionTypeEnum tpegDirection_type;
    typedef ::xsd::cxx::tree::traits< tpegDirection_type, char > tpegDirection_traits;

    const tpegDirection_type&
    tpegDirection () const;

    tpegDirection_type&
    tpegDirection ();

    void
    tpegDirection (const tpegDirection_type& x);

    void
    tpegDirection (::std::auto_ptr< tpegDirection_type > p);

    // tpegPointLocationExtension
    // 
    typedef ::datex2::ExtensionType tpegPointLocationExtension_type;
    typedef ::xsd::cxx::tree::optional< tpegPointLocationExtension_type > tpegPointLocationExtension_optional;
    typedef ::xsd::cxx::tree::traits< tpegPointLocationExtension_type, char > tpegPointLocationExtension_traits;

    const tpegPointLocationExtension_optional&
    tpegPointLocationExtension () const;

    tpegPointLocationExtension_optional&
    tpegPointLocationExtension ();

    void
    tpegPointLocationExtension (const tpegPointLocationExtension_type& x);

    void
    tpegPointLocationExtension (const tpegPointLocationExtension_optional& x);

    void
    tpegPointLocationExtension (::std::auto_ptr< tpegPointLocationExtension_type > p);

    // Constructors.
    //
    TpegPointLocation (const tpegDirection_type&);

    TpegPointLocation (const xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    TpegPointLocation (const TpegPointLocation& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual TpegPointLocation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TpegPointLocation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< tpegDirection_type > tpegDirection_;
    tpegPointLocationExtension_optional tpegPointLocationExtension_;
  };

  class TpegFramedPoint: public ::datex2::TpegPointLocation
  {
    public:
    // tpegFramedPointLocationType
    // 
    typedef ::datex2::TpegLoc01FramedPointLocationSubtypeEnum tpegFramedPointLocationType_type;
    typedef ::xsd::cxx::tree::traits< tpegFramedPointLocationType_type, char > tpegFramedPointLocationType_traits;

    const tpegFramedPointLocationType_type&
    tpegFramedPointLocationType () const;

    tpegFramedPointLocationType_type&
    tpegFramedPointLocationType ();

    void
    tpegFramedPointLocationType (const tpegFramedPointLocationType_type& x);

    void
    tpegFramedPointLocationType (::std::auto_ptr< tpegFramedPointLocationType_type > p);

    // framedPoint
    // 
    typedef ::datex2::TpegNonJunctionPoint framedPoint_type;
    typedef ::xsd::cxx::tree::traits< framedPoint_type, char > framedPoint_traits;

    const framedPoint_type&
    framedPoint () const;

    framedPoint_type&
    framedPoint ();

    void
    framedPoint (const framedPoint_type& x);

    void
    framedPoint (::std::auto_ptr< framedPoint_type > p);

    // to
    // 
    typedef ::datex2::TpegPoint to_type;
    typedef ::xsd::cxx::tree::traits< to_type, char > to_traits;

    const to_type&
    to () const;

    to_type&
    to ();

    void
    to (const to_type& x);

    void
    to (::std::auto_ptr< to_type > p);

    // from
    // 
    typedef ::datex2::TpegPoint from_type;
    typedef ::xsd::cxx::tree::traits< from_type, char > from_traits;

    const from_type&
    from () const;

    from_type&
    from ();

    void
    from (const from_type& x);

    void
    from (::std::auto_ptr< from_type > p);

    // tpegFramedPointExtension
    // 
    typedef ::datex2::ExtensionType tpegFramedPointExtension_type;
    typedef ::xsd::cxx::tree::optional< tpegFramedPointExtension_type > tpegFramedPointExtension_optional;
    typedef ::xsd::cxx::tree::traits< tpegFramedPointExtension_type, char > tpegFramedPointExtension_traits;

    const tpegFramedPointExtension_optional&
    tpegFramedPointExtension () const;

    tpegFramedPointExtension_optional&
    tpegFramedPointExtension ();

    void
    tpegFramedPointExtension (const tpegFramedPointExtension_type& x);

    void
    tpegFramedPointExtension (const tpegFramedPointExtension_optional& x);

    void
    tpegFramedPointExtension (::std::auto_ptr< tpegFramedPointExtension_type > p);

    // Constructors.
    //
    TpegFramedPoint (const tpegDirection_type&,
                     const tpegFramedPointLocationType_type&,
                     const framedPoint_type&,
                     const to_type&,
                     const from_type&);

    TpegFramedPoint (const tpegDirection_type&,
                     const tpegFramedPointLocationType_type&,
                     ::std::auto_ptr< framedPoint_type >&,
                     ::std::auto_ptr< to_type >&,
                     ::std::auto_ptr< from_type >&);

    TpegFramedPoint (const xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    TpegFramedPoint (const TpegFramedPoint& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual TpegFramedPoint*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TpegFramedPoint ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< tpegFramedPointLocationType_type > tpegFramedPointLocationType_;
    ::xsd::cxx::tree::one< framedPoint_type > framedPoint_;
    ::xsd::cxx::tree::one< to_type > to_;
    ::xsd::cxx::tree::one< from_type > from_;
    tpegFramedPointExtension_optional tpegFramedPointExtension_;
  };

  class TpegGeometricArea: public ::datex2::TpegAreaLocation
  {
    public:
    // radius
    // 
    typedef ::datex2::MetresAsNonNegativeInteger radius_type;
    typedef ::xsd::cxx::tree::traits< radius_type, char > radius_traits;

    const radius_type&
    radius () const;

    radius_type&
    radius ();

    void
    radius (const radius_type& x);

    void
    radius (::std::auto_ptr< radius_type > p);

    // centrePoint
    // 
    typedef ::datex2::PointCoordinates centrePoint_type;
    typedef ::xsd::cxx::tree::traits< centrePoint_type, char > centrePoint_traits;

    const centrePoint_type&
    centrePoint () const;

    centrePoint_type&
    centrePoint ();

    void
    centrePoint (const centrePoint_type& x);

    void
    centrePoint (::std::auto_ptr< centrePoint_type > p);

    // name
    // 
    typedef ::datex2::TpegAreaDescriptor name_type;
    typedef ::xsd::cxx::tree::optional< name_type > name_optional;
    typedef ::xsd::cxx::tree::traits< name_type, char > name_traits;

    const name_optional&
    name () const;

    name_optional&
    name ();

    void
    name (const name_type& x);

    void
    name (const name_optional& x);

    void
    name (::std::auto_ptr< name_type > p);

    // tpegGeometricAreaExtension
    // 
    typedef ::datex2::ExtensionType tpegGeometricAreaExtension_type;
    typedef ::xsd::cxx::tree::optional< tpegGeometricAreaExtension_type > tpegGeometricAreaExtension_optional;
    typedef ::xsd::cxx::tree::traits< tpegGeometricAreaExtension_type, char > tpegGeometricAreaExtension_traits;

    const tpegGeometricAreaExtension_optional&
    tpegGeometricAreaExtension () const;

    tpegGeometricAreaExtension_optional&
    tpegGeometricAreaExtension ();

    void
    tpegGeometricAreaExtension (const tpegGeometricAreaExtension_type& x);

    void
    tpegGeometricAreaExtension (const tpegGeometricAreaExtension_optional& x);

    void
    tpegGeometricAreaExtension (::std::auto_ptr< tpegGeometricAreaExtension_type > p);

    // Constructors.
    //
    TpegGeometricArea (const tpegAreaLocationType_type&,
                       const radius_type&,
                       const centrePoint_type&);

    TpegGeometricArea (const tpegAreaLocationType_type&,
                       const radius_type&,
                       ::std::auto_ptr< centrePoint_type >&);

    TpegGeometricArea (const xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    TpegGeometricArea (const TpegGeometricArea& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual TpegGeometricArea*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TpegGeometricArea ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< radius_type > radius_;
    ::xsd::cxx::tree::one< centrePoint_type > centrePoint_;
    name_optional name_;
    tpegGeometricAreaExtension_optional tpegGeometricAreaExtension_;
  };

  class TpegHeight: public ::xml_schema::type
  {
    public:
    // height
    // 
    typedef ::datex2::MetresAsFloat height_type;
    typedef ::xsd::cxx::tree::optional< height_type > height_optional;
    typedef ::xsd::cxx::tree::traits< height_type, char > height_traits;

    const height_optional&
    height () const;

    height_optional&
    height ();

    void
    height (const height_type& x);

    void
    height (const height_optional& x);

    void
    height (::std::auto_ptr< height_type > p);

    // heightType
    // 
    typedef ::datex2::TpegLoc04HeightTypeEnum heightType_type;
    typedef ::xsd::cxx::tree::traits< heightType_type, char > heightType_traits;

    const heightType_type&
    heightType () const;

    heightType_type&
    heightType ();

    void
    heightType (const heightType_type& x);

    void
    heightType (::std::auto_ptr< heightType_type > p);

    // tpegHeightExtension
    // 
    typedef ::datex2::ExtensionType tpegHeightExtension_type;
    typedef ::xsd::cxx::tree::optional< tpegHeightExtension_type > tpegHeightExtension_optional;
    typedef ::xsd::cxx::tree::traits< tpegHeightExtension_type, char > tpegHeightExtension_traits;

    const tpegHeightExtension_optional&
    tpegHeightExtension () const;

    tpegHeightExtension_optional&
    tpegHeightExtension ();

    void
    tpegHeightExtension (const tpegHeightExtension_type& x);

    void
    tpegHeightExtension (const tpegHeightExtension_optional& x);

    void
    tpegHeightExtension (::std::auto_ptr< tpegHeightExtension_type > p);

    // Constructors.
    //
    TpegHeight (const heightType_type&);

    TpegHeight (const xercesc::DOMElement& e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    TpegHeight (const TpegHeight& x,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    virtual TpegHeight*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TpegHeight ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    height_optional height_;
    ::xsd::cxx::tree::one< heightType_type > heightType_;
    tpegHeightExtension_optional tpegHeightExtension_;
  };

  class TpegPointDescriptor: public ::datex2::TpegDescriptor
  {
    public:
    // tpegPointDescriptorExtension
    // 
    typedef ::datex2::ExtensionType tpegPointDescriptorExtension_type;
    typedef ::xsd::cxx::tree::optional< tpegPointDescriptorExtension_type > tpegPointDescriptorExtension_optional;
    typedef ::xsd::cxx::tree::traits< tpegPointDescriptorExtension_type, char > tpegPointDescriptorExtension_traits;

    const tpegPointDescriptorExtension_optional&
    tpegPointDescriptorExtension () const;

    tpegPointDescriptorExtension_optional&
    tpegPointDescriptorExtension ();

    void
    tpegPointDescriptorExtension (const tpegPointDescriptorExtension_type& x);

    void
    tpegPointDescriptorExtension (const tpegPointDescriptorExtension_optional& x);

    void
    tpegPointDescriptorExtension (::std::auto_ptr< tpegPointDescriptorExtension_type > p);

    // Constructors.
    //
    TpegPointDescriptor (const descriptor_type&);

    TpegPointDescriptor (::std::auto_ptr< descriptor_type >&);

    TpegPointDescriptor (const xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    TpegPointDescriptor (const TpegPointDescriptor& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual TpegPointDescriptor*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TpegPointDescriptor ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    tpegPointDescriptorExtension_optional tpegPointDescriptorExtension_;
  };

  class TpegIlcPointDescriptor: public ::datex2::TpegPointDescriptor
  {
    public:
    // tpegIlcPointDescriptorType
    // 
    typedef ::datex2::TpegLoc03IlcPointDescriptorSubtypeEnum tpegIlcPointDescriptorType_type;
    typedef ::xsd::cxx::tree::traits< tpegIlcPointDescriptorType_type, char > tpegIlcPointDescriptorType_traits;

    const tpegIlcPointDescriptorType_type&
    tpegIlcPointDescriptorType () const;

    tpegIlcPointDescriptorType_type&
    tpegIlcPointDescriptorType ();

    void
    tpegIlcPointDescriptorType (const tpegIlcPointDescriptorType_type& x);

    void
    tpegIlcPointDescriptorType (::std::auto_ptr< tpegIlcPointDescriptorType_type > p);

    // tpegIlcPointDescriptorExtension
    // 
    typedef ::datex2::ExtensionType tpegIlcPointDescriptorExtension_type;
    typedef ::xsd::cxx::tree::optional< tpegIlcPointDescriptorExtension_type > tpegIlcPointDescriptorExtension_optional;
    typedef ::xsd::cxx::tree::traits< tpegIlcPointDescriptorExtension_type, char > tpegIlcPointDescriptorExtension_traits;

    const tpegIlcPointDescriptorExtension_optional&
    tpegIlcPointDescriptorExtension () const;

    tpegIlcPointDescriptorExtension_optional&
    tpegIlcPointDescriptorExtension ();

    void
    tpegIlcPointDescriptorExtension (const tpegIlcPointDescriptorExtension_type& x);

    void
    tpegIlcPointDescriptorExtension (const tpegIlcPointDescriptorExtension_optional& x);

    void
    tpegIlcPointDescriptorExtension (::std::auto_ptr< tpegIlcPointDescriptorExtension_type > p);

    // Constructors.
    //
    TpegIlcPointDescriptor (const descriptor_type&,
                            const tpegIlcPointDescriptorType_type&);

    TpegIlcPointDescriptor (::std::auto_ptr< descriptor_type >&,
                            const tpegIlcPointDescriptorType_type&);

    TpegIlcPointDescriptor (const xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    TpegIlcPointDescriptor (const TpegIlcPointDescriptor& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual TpegIlcPointDescriptor*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TpegIlcPointDescriptor ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< tpegIlcPointDescriptorType_type > tpegIlcPointDescriptorType_;
    tpegIlcPointDescriptorExtension_optional tpegIlcPointDescriptorExtension_;
  };

  class TpegPoint: public ::xml_schema::type
  {
    public:
    // tpegPointExtension
    // 
    typedef ::datex2::ExtensionType tpegPointExtension_type;
    typedef ::xsd::cxx::tree::optional< tpegPointExtension_type > tpegPointExtension_optional;
    typedef ::xsd::cxx::tree::traits< tpegPointExtension_type, char > tpegPointExtension_traits;

    const tpegPointExtension_optional&
    tpegPointExtension () const;

    tpegPointExtension_optional&
    tpegPointExtension ();

    void
    tpegPointExtension (const tpegPointExtension_type& x);

    void
    tpegPointExtension (const tpegPointExtension_optional& x);

    void
    tpegPointExtension (::std::auto_ptr< tpegPointExtension_type > p);

    // Constructors.
    //
    TpegPoint ();

    TpegPoint (const xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    TpegPoint (const TpegPoint& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual TpegPoint*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TpegPoint ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    tpegPointExtension_optional tpegPointExtension_;
  };

  class TpegJunction: public ::datex2::TpegPoint
  {
    public:
    // pointCoordinates
    // 
    typedef ::datex2::PointCoordinates pointCoordinates_type;
    typedef ::xsd::cxx::tree::traits< pointCoordinates_type, char > pointCoordinates_traits;

    const pointCoordinates_type&
    pointCoordinates () const;

    pointCoordinates_type&
    pointCoordinates ();

    void
    pointCoordinates (const pointCoordinates_type& x);

    void
    pointCoordinates (::std::auto_ptr< pointCoordinates_type > p);

    // name
    // 
    typedef ::datex2::TpegJunctionPointDescriptor name_type;
    typedef ::xsd::cxx::tree::optional< name_type > name_optional;
    typedef ::xsd::cxx::tree::traits< name_type, char > name_traits;

    const name_optional&
    name () const;

    name_optional&
    name ();

    void
    name (const name_type& x);

    void
    name (const name_optional& x);

    void
    name (::std::auto_ptr< name_type > p);

    // ilc
    // 
    typedef ::datex2::TpegIlcPointDescriptor ilc_type;
    typedef ::xsd::cxx::tree::sequence< ilc_type > ilc_sequence;
    typedef xsd::cxx::tree::sequence< ilc_type >::iterator ilc_iterator;
    typedef xsd::cxx::tree::sequence< ilc_type >::const_iterator ilc_const_iterator;
    typedef ::xsd::cxx::tree::traits< ilc_type, char > ilc_traits;

    const ilc_sequence&
    ilc () const;

    ilc_sequence&
    ilc ();

    void
    ilc (const ilc_sequence& s);

    // otherName
    // 
    typedef ::datex2::TpegOtherPointDescriptor otherName_type;
    typedef ::xsd::cxx::tree::sequence< otherName_type > otherName_sequence;
    typedef xsd::cxx::tree::sequence< otherName_type >::iterator otherName_iterator;
    typedef xsd::cxx::tree::sequence< otherName_type >::const_iterator otherName_const_iterator;
    typedef ::xsd::cxx::tree::traits< otherName_type, char > otherName_traits;

    const otherName_sequence&
    otherName () const;

    otherName_sequence&
    otherName ();

    void
    otherName (const otherName_sequence& s);

    // tpegJunctionExtension
    // 
    typedef ::datex2::ExtensionType tpegJunctionExtension_type;
    typedef ::xsd::cxx::tree::optional< tpegJunctionExtension_type > tpegJunctionExtension_optional;
    typedef ::xsd::cxx::tree::traits< tpegJunctionExtension_type, char > tpegJunctionExtension_traits;

    const tpegJunctionExtension_optional&
    tpegJunctionExtension () const;

    tpegJunctionExtension_optional&
    tpegJunctionExtension ();

    void
    tpegJunctionExtension (const tpegJunctionExtension_type& x);

    void
    tpegJunctionExtension (const tpegJunctionExtension_optional& x);

    void
    tpegJunctionExtension (::std::auto_ptr< tpegJunctionExtension_type > p);

    // Constructors.
    //
    TpegJunction (const pointCoordinates_type&);

    TpegJunction (::std::auto_ptr< pointCoordinates_type >&);

    TpegJunction (const xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    TpegJunction (const TpegJunction& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual TpegJunction*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TpegJunction ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< pointCoordinates_type > pointCoordinates_;
    name_optional name_;
    ilc_sequence ilc_;
    otherName_sequence otherName_;
    tpegJunctionExtension_optional tpegJunctionExtension_;
  };

  class TpegJunctionPointDescriptor: public ::datex2::TpegPointDescriptor
  {
    public:
    // tpegJunctionPointDescriptorType
    // 
    typedef ::datex2::TpegLoc03JunctionPointDescriptorSubtypeEnum tpegJunctionPointDescriptorType_type;
    typedef ::xsd::cxx::tree::traits< tpegJunctionPointDescriptorType_type, char > tpegJunctionPointDescriptorType_traits;

    const tpegJunctionPointDescriptorType_type&
    tpegJunctionPointDescriptorType () const;

    tpegJunctionPointDescriptorType_type&
    tpegJunctionPointDescriptorType ();

    void
    tpegJunctionPointDescriptorType (const tpegJunctionPointDescriptorType_type& x);

    void
    tpegJunctionPointDescriptorType (::std::auto_ptr< tpegJunctionPointDescriptorType_type > p);

    // tpegJunctionPointDescriptorExtension
    // 
    typedef ::datex2::ExtensionType tpegJunctionPointDescriptorExtension_type;
    typedef ::xsd::cxx::tree::optional< tpegJunctionPointDescriptorExtension_type > tpegJunctionPointDescriptorExtension_optional;
    typedef ::xsd::cxx::tree::traits< tpegJunctionPointDescriptorExtension_type, char > tpegJunctionPointDescriptorExtension_traits;

    const tpegJunctionPointDescriptorExtension_optional&
    tpegJunctionPointDescriptorExtension () const;

    tpegJunctionPointDescriptorExtension_optional&
    tpegJunctionPointDescriptorExtension ();

    void
    tpegJunctionPointDescriptorExtension (const tpegJunctionPointDescriptorExtension_type& x);

    void
    tpegJunctionPointDescriptorExtension (const tpegJunctionPointDescriptorExtension_optional& x);

    void
    tpegJunctionPointDescriptorExtension (::std::auto_ptr< tpegJunctionPointDescriptorExtension_type > p);

    // Constructors.
    //
    TpegJunctionPointDescriptor (const descriptor_type&,
                                 const tpegJunctionPointDescriptorType_type&);

    TpegJunctionPointDescriptor (::std::auto_ptr< descriptor_type >&,
                                 const tpegJunctionPointDescriptorType_type&);

    TpegJunctionPointDescriptor (const xercesc::DOMElement& e,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    TpegJunctionPointDescriptor (const TpegJunctionPointDescriptor& x,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    virtual TpegJunctionPointDescriptor*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TpegJunctionPointDescriptor ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< tpegJunctionPointDescriptorType_type > tpegJunctionPointDescriptorType_;
    tpegJunctionPointDescriptorExtension_optional tpegJunctionPointDescriptorExtension_;
  };

  class TpegLinearLocation: public ::xml_schema::type
  {
    public:
    // tpegDirection
    // 
    typedef ::datex2::TpegLoc02DirectionTypeEnum tpegDirection_type;
    typedef ::xsd::cxx::tree::traits< tpegDirection_type, char > tpegDirection_traits;

    const tpegDirection_type&
    tpegDirection () const;

    tpegDirection_type&
    tpegDirection ();

    void
    tpegDirection (const tpegDirection_type& x);

    void
    tpegDirection (::std::auto_ptr< tpegDirection_type > p);

    // tpegLinearLocationType
    // 
    typedef ::datex2::TpegLoc01LinearLocationSubtypeEnum tpegLinearLocationType_type;
    typedef ::xsd::cxx::tree::traits< tpegLinearLocationType_type, char > tpegLinearLocationType_traits;

    const tpegLinearLocationType_type&
    tpegLinearLocationType () const;

    tpegLinearLocationType_type&
    tpegLinearLocationType ();

    void
    tpegLinearLocationType (const tpegLinearLocationType_type& x);

    void
    tpegLinearLocationType (::std::auto_ptr< tpegLinearLocationType_type > p);

    // to
    // 
    typedef ::datex2::TpegPoint to_type;
    typedef ::xsd::cxx::tree::traits< to_type, char > to_traits;

    const to_type&
    to () const;

    to_type&
    to ();

    void
    to (const to_type& x);

    void
    to (::std::auto_ptr< to_type > p);

    // from
    // 
    typedef ::datex2::TpegPoint from_type;
    typedef ::xsd::cxx::tree::traits< from_type, char > from_traits;

    const from_type&
    from () const;

    from_type&
    from ();

    void
    from (const from_type& x);

    void
    from (::std::auto_ptr< from_type > p);

    // tpegLinearLocationExtension
    // 
    typedef ::datex2::ExtensionType tpegLinearLocationExtension_type;
    typedef ::xsd::cxx::tree::optional< tpegLinearLocationExtension_type > tpegLinearLocationExtension_optional;
    typedef ::xsd::cxx::tree::traits< tpegLinearLocationExtension_type, char > tpegLinearLocationExtension_traits;

    const tpegLinearLocationExtension_optional&
    tpegLinearLocationExtension () const;

    tpegLinearLocationExtension_optional&
    tpegLinearLocationExtension ();

    void
    tpegLinearLocationExtension (const tpegLinearLocationExtension_type& x);

    void
    tpegLinearLocationExtension (const tpegLinearLocationExtension_optional& x);

    void
    tpegLinearLocationExtension (::std::auto_ptr< tpegLinearLocationExtension_type > p);

    // Constructors.
    //
    TpegLinearLocation (const tpegDirection_type&,
                        const tpegLinearLocationType_type&,
                        const to_type&,
                        const from_type&);

    TpegLinearLocation (const tpegDirection_type&,
                        const tpegLinearLocationType_type&,
                        ::std::auto_ptr< to_type >&,
                        ::std::auto_ptr< from_type >&);

    TpegLinearLocation (const xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    TpegLinearLocation (const TpegLinearLocation& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual TpegLinearLocation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TpegLinearLocation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< tpegDirection_type > tpegDirection_;
    ::xsd::cxx::tree::one< tpegLinearLocationType_type > tpegLinearLocationType_;
    ::xsd::cxx::tree::one< to_type > to_;
    ::xsd::cxx::tree::one< from_type > from_;
    tpegLinearLocationExtension_optional tpegLinearLocationExtension_;
  };

  class TpegLoc01AreaLocationSubtypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      largeArea,
      other
    };

    TpegLoc01AreaLocationSubtypeEnum (value v);

    TpegLoc01AreaLocationSubtypeEnum (const char* v);

    TpegLoc01AreaLocationSubtypeEnum (const ::std::string& v);

    TpegLoc01AreaLocationSubtypeEnum (const ::xml_schema::string& v);

    TpegLoc01AreaLocationSubtypeEnum (const xercesc::DOMElement& e,
                                      ::xml_schema::flags f = 0,
                                      ::xml_schema::container* c = 0);

    TpegLoc01AreaLocationSubtypeEnum (const xercesc::DOMAttr& a,
                                      ::xml_schema::flags f = 0,
                                      ::xml_schema::container* c = 0);

    TpegLoc01AreaLocationSubtypeEnum (const ::std::string& s,
                                      const xercesc::DOMElement* e,
                                      ::xml_schema::flags f = 0,
                                      ::xml_schema::container* c = 0);

    TpegLoc01AreaLocationSubtypeEnum (const TpegLoc01AreaLocationSubtypeEnum& x,
                                      ::xml_schema::flags f = 0,
                                      ::xml_schema::container* c = 0);

    virtual TpegLoc01AreaLocationSubtypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    TpegLoc01AreaLocationSubtypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_TpegLoc01AreaLocationSubtypeEnum_convert ();
    }

    protected:
    value
    _xsd_TpegLoc01AreaLocationSubtypeEnum_convert () const;

    public:
    static const char* const _xsd_TpegLoc01AreaLocationSubtypeEnum_literals_[2];
    static const value _xsd_TpegLoc01AreaLocationSubtypeEnum_indexes_[2];
  };

  class TpegLoc01FramedPointLocationSubtypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      framedPoint
    };

    TpegLoc01FramedPointLocationSubtypeEnum (value v);

    TpegLoc01FramedPointLocationSubtypeEnum (const char* v);

    TpegLoc01FramedPointLocationSubtypeEnum (const ::std::string& v);

    TpegLoc01FramedPointLocationSubtypeEnum (const ::xml_schema::string& v);

    TpegLoc01FramedPointLocationSubtypeEnum (const xercesc::DOMElement& e,
                                             ::xml_schema::flags f = 0,
                                             ::xml_schema::container* c = 0);

    TpegLoc01FramedPointLocationSubtypeEnum (const xercesc::DOMAttr& a,
                                             ::xml_schema::flags f = 0,
                                             ::xml_schema::container* c = 0);

    TpegLoc01FramedPointLocationSubtypeEnum (const ::std::string& s,
                                             const xercesc::DOMElement* e,
                                             ::xml_schema::flags f = 0,
                                             ::xml_schema::container* c = 0);

    TpegLoc01FramedPointLocationSubtypeEnum (const TpegLoc01FramedPointLocationSubtypeEnum& x,
                                             ::xml_schema::flags f = 0,
                                             ::xml_schema::container* c = 0);

    virtual TpegLoc01FramedPointLocationSubtypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    TpegLoc01FramedPointLocationSubtypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_TpegLoc01FramedPointLocationSubtypeEnum_convert ();
    }

    protected:
    value
    _xsd_TpegLoc01FramedPointLocationSubtypeEnum_convert () const;

    public:
    static const char* const _xsd_TpegLoc01FramedPointLocationSubtypeEnum_literals_[1];
    static const value _xsd_TpegLoc01FramedPointLocationSubtypeEnum_indexes_[1];
  };

  class TpegLoc01LinearLocationSubtypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      segment
    };

    TpegLoc01LinearLocationSubtypeEnum (value v);

    TpegLoc01LinearLocationSubtypeEnum (const char* v);

    TpegLoc01LinearLocationSubtypeEnum (const ::std::string& v);

    TpegLoc01LinearLocationSubtypeEnum (const ::xml_schema::string& v);

    TpegLoc01LinearLocationSubtypeEnum (const xercesc::DOMElement& e,
                                        ::xml_schema::flags f = 0,
                                        ::xml_schema::container* c = 0);

    TpegLoc01LinearLocationSubtypeEnum (const xercesc::DOMAttr& a,
                                        ::xml_schema::flags f = 0,
                                        ::xml_schema::container* c = 0);

    TpegLoc01LinearLocationSubtypeEnum (const ::std::string& s,
                                        const xercesc::DOMElement* e,
                                        ::xml_schema::flags f = 0,
                                        ::xml_schema::container* c = 0);

    TpegLoc01LinearLocationSubtypeEnum (const TpegLoc01LinearLocationSubtypeEnum& x,
                                        ::xml_schema::flags f = 0,
                                        ::xml_schema::container* c = 0);

    virtual TpegLoc01LinearLocationSubtypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    TpegLoc01LinearLocationSubtypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_TpegLoc01LinearLocationSubtypeEnum_convert ();
    }

    protected:
    value
    _xsd_TpegLoc01LinearLocationSubtypeEnum_convert () const;

    public:
    static const char* const _xsd_TpegLoc01LinearLocationSubtypeEnum_literals_[1];
    static const value _xsd_TpegLoc01LinearLocationSubtypeEnum_indexes_[1];
  };

  class TpegLoc01SimplePointLocationSubtypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      intersection,
      nonLinkedPoint
    };

    TpegLoc01SimplePointLocationSubtypeEnum (value v);

    TpegLoc01SimplePointLocationSubtypeEnum (const char* v);

    TpegLoc01SimplePointLocationSubtypeEnum (const ::std::string& v);

    TpegLoc01SimplePointLocationSubtypeEnum (const ::xml_schema::string& v);

    TpegLoc01SimplePointLocationSubtypeEnum (const xercesc::DOMElement& e,
                                             ::xml_schema::flags f = 0,
                                             ::xml_schema::container* c = 0);

    TpegLoc01SimplePointLocationSubtypeEnum (const xercesc::DOMAttr& a,
                                             ::xml_schema::flags f = 0,
                                             ::xml_schema::container* c = 0);

    TpegLoc01SimplePointLocationSubtypeEnum (const ::std::string& s,
                                             const xercesc::DOMElement* e,
                                             ::xml_schema::flags f = 0,
                                             ::xml_schema::container* c = 0);

    TpegLoc01SimplePointLocationSubtypeEnum (const TpegLoc01SimplePointLocationSubtypeEnum& x,
                                             ::xml_schema::flags f = 0,
                                             ::xml_schema::container* c = 0);

    virtual TpegLoc01SimplePointLocationSubtypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    TpegLoc01SimplePointLocationSubtypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_TpegLoc01SimplePointLocationSubtypeEnum_convert ();
    }

    protected:
    value
    _xsd_TpegLoc01SimplePointLocationSubtypeEnum_convert () const;

    public:
    static const char* const _xsd_TpegLoc01SimplePointLocationSubtypeEnum_literals_[2];
    static const value _xsd_TpegLoc01SimplePointLocationSubtypeEnum_indexes_[2];
  };

  class TpegLoc02DirectionTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      allDirections,
      anticlockwise,
      bothWays,
      clockwise,
      eastBound,
      innerRing,
      northBound,
      northEastBound,
      northWestBound,
      opposite,
      outerRing,
      southBound,
      southEastBound,
      southWestBound,
      westBound,
      unknown,
      other
    };

    TpegLoc02DirectionTypeEnum (value v);

    TpegLoc02DirectionTypeEnum (const char* v);

    TpegLoc02DirectionTypeEnum (const ::std::string& v);

    TpegLoc02DirectionTypeEnum (const ::xml_schema::string& v);

    TpegLoc02DirectionTypeEnum (const xercesc::DOMElement& e,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    TpegLoc02DirectionTypeEnum (const xercesc::DOMAttr& a,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    TpegLoc02DirectionTypeEnum (const ::std::string& s,
                                const xercesc::DOMElement* e,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    TpegLoc02DirectionTypeEnum (const TpegLoc02DirectionTypeEnum& x,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    virtual TpegLoc02DirectionTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    TpegLoc02DirectionTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_TpegLoc02DirectionTypeEnum_convert ();
    }

    protected:
    value
    _xsd_TpegLoc02DirectionTypeEnum_convert () const;

    public:
    static const char* const _xsd_TpegLoc02DirectionTypeEnum_literals_[17];
    static const value _xsd_TpegLoc02DirectionTypeEnum_indexes_[17];
  };

  class TpegLoc03AreaDescriptorSubtypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      administrativeAreaName,
      administrativeReferenceName,
      areaName,
      countyName,
      lakeName,
      nationName,
      policeForceControlAreaName,
      regionName,
      seaName,
      townName,
      other
    };

    TpegLoc03AreaDescriptorSubtypeEnum (value v);

    TpegLoc03AreaDescriptorSubtypeEnum (const char* v);

    TpegLoc03AreaDescriptorSubtypeEnum (const ::std::string& v);

    TpegLoc03AreaDescriptorSubtypeEnum (const ::xml_schema::string& v);

    TpegLoc03AreaDescriptorSubtypeEnum (const xercesc::DOMElement& e,
                                        ::xml_schema::flags f = 0,
                                        ::xml_schema::container* c = 0);

    TpegLoc03AreaDescriptorSubtypeEnum (const xercesc::DOMAttr& a,
                                        ::xml_schema::flags f = 0,
                                        ::xml_schema::container* c = 0);

    TpegLoc03AreaDescriptorSubtypeEnum (const ::std::string& s,
                                        const xercesc::DOMElement* e,
                                        ::xml_schema::flags f = 0,
                                        ::xml_schema::container* c = 0);

    TpegLoc03AreaDescriptorSubtypeEnum (const TpegLoc03AreaDescriptorSubtypeEnum& x,
                                        ::xml_schema::flags f = 0,
                                        ::xml_schema::container* c = 0);

    virtual TpegLoc03AreaDescriptorSubtypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    TpegLoc03AreaDescriptorSubtypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_TpegLoc03AreaDescriptorSubtypeEnum_convert ();
    }

    protected:
    value
    _xsd_TpegLoc03AreaDescriptorSubtypeEnum_convert () const;

    public:
    static const char* const _xsd_TpegLoc03AreaDescriptorSubtypeEnum_literals_[11];
    static const value _xsd_TpegLoc03AreaDescriptorSubtypeEnum_indexes_[11];
  };

  class TpegLoc03IlcPointDescriptorSubtypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      tpegIlcName1,
      tpegIlcName2,
      tpegIlcName3
    };

    TpegLoc03IlcPointDescriptorSubtypeEnum (value v);

    TpegLoc03IlcPointDescriptorSubtypeEnum (const char* v);

    TpegLoc03IlcPointDescriptorSubtypeEnum (const ::std::string& v);

    TpegLoc03IlcPointDescriptorSubtypeEnum (const ::xml_schema::string& v);

    TpegLoc03IlcPointDescriptorSubtypeEnum (const xercesc::DOMElement& e,
                                            ::xml_schema::flags f = 0,
                                            ::xml_schema::container* c = 0);

    TpegLoc03IlcPointDescriptorSubtypeEnum (const xercesc::DOMAttr& a,
                                            ::xml_schema::flags f = 0,
                                            ::xml_schema::container* c = 0);

    TpegLoc03IlcPointDescriptorSubtypeEnum (const ::std::string& s,
                                            const xercesc::DOMElement* e,
                                            ::xml_schema::flags f = 0,
                                            ::xml_schema::container* c = 0);

    TpegLoc03IlcPointDescriptorSubtypeEnum (const TpegLoc03IlcPointDescriptorSubtypeEnum& x,
                                            ::xml_schema::flags f = 0,
                                            ::xml_schema::container* c = 0);

    virtual TpegLoc03IlcPointDescriptorSubtypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    TpegLoc03IlcPointDescriptorSubtypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_TpegLoc03IlcPointDescriptorSubtypeEnum_convert ();
    }

    protected:
    value
    _xsd_TpegLoc03IlcPointDescriptorSubtypeEnum_convert () const;

    public:
    static const char* const _xsd_TpegLoc03IlcPointDescriptorSubtypeEnum_literals_[3];
    static const value _xsd_TpegLoc03IlcPointDescriptorSubtypeEnum_indexes_[3];
  };

  class TpegLoc03JunctionPointDescriptorSubtypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      junctionName
    };

    TpegLoc03JunctionPointDescriptorSubtypeEnum (value v);

    TpegLoc03JunctionPointDescriptorSubtypeEnum (const char* v);

    TpegLoc03JunctionPointDescriptorSubtypeEnum (const ::std::string& v);

    TpegLoc03JunctionPointDescriptorSubtypeEnum (const ::xml_schema::string& v);

    TpegLoc03JunctionPointDescriptorSubtypeEnum (const xercesc::DOMElement& e,
                                                 ::xml_schema::flags f = 0,
                                                 ::xml_schema::container* c = 0);

    TpegLoc03JunctionPointDescriptorSubtypeEnum (const xercesc::DOMAttr& a,
                                                 ::xml_schema::flags f = 0,
                                                 ::xml_schema::container* c = 0);

    TpegLoc03JunctionPointDescriptorSubtypeEnum (const ::std::string& s,
                                                 const xercesc::DOMElement* e,
                                                 ::xml_schema::flags f = 0,
                                                 ::xml_schema::container* c = 0);

    TpegLoc03JunctionPointDescriptorSubtypeEnum (const TpegLoc03JunctionPointDescriptorSubtypeEnum& x,
                                                 ::xml_schema::flags f = 0,
                                                 ::xml_schema::container* c = 0);

    virtual TpegLoc03JunctionPointDescriptorSubtypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    TpegLoc03JunctionPointDescriptorSubtypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_TpegLoc03JunctionPointDescriptorSubtypeEnum_convert ();
    }

    protected:
    value
    _xsd_TpegLoc03JunctionPointDescriptorSubtypeEnum_convert () const;

    public:
    static const char* const _xsd_TpegLoc03JunctionPointDescriptorSubtypeEnum_literals_[1];
    static const value _xsd_TpegLoc03JunctionPointDescriptorSubtypeEnum_indexes_[1];
  };

  class TpegLoc03OtherPointDescriptorSubtypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      administrativeAreaName,
      administrativeReferenceName,
      airportName,
      areaName,
      buildingName,
      busStopIdentifier,
      busStopName,
      canalName,
      countyName,
      ferryPortName,
      intersectionName,
      lakeName,
      linkName,
      localLinkName,
      metroStationName,
      nationName,
      nonLinkedPointName,
      parkingFacilityName,
      pointName,
      pointOfInterestName,
      railwayStation,
      regionName,
      riverName,
      seaName,
      serviceAreaName,
      tidalRiverName,
      townName,
      other
    };

    TpegLoc03OtherPointDescriptorSubtypeEnum (value v);

    TpegLoc03OtherPointDescriptorSubtypeEnum (const char* v);

    TpegLoc03OtherPointDescriptorSubtypeEnum (const ::std::string& v);

    TpegLoc03OtherPointDescriptorSubtypeEnum (const ::xml_schema::string& v);

    TpegLoc03OtherPointDescriptorSubtypeEnum (const xercesc::DOMElement& e,
                                              ::xml_schema::flags f = 0,
                                              ::xml_schema::container* c = 0);

    TpegLoc03OtherPointDescriptorSubtypeEnum (const xercesc::DOMAttr& a,
                                              ::xml_schema::flags f = 0,
                                              ::xml_schema::container* c = 0);

    TpegLoc03OtherPointDescriptorSubtypeEnum (const ::std::string& s,
                                              const xercesc::DOMElement* e,
                                              ::xml_schema::flags f = 0,
                                              ::xml_schema::container* c = 0);

    TpegLoc03OtherPointDescriptorSubtypeEnum (const TpegLoc03OtherPointDescriptorSubtypeEnum& x,
                                              ::xml_schema::flags f = 0,
                                              ::xml_schema::container* c = 0);

    virtual TpegLoc03OtherPointDescriptorSubtypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    TpegLoc03OtherPointDescriptorSubtypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_TpegLoc03OtherPointDescriptorSubtypeEnum_convert ();
    }

    protected:
    value
    _xsd_TpegLoc03OtherPointDescriptorSubtypeEnum_convert () const;

    public:
    static const char* const _xsd_TpegLoc03OtherPointDescriptorSubtypeEnum_literals_[28];
    static const value _xsd_TpegLoc03OtherPointDescriptorSubtypeEnum_indexes_[28];
  };

  class TpegLoc04HeightTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      above,
      aboveSeaLevel,
      aboveStreetLevel,
      at,
      atSeaLevel,
      atStreetLevel,
      below,
      belowSeaLevel,
      belowStreetLevel,
      undefined,
      unknown,
      other
    };

    TpegLoc04HeightTypeEnum (value v);

    TpegLoc04HeightTypeEnum (const char* v);

    TpegLoc04HeightTypeEnum (const ::std::string& v);

    TpegLoc04HeightTypeEnum (const ::xml_schema::string& v);

    TpegLoc04HeightTypeEnum (const xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    TpegLoc04HeightTypeEnum (const xercesc::DOMAttr& a,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    TpegLoc04HeightTypeEnum (const ::std::string& s,
                             const xercesc::DOMElement* e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    TpegLoc04HeightTypeEnum (const TpegLoc04HeightTypeEnum& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual TpegLoc04HeightTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    TpegLoc04HeightTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_TpegLoc04HeightTypeEnum_convert ();
    }

    protected:
    value
    _xsd_TpegLoc04HeightTypeEnum_convert () const;

    public:
    static const char* const _xsd_TpegLoc04HeightTypeEnum_literals_[12];
    static const value _xsd_TpegLoc04HeightTypeEnum_indexes_[12];
  };

  class TpegNamedOnlyArea: public ::datex2::TpegAreaLocation
  {
    public:
    // name
    // 
    typedef ::datex2::TpegAreaDescriptor name_type;
    typedef ::xsd::cxx::tree::sequence< name_type > name_sequence;
    typedef xsd::cxx::tree::sequence< name_type >::iterator name_iterator;
    typedef xsd::cxx::tree::sequence< name_type >::const_iterator name_const_iterator;
    typedef ::xsd::cxx::tree::traits< name_type, char > name_traits;

    const name_sequence&
    name () const;

    name_sequence&
    name ();

    void
    name (const name_sequence& s);

    // tpegNamedOnlyAreaExtension
    // 
    typedef ::datex2::ExtensionType tpegNamedOnlyAreaExtension_type;
    typedef ::xsd::cxx::tree::optional< tpegNamedOnlyAreaExtension_type > tpegNamedOnlyAreaExtension_optional;
    typedef ::xsd::cxx::tree::traits< tpegNamedOnlyAreaExtension_type, char > tpegNamedOnlyAreaExtension_traits;

    const tpegNamedOnlyAreaExtension_optional&
    tpegNamedOnlyAreaExtension () const;

    tpegNamedOnlyAreaExtension_optional&
    tpegNamedOnlyAreaExtension ();

    void
    tpegNamedOnlyAreaExtension (const tpegNamedOnlyAreaExtension_type& x);

    void
    tpegNamedOnlyAreaExtension (const tpegNamedOnlyAreaExtension_optional& x);

    void
    tpegNamedOnlyAreaExtension (::std::auto_ptr< tpegNamedOnlyAreaExtension_type > p);

    // Constructors.
    //
    TpegNamedOnlyArea (const tpegAreaLocationType_type&);

    TpegNamedOnlyArea (const xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    TpegNamedOnlyArea (const TpegNamedOnlyArea& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual TpegNamedOnlyArea*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TpegNamedOnlyArea ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    name_sequence name_;
    tpegNamedOnlyAreaExtension_optional tpegNamedOnlyAreaExtension_;
  };

  class TpegNonJunctionPoint: public ::datex2::TpegPoint
  {
    public:
    // pointCoordinates
    // 
    typedef ::datex2::PointCoordinates pointCoordinates_type;
    typedef ::xsd::cxx::tree::traits< pointCoordinates_type, char > pointCoordinates_traits;

    const pointCoordinates_type&
    pointCoordinates () const;

    pointCoordinates_type&
    pointCoordinates ();

    void
    pointCoordinates (const pointCoordinates_type& x);

    void
    pointCoordinates (::std::auto_ptr< pointCoordinates_type > p);

    // name
    // 
    typedef ::datex2::TpegOtherPointDescriptor name_type;
    typedef ::xsd::cxx::tree::sequence< name_type > name_sequence;
    typedef xsd::cxx::tree::sequence< name_type >::iterator name_iterator;
    typedef xsd::cxx::tree::sequence< name_type >::const_iterator name_const_iterator;
    typedef ::xsd::cxx::tree::traits< name_type, char > name_traits;

    const name_sequence&
    name () const;

    name_sequence&
    name ();

    void
    name (const name_sequence& s);

    // tpegNonJunctionPointExtension
    // 
    typedef ::datex2::ExtensionType tpegNonJunctionPointExtension_type;
    typedef ::xsd::cxx::tree::optional< tpegNonJunctionPointExtension_type > tpegNonJunctionPointExtension_optional;
    typedef ::xsd::cxx::tree::traits< tpegNonJunctionPointExtension_type, char > tpegNonJunctionPointExtension_traits;

    const tpegNonJunctionPointExtension_optional&
    tpegNonJunctionPointExtension () const;

    tpegNonJunctionPointExtension_optional&
    tpegNonJunctionPointExtension ();

    void
    tpegNonJunctionPointExtension (const tpegNonJunctionPointExtension_type& x);

    void
    tpegNonJunctionPointExtension (const tpegNonJunctionPointExtension_optional& x);

    void
    tpegNonJunctionPointExtension (::std::auto_ptr< tpegNonJunctionPointExtension_type > p);

    // Constructors.
    //
    TpegNonJunctionPoint (const pointCoordinates_type&);

    TpegNonJunctionPoint (::std::auto_ptr< pointCoordinates_type >&);

    TpegNonJunctionPoint (const xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    TpegNonJunctionPoint (const TpegNonJunctionPoint& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual TpegNonJunctionPoint*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TpegNonJunctionPoint ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< pointCoordinates_type > pointCoordinates_;
    name_sequence name_;
    tpegNonJunctionPointExtension_optional tpegNonJunctionPointExtension_;
  };

  class TpegOtherPointDescriptor: public ::datex2::TpegPointDescriptor
  {
    public:
    // tpegOtherPointDescriptorType
    // 
    typedef ::datex2::TpegLoc03OtherPointDescriptorSubtypeEnum tpegOtherPointDescriptorType_type;
    typedef ::xsd::cxx::tree::traits< tpegOtherPointDescriptorType_type, char > tpegOtherPointDescriptorType_traits;

    const tpegOtherPointDescriptorType_type&
    tpegOtherPointDescriptorType () const;

    tpegOtherPointDescriptorType_type&
    tpegOtherPointDescriptorType ();

    void
    tpegOtherPointDescriptorType (const tpegOtherPointDescriptorType_type& x);

    void
    tpegOtherPointDescriptorType (::std::auto_ptr< tpegOtherPointDescriptorType_type > p);

    // tpegOtherPointDescriptorExtension
    // 
    typedef ::datex2::ExtensionType tpegOtherPointDescriptorExtension_type;
    typedef ::xsd::cxx::tree::optional< tpegOtherPointDescriptorExtension_type > tpegOtherPointDescriptorExtension_optional;
    typedef ::xsd::cxx::tree::traits< tpegOtherPointDescriptorExtension_type, char > tpegOtherPointDescriptorExtension_traits;

    const tpegOtherPointDescriptorExtension_optional&
    tpegOtherPointDescriptorExtension () const;

    tpegOtherPointDescriptorExtension_optional&
    tpegOtherPointDescriptorExtension ();

    void
    tpegOtherPointDescriptorExtension (const tpegOtherPointDescriptorExtension_type& x);

    void
    tpegOtherPointDescriptorExtension (const tpegOtherPointDescriptorExtension_optional& x);

    void
    tpegOtherPointDescriptorExtension (::std::auto_ptr< tpegOtherPointDescriptorExtension_type > p);

    // Constructors.
    //
    TpegOtherPointDescriptor (const descriptor_type&,
                              const tpegOtherPointDescriptorType_type&);

    TpegOtherPointDescriptor (::std::auto_ptr< descriptor_type >&,
                              const tpegOtherPointDescriptorType_type&);

    TpegOtherPointDescriptor (const xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    TpegOtherPointDescriptor (const TpegOtherPointDescriptor& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual TpegOtherPointDescriptor*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TpegOtherPointDescriptor ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< tpegOtherPointDescriptorType_type > tpegOtherPointDescriptorType_;
    tpegOtherPointDescriptorExtension_optional tpegOtherPointDescriptorExtension_;
  };

  class TpegSimplePoint: public ::datex2::TpegPointLocation
  {
    public:
    // tpegSimplePointLocationType
    // 
    typedef ::datex2::TpegLoc01SimplePointLocationSubtypeEnum tpegSimplePointLocationType_type;
    typedef ::xsd::cxx::tree::traits< tpegSimplePointLocationType_type, char > tpegSimplePointLocationType_traits;

    const tpegSimplePointLocationType_type&
    tpegSimplePointLocationType () const;

    tpegSimplePointLocationType_type&
    tpegSimplePointLocationType ();

    void
    tpegSimplePointLocationType (const tpegSimplePointLocationType_type& x);

    void
    tpegSimplePointLocationType (::std::auto_ptr< tpegSimplePointLocationType_type > p);

    // point
    // 
    typedef ::datex2::TpegPoint point_type;
    typedef ::xsd::cxx::tree::traits< point_type, char > point_traits;

    const point_type&
    point () const;

    point_type&
    point ();

    void
    point (const point_type& x);

    void
    point (::std::auto_ptr< point_type > p);

    // tpegSimplePointExtension
    // 
    typedef ::datex2::ExtensionType tpegSimplePointExtension_type;
    typedef ::xsd::cxx::tree::optional< tpegSimplePointExtension_type > tpegSimplePointExtension_optional;
    typedef ::xsd::cxx::tree::traits< tpegSimplePointExtension_type, char > tpegSimplePointExtension_traits;

    const tpegSimplePointExtension_optional&
    tpegSimplePointExtension () const;

    tpegSimplePointExtension_optional&
    tpegSimplePointExtension ();

    void
    tpegSimplePointExtension (const tpegSimplePointExtension_type& x);

    void
    tpegSimplePointExtension (const tpegSimplePointExtension_optional& x);

    void
    tpegSimplePointExtension (::std::auto_ptr< tpegSimplePointExtension_type > p);

    // Constructors.
    //
    TpegSimplePoint (const tpegDirection_type&,
                     const tpegSimplePointLocationType_type&,
                     const point_type&);

    TpegSimplePoint (const tpegDirection_type&,
                     const tpegSimplePointLocationType_type&,
                     ::std::auto_ptr< point_type >&);

    TpegSimplePoint (const xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    TpegSimplePoint (const TpegSimplePoint& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual TpegSimplePoint*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TpegSimplePoint ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< tpegSimplePointLocationType_type > tpegSimplePointLocationType_;
    ::xsd::cxx::tree::one< point_type > point_;
    tpegSimplePointExtension_optional tpegSimplePointExtension_;
  };

  class TrafficConcentration: public ::datex2::TrafficValue
  {
    public:
    // concentration
    // 
    typedef ::datex2::ConcentrationVehiclesPerKilometre concentration_type;
    typedef ::xsd::cxx::tree::optional< concentration_type > concentration_optional;
    typedef ::xsd::cxx::tree::traits< concentration_type, char > concentration_traits;

    const concentration_optional&
    concentration () const;

    concentration_optional&
    concentration ();

    void
    concentration (const concentration_type& x);

    void
    concentration (const concentration_optional& x);

    void
    concentration (::std::auto_ptr< concentration_type > p);

    // occupancy
    // 
    typedef ::datex2::Percentage occupancy_type;
    typedef ::xsd::cxx::tree::optional< occupancy_type > occupancy_optional;
    typedef ::xsd::cxx::tree::traits< occupancy_type, char > occupancy_traits;

    const occupancy_optional&
    occupancy () const;

    occupancy_optional&
    occupancy ();

    void
    occupancy (const occupancy_type& x);

    void
    occupancy (const occupancy_optional& x);

    void
    occupancy (::std::auto_ptr< occupancy_type > p);

    // trafficConcentrationExtension
    // 
    typedef ::datex2::ExtensionType trafficConcentrationExtension_type;
    typedef ::xsd::cxx::tree::optional< trafficConcentrationExtension_type > trafficConcentrationExtension_optional;
    typedef ::xsd::cxx::tree::traits< trafficConcentrationExtension_type, char > trafficConcentrationExtension_traits;

    const trafficConcentrationExtension_optional&
    trafficConcentrationExtension () const;

    trafficConcentrationExtension_optional&
    trafficConcentrationExtension ();

    void
    trafficConcentrationExtension (const trafficConcentrationExtension_type& x);

    void
    trafficConcentrationExtension (const trafficConcentrationExtension_optional& x);

    void
    trafficConcentrationExtension (::std::auto_ptr< trafficConcentrationExtension_type > p);

    // Constructors.
    //
    TrafficConcentration ();

    TrafficConcentration (const xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    TrafficConcentration (const TrafficConcentration& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual TrafficConcentration*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TrafficConcentration ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    concentration_optional concentration_;
    occupancy_optional occupancy_;
    trafficConcentrationExtension_optional trafficConcentrationExtension_;
  };

  class TrafficConstrictionTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      carriagewayBlocked,
      carriagewayPartiallyObstructed,
      lanesBlocked,
      lanesPartiallyObstructed,
      roadBlocked,
      roadPartiallyObstructed
    };

    TrafficConstrictionTypeEnum (value v);

    TrafficConstrictionTypeEnum (const char* v);

    TrafficConstrictionTypeEnum (const ::std::string& v);

    TrafficConstrictionTypeEnum (const ::xml_schema::string& v);

    TrafficConstrictionTypeEnum (const xercesc::DOMElement& e,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    TrafficConstrictionTypeEnum (const xercesc::DOMAttr& a,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    TrafficConstrictionTypeEnum (const ::std::string& s,
                                 const xercesc::DOMElement* e,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    TrafficConstrictionTypeEnum (const TrafficConstrictionTypeEnum& x,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    virtual TrafficConstrictionTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    TrafficConstrictionTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_TrafficConstrictionTypeEnum_convert ();
    }

    protected:
    value
    _xsd_TrafficConstrictionTypeEnum_convert () const;

    public:
    static const char* const _xsd_TrafficConstrictionTypeEnum_literals_[6];
    static const value _xsd_TrafficConstrictionTypeEnum_indexes_[6];
  };

  class TrafficFlow: public ::datex2::TrafficValue
  {
    public:
    // axleFlow
    // 
    typedef ::datex2::AxlesPerHour axleFlow_type;
    typedef ::xsd::cxx::tree::optional< axleFlow_type > axleFlow_optional;
    typedef ::xsd::cxx::tree::traits< axleFlow_type, char > axleFlow_traits;

    const axleFlow_optional&
    axleFlow () const;

    axleFlow_optional&
    axleFlow ();

    void
    axleFlow (const axleFlow_type& x);

    void
    axleFlow (const axleFlow_optional& x);

    void
    axleFlow (::std::auto_ptr< axleFlow_type > p);

    // pcuFlow
    // 
    typedef ::datex2::PassengerCarUnitsPerHour pcuFlow_type;
    typedef ::xsd::cxx::tree::optional< pcuFlow_type > pcuFlow_optional;
    typedef ::xsd::cxx::tree::traits< pcuFlow_type, char > pcuFlow_traits;

    const pcuFlow_optional&
    pcuFlow () const;

    pcuFlow_optional&
    pcuFlow ();

    void
    pcuFlow (const pcuFlow_type& x);

    void
    pcuFlow (const pcuFlow_optional& x);

    void
    pcuFlow (::std::auto_ptr< pcuFlow_type > p);

    // percentageLongVehicles
    // 
    typedef ::datex2::Percentage percentageLongVehicles_type;
    typedef ::xsd::cxx::tree::optional< percentageLongVehicles_type > percentageLongVehicles_optional;
    typedef ::xsd::cxx::tree::traits< percentageLongVehicles_type, char > percentageLongVehicles_traits;

    const percentageLongVehicles_optional&
    percentageLongVehicles () const;

    percentageLongVehicles_optional&
    percentageLongVehicles ();

    void
    percentageLongVehicles (const percentageLongVehicles_type& x);

    void
    percentageLongVehicles (const percentageLongVehicles_optional& x);

    void
    percentageLongVehicles (::std::auto_ptr< percentageLongVehicles_type > p);

    // vehicleFlow
    // 
    typedef ::datex2::VehiclesPerHour vehicleFlow_type;
    typedef ::xsd::cxx::tree::optional< vehicleFlow_type > vehicleFlow_optional;
    typedef ::xsd::cxx::tree::traits< vehicleFlow_type, char > vehicleFlow_traits;

    const vehicleFlow_optional&
    vehicleFlow () const;

    vehicleFlow_optional&
    vehicleFlow ();

    void
    vehicleFlow (const vehicleFlow_type& x);

    void
    vehicleFlow (const vehicleFlow_optional& x);

    void
    vehicleFlow (::std::auto_ptr< vehicleFlow_type > p);

    // trafficFlowExtension
    // 
    typedef ::datex2::ExtensionType trafficFlowExtension_type;
    typedef ::xsd::cxx::tree::optional< trafficFlowExtension_type > trafficFlowExtension_optional;
    typedef ::xsd::cxx::tree::traits< trafficFlowExtension_type, char > trafficFlowExtension_traits;

    const trafficFlowExtension_optional&
    trafficFlowExtension () const;

    trafficFlowExtension_optional&
    trafficFlowExtension ();

    void
    trafficFlowExtension (const trafficFlowExtension_type& x);

    void
    trafficFlowExtension (const trafficFlowExtension_optional& x);

    void
    trafficFlowExtension (::std::auto_ptr< trafficFlowExtension_type > p);

    // Constructors.
    //
    TrafficFlow ();

    TrafficFlow (const xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    TrafficFlow (const TrafficFlow& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual TrafficFlow*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TrafficFlow ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    axleFlow_optional axleFlow_;
    pcuFlow_optional pcuFlow_;
    percentageLongVehicles_optional percentageLongVehicles_;
    vehicleFlow_optional vehicleFlow_;
    trafficFlowExtension_optional trafficFlowExtension_;
  };

  class TrafficFlowCharacteristicsEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      erraticFlow,
      smoothFlow,
      stopAndGo,
      trafficBlocked
    };

    TrafficFlowCharacteristicsEnum (value v);

    TrafficFlowCharacteristicsEnum (const char* v);

    TrafficFlowCharacteristicsEnum (const ::std::string& v);

    TrafficFlowCharacteristicsEnum (const ::xml_schema::string& v);

    TrafficFlowCharacteristicsEnum (const xercesc::DOMElement& e,
                                    ::xml_schema::flags f = 0,
                                    ::xml_schema::container* c = 0);

    TrafficFlowCharacteristicsEnum (const xercesc::DOMAttr& a,
                                    ::xml_schema::flags f = 0,
                                    ::xml_schema::container* c = 0);

    TrafficFlowCharacteristicsEnum (const ::std::string& s,
                                    const xercesc::DOMElement* e,
                                    ::xml_schema::flags f = 0,
                                    ::xml_schema::container* c = 0);

    TrafficFlowCharacteristicsEnum (const TrafficFlowCharacteristicsEnum& x,
                                    ::xml_schema::flags f = 0,
                                    ::xml_schema::container* c = 0);

    virtual TrafficFlowCharacteristicsEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    TrafficFlowCharacteristicsEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_TrafficFlowCharacteristicsEnum_convert ();
    }

    protected:
    value
    _xsd_TrafficFlowCharacteristicsEnum_convert () const;

    public:
    static const char* const _xsd_TrafficFlowCharacteristicsEnum_literals_[4];
    static const value _xsd_TrafficFlowCharacteristicsEnum_indexes_[4];
  };

  class TrafficHeadway: public ::datex2::TrafficValue
  {
    public:
    // averageDistanceHeadway
    // 
    typedef ::datex2::MetresAsFloat averageDistanceHeadway_type;
    typedef ::xsd::cxx::tree::optional< averageDistanceHeadway_type > averageDistanceHeadway_optional;
    typedef ::xsd::cxx::tree::traits< averageDistanceHeadway_type, char > averageDistanceHeadway_traits;

    const averageDistanceHeadway_optional&
    averageDistanceHeadway () const;

    averageDistanceHeadway_optional&
    averageDistanceHeadway ();

    void
    averageDistanceHeadway (const averageDistanceHeadway_type& x);

    void
    averageDistanceHeadway (const averageDistanceHeadway_optional& x);

    void
    averageDistanceHeadway (::std::auto_ptr< averageDistanceHeadway_type > p);

    // averageTimeHeadway
    // 
    typedef ::datex2::Seconds averageTimeHeadway_type;
    typedef ::xsd::cxx::tree::optional< averageTimeHeadway_type > averageTimeHeadway_optional;
    typedef ::xsd::cxx::tree::traits< averageTimeHeadway_type, char > averageTimeHeadway_traits;

    const averageTimeHeadway_optional&
    averageTimeHeadway () const;

    averageTimeHeadway_optional&
    averageTimeHeadway ();

    void
    averageTimeHeadway (const averageTimeHeadway_type& x);

    void
    averageTimeHeadway (const averageTimeHeadway_optional& x);

    void
    averageTimeHeadway (::std::auto_ptr< averageTimeHeadway_type > p);

    // trafficHeadwayExtension
    // 
    typedef ::datex2::ExtensionType trafficHeadwayExtension_type;
    typedef ::xsd::cxx::tree::optional< trafficHeadwayExtension_type > trafficHeadwayExtension_optional;
    typedef ::xsd::cxx::tree::traits< trafficHeadwayExtension_type, char > trafficHeadwayExtension_traits;

    const trafficHeadwayExtension_optional&
    trafficHeadwayExtension () const;

    trafficHeadwayExtension_optional&
    trafficHeadwayExtension ();

    void
    trafficHeadwayExtension (const trafficHeadwayExtension_type& x);

    void
    trafficHeadwayExtension (const trafficHeadwayExtension_optional& x);

    void
    trafficHeadwayExtension (::std::auto_ptr< trafficHeadwayExtension_type > p);

    // Constructors.
    //
    TrafficHeadway ();

    TrafficHeadway (const xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    TrafficHeadway (const TrafficHeadway& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual TrafficHeadway*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TrafficHeadway ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    averageDistanceHeadway_optional averageDistanceHeadway_;
    averageTimeHeadway_optional averageTimeHeadway_;
    trafficHeadwayExtension_optional trafficHeadwayExtension_;
  };

  class TrafficSpeed: public ::datex2::TrafficValue
  {
    public:
    // averageVehicleSpeed
    // 
    typedef ::datex2::KilometresPerHour averageVehicleSpeed_type;
    typedef ::xsd::cxx::tree::optional< averageVehicleSpeed_type > averageVehicleSpeed_optional;
    typedef ::xsd::cxx::tree::traits< averageVehicleSpeed_type, char > averageVehicleSpeed_traits;

    const averageVehicleSpeed_optional&
    averageVehicleSpeed () const;

    averageVehicleSpeed_optional&
    averageVehicleSpeed ();

    void
    averageVehicleSpeed (const averageVehicleSpeed_type& x);

    void
    averageVehicleSpeed (const averageVehicleSpeed_optional& x);

    void
    averageVehicleSpeed (::std::auto_ptr< averageVehicleSpeed_type > p);

    // speedPercentile
    // 
    typedef ::datex2::SpeedPercentile speedPercentile_type;
    typedef ::xsd::cxx::tree::optional< speedPercentile_type > speedPercentile_optional;
    typedef ::xsd::cxx::tree::traits< speedPercentile_type, char > speedPercentile_traits;

    const speedPercentile_optional&
    speedPercentile () const;

    speedPercentile_optional&
    speedPercentile ();

    void
    speedPercentile (const speedPercentile_type& x);

    void
    speedPercentile (const speedPercentile_optional& x);

    void
    speedPercentile (::std::auto_ptr< speedPercentile_type > p);

    // trafficSpeedExtension
    // 
    typedef ::datex2::ExtensionType trafficSpeedExtension_type;
    typedef ::xsd::cxx::tree::optional< trafficSpeedExtension_type > trafficSpeedExtension_optional;
    typedef ::xsd::cxx::tree::traits< trafficSpeedExtension_type, char > trafficSpeedExtension_traits;

    const trafficSpeedExtension_optional&
    trafficSpeedExtension () const;

    trafficSpeedExtension_optional&
    trafficSpeedExtension ();

    void
    trafficSpeedExtension (const trafficSpeedExtension_type& x);

    void
    trafficSpeedExtension (const trafficSpeedExtension_optional& x);

    void
    trafficSpeedExtension (::std::auto_ptr< trafficSpeedExtension_type > p);

    // Constructors.
    //
    TrafficSpeed ();

    TrafficSpeed (const xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    TrafficSpeed (const TrafficSpeed& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual TrafficSpeed*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TrafficSpeed ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    averageVehicleSpeed_optional averageVehicleSpeed_;
    speedPercentile_optional speedPercentile_;
    trafficSpeedExtension_optional trafficSpeedExtension_;
  };

  class TrafficStatusEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      impossible,
      congested,
      heavy,
      freeFlow,
      unknown
    };

    TrafficStatusEnum (value v);

    TrafficStatusEnum (const char* v);

    TrafficStatusEnum (const ::std::string& v);

    TrafficStatusEnum (const ::xml_schema::string& v);

    TrafficStatusEnum (const xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    TrafficStatusEnum (const xercesc::DOMAttr& a,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    TrafficStatusEnum (const ::std::string& s,
                       const xercesc::DOMElement* e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    TrafficStatusEnum (const TrafficStatusEnum& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual TrafficStatusEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    TrafficStatusEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_TrafficStatusEnum_convert ();
    }

    protected:
    value
    _xsd_TrafficStatusEnum_convert () const;

    public:
    static const char* const _xsd_TrafficStatusEnum_literals_[5];
    static const value _xsd_TrafficStatusEnum_indexes_[5];
  };

  class TrafficStatusValue: public ::datex2::BasicDataValue
  {
    public:
    // trafficStatus
    // 
    typedef ::datex2::TrafficStatusEnum trafficStatus_type;
    typedef ::xsd::cxx::tree::optional< trafficStatus_type > trafficStatus_optional;
    typedef ::xsd::cxx::tree::traits< trafficStatus_type, char > trafficStatus_traits;

    const trafficStatus_optional&
    trafficStatus () const;

    trafficStatus_optional&
    trafficStatus ();

    void
    trafficStatus (const trafficStatus_type& x);

    void
    trafficStatus (const trafficStatus_optional& x);

    void
    trafficStatus (::std::auto_ptr< trafficStatus_type > p);

    // trafficTrendType
    // 
    typedef ::datex2::TrafficTrendTypeEnum trafficTrendType_type;
    typedef ::xsd::cxx::tree::optional< trafficTrendType_type > trafficTrendType_optional;
    typedef ::xsd::cxx::tree::traits< trafficTrendType_type, char > trafficTrendType_traits;

    const trafficTrendType_optional&
    trafficTrendType () const;

    trafficTrendType_optional&
    trafficTrendType ();

    void
    trafficTrendType (const trafficTrendType_type& x);

    void
    trafficTrendType (const trafficTrendType_optional& x);

    void
    trafficTrendType (::std::auto_ptr< trafficTrendType_type > p);

    // trafficStatusValueExtension
    // 
    typedef ::datex2::ExtensionType trafficStatusValueExtension_type;
    typedef ::xsd::cxx::tree::optional< trafficStatusValueExtension_type > trafficStatusValueExtension_optional;
    typedef ::xsd::cxx::tree::traits< trafficStatusValueExtension_type, char > trafficStatusValueExtension_traits;

    const trafficStatusValueExtension_optional&
    trafficStatusValueExtension () const;

    trafficStatusValueExtension_optional&
    trafficStatusValueExtension ();

    void
    trafficStatusValueExtension (const trafficStatusValueExtension_type& x);

    void
    trafficStatusValueExtension (const trafficStatusValueExtension_optional& x);

    void
    trafficStatusValueExtension (::std::auto_ptr< trafficStatusValueExtension_type > p);

    // Constructors.
    //
    TrafficStatusValue ();

    TrafficStatusValue (const xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    TrafficStatusValue (const TrafficStatusValue& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual TrafficStatusValue*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TrafficStatusValue ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    trafficStatus_optional trafficStatus_;
    trafficTrendType_optional trafficTrendType_;
    trafficStatusValueExtension_optional trafficStatusValueExtension_;
  };

  class TrafficTrendTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      trafficBuildingUp,
      trafficEasing,
      trafficStable,
      unknown
    };

    TrafficTrendTypeEnum (value v);

    TrafficTrendTypeEnum (const char* v);

    TrafficTrendTypeEnum (const ::std::string& v);

    TrafficTrendTypeEnum (const ::xml_schema::string& v);

    TrafficTrendTypeEnum (const xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    TrafficTrendTypeEnum (const xercesc::DOMAttr& a,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    TrafficTrendTypeEnum (const ::std::string& s,
                          const xercesc::DOMElement* e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    TrafficTrendTypeEnum (const TrafficTrendTypeEnum& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual TrafficTrendTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    TrafficTrendTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_TrafficTrendTypeEnum_convert ();
    }

    protected:
    value
    _xsd_TrafficTrendTypeEnum_convert () const;

    public:
    static const char* const _xsd_TrafficTrendTypeEnum_literals_[4];
    static const value _xsd_TrafficTrendTypeEnum_indexes_[4];
  };

  class TrafficTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      accessOnlyTraffic,
      destinedForAirport,
      destinedForAirportArrivals,
      destinedForAirportDepartures,
      destinedForFerryService,
      destinedForRailService,
      holidayTraffic,
      localTraffic,
      longDistanceTraffic,
      regionalTraffic,
      residentsOnlyTraffic,
      throughTraffic,
      visitorTraffic
    };

    TrafficTypeEnum (value v);

    TrafficTypeEnum (const char* v);

    TrafficTypeEnum (const ::std::string& v);

    TrafficTypeEnum (const ::xml_schema::string& v);

    TrafficTypeEnum (const xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    TrafficTypeEnum (const xercesc::DOMAttr& a,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    TrafficTypeEnum (const ::std::string& s,
                     const xercesc::DOMElement* e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    TrafficTypeEnum (const TrafficTypeEnum& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual TrafficTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    TrafficTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_TrafficTypeEnum_convert ();
    }

    protected:
    value
    _xsd_TrafficTypeEnum_convert () const;

    public:
    static const char* const _xsd_TrafficTypeEnum_literals_[13];
    static const value _xsd_TrafficTypeEnum_indexes_[13];
  };

  class TrafficView: public ::xml_schema::type
  {
    public:
    // trafficViewTime
    // 
    typedef ::datex2::DateTime trafficViewTime_type;
    typedef ::xsd::cxx::tree::traits< trafficViewTime_type, char > trafficViewTime_traits;

    const trafficViewTime_type&
    trafficViewTime () const;

    trafficViewTime_type&
    trafficViewTime ();

    void
    trafficViewTime (const trafficViewTime_type& x);

    void
    trafficViewTime (::std::auto_ptr< trafficViewTime_type > p);

    // predefinedLocationSetReference
    // 
    typedef ::datex2::Reference predefinedLocationSetReference_type;
    typedef ::xsd::cxx::tree::traits< predefinedLocationSetReference_type, char > predefinedLocationSetReference_traits;

    const predefinedLocationSetReference_type&
    predefinedLocationSetReference () const;

    predefinedLocationSetReference_type&
    predefinedLocationSetReference ();

    void
    predefinedLocationSetReference (const predefinedLocationSetReference_type& x);

    void
    predefinedLocationSetReference (::std::auto_ptr< predefinedLocationSetReference_type > p);

    // linearTrafficView
    // 
    typedef ::datex2::LinearTrafficView linearTrafficView_type;
    typedef ::xsd::cxx::tree::sequence< linearTrafficView_type > linearTrafficView_sequence;
    typedef xsd::cxx::tree::sequence< linearTrafficView_type >::iterator linearTrafficView_iterator;
    typedef xsd::cxx::tree::sequence< linearTrafficView_type >::const_iterator linearTrafficView_const_iterator;
    typedef ::xsd::cxx::tree::traits< linearTrafficView_type, char > linearTrafficView_traits;

    const linearTrafficView_sequence&
    linearTrafficView () const;

    linearTrafficView_sequence&
    linearTrafficView ();

    void
    linearTrafficView (const linearTrafficView_sequence& s);

    // trafficViewExtension
    // 
    typedef ::datex2::ExtensionType trafficViewExtension_type;
    typedef ::xsd::cxx::tree::optional< trafficViewExtension_type > trafficViewExtension_optional;
    typedef ::xsd::cxx::tree::traits< trafficViewExtension_type, char > trafficViewExtension_traits;

    const trafficViewExtension_optional&
    trafficViewExtension () const;

    trafficViewExtension_optional&
    trafficViewExtension ();

    void
    trafficViewExtension (const trafficViewExtension_type& x);

    void
    trafficViewExtension (const trafficViewExtension_optional& x);

    void
    trafficViewExtension (::std::auto_ptr< trafficViewExtension_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_type&
    id () const;

    id_type&
    id ();

    void
    id (const id_type& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    TrafficView (const trafficViewTime_type&,
                 const predefinedLocationSetReference_type&,
                 const id_type&);

    TrafficView (const xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    TrafficView (const TrafficView& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual TrafficView*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TrafficView ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< trafficViewTime_type > trafficViewTime_;
    ::xsd::cxx::tree::one< predefinedLocationSetReference_type > predefinedLocationSetReference_;
    linearTrafficView_sequence linearTrafficView_;
    trafficViewExtension_optional trafficViewExtension_;
    ::xsd::cxx::tree::one< id_type > id_;
  };

  class TrafficViewPublication: public ::datex2::PayloadPublication
  {
    public:
    // headerInformation
    // 
    typedef ::datex2::HeaderInformation headerInformation_type;
    typedef ::xsd::cxx::tree::traits< headerInformation_type, char > headerInformation_traits;

    const headerInformation_type&
    headerInformation () const;

    headerInformation_type&
    headerInformation ();

    void
    headerInformation (const headerInformation_type& x);

    void
    headerInformation (::std::auto_ptr< headerInformation_type > p);

    // trafficView
    // 
    typedef ::datex2::TrafficView trafficView_type;
    typedef ::xsd::cxx::tree::sequence< trafficView_type > trafficView_sequence;
    typedef xsd::cxx::tree::sequence< trafficView_type >::iterator trafficView_iterator;
    typedef xsd::cxx::tree::sequence< trafficView_type >::const_iterator trafficView_const_iterator;
    typedef ::xsd::cxx::tree::traits< trafficView_type, char > trafficView_traits;

    const trafficView_sequence&
    trafficView () const;

    trafficView_sequence&
    trafficView ();

    void
    trafficView (const trafficView_sequence& s);

    // trafficViewPublicationExtension
    // 
    typedef ::datex2::ExtensionType trafficViewPublicationExtension_type;
    typedef ::xsd::cxx::tree::optional< trafficViewPublicationExtension_type > trafficViewPublicationExtension_optional;
    typedef ::xsd::cxx::tree::traits< trafficViewPublicationExtension_type, char > trafficViewPublicationExtension_traits;

    const trafficViewPublicationExtension_optional&
    trafficViewPublicationExtension () const;

    trafficViewPublicationExtension_optional&
    trafficViewPublicationExtension ();

    void
    trafficViewPublicationExtension (const trafficViewPublicationExtension_type& x);

    void
    trafficViewPublicationExtension (const trafficViewPublicationExtension_optional& x);

    void
    trafficViewPublicationExtension (::std::auto_ptr< trafficViewPublicationExtension_type > p);

    // Constructors.
    //
    TrafficViewPublication (const publicationTime_type&,
                            const publicationCreator_type&,
                            const lang_type&,
                            const headerInformation_type&);

    TrafficViewPublication (const publicationTime_type&,
                            ::std::auto_ptr< publicationCreator_type >&,
                            const lang_type&,
                            ::std::auto_ptr< headerInformation_type >&);

    TrafficViewPublication (const xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    TrafficViewPublication (const TrafficViewPublication& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual TrafficViewPublication*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TrafficViewPublication ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< headerInformation_type > headerInformation_;
    trafficView_sequence trafficView_;
    trafficViewPublicationExtension_optional trafficViewPublicationExtension_;
  };

  class TrafficViewRecord: public ::xml_schema::type
  {
    public:
    // recordSequenceNumber
    // 
    typedef ::datex2::NonNegativeInteger recordSequenceNumber_type;
    typedef ::xsd::cxx::tree::traits< recordSequenceNumber_type, char > recordSequenceNumber_traits;

    const recordSequenceNumber_type&
    recordSequenceNumber () const;

    recordSequenceNumber_type&
    recordSequenceNumber ();

    void
    recordSequenceNumber (const recordSequenceNumber_type& x);

    void
    recordSequenceNumber (::std::auto_ptr< recordSequenceNumber_type > p);

    // trafficElement
    // 
    typedef ::datex2::TrafficElement trafficElement_type;
    typedef ::xsd::cxx::tree::optional< trafficElement_type > trafficElement_optional;
    typedef ::xsd::cxx::tree::traits< trafficElement_type, char > trafficElement_traits;

    const trafficElement_optional&
    trafficElement () const;

    trafficElement_optional&
    trafficElement ();

    void
    trafficElement (const trafficElement_type& x);

    void
    trafficElement (const trafficElement_optional& x);

    void
    trafficElement (::std::auto_ptr< trafficElement_type > p);

    // operatorAction
    // 
    typedef ::datex2::OperatorAction operatorAction_type;
    typedef ::xsd::cxx::tree::optional< operatorAction_type > operatorAction_optional;
    typedef ::xsd::cxx::tree::traits< operatorAction_type, char > operatorAction_traits;

    const operatorAction_optional&
    operatorAction () const;

    operatorAction_optional&
    operatorAction ();

    void
    operatorAction (const operatorAction_type& x);

    void
    operatorAction (const operatorAction_optional& x);

    void
    operatorAction (::std::auto_ptr< operatorAction_type > p);

    // elaboratedData
    // 
    typedef ::datex2::ElaboratedData elaboratedData_type;
    typedef ::xsd::cxx::tree::optional< elaboratedData_type > elaboratedData_optional;
    typedef ::xsd::cxx::tree::traits< elaboratedData_type, char > elaboratedData_traits;

    const elaboratedData_optional&
    elaboratedData () const;

    elaboratedData_optional&
    elaboratedData ();

    void
    elaboratedData (const elaboratedData_type& x);

    void
    elaboratedData (const elaboratedData_optional& x);

    void
    elaboratedData (::std::auto_ptr< elaboratedData_type > p);

    // urlLink
    // 
    typedef ::datex2::UrlLink urlLink_type;
    typedef ::xsd::cxx::tree::sequence< urlLink_type > urlLink_sequence;
    typedef xsd::cxx::tree::sequence< urlLink_type >::iterator urlLink_iterator;
    typedef xsd::cxx::tree::sequence< urlLink_type >::const_iterator urlLink_const_iterator;
    typedef ::xsd::cxx::tree::traits< urlLink_type, char > urlLink_traits;

    const urlLink_sequence&
    urlLink () const;

    urlLink_sequence&
    urlLink ();

    void
    urlLink (const urlLink_sequence& s);

    // trafficViewRecordExtension
    // 
    typedef ::datex2::ExtensionType trafficViewRecordExtension_type;
    typedef ::xsd::cxx::tree::optional< trafficViewRecordExtension_type > trafficViewRecordExtension_optional;
    typedef ::xsd::cxx::tree::traits< trafficViewRecordExtension_type, char > trafficViewRecordExtension_traits;

    const trafficViewRecordExtension_optional&
    trafficViewRecordExtension () const;

    trafficViewRecordExtension_optional&
    trafficViewRecordExtension ();

    void
    trafficViewRecordExtension (const trafficViewRecordExtension_type& x);

    void
    trafficViewRecordExtension (const trafficViewRecordExtension_optional& x);

    void
    trafficViewRecordExtension (::std::auto_ptr< trafficViewRecordExtension_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_type&
    id () const;

    id_type&
    id ();

    void
    id (const id_type& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    TrafficViewRecord (const recordSequenceNumber_type&,
                       const id_type&);

    TrafficViewRecord (const xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    TrafficViewRecord (const TrafficViewRecord& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual TrafficViewRecord*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TrafficViewRecord ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< recordSequenceNumber_type > recordSequenceNumber_;
    trafficElement_optional trafficElement_;
    operatorAction_optional operatorAction_;
    elaboratedData_optional elaboratedData_;
    urlLink_sequence urlLink_;
    trafficViewRecordExtension_optional trafficViewRecordExtension_;
    ::xsd::cxx::tree::one< id_type > id_;
  };

  class TransitInformation: public ::datex2::NonRoadEventInformation
  {
    public:
    // journeyDestination
    // 
    typedef ::datex2::MultilingualString journeyDestination_type;
    typedef ::xsd::cxx::tree::optional< journeyDestination_type > journeyDestination_optional;
    typedef ::xsd::cxx::tree::traits< journeyDestination_type, char > journeyDestination_traits;

    const journeyDestination_optional&
    journeyDestination () const;

    journeyDestination_optional&
    journeyDestination ();

    void
    journeyDestination (const journeyDestination_type& x);

    void
    journeyDestination (const journeyDestination_optional& x);

    void
    journeyDestination (::std::auto_ptr< journeyDestination_type > p);

    // journeyOrigin
    // 
    typedef ::datex2::MultilingualString journeyOrigin_type;
    typedef ::xsd::cxx::tree::optional< journeyOrigin_type > journeyOrigin_optional;
    typedef ::xsd::cxx::tree::traits< journeyOrigin_type, char > journeyOrigin_traits;

    const journeyOrigin_optional&
    journeyOrigin () const;

    journeyOrigin_optional&
    journeyOrigin ();

    void
    journeyOrigin (const journeyOrigin_type& x);

    void
    journeyOrigin (const journeyOrigin_optional& x);

    void
    journeyOrigin (::std::auto_ptr< journeyOrigin_type > p);

    // journeyReference
    // 
    typedef ::datex2::String journeyReference_type;
    typedef ::xsd::cxx::tree::optional< journeyReference_type > journeyReference_optional;
    typedef ::xsd::cxx::tree::traits< journeyReference_type, char > journeyReference_traits;

    const journeyReference_optional&
    journeyReference () const;

    journeyReference_optional&
    journeyReference ();

    void
    journeyReference (const journeyReference_type& x);

    void
    journeyReference (const journeyReference_optional& x);

    void
    journeyReference (::std::auto_ptr< journeyReference_type > p);

    // transitServiceInformation
    // 
    typedef ::datex2::TransitServiceInformationEnum transitServiceInformation_type;
    typedef ::xsd::cxx::tree::traits< transitServiceInformation_type, char > transitServiceInformation_traits;

    const transitServiceInformation_type&
    transitServiceInformation () const;

    transitServiceInformation_type&
    transitServiceInformation ();

    void
    transitServiceInformation (const transitServiceInformation_type& x);

    void
    transitServiceInformation (::std::auto_ptr< transitServiceInformation_type > p);

    // transitServiceType
    // 
    typedef ::datex2::TransitServiceTypeEnum transitServiceType_type;
    typedef ::xsd::cxx::tree::traits< transitServiceType_type, char > transitServiceType_traits;

    const transitServiceType_type&
    transitServiceType () const;

    transitServiceType_type&
    transitServiceType ();

    void
    transitServiceType (const transitServiceType_type& x);

    void
    transitServiceType (::std::auto_ptr< transitServiceType_type > p);

    // scheduledDepartureTime
    // 
    typedef ::datex2::DateTime scheduledDepartureTime_type;
    typedef ::xsd::cxx::tree::optional< scheduledDepartureTime_type > scheduledDepartureTime_optional;
    typedef ::xsd::cxx::tree::traits< scheduledDepartureTime_type, char > scheduledDepartureTime_traits;

    const scheduledDepartureTime_optional&
    scheduledDepartureTime () const;

    scheduledDepartureTime_optional&
    scheduledDepartureTime ();

    void
    scheduledDepartureTime (const scheduledDepartureTime_type& x);

    void
    scheduledDepartureTime (const scheduledDepartureTime_optional& x);

    void
    scheduledDepartureTime (::std::auto_ptr< scheduledDepartureTime_type > p);

    // transitInformationExtension
    // 
    typedef ::datex2::ExtensionType transitInformationExtension_type;
    typedef ::xsd::cxx::tree::optional< transitInformationExtension_type > transitInformationExtension_optional;
    typedef ::xsd::cxx::tree::traits< transitInformationExtension_type, char > transitInformationExtension_traits;

    const transitInformationExtension_optional&
    transitInformationExtension () const;

    transitInformationExtension_optional&
    transitInformationExtension ();

    void
    transitInformationExtension (const transitInformationExtension_type& x);

    void
    transitInformationExtension (const transitInformationExtension_optional& x);

    void
    transitInformationExtension (::std::auto_ptr< transitInformationExtension_type > p);

    // Constructors.
    //
    TransitInformation (const situationRecordCreationTime_type&,
                        const situationRecordVersion_type&,
                        const situationRecordVersionTime_type&,
                        const probabilityOfOccurrence_type&,
                        const validity_type&,
                        const groupOfLocations_type&,
                        const id_type&,
                        const transitServiceInformation_type&,
                        const transitServiceType_type&);

    TransitInformation (const situationRecordCreationTime_type&,
                        const situationRecordVersion_type&,
                        const situationRecordVersionTime_type&,
                        const probabilityOfOccurrence_type&,
                        ::std::auto_ptr< validity_type >&,
                        ::std::auto_ptr< groupOfLocations_type >&,
                        const id_type&,
                        const transitServiceInformation_type&,
                        const transitServiceType_type&);

    TransitInformation (const xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    TransitInformation (const TransitInformation& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual TransitInformation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TransitInformation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    journeyDestination_optional journeyDestination_;
    journeyOrigin_optional journeyOrigin_;
    journeyReference_optional journeyReference_;
    ::xsd::cxx::tree::one< transitServiceInformation_type > transitServiceInformation_;
    ::xsd::cxx::tree::one< transitServiceType_type > transitServiceType_;
    scheduledDepartureTime_optional scheduledDepartureTime_;
    transitInformationExtension_optional transitInformationExtension_;
  };

  class TransitServiceInformationEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      cancellations,
      delayDueToBadWeather,
      delayDueToRepairs,
      delayedUntilFurtherNotice,
      delaysDueToFlotsum,
      departureOnSchedule,
      ferryReplacedByIceRoad,
      freeShuttleServiceOperating,
      informationServiceNotAvailable,
      irregularServiceDelays,
      loadCapacityChanged,
      restrictionsForLongerVehicles,
      serviceDelays,
      serviceDelaysOfUncertainDuration,
      serviceFullyBooked,
      serviceNotOperating,
      serviceNotOperatingSubstituteServiceAvailable,
      serviceSuspended,
      serviceWithdrawn,
      shuttleServiceOperating,
      temporaryChangesToTimetables,
      other
    };

    TransitServiceInformationEnum (value v);

    TransitServiceInformationEnum (const char* v);

    TransitServiceInformationEnum (const ::std::string& v);

    TransitServiceInformationEnum (const ::xml_schema::string& v);

    TransitServiceInformationEnum (const xercesc::DOMElement& e,
                                   ::xml_schema::flags f = 0,
                                   ::xml_schema::container* c = 0);

    TransitServiceInformationEnum (const xercesc::DOMAttr& a,
                                   ::xml_schema::flags f = 0,
                                   ::xml_schema::container* c = 0);

    TransitServiceInformationEnum (const ::std::string& s,
                                   const xercesc::DOMElement* e,
                                   ::xml_schema::flags f = 0,
                                   ::xml_schema::container* c = 0);

    TransitServiceInformationEnum (const TransitServiceInformationEnum& x,
                                   ::xml_schema::flags f = 0,
                                   ::xml_schema::container* c = 0);

    virtual TransitServiceInformationEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    TransitServiceInformationEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_TransitServiceInformationEnum_convert ();
    }

    protected:
    value
    _xsd_TransitServiceInformationEnum_convert () const;

    public:
    static const char* const _xsd_TransitServiceInformationEnum_literals_[22];
    static const value _xsd_TransitServiceInformationEnum_indexes_[22];
  };

  class TransitServiceTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      air,
      bus,
      ferry,
      hydrofoil,
      rail,
      tram,
      undergroundMetro
    };

    TransitServiceTypeEnum (value v);

    TransitServiceTypeEnum (const char* v);

    TransitServiceTypeEnum (const ::std::string& v);

    TransitServiceTypeEnum (const ::xml_schema::string& v);

    TransitServiceTypeEnum (const xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    TransitServiceTypeEnum (const xercesc::DOMAttr& a,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    TransitServiceTypeEnum (const ::std::string& s,
                            const xercesc::DOMElement* e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    TransitServiceTypeEnum (const TransitServiceTypeEnum& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual TransitServiceTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    TransitServiceTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_TransitServiceTypeEnum_convert ();
    }

    protected:
    value
    _xsd_TransitServiceTypeEnum_convert () const;

    public:
    static const char* const _xsd_TransitServiceTypeEnum_literals_[7];
    static const value _xsd_TransitServiceTypeEnum_indexes_[7];
  };

  class TravelTimeTrendTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      decreasing,
      increasing,
      stable
    };

    TravelTimeTrendTypeEnum (value v);

    TravelTimeTrendTypeEnum (const char* v);

    TravelTimeTrendTypeEnum (const ::std::string& v);

    TravelTimeTrendTypeEnum (const ::xml_schema::string& v);

    TravelTimeTrendTypeEnum (const xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    TravelTimeTrendTypeEnum (const xercesc::DOMAttr& a,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    TravelTimeTrendTypeEnum (const ::std::string& s,
                             const xercesc::DOMElement* e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    TravelTimeTrendTypeEnum (const TravelTimeTrendTypeEnum& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual TravelTimeTrendTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    TravelTimeTrendTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_TravelTimeTrendTypeEnum_convert ();
    }

    protected:
    value
    _xsd_TravelTimeTrendTypeEnum_convert () const;

    public:
    static const char* const _xsd_TravelTimeTrendTypeEnum_literals_[3];
    static const value _xsd_TravelTimeTrendTypeEnum_indexes_[3];
  };

  class TravelTimeTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      best,
      estimated,
      instantaneous,
      reconstituted
    };

    TravelTimeTypeEnum (value v);

    TravelTimeTypeEnum (const char* v);

    TravelTimeTypeEnum (const ::std::string& v);

    TravelTimeTypeEnum (const ::xml_schema::string& v);

    TravelTimeTypeEnum (const xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    TravelTimeTypeEnum (const xercesc::DOMAttr& a,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    TravelTimeTypeEnum (const ::std::string& s,
                        const xercesc::DOMElement* e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    TravelTimeTypeEnum (const TravelTimeTypeEnum& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual TravelTimeTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    TravelTimeTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_TravelTimeTypeEnum_convert ();
    }

    protected:
    value
    _xsd_TravelTimeTypeEnum_convert () const;

    public:
    static const char* const _xsd_TravelTimeTypeEnum_literals_[4];
    static const value _xsd_TravelTimeTypeEnum_indexes_[4];
  };

  class TravelTimeValue: public ::datex2::BasicDataValue
  {
    public:
    // travelTime
    // 
    typedef ::datex2::Seconds travelTime_type;
    typedef ::xsd::cxx::tree::optional< travelTime_type > travelTime_optional;
    typedef ::xsd::cxx::tree::traits< travelTime_type, char > travelTime_traits;

    const travelTime_optional&
    travelTime () const;

    travelTime_optional&
    travelTime ();

    void
    travelTime (const travelTime_type& x);

    void
    travelTime (const travelTime_optional& x);

    void
    travelTime (::std::auto_ptr< travelTime_type > p);

    // travelTimeTrendType
    // 
    typedef ::datex2::TravelTimeTrendTypeEnum travelTimeTrendType_type;
    typedef ::xsd::cxx::tree::optional< travelTimeTrendType_type > travelTimeTrendType_optional;
    typedef ::xsd::cxx::tree::traits< travelTimeTrendType_type, char > travelTimeTrendType_traits;

    const travelTimeTrendType_optional&
    travelTimeTrendType () const;

    travelTimeTrendType_optional&
    travelTimeTrendType ();

    void
    travelTimeTrendType (const travelTimeTrendType_type& x);

    void
    travelTimeTrendType (const travelTimeTrendType_optional& x);

    void
    travelTimeTrendType (::std::auto_ptr< travelTimeTrendType_type > p);

    // travelTimeType
    // 
    typedef ::datex2::TravelTimeTypeEnum travelTimeType_type;
    typedef ::xsd::cxx::tree::optional< travelTimeType_type > travelTimeType_optional;
    typedef ::xsd::cxx::tree::traits< travelTimeType_type, char > travelTimeType_traits;

    const travelTimeType_optional&
    travelTimeType () const;

    travelTimeType_optional&
    travelTimeType ();

    void
    travelTimeType (const travelTimeType_type& x);

    void
    travelTimeType (const travelTimeType_optional& x);

    void
    travelTimeType (::std::auto_ptr< travelTimeType_type > p);

    // freeFlowSpeed
    // 
    typedef ::datex2::KilometresPerHour freeFlowSpeed_type;
    typedef ::xsd::cxx::tree::optional< freeFlowSpeed_type > freeFlowSpeed_optional;
    typedef ::xsd::cxx::tree::traits< freeFlowSpeed_type, char > freeFlowSpeed_traits;

    const freeFlowSpeed_optional&
    freeFlowSpeed () const;

    freeFlowSpeed_optional&
    freeFlowSpeed ();

    void
    freeFlowSpeed (const freeFlowSpeed_type& x);

    void
    freeFlowSpeed (const freeFlowSpeed_optional& x);

    void
    freeFlowSpeed (::std::auto_ptr< freeFlowSpeed_type > p);

    // freeFlowTravelTime
    // 
    typedef ::datex2::Seconds freeFlowTravelTime_type;
    typedef ::xsd::cxx::tree::optional< freeFlowTravelTime_type > freeFlowTravelTime_optional;
    typedef ::xsd::cxx::tree::traits< freeFlowTravelTime_type, char > freeFlowTravelTime_traits;

    const freeFlowTravelTime_optional&
    freeFlowTravelTime () const;

    freeFlowTravelTime_optional&
    freeFlowTravelTime ();

    void
    freeFlowTravelTime (const freeFlowTravelTime_type& x);

    void
    freeFlowTravelTime (const freeFlowTravelTime_optional& x);

    void
    freeFlowTravelTime (::std::auto_ptr< freeFlowTravelTime_type > p);

    // normallyExpectedTravelTime
    // 
    typedef ::datex2::Seconds normallyExpectedTravelTime_type;
    typedef ::xsd::cxx::tree::optional< normallyExpectedTravelTime_type > normallyExpectedTravelTime_optional;
    typedef ::xsd::cxx::tree::traits< normallyExpectedTravelTime_type, char > normallyExpectedTravelTime_traits;

    const normallyExpectedTravelTime_optional&
    normallyExpectedTravelTime () const;

    normallyExpectedTravelTime_optional&
    normallyExpectedTravelTime ();

    void
    normallyExpectedTravelTime (const normallyExpectedTravelTime_type& x);

    void
    normallyExpectedTravelTime (const normallyExpectedTravelTime_optional& x);

    void
    normallyExpectedTravelTime (::std::auto_ptr< normallyExpectedTravelTime_type > p);

    // vehicleType
    // 
    typedef ::datex2::VehicleTypeEnum vehicleType_type;
    typedef ::xsd::cxx::tree::sequence< vehicleType_type > vehicleType_sequence;
    typedef xsd::cxx::tree::sequence< vehicleType_type >::iterator vehicleType_iterator;
    typedef xsd::cxx::tree::sequence< vehicleType_type >::const_iterator vehicleType_const_iterator;
    typedef ::xsd::cxx::tree::traits< vehicleType_type, char > vehicleType_traits;

    const vehicleType_sequence&
    vehicleType () const;

    vehicleType_sequence&
    vehicleType ();

    void
    vehicleType (const vehicleType_sequence& s);

    // travelTimeValueExtension
    // 
    typedef ::datex2::ExtensionType travelTimeValueExtension_type;
    typedef ::xsd::cxx::tree::optional< travelTimeValueExtension_type > travelTimeValueExtension_optional;
    typedef ::xsd::cxx::tree::traits< travelTimeValueExtension_type, char > travelTimeValueExtension_traits;

    const travelTimeValueExtension_optional&
    travelTimeValueExtension () const;

    travelTimeValueExtension_optional&
    travelTimeValueExtension ();

    void
    travelTimeValueExtension (const travelTimeValueExtension_type& x);

    void
    travelTimeValueExtension (const travelTimeValueExtension_optional& x);

    void
    travelTimeValueExtension (::std::auto_ptr< travelTimeValueExtension_type > p);

    // Constructors.
    //
    TravelTimeValue ();

    TravelTimeValue (const xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    TravelTimeValue (const TravelTimeValue& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual TravelTimeValue*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TravelTimeValue ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    travelTime_optional travelTime_;
    travelTimeTrendType_optional travelTimeTrendType_;
    travelTimeType_optional travelTimeType_;
    freeFlowSpeed_optional freeFlowSpeed_;
    freeFlowTravelTime_optional freeFlowTravelTime_;
    normallyExpectedTravelTime_optional normallyExpectedTravelTime_;
    vehicleType_sequence vehicleType_;
    travelTimeValueExtension_optional travelTimeValueExtension_;
  };

  class UpdateMethodEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      allElementUpdate,
      singleElementUpdate,
      snapshot
    };

    UpdateMethodEnum (value v);

    UpdateMethodEnum (const char* v);

    UpdateMethodEnum (const ::std::string& v);

    UpdateMethodEnum (const ::xml_schema::string& v);

    UpdateMethodEnum (const xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    UpdateMethodEnum (const xercesc::DOMAttr& a,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    UpdateMethodEnum (const ::std::string& s,
                      const xercesc::DOMElement* e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    UpdateMethodEnum (const UpdateMethodEnum& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual UpdateMethodEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    UpdateMethodEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_UpdateMethodEnum_convert ();
    }

    protected:
    value
    _xsd_UpdateMethodEnum_convert () const;

    public:
    static const char* const _xsd_UpdateMethodEnum_literals_[3];
    static const value _xsd_UpdateMethodEnum_indexes_[3];
  };

  class UrgencyEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      extremelyUrgent,
      urgent,
      normalUrgency
    };

    UrgencyEnum (value v);

    UrgencyEnum (const char* v);

    UrgencyEnum (const ::std::string& v);

    UrgencyEnum (const ::xml_schema::string& v);

    UrgencyEnum (const xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    UrgencyEnum (const xercesc::DOMAttr& a,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    UrgencyEnum (const ::std::string& s,
                 const xercesc::DOMElement* e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    UrgencyEnum (const UrgencyEnum& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual UrgencyEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    UrgencyEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_UrgencyEnum_convert ();
    }

    protected:
    value
    _xsd_UrgencyEnum_convert () const;

    public:
    static const char* const _xsd_UrgencyEnum_literals_[3];
    static const value _xsd_UrgencyEnum_indexes_[3];
  };

  class Url: public ::xml_schema::uri
  {
    public:
    // Constructors.
    //
    Url (const ::xml_schema::uri&);

    Url (const xercesc::DOMElement& e,
         ::xml_schema::flags f = 0,
         ::xml_schema::container* c = 0);

    Url (const xercesc::DOMAttr& a,
         ::xml_schema::flags f = 0,
         ::xml_schema::container* c = 0);

    Url (const ::std::string& s,
         const xercesc::DOMElement* e,
         ::xml_schema::flags f = 0,
         ::xml_schema::container* c = 0);

    Url (const Url& x,
         ::xml_schema::flags f = 0,
         ::xml_schema::container* c = 0);

    virtual Url*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Url ();
  };

  class UrlLink: public ::xml_schema::type
  {
    public:
    // urlLinkAddress
    // 
    typedef ::datex2::Url urlLinkAddress_type;
    typedef ::xsd::cxx::tree::traits< urlLinkAddress_type, char > urlLinkAddress_traits;

    const urlLinkAddress_type&
    urlLinkAddress () const;

    urlLinkAddress_type&
    urlLinkAddress ();

    void
    urlLinkAddress (const urlLinkAddress_type& x);

    void
    urlLinkAddress (::std::auto_ptr< urlLinkAddress_type > p);

    // urlLinkDescription
    // 
    typedef ::datex2::MultilingualString urlLinkDescription_type;
    typedef ::xsd::cxx::tree::optional< urlLinkDescription_type > urlLinkDescription_optional;
    typedef ::xsd::cxx::tree::traits< urlLinkDescription_type, char > urlLinkDescription_traits;

    const urlLinkDescription_optional&
    urlLinkDescription () const;

    urlLinkDescription_optional&
    urlLinkDescription ();

    void
    urlLinkDescription (const urlLinkDescription_type& x);

    void
    urlLinkDescription (const urlLinkDescription_optional& x);

    void
    urlLinkDescription (::std::auto_ptr< urlLinkDescription_type > p);

    // urlLinkType
    // 
    typedef ::datex2::UrlLinkTypeEnum urlLinkType_type;
    typedef ::xsd::cxx::tree::optional< urlLinkType_type > urlLinkType_optional;
    typedef ::xsd::cxx::tree::traits< urlLinkType_type, char > urlLinkType_traits;

    const urlLinkType_optional&
    urlLinkType () const;

    urlLinkType_optional&
    urlLinkType ();

    void
    urlLinkType (const urlLinkType_type& x);

    void
    urlLinkType (const urlLinkType_optional& x);

    void
    urlLinkType (::std::auto_ptr< urlLinkType_type > p);

    // urlLinkExtension
    // 
    typedef ::datex2::ExtensionType urlLinkExtension_type;
    typedef ::xsd::cxx::tree::optional< urlLinkExtension_type > urlLinkExtension_optional;
    typedef ::xsd::cxx::tree::traits< urlLinkExtension_type, char > urlLinkExtension_traits;

    const urlLinkExtension_optional&
    urlLinkExtension () const;

    urlLinkExtension_optional&
    urlLinkExtension ();

    void
    urlLinkExtension (const urlLinkExtension_type& x);

    void
    urlLinkExtension (const urlLinkExtension_optional& x);

    void
    urlLinkExtension (::std::auto_ptr< urlLinkExtension_type > p);

    // Constructors.
    //
    UrlLink (const urlLinkAddress_type&);

    UrlLink (const xercesc::DOMElement& e,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    UrlLink (const UrlLink& x,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    virtual UrlLink*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~UrlLink ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< urlLinkAddress_type > urlLinkAddress_;
    urlLinkDescription_optional urlLinkDescription_;
    urlLinkType_optional urlLinkType_;
    urlLinkExtension_optional urlLinkExtension_;
  };

  class UrlLinkTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      documentPdf,
      html,
      image,
      rss,
      videoStream,
      voiceStream,
      other
    };

    UrlLinkTypeEnum (value v);

    UrlLinkTypeEnum (const char* v);

    UrlLinkTypeEnum (const ::std::string& v);

    UrlLinkTypeEnum (const ::xml_schema::string& v);

    UrlLinkTypeEnum (const xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    UrlLinkTypeEnum (const xercesc::DOMAttr& a,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    UrlLinkTypeEnum (const ::std::string& s,
                     const xercesc::DOMElement* e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    UrlLinkTypeEnum (const UrlLinkTypeEnum& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual UrlLinkTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    UrlLinkTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_UrlLinkTypeEnum_convert ();
    }

    protected:
    value
    _xsd_UrlLinkTypeEnum_convert () const;

    public:
    static const char* const _xsd_UrlLinkTypeEnum_literals_[7];
    static const value _xsd_UrlLinkTypeEnum_indexes_[7];
  };

  class Validity: public ::xml_schema::type
  {
    public:
    // validityStatus
    // 
    typedef ::datex2::ValidityStatusEnum validityStatus_type;
    typedef ::xsd::cxx::tree::traits< validityStatus_type, char > validityStatus_traits;

    const validityStatus_type&
    validityStatus () const;

    validityStatus_type&
    validityStatus ();

    void
    validityStatus (const validityStatus_type& x);

    void
    validityStatus (::std::auto_ptr< validityStatus_type > p);

    // overrunning
    // 
    typedef ::datex2::Boolean overrunning_type;
    typedef ::xsd::cxx::tree::optional< overrunning_type > overrunning_optional;
    typedef ::xsd::cxx::tree::traits< overrunning_type, char > overrunning_traits;

    const overrunning_optional&
    overrunning () const;

    overrunning_optional&
    overrunning ();

    void
    overrunning (const overrunning_type& x);

    void
    overrunning (const overrunning_optional& x);

    void
    overrunning (::std::auto_ptr< overrunning_type > p);

    // validityTimeSpecification
    // 
    typedef ::datex2::OverallPeriod validityTimeSpecification_type;
    typedef ::xsd::cxx::tree::traits< validityTimeSpecification_type, char > validityTimeSpecification_traits;

    const validityTimeSpecification_type&
    validityTimeSpecification () const;

    validityTimeSpecification_type&
    validityTimeSpecification ();

    void
    validityTimeSpecification (const validityTimeSpecification_type& x);

    void
    validityTimeSpecification (::std::auto_ptr< validityTimeSpecification_type > p);

    // validityExtension
    // 
    typedef ::datex2::ExtensionType validityExtension_type;
    typedef ::xsd::cxx::tree::optional< validityExtension_type > validityExtension_optional;
    typedef ::xsd::cxx::tree::traits< validityExtension_type, char > validityExtension_traits;

    const validityExtension_optional&
    validityExtension () const;

    validityExtension_optional&
    validityExtension ();

    void
    validityExtension (const validityExtension_type& x);

    void
    validityExtension (const validityExtension_optional& x);

    void
    validityExtension (::std::auto_ptr< validityExtension_type > p);

    // Constructors.
    //
    Validity (const validityStatus_type&,
              const validityTimeSpecification_type&);

    Validity (const validityStatus_type&,
              ::std::auto_ptr< validityTimeSpecification_type >&);

    Validity (const xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    Validity (const Validity& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual Validity*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Validity ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< validityStatus_type > validityStatus_;
    overrunning_optional overrunning_;
    ::xsd::cxx::tree::one< validityTimeSpecification_type > validityTimeSpecification_;
    validityExtension_optional validityExtension_;
  };

  class ValidityStatusEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      active,
      suspended,
      definedByValidityTimeSpec
    };

    ValidityStatusEnum (value v);

    ValidityStatusEnum (const char* v);

    ValidityStatusEnum (const ::std::string& v);

    ValidityStatusEnum (const ::xml_schema::string& v);

    ValidityStatusEnum (const xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    ValidityStatusEnum (const xercesc::DOMAttr& a,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    ValidityStatusEnum (const ::std::string& s,
                        const xercesc::DOMElement* e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    ValidityStatusEnum (const ValidityStatusEnum& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual ValidityStatusEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    ValidityStatusEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_ValidityStatusEnum_convert ();
    }

    protected:
    value
    _xsd_ValidityStatusEnum_convert () const;

    public:
    static const char* const _xsd_ValidityStatusEnum_literals_[3];
    static const value _xsd_ValidityStatusEnum_indexes_[3];
  };

  class VariableMessageSignSetting: public ::datex2::SignSetting
  {
    public:
    // numberOfCharacters
    // 
    typedef ::datex2::NonNegativeInteger numberOfCharacters_type;
    typedef ::xsd::cxx::tree::optional< numberOfCharacters_type > numberOfCharacters_optional;
    typedef ::xsd::cxx::tree::traits< numberOfCharacters_type, char > numberOfCharacters_traits;

    const numberOfCharacters_optional&
    numberOfCharacters () const;

    numberOfCharacters_optional&
    numberOfCharacters ();

    void
    numberOfCharacters (const numberOfCharacters_type& x);

    void
    numberOfCharacters (const numberOfCharacters_optional& x);

    void
    numberOfCharacters (::std::auto_ptr< numberOfCharacters_type > p);

    // numberOfRows
    // 
    typedef ::datex2::NonNegativeInteger numberOfRows_type;
    typedef ::xsd::cxx::tree::optional< numberOfRows_type > numberOfRows_optional;
    typedef ::xsd::cxx::tree::traits< numberOfRows_type, char > numberOfRows_traits;

    const numberOfRows_optional&
    numberOfRows () const;

    numberOfRows_optional&
    numberOfRows ();

    void
    numberOfRows (const numberOfRows_type& x);

    void
    numberOfRows (const numberOfRows_optional& x);

    void
    numberOfRows (::std::auto_ptr< numberOfRows_type > p);

    // vmsFault
    // 
    typedef ::datex2::VmsFaultEnum vmsFault_type;
    typedef ::xsd::cxx::tree::sequence< vmsFault_type > vmsFault_sequence;
    typedef xsd::cxx::tree::sequence< vmsFault_type >::iterator vmsFault_iterator;
    typedef xsd::cxx::tree::sequence< vmsFault_type >::const_iterator vmsFault_const_iterator;
    typedef ::xsd::cxx::tree::traits< vmsFault_type, char > vmsFault_traits;

    const vmsFault_sequence&
    vmsFault () const;

    vmsFault_sequence&
    vmsFault ();

    void
    vmsFault (const vmsFault_sequence& s);

    // vmsIdentifier
    // 
    typedef ::datex2::String vmsIdentifier_type;
    typedef ::xsd::cxx::tree::optional< vmsIdentifier_type > vmsIdentifier_optional;
    typedef ::xsd::cxx::tree::traits< vmsIdentifier_type, char > vmsIdentifier_traits;

    const vmsIdentifier_optional&
    vmsIdentifier () const;

    vmsIdentifier_optional&
    vmsIdentifier ();

    void
    vmsIdentifier (const vmsIdentifier_type& x);

    void
    vmsIdentifier (const vmsIdentifier_optional& x);

    void
    vmsIdentifier (::std::auto_ptr< vmsIdentifier_type > p);

    // vmsLegend
    // 
    typedef ::datex2::MultilingualString vmsLegend_type;
    typedef ::xsd::cxx::tree::sequence< vmsLegend_type > vmsLegend_sequence;
    typedef xsd::cxx::tree::sequence< vmsLegend_type >::iterator vmsLegend_iterator;
    typedef xsd::cxx::tree::sequence< vmsLegend_type >::const_iterator vmsLegend_const_iterator;
    typedef ::xsd::cxx::tree::traits< vmsLegend_type, char > vmsLegend_traits;

    const vmsLegend_sequence&
    vmsLegend () const;

    vmsLegend_sequence&
    vmsLegend ();

    void
    vmsLegend (const vmsLegend_sequence& s);

    // vmsType
    // 
    typedef ::datex2::VmsTypeEnum vmsType_type;
    typedef ::xsd::cxx::tree::optional< vmsType_type > vmsType_optional;
    typedef ::xsd::cxx::tree::traits< vmsType_type, char > vmsType_traits;

    const vmsType_optional&
    vmsType () const;

    vmsType_optional&
    vmsType ();

    void
    vmsType (const vmsType_type& x);

    void
    vmsType (const vmsType_optional& x);

    void
    vmsType (::std::auto_ptr< vmsType_type > p);

    // variableMessageSignSettingExtension
    // 
    typedef ::datex2::ExtensionType variableMessageSignSettingExtension_type;
    typedef ::xsd::cxx::tree::optional< variableMessageSignSettingExtension_type > variableMessageSignSettingExtension_optional;
    typedef ::xsd::cxx::tree::traits< variableMessageSignSettingExtension_type, char > variableMessageSignSettingExtension_traits;

    const variableMessageSignSettingExtension_optional&
    variableMessageSignSettingExtension () const;

    variableMessageSignSettingExtension_optional&
    variableMessageSignSettingExtension ();

    void
    variableMessageSignSettingExtension (const variableMessageSignSettingExtension_type& x);

    void
    variableMessageSignSettingExtension (const variableMessageSignSettingExtension_optional& x);

    void
    variableMessageSignSettingExtension (::std::auto_ptr< variableMessageSignSettingExtension_type > p);

    // Constructors.
    //
    VariableMessageSignSetting (const situationRecordCreationTime_type&,
                                const situationRecordVersion_type&,
                                const situationRecordVersionTime_type&,
                                const probabilityOfOccurrence_type&,
                                const validity_type&,
                                const groupOfLocations_type&,
                                const id_type&);

    VariableMessageSignSetting (const situationRecordCreationTime_type&,
                                const situationRecordVersion_type&,
                                const situationRecordVersionTime_type&,
                                const probabilityOfOccurrence_type&,
                                ::std::auto_ptr< validity_type >&,
                                ::std::auto_ptr< groupOfLocations_type >&,
                                const id_type&);

    VariableMessageSignSetting (const xercesc::DOMElement& e,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    VariableMessageSignSetting (const VariableMessageSignSetting& x,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    virtual VariableMessageSignSetting*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~VariableMessageSignSetting ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    numberOfCharacters_optional numberOfCharacters_;
    numberOfRows_optional numberOfRows_;
    vmsFault_sequence vmsFault_;
    vmsIdentifier_optional vmsIdentifier_;
    vmsLegend_sequence vmsLegend_;
    vmsType_optional vmsType_;
    variableMessageSignSettingExtension_optional variableMessageSignSettingExtension_;
  };

  class Vehicle: public ::xml_schema::type
  {
    public:
    // vehicleColour
    // 
    typedef ::datex2::MultilingualString vehicleColour_type;
    typedef ::xsd::cxx::tree::optional< vehicleColour_type > vehicleColour_optional;
    typedef ::xsd::cxx::tree::traits< vehicleColour_type, char > vehicleColour_traits;

    const vehicleColour_optional&
    vehicleColour () const;

    vehicleColour_optional&
    vehicleColour ();

    void
    vehicleColour (const vehicleColour_type& x);

    void
    vehicleColour (const vehicleColour_optional& x);

    void
    vehicleColour (::std::auto_ptr< vehicleColour_type > p);

    // vehicleCountryOfOrigin
    // 
    typedef ::datex2::MultilingualString vehicleCountryOfOrigin_type;
    typedef ::xsd::cxx::tree::optional< vehicleCountryOfOrigin_type > vehicleCountryOfOrigin_optional;
    typedef ::xsd::cxx::tree::traits< vehicleCountryOfOrigin_type, char > vehicleCountryOfOrigin_traits;

    const vehicleCountryOfOrigin_optional&
    vehicleCountryOfOrigin () const;

    vehicleCountryOfOrigin_optional&
    vehicleCountryOfOrigin ();

    void
    vehicleCountryOfOrigin (const vehicleCountryOfOrigin_type& x);

    void
    vehicleCountryOfOrigin (const vehicleCountryOfOrigin_optional& x);

    void
    vehicleCountryOfOrigin (::std::auto_ptr< vehicleCountryOfOrigin_type > p);

    // vehicleIdentifier
    // 
    typedef ::datex2::String vehicleIdentifier_type;
    typedef ::xsd::cxx::tree::optional< vehicleIdentifier_type > vehicleIdentifier_optional;
    typedef ::xsd::cxx::tree::traits< vehicleIdentifier_type, char > vehicleIdentifier_traits;

    const vehicleIdentifier_optional&
    vehicleIdentifier () const;

    vehicleIdentifier_optional&
    vehicleIdentifier ();

    void
    vehicleIdentifier (const vehicleIdentifier_type& x);

    void
    vehicleIdentifier (const vehicleIdentifier_optional& x);

    void
    vehicleIdentifier (::std::auto_ptr< vehicleIdentifier_type > p);

    // vehicleManufacturer
    // 
    typedef ::datex2::String vehicleManufacturer_type;
    typedef ::xsd::cxx::tree::optional< vehicleManufacturer_type > vehicleManufacturer_optional;
    typedef ::xsd::cxx::tree::traits< vehicleManufacturer_type, char > vehicleManufacturer_traits;

    const vehicleManufacturer_optional&
    vehicleManufacturer () const;

    vehicleManufacturer_optional&
    vehicleManufacturer ();

    void
    vehicleManufacturer (const vehicleManufacturer_type& x);

    void
    vehicleManufacturer (const vehicleManufacturer_optional& x);

    void
    vehicleManufacturer (::std::auto_ptr< vehicleManufacturer_type > p);

    // vehicleModel
    // 
    typedef ::datex2::String vehicleModel_type;
    typedef ::xsd::cxx::tree::optional< vehicleModel_type > vehicleModel_optional;
    typedef ::xsd::cxx::tree::traits< vehicleModel_type, char > vehicleModel_traits;

    const vehicleModel_optional&
    vehicleModel () const;

    vehicleModel_optional&
    vehicleModel ();

    void
    vehicleModel (const vehicleModel_type& x);

    void
    vehicleModel (const vehicleModel_optional& x);

    void
    vehicleModel (::std::auto_ptr< vehicleModel_type > p);

    // vehicleRegistrationPlateIdentifier
    // 
    typedef ::datex2::String vehicleRegistrationPlateIdentifier_type;
    typedef ::xsd::cxx::tree::optional< vehicleRegistrationPlateIdentifier_type > vehicleRegistrationPlateIdentifier_optional;
    typedef ::xsd::cxx::tree::traits< vehicleRegistrationPlateIdentifier_type, char > vehicleRegistrationPlateIdentifier_traits;

    const vehicleRegistrationPlateIdentifier_optional&
    vehicleRegistrationPlateIdentifier () const;

    vehicleRegistrationPlateIdentifier_optional&
    vehicleRegistrationPlateIdentifier ();

    void
    vehicleRegistrationPlateIdentifier (const vehicleRegistrationPlateIdentifier_type& x);

    void
    vehicleRegistrationPlateIdentifier (const vehicleRegistrationPlateIdentifier_optional& x);

    void
    vehicleRegistrationPlateIdentifier (::std::auto_ptr< vehicleRegistrationPlateIdentifier_type > p);

    // vehicleStatus
    // 
    typedef ::datex2::VehicleStatusEnum vehicleStatus_type;
    typedef ::xsd::cxx::tree::optional< vehicleStatus_type > vehicleStatus_optional;
    typedef ::xsd::cxx::tree::traits< vehicleStatus_type, char > vehicleStatus_traits;

    const vehicleStatus_optional&
    vehicleStatus () const;

    vehicleStatus_optional&
    vehicleStatus ();

    void
    vehicleStatus (const vehicleStatus_type& x);

    void
    vehicleStatus (const vehicleStatus_optional& x);

    void
    vehicleStatus (::std::auto_ptr< vehicleStatus_type > p);

    // vehicleCharacteristics
    // 
    typedef ::datex2::VehicleCharacteristics vehicleCharacteristics_type;
    typedef ::xsd::cxx::tree::optional< vehicleCharacteristics_type > vehicleCharacteristics_optional;
    typedef ::xsd::cxx::tree::traits< vehicleCharacteristics_type, char > vehicleCharacteristics_traits;

    const vehicleCharacteristics_optional&
    vehicleCharacteristics () const;

    vehicleCharacteristics_optional&
    vehicleCharacteristics ();

    void
    vehicleCharacteristics (const vehicleCharacteristics_type& x);

    void
    vehicleCharacteristics (const vehicleCharacteristics_optional& x);

    void
    vehicleCharacteristics (::std::auto_ptr< vehicleCharacteristics_type > p);

    // axleSpacingOnVehicle
    // 
    typedef ::datex2::AxleSpacing axleSpacingOnVehicle_type;
    typedef ::xsd::cxx::tree::sequence< axleSpacingOnVehicle_type > axleSpacingOnVehicle_sequence;
    typedef xsd::cxx::tree::sequence< axleSpacingOnVehicle_type >::iterator axleSpacingOnVehicle_iterator;
    typedef xsd::cxx::tree::sequence< axleSpacingOnVehicle_type >::const_iterator axleSpacingOnVehicle_const_iterator;
    typedef ::xsd::cxx::tree::traits< axleSpacingOnVehicle_type, char > axleSpacingOnVehicle_traits;

    const axleSpacingOnVehicle_sequence&
    axleSpacingOnVehicle () const;

    axleSpacingOnVehicle_sequence&
    axleSpacingOnVehicle ();

    void
    axleSpacingOnVehicle (const axleSpacingOnVehicle_sequence& s);

    // specificAxleWeight
    // 
    typedef ::datex2::AxleWeight specificAxleWeight_type;
    typedef ::xsd::cxx::tree::sequence< specificAxleWeight_type > specificAxleWeight_sequence;
    typedef xsd::cxx::tree::sequence< specificAxleWeight_type >::iterator specificAxleWeight_iterator;
    typedef xsd::cxx::tree::sequence< specificAxleWeight_type >::const_iterator specificAxleWeight_const_iterator;
    typedef ::xsd::cxx::tree::traits< specificAxleWeight_type, char > specificAxleWeight_traits;

    const specificAxleWeight_sequence&
    specificAxleWeight () const;

    specificAxleWeight_sequence&
    specificAxleWeight ();

    void
    specificAxleWeight (const specificAxleWeight_sequence& s);

    // hazardousGoodsAssociatedWithVehicle
    // 
    typedef ::datex2::HazardousMaterials hazardousGoodsAssociatedWithVehicle_type;
    typedef ::xsd::cxx::tree::optional< hazardousGoodsAssociatedWithVehicle_type > hazardousGoodsAssociatedWithVehicle_optional;
    typedef ::xsd::cxx::tree::traits< hazardousGoodsAssociatedWithVehicle_type, char > hazardousGoodsAssociatedWithVehicle_traits;

    const hazardousGoodsAssociatedWithVehicle_optional&
    hazardousGoodsAssociatedWithVehicle () const;

    hazardousGoodsAssociatedWithVehicle_optional&
    hazardousGoodsAssociatedWithVehicle ();

    void
    hazardousGoodsAssociatedWithVehicle (const hazardousGoodsAssociatedWithVehicle_type& x);

    void
    hazardousGoodsAssociatedWithVehicle (const hazardousGoodsAssociatedWithVehicle_optional& x);

    void
    hazardousGoodsAssociatedWithVehicle (::std::auto_ptr< hazardousGoodsAssociatedWithVehicle_type > p);

    // vehicleExtension
    // 
    typedef ::datex2::ExtensionType vehicleExtension_type;
    typedef ::xsd::cxx::tree::optional< vehicleExtension_type > vehicleExtension_optional;
    typedef ::xsd::cxx::tree::traits< vehicleExtension_type, char > vehicleExtension_traits;

    const vehicleExtension_optional&
    vehicleExtension () const;

    vehicleExtension_optional&
    vehicleExtension ();

    void
    vehicleExtension (const vehicleExtension_type& x);

    void
    vehicleExtension (const vehicleExtension_optional& x);

    void
    vehicleExtension (::std::auto_ptr< vehicleExtension_type > p);

    // Constructors.
    //
    Vehicle ();

    Vehicle (const xercesc::DOMElement& e,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    Vehicle (const Vehicle& x,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    virtual Vehicle*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Vehicle ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    vehicleColour_optional vehicleColour_;
    vehicleCountryOfOrigin_optional vehicleCountryOfOrigin_;
    vehicleIdentifier_optional vehicleIdentifier_;
    vehicleManufacturer_optional vehicleManufacturer_;
    vehicleModel_optional vehicleModel_;
    vehicleRegistrationPlateIdentifier_optional vehicleRegistrationPlateIdentifier_;
    vehicleStatus_optional vehicleStatus_;
    vehicleCharacteristics_optional vehicleCharacteristics_;
    axleSpacingOnVehicle_sequence axleSpacingOnVehicle_;
    specificAxleWeight_sequence specificAxleWeight_;
    hazardousGoodsAssociatedWithVehicle_optional hazardousGoodsAssociatedWithVehicle_;
    vehicleExtension_optional vehicleExtension_;
  };

  class VehicleCharacteristics: public ::xml_schema::type
  {
    public:
    // fuelType
    // 
    typedef ::datex2::FuelTypeEnum fuelType_type;
    typedef ::xsd::cxx::tree::optional< fuelType_type > fuelType_optional;
    typedef ::xsd::cxx::tree::traits< fuelType_type, char > fuelType_traits;

    const fuelType_optional&
    fuelType () const;

    fuelType_optional&
    fuelType ();

    void
    fuelType (const fuelType_type& x);

    void
    fuelType (const fuelType_optional& x);

    void
    fuelType (::std::auto_ptr< fuelType_type > p);

    // loadType
    // 
    typedef ::datex2::LoadTypeEnum loadType_type;
    typedef ::xsd::cxx::tree::optional< loadType_type > loadType_optional;
    typedef ::xsd::cxx::tree::traits< loadType_type, char > loadType_traits;

    const loadType_optional&
    loadType () const;

    loadType_optional&
    loadType ();

    void
    loadType (const loadType_type& x);

    void
    loadType (const loadType_optional& x);

    void
    loadType (::std::auto_ptr< loadType_type > p);

    // vehicleEquipment
    // 
    typedef ::datex2::VehicleEquipmentEnum vehicleEquipment_type;
    typedef ::xsd::cxx::tree::optional< vehicleEquipment_type > vehicleEquipment_optional;
    typedef ::xsd::cxx::tree::traits< vehicleEquipment_type, char > vehicleEquipment_traits;

    const vehicleEquipment_optional&
    vehicleEquipment () const;

    vehicleEquipment_optional&
    vehicleEquipment ();

    void
    vehicleEquipment (const vehicleEquipment_type& x);

    void
    vehicleEquipment (const vehicleEquipment_optional& x);

    void
    vehicleEquipment (::std::auto_ptr< vehicleEquipment_type > p);

    // vehicleType
    // 
    typedef ::datex2::VehicleTypeEnum vehicleType_type;
    typedef ::xsd::cxx::tree::sequence< vehicleType_type > vehicleType_sequence;
    typedef xsd::cxx::tree::sequence< vehicleType_type >::iterator vehicleType_iterator;
    typedef xsd::cxx::tree::sequence< vehicleType_type >::const_iterator vehicleType_const_iterator;
    typedef ::xsd::cxx::tree::traits< vehicleType_type, char > vehicleType_traits;

    const vehicleType_sequence&
    vehicleType () const;

    vehicleType_sequence&
    vehicleType ();

    void
    vehicleType (const vehicleType_sequence& s);

    // vehicleUsage
    // 
    typedef ::datex2::VehicleUsageEnum vehicleUsage_type;
    typedef ::xsd::cxx::tree::optional< vehicleUsage_type > vehicleUsage_optional;
    typedef ::xsd::cxx::tree::traits< vehicleUsage_type, char > vehicleUsage_traits;

    const vehicleUsage_optional&
    vehicleUsage () const;

    vehicleUsage_optional&
    vehicleUsage ();

    void
    vehicleUsage (const vehicleUsage_type& x);

    void
    vehicleUsage (const vehicleUsage_optional& x);

    void
    vehicleUsage (::std::auto_ptr< vehicleUsage_type > p);

    // grossWeightCharacteristic
    // 
    typedef ::datex2::GrossWeightCharacteristic grossWeightCharacteristic_type;
    typedef ::xsd::cxx::tree::sequence< grossWeightCharacteristic_type > grossWeightCharacteristic_sequence;
    typedef xsd::cxx::tree::sequence< grossWeightCharacteristic_type >::iterator grossWeightCharacteristic_iterator;
    typedef xsd::cxx::tree::sequence< grossWeightCharacteristic_type >::const_iterator grossWeightCharacteristic_const_iterator;
    typedef ::xsd::cxx::tree::traits< grossWeightCharacteristic_type, char > grossWeightCharacteristic_traits;

    const grossWeightCharacteristic_sequence&
    grossWeightCharacteristic () const;

    grossWeightCharacteristic_sequence&
    grossWeightCharacteristic ();

    void
    grossWeightCharacteristic (const grossWeightCharacteristic_sequence& s);

    // heightCharacteristic
    // 
    typedef ::datex2::HeightCharacteristic heightCharacteristic_type;
    typedef ::xsd::cxx::tree::sequence< heightCharacteristic_type > heightCharacteristic_sequence;
    typedef xsd::cxx::tree::sequence< heightCharacteristic_type >::iterator heightCharacteristic_iterator;
    typedef xsd::cxx::tree::sequence< heightCharacteristic_type >::const_iterator heightCharacteristic_const_iterator;
    typedef ::xsd::cxx::tree::traits< heightCharacteristic_type, char > heightCharacteristic_traits;

    const heightCharacteristic_sequence&
    heightCharacteristic () const;

    heightCharacteristic_sequence&
    heightCharacteristic ();

    void
    heightCharacteristic (const heightCharacteristic_sequence& s);

    // lengthCharacteristic
    // 
    typedef ::datex2::LengthCharacteristic lengthCharacteristic_type;
    typedef ::xsd::cxx::tree::sequence< lengthCharacteristic_type > lengthCharacteristic_sequence;
    typedef xsd::cxx::tree::sequence< lengthCharacteristic_type >::iterator lengthCharacteristic_iterator;
    typedef xsd::cxx::tree::sequence< lengthCharacteristic_type >::const_iterator lengthCharacteristic_const_iterator;
    typedef ::xsd::cxx::tree::traits< lengthCharacteristic_type, char > lengthCharacteristic_traits;

    const lengthCharacteristic_sequence&
    lengthCharacteristic () const;

    lengthCharacteristic_sequence&
    lengthCharacteristic ();

    void
    lengthCharacteristic (const lengthCharacteristic_sequence& s);

    // widthCharacteristic
    // 
    typedef ::datex2::WidthCharacteristic widthCharacteristic_type;
    typedef ::xsd::cxx::tree::sequence< widthCharacteristic_type > widthCharacteristic_sequence;
    typedef xsd::cxx::tree::sequence< widthCharacteristic_type >::iterator widthCharacteristic_iterator;
    typedef xsd::cxx::tree::sequence< widthCharacteristic_type >::const_iterator widthCharacteristic_const_iterator;
    typedef ::xsd::cxx::tree::traits< widthCharacteristic_type, char > widthCharacteristic_traits;

    const widthCharacteristic_sequence&
    widthCharacteristic () const;

    widthCharacteristic_sequence&
    widthCharacteristic ();

    void
    widthCharacteristic (const widthCharacteristic_sequence& s);

    // heaviestAxleWeightCharacteristic
    // 
    typedef ::datex2::HeaviestAxleWeightCharacteristic heaviestAxleWeightCharacteristic_type;
    typedef ::xsd::cxx::tree::sequence< heaviestAxleWeightCharacteristic_type > heaviestAxleWeightCharacteristic_sequence;
    typedef xsd::cxx::tree::sequence< heaviestAxleWeightCharacteristic_type >::iterator heaviestAxleWeightCharacteristic_iterator;
    typedef xsd::cxx::tree::sequence< heaviestAxleWeightCharacteristic_type >::const_iterator heaviestAxleWeightCharacteristic_const_iterator;
    typedef ::xsd::cxx::tree::traits< heaviestAxleWeightCharacteristic_type, char > heaviestAxleWeightCharacteristic_traits;

    const heaviestAxleWeightCharacteristic_sequence&
    heaviestAxleWeightCharacteristic () const;

    heaviestAxleWeightCharacteristic_sequence&
    heaviestAxleWeightCharacteristic ();

    void
    heaviestAxleWeightCharacteristic (const heaviestAxleWeightCharacteristic_sequence& s);

    // numberOfAxlesCharacteristic
    // 
    typedef ::datex2::NumberOfAxlesCharacteristic numberOfAxlesCharacteristic_type;
    typedef ::xsd::cxx::tree::sequence< numberOfAxlesCharacteristic_type > numberOfAxlesCharacteristic_sequence;
    typedef xsd::cxx::tree::sequence< numberOfAxlesCharacteristic_type >::iterator numberOfAxlesCharacteristic_iterator;
    typedef xsd::cxx::tree::sequence< numberOfAxlesCharacteristic_type >::const_iterator numberOfAxlesCharacteristic_const_iterator;
    typedef ::xsd::cxx::tree::traits< numberOfAxlesCharacteristic_type, char > numberOfAxlesCharacteristic_traits;

    const numberOfAxlesCharacteristic_sequence&
    numberOfAxlesCharacteristic () const;

    numberOfAxlesCharacteristic_sequence&
    numberOfAxlesCharacteristic ();

    void
    numberOfAxlesCharacteristic (const numberOfAxlesCharacteristic_sequence& s);

    // vehicleCharacteristicsExtension
    // 
    typedef ::datex2::ExtensionType vehicleCharacteristicsExtension_type;
    typedef ::xsd::cxx::tree::optional< vehicleCharacteristicsExtension_type > vehicleCharacteristicsExtension_optional;
    typedef ::xsd::cxx::tree::traits< vehicleCharacteristicsExtension_type, char > vehicleCharacteristicsExtension_traits;

    const vehicleCharacteristicsExtension_optional&
    vehicleCharacteristicsExtension () const;

    vehicleCharacteristicsExtension_optional&
    vehicleCharacteristicsExtension ();

    void
    vehicleCharacteristicsExtension (const vehicleCharacteristicsExtension_type& x);

    void
    vehicleCharacteristicsExtension (const vehicleCharacteristicsExtension_optional& x);

    void
    vehicleCharacteristicsExtension (::std::auto_ptr< vehicleCharacteristicsExtension_type > p);

    // Constructors.
    //
    VehicleCharacteristics ();

    VehicleCharacteristics (const xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    VehicleCharacteristics (const VehicleCharacteristics& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual VehicleCharacteristics*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~VehicleCharacteristics ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    fuelType_optional fuelType_;
    loadType_optional loadType_;
    vehicleEquipment_optional vehicleEquipment_;
    vehicleType_sequence vehicleType_;
    vehicleUsage_optional vehicleUsage_;
    grossWeightCharacteristic_sequence grossWeightCharacteristic_;
    heightCharacteristic_sequence heightCharacteristic_;
    lengthCharacteristic_sequence lengthCharacteristic_;
    widthCharacteristic_sequence widthCharacteristic_;
    heaviestAxleWeightCharacteristic_sequence heaviestAxleWeightCharacteristic_;
    numberOfAxlesCharacteristic_sequence numberOfAxlesCharacteristic_;
    vehicleCharacteristicsExtension_optional vehicleCharacteristicsExtension_;
  };

  class VehicleDetectionTime: public ::xml_schema::type
  {
    public:
    // arrivalTime
    // 
    typedef ::datex2::DateTime arrivalTime_type;
    typedef ::xsd::cxx::tree::optional< arrivalTime_type > arrivalTime_optional;
    typedef ::xsd::cxx::tree::traits< arrivalTime_type, char > arrivalTime_traits;

    const arrivalTime_optional&
    arrivalTime () const;

    arrivalTime_optional&
    arrivalTime ();

    void
    arrivalTime (const arrivalTime_type& x);

    void
    arrivalTime (const arrivalTime_optional& x);

    void
    arrivalTime (::std::auto_ptr< arrivalTime_type > p);

    // exitTime
    // 
    typedef ::datex2::DateTime exitTime_type;
    typedef ::xsd::cxx::tree::optional< exitTime_type > exitTime_optional;
    typedef ::xsd::cxx::tree::traits< exitTime_type, char > exitTime_traits;

    const exitTime_optional&
    exitTime () const;

    exitTime_optional&
    exitTime ();

    void
    exitTime (const exitTime_type& x);

    void
    exitTime (const exitTime_optional& x);

    void
    exitTime (::std::auto_ptr< exitTime_type > p);

    // passageTime
    // 
    typedef ::datex2::NonNegativeInteger passageTime_type;
    typedef ::xsd::cxx::tree::optional< passageTime_type > passageTime_optional;
    typedef ::xsd::cxx::tree::traits< passageTime_type, char > passageTime_traits;

    const passageTime_optional&
    passageTime () const;

    passageTime_optional&
    passageTime ();

    void
    passageTime (const passageTime_type& x);

    void
    passageTime (const passageTime_optional& x);

    void
    passageTime (::std::auto_ptr< passageTime_type > p);

    // presenceTime
    // 
    typedef ::datex2::DateTime presenceTime_type;
    typedef ::xsd::cxx::tree::optional< presenceTime_type > presenceTime_optional;
    typedef ::xsd::cxx::tree::traits< presenceTime_type, char > presenceTime_traits;

    const presenceTime_optional&
    presenceTime () const;

    presenceTime_optional&
    presenceTime ();

    void
    presenceTime (const presenceTime_type& x);

    void
    presenceTime (const presenceTime_optional& x);

    void
    presenceTime (::std::auto_ptr< presenceTime_type > p);

    // timeGap
    // 
    typedef ::datex2::Seconds timeGap_type;
    typedef ::xsd::cxx::tree::optional< timeGap_type > timeGap_optional;
    typedef ::xsd::cxx::tree::traits< timeGap_type, char > timeGap_traits;

    const timeGap_optional&
    timeGap () const;

    timeGap_optional&
    timeGap ();

    void
    timeGap (const timeGap_type& x);

    void
    timeGap (const timeGap_optional& x);

    void
    timeGap (::std::auto_ptr< timeGap_type > p);

    // timeHeadway
    // 
    typedef ::datex2::Seconds timeHeadway_type;
    typedef ::xsd::cxx::tree::optional< timeHeadway_type > timeHeadway_optional;
    typedef ::xsd::cxx::tree::traits< timeHeadway_type, char > timeHeadway_traits;

    const timeHeadway_optional&
    timeHeadway () const;

    timeHeadway_optional&
    timeHeadway ();

    void
    timeHeadway (const timeHeadway_type& x);

    void
    timeHeadway (const timeHeadway_optional& x);

    void
    timeHeadway (::std::auto_ptr< timeHeadway_type > p);

    // vehicleDetectionTimeExtension
    // 
    typedef ::datex2::ExtensionType vehicleDetectionTimeExtension_type;
    typedef ::xsd::cxx::tree::optional< vehicleDetectionTimeExtension_type > vehicleDetectionTimeExtension_optional;
    typedef ::xsd::cxx::tree::traits< vehicleDetectionTimeExtension_type, char > vehicleDetectionTimeExtension_traits;

    const vehicleDetectionTimeExtension_optional&
    vehicleDetectionTimeExtension () const;

    vehicleDetectionTimeExtension_optional&
    vehicleDetectionTimeExtension ();

    void
    vehicleDetectionTimeExtension (const vehicleDetectionTimeExtension_type& x);

    void
    vehicleDetectionTimeExtension (const vehicleDetectionTimeExtension_optional& x);

    void
    vehicleDetectionTimeExtension (::std::auto_ptr< vehicleDetectionTimeExtension_type > p);

    // Constructors.
    //
    VehicleDetectionTime ();

    VehicleDetectionTime (const xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    VehicleDetectionTime (const VehicleDetectionTime& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual VehicleDetectionTime*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~VehicleDetectionTime ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    arrivalTime_optional arrivalTime_;
    exitTime_optional exitTime_;
    passageTime_optional passageTime_;
    presenceTime_optional presenceTime_;
    timeGap_optional timeGap_;
    timeHeadway_optional timeHeadway_;
    vehicleDetectionTimeExtension_optional vehicleDetectionTimeExtension_;
  };

  class VehicleEquipmentEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      notUsingSnowChains,
      notUsingSnowChainsOrTyres,
      snowChainsInUse,
      snowTyresInUse,
      snowChainsOrTyresInUse,
      withoutSnowTyresOrChainsOnBoard
    };

    VehicleEquipmentEnum (value v);

    VehicleEquipmentEnum (const char* v);

    VehicleEquipmentEnum (const ::std::string& v);

    VehicleEquipmentEnum (const ::xml_schema::string& v);

    VehicleEquipmentEnum (const xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    VehicleEquipmentEnum (const xercesc::DOMAttr& a,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    VehicleEquipmentEnum (const ::std::string& s,
                          const xercesc::DOMElement* e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    VehicleEquipmentEnum (const VehicleEquipmentEnum& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual VehicleEquipmentEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    VehicleEquipmentEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_VehicleEquipmentEnum_convert ();
    }

    protected:
    value
    _xsd_VehicleEquipmentEnum_convert () const;

    public:
    static const char* const _xsd_VehicleEquipmentEnum_literals_[6];
    static const value _xsd_VehicleEquipmentEnum_indexes_[6];
  };

  class VehicleHeadway: public ::xml_schema::type
  {
    public:
    // distanceGap
    // 
    typedef ::datex2::MetresAsFloat distanceGap_type;
    typedef ::xsd::cxx::tree::optional< distanceGap_type > distanceGap_optional;
    typedef ::xsd::cxx::tree::traits< distanceGap_type, char > distanceGap_traits;

    const distanceGap_optional&
    distanceGap () const;

    distanceGap_optional&
    distanceGap ();

    void
    distanceGap (const distanceGap_type& x);

    void
    distanceGap (const distanceGap_optional& x);

    void
    distanceGap (::std::auto_ptr< distanceGap_type > p);

    // distanceHeadway
    // 
    typedef ::datex2::MetresAsFloat distanceHeadway_type;
    typedef ::xsd::cxx::tree::optional< distanceHeadway_type > distanceHeadway_optional;
    typedef ::xsd::cxx::tree::traits< distanceHeadway_type, char > distanceHeadway_traits;

    const distanceHeadway_optional&
    distanceHeadway () const;

    distanceHeadway_optional&
    distanceHeadway ();

    void
    distanceHeadway (const distanceHeadway_type& x);

    void
    distanceHeadway (const distanceHeadway_optional& x);

    void
    distanceHeadway (::std::auto_ptr< distanceHeadway_type > p);

    // vehicleHeadwayExtension
    // 
    typedef ::datex2::ExtensionType vehicleHeadwayExtension_type;
    typedef ::xsd::cxx::tree::optional< vehicleHeadwayExtension_type > vehicleHeadwayExtension_optional;
    typedef ::xsd::cxx::tree::traits< vehicleHeadwayExtension_type, char > vehicleHeadwayExtension_traits;

    const vehicleHeadwayExtension_optional&
    vehicleHeadwayExtension () const;

    vehicleHeadwayExtension_optional&
    vehicleHeadwayExtension ();

    void
    vehicleHeadwayExtension (const vehicleHeadwayExtension_type& x);

    void
    vehicleHeadwayExtension (const vehicleHeadwayExtension_optional& x);

    void
    vehicleHeadwayExtension (::std::auto_ptr< vehicleHeadwayExtension_type > p);

    // Constructors.
    //
    VehicleHeadway ();

    VehicleHeadway (const xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    VehicleHeadway (const VehicleHeadway& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual VehicleHeadway*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~VehicleHeadway ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    distanceGap_optional distanceGap_;
    distanceHeadway_optional distanceHeadway_;
    vehicleHeadwayExtension_optional vehicleHeadwayExtension_;
  };

  class VehicleObstruction: public ::datex2::Obstruction
  {
    public:
    // vehicleObstructionType
    // 
    typedef ::datex2::VehicleObstructionTypeEnum vehicleObstructionType_type;
    typedef ::xsd::cxx::tree::traits< vehicleObstructionType_type, char > vehicleObstructionType_traits;

    const vehicleObstructionType_type&
    vehicleObstructionType () const;

    vehicleObstructionType_type&
    vehicleObstructionType ();

    void
    vehicleObstructionType (const vehicleObstructionType_type& x);

    void
    vehicleObstructionType (::std::auto_ptr< vehicleObstructionType_type > p);

    // obstructingVehicle
    // 
    typedef ::datex2::Vehicle obstructingVehicle_type;
    typedef ::xsd::cxx::tree::sequence< obstructingVehicle_type > obstructingVehicle_sequence;
    typedef xsd::cxx::tree::sequence< obstructingVehicle_type >::iterator obstructingVehicle_iterator;
    typedef xsd::cxx::tree::sequence< obstructingVehicle_type >::const_iterator obstructingVehicle_const_iterator;
    typedef ::xsd::cxx::tree::traits< obstructingVehicle_type, char > obstructingVehicle_traits;

    const obstructingVehicle_sequence&
    obstructingVehicle () const;

    obstructingVehicle_sequence&
    obstructingVehicle ();

    void
    obstructingVehicle (const obstructingVehicle_sequence& s);

    // vehicleObstructionExtension
    // 
    typedef ::datex2::ExtensionType vehicleObstructionExtension_type;
    typedef ::xsd::cxx::tree::optional< vehicleObstructionExtension_type > vehicleObstructionExtension_optional;
    typedef ::xsd::cxx::tree::traits< vehicleObstructionExtension_type, char > vehicleObstructionExtension_traits;

    const vehicleObstructionExtension_optional&
    vehicleObstructionExtension () const;

    vehicleObstructionExtension_optional&
    vehicleObstructionExtension ();

    void
    vehicleObstructionExtension (const vehicleObstructionExtension_type& x);

    void
    vehicleObstructionExtension (const vehicleObstructionExtension_optional& x);

    void
    vehicleObstructionExtension (::std::auto_ptr< vehicleObstructionExtension_type > p);

    // Constructors.
    //
    VehicleObstruction (const situationRecordCreationTime_type&,
                        const situationRecordVersion_type&,
                        const situationRecordVersionTime_type&,
                        const probabilityOfOccurrence_type&,
                        const validity_type&,
                        const groupOfLocations_type&,
                        const id_type&,
                        const vehicleObstructionType_type&);

    VehicleObstruction (const situationRecordCreationTime_type&,
                        const situationRecordVersion_type&,
                        const situationRecordVersionTime_type&,
                        const probabilityOfOccurrence_type&,
                        ::std::auto_ptr< validity_type >&,
                        ::std::auto_ptr< groupOfLocations_type >&,
                        const id_type&,
                        const vehicleObstructionType_type&);

    VehicleObstruction (const xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    VehicleObstruction (const VehicleObstruction& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual VehicleObstruction*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~VehicleObstruction ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< vehicleObstructionType_type > vehicleObstructionType_;
    obstructingVehicle_sequence obstructingVehicle_;
    vehicleObstructionExtension_optional vehicleObstructionExtension_;
  };

  class VehicleObstructionTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      abandonedVehicle,
      abnormalLoad,
      brokenDownBus,
      brokenDownHeavyLorry,
      brokenDownVehicle,
      convoy,
      damagedVehicle,
      dangerousSlowMovingVehicle,
      emergencyVehicle,
      highSpeedEmergencyVehicle,
      longLoad,
      militaryConvoy,
      overheightVehicle,
      prohibitedVehicleOnTheRoadway,
      saltingOrGrittingVehicleInUse,
      slowMovingMaintenanceVehicle,
      slowVehicle,
      snowplough,
      trackLayingVehicle,
      unlitVehicleOnTheRoad,
      vehicleOnFire,
      vehicleCarryingHazardousMaterials,
      vehicleInDifficulty,
      vehicleOnWrongCarriageway,
      vehicleStuck,
      vehicleStuckUnderBridge,
      vehicleWithOverheightLoad,
      vehicleWithOverwideLoad,
      other
    };

    VehicleObstructionTypeEnum (value v);

    VehicleObstructionTypeEnum (const char* v);

    VehicleObstructionTypeEnum (const ::std::string& v);

    VehicleObstructionTypeEnum (const ::xml_schema::string& v);

    VehicleObstructionTypeEnum (const xercesc::DOMElement& e,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    VehicleObstructionTypeEnum (const xercesc::DOMAttr& a,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    VehicleObstructionTypeEnum (const ::std::string& s,
                                const xercesc::DOMElement* e,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    VehicleObstructionTypeEnum (const VehicleObstructionTypeEnum& x,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    virtual VehicleObstructionTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    VehicleObstructionTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_VehicleObstructionTypeEnum_convert ();
    }

    protected:
    value
    _xsd_VehicleObstructionTypeEnum_convert () const;

    public:
    static const char* const _xsd_VehicleObstructionTypeEnum_literals_[29];
    static const value _xsd_VehicleObstructionTypeEnum_indexes_[29];
  };

  class VehicleSpeed: public ::xml_schema::type
  {
    public:
    // individualVehicleSpeed
    // 
    typedef ::datex2::KilometresPerHour individualVehicleSpeed_type;
    typedef ::xsd::cxx::tree::traits< individualVehicleSpeed_type, char > individualVehicleSpeed_traits;

    const individualVehicleSpeed_type&
    individualVehicleSpeed () const;

    individualVehicleSpeed_type&
    individualVehicleSpeed ();

    void
    individualVehicleSpeed (const individualVehicleSpeed_type& x);

    void
    individualVehicleSpeed (::std::auto_ptr< individualVehicleSpeed_type > p);

    // vehicleSpeedExtension
    // 
    typedef ::datex2::ExtensionType vehicleSpeedExtension_type;
    typedef ::xsd::cxx::tree::optional< vehicleSpeedExtension_type > vehicleSpeedExtension_optional;
    typedef ::xsd::cxx::tree::traits< vehicleSpeedExtension_type, char > vehicleSpeedExtension_traits;

    const vehicleSpeedExtension_optional&
    vehicleSpeedExtension () const;

    vehicleSpeedExtension_optional&
    vehicleSpeedExtension ();

    void
    vehicleSpeedExtension (const vehicleSpeedExtension_type& x);

    void
    vehicleSpeedExtension (const vehicleSpeedExtension_optional& x);

    void
    vehicleSpeedExtension (::std::auto_ptr< vehicleSpeedExtension_type > p);

    // Constructors.
    //
    VehicleSpeed (const individualVehicleSpeed_type&);

    VehicleSpeed (const xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    VehicleSpeed (const VehicleSpeed& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual VehicleSpeed*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~VehicleSpeed ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< individualVehicleSpeed_type > individualVehicleSpeed_;
    vehicleSpeedExtension_optional vehicleSpeedExtension_;
  };

  class VehiclesPerHour: public ::datex2::NonNegativeInteger
  {
    public:
    // Constructors.
    //
    VehiclesPerHour (const ::xml_schema::non_negative_integer&);

    VehiclesPerHour (const xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    VehiclesPerHour (const xercesc::DOMAttr& a,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    VehiclesPerHour (const ::std::string& s,
                     const xercesc::DOMElement* e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    VehiclesPerHour (const VehiclesPerHour& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual VehiclesPerHour*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~VehiclesPerHour ();
  };

  class VehicleStatusEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      abandoned,
      brokenDown,
      burntOut,
      damaged,
      damagedAndImmobililized,
      onFire
    };

    VehicleStatusEnum (value v);

    VehicleStatusEnum (const char* v);

    VehicleStatusEnum (const ::std::string& v);

    VehicleStatusEnum (const ::xml_schema::string& v);

    VehicleStatusEnum (const xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    VehicleStatusEnum (const xercesc::DOMAttr& a,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    VehicleStatusEnum (const ::std::string& s,
                       const xercesc::DOMElement* e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    VehicleStatusEnum (const VehicleStatusEnum& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual VehicleStatusEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    VehicleStatusEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_VehicleStatusEnum_convert ();
    }

    protected:
    value
    _xsd_VehicleStatusEnum_convert () const;

    public:
    static const char* const _xsd_VehicleStatusEnum_literals_[6];
    static const value _xsd_VehicleStatusEnum_indexes_[6];
  };

  class VehicleTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      anyVehicle,
      articulatedVehicle,
      bicycle,
      bus,
      car,
      caravan,
      carOrLightVehicle,
      carWithCaravan,
      carWithTrailer,
      fourWheelDrive,
      highSidedVehicle,
      lorry,
      moped,
      motorcycle,
      motorcycleWithSideCar,
      motorscooter,
      tanker,
      threeWheeledVehicle,
      trailer,
      tram,
      twoWheeledVehicle,
      van,
      vehicleWithCatalyticConverter,
      vehicleWithoutCatalyticConverter,
      vehicleWithCaravan,
      vehicleWithTrailer,
      withEvenNumberedRegistrationPlates,
      withOddNumberedRegistrationPlates,
      other
    };

    VehicleTypeEnum (value v);

    VehicleTypeEnum (const char* v);

    VehicleTypeEnum (const ::std::string& v);

    VehicleTypeEnum (const ::xml_schema::string& v);

    VehicleTypeEnum (const xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    VehicleTypeEnum (const xercesc::DOMAttr& a,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    VehicleTypeEnum (const ::std::string& s,
                     const xercesc::DOMElement* e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    VehicleTypeEnum (const VehicleTypeEnum& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual VehicleTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    VehicleTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_VehicleTypeEnum_convert ();
    }

    protected:
    value
    _xsd_VehicleTypeEnum_convert () const;

    public:
    static const char* const _xsd_VehicleTypeEnum_literals_[29];
    static const value _xsd_VehicleTypeEnum_indexes_[29];
  };

  class VehicleUsageEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      agricultural,
      commercial,
      emergencyServices,
      military,
      nonCommercial,
      patrol,
      recoveryServices,
      roadMaintenanceOrConstruction,
      roadOperator,
      taxi
    };

    VehicleUsageEnum (value v);

    VehicleUsageEnum (const char* v);

    VehicleUsageEnum (const ::std::string& v);

    VehicleUsageEnum (const ::xml_schema::string& v);

    VehicleUsageEnum (const xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    VehicleUsageEnum (const xercesc::DOMAttr& a,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    VehicleUsageEnum (const ::std::string& s,
                      const xercesc::DOMElement* e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    VehicleUsageEnum (const VehicleUsageEnum& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual VehicleUsageEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    VehicleUsageEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_VehicleUsageEnum_convert ();
    }

    protected:
    value
    _xsd_VehicleUsageEnum_convert () const;

    public:
    static const char* const _xsd_VehicleUsageEnum_literals_[10];
    static const value _xsd_VehicleUsageEnum_indexes_[10];
  };

  class Visibility: public ::xml_schema::type
  {
    public:
    // minimumVisibilityDistance
    // 
    typedef ::datex2::MetresAsNonNegativeInteger minimumVisibilityDistance_type;
    typedef ::xsd::cxx::tree::traits< minimumVisibilityDistance_type, char > minimumVisibilityDistance_traits;

    const minimumVisibilityDistance_type&
    minimumVisibilityDistance () const;

    minimumVisibilityDistance_type&
    minimumVisibilityDistance ();

    void
    minimumVisibilityDistance (const minimumVisibilityDistance_type& x);

    void
    minimumVisibilityDistance (::std::auto_ptr< minimumVisibilityDistance_type > p);

    // visibilityExtension
    // 
    typedef ::datex2::ExtensionType visibilityExtension_type;
    typedef ::xsd::cxx::tree::optional< visibilityExtension_type > visibilityExtension_optional;
    typedef ::xsd::cxx::tree::traits< visibilityExtension_type, char > visibilityExtension_traits;

    const visibilityExtension_optional&
    visibilityExtension () const;

    visibilityExtension_optional&
    visibilityExtension ();

    void
    visibilityExtension (const visibilityExtension_type& x);

    void
    visibilityExtension (const visibilityExtension_optional& x);

    void
    visibilityExtension (::std::auto_ptr< visibilityExtension_type > p);

    // Constructors.
    //
    Visibility (const minimumVisibilityDistance_type&);

    Visibility (const xercesc::DOMElement& e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    Visibility (const Visibility& x,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    virtual Visibility*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Visibility ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< minimumVisibilityDistance_type > minimumVisibilityDistance_;
    visibilityExtension_optional visibilityExtension_;
  };

  class VisibilityInformation: public ::datex2::WeatherValue
  {
    public:
    // visibility
    // 
    typedef ::datex2::Visibility visibility_type;
    typedef ::xsd::cxx::tree::traits< visibility_type, char > visibility_traits;

    const visibility_type&
    visibility () const;

    visibility_type&
    visibility ();

    void
    visibility (const visibility_type& x);

    void
    visibility (::std::auto_ptr< visibility_type > p);

    // visibilityInformationExtension
    // 
    typedef ::datex2::ExtensionType visibilityInformationExtension_type;
    typedef ::xsd::cxx::tree::optional< visibilityInformationExtension_type > visibilityInformationExtension_optional;
    typedef ::xsd::cxx::tree::traits< visibilityInformationExtension_type, char > visibilityInformationExtension_traits;

    const visibilityInformationExtension_optional&
    visibilityInformationExtension () const;

    visibilityInformationExtension_optional&
    visibilityInformationExtension ();

    void
    visibilityInformationExtension (const visibilityInformationExtension_type& x);

    void
    visibilityInformationExtension (const visibilityInformationExtension_optional& x);

    void
    visibilityInformationExtension (::std::auto_ptr< visibilityInformationExtension_type > p);

    // Constructors.
    //
    VisibilityInformation (const visibility_type&);

    VisibilityInformation (::std::auto_ptr< visibility_type >&);

    VisibilityInformation (const xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    VisibilityInformation (const VisibilityInformation& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual VisibilityInformation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~VisibilityInformation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< visibility_type > visibility_;
    visibilityInformationExtension_optional visibilityInformationExtension_;
  };

  class VmsFaultEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      communicationsFailure,
      incorrectMessageDisplayed,
      incorrectPictogramDisplayed,
      outOfService,
      powerFailure,
      unableToClearDown,
      unknown,
      other
    };

    VmsFaultEnum (value v);

    VmsFaultEnum (const char* v);

    VmsFaultEnum (const ::std::string& v);

    VmsFaultEnum (const ::xml_schema::string& v);

    VmsFaultEnum (const xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    VmsFaultEnum (const xercesc::DOMAttr& a,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    VmsFaultEnum (const ::std::string& s,
                  const xercesc::DOMElement* e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    VmsFaultEnum (const VmsFaultEnum& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual VmsFaultEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    VmsFaultEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_VmsFaultEnum_convert ();
    }

    protected:
    value
    _xsd_VmsFaultEnum_convert () const;

    public:
    static const char* const _xsd_VmsFaultEnum_literals_[8];
    static const value _xsd_VmsFaultEnum_indexes_[8];
  };

  class VmsTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      colourGraphic,
      continuousSign,
      monochromeGraphic,
      other
    };

    VmsTypeEnum (value v);

    VmsTypeEnum (const char* v);

    VmsTypeEnum (const ::std::string& v);

    VmsTypeEnum (const ::xml_schema::string& v);

    VmsTypeEnum (const xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    VmsTypeEnum (const xercesc::DOMAttr& a,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    VmsTypeEnum (const ::std::string& s,
                 const xercesc::DOMElement* e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    VmsTypeEnum (const VmsTypeEnum& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual VmsTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    VmsTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_VmsTypeEnum_convert ();
    }

    protected:
    value
    _xsd_VmsTypeEnum_convert () const;

    public:
    static const char* const _xsd_VmsTypeEnum_literals_[4];
    static const value _xsd_VmsTypeEnum_indexes_[4];
  };

  class WeatherRelatedRoadConditions: public ::datex2::RoadConditions
  {
    public:
    // weatherRelatedRoadConditionType
    // 
    typedef ::datex2::WeatherRelatedRoadConditionTypeEnum weatherRelatedRoadConditionType_type;
    typedef ::xsd::cxx::tree::sequence< weatherRelatedRoadConditionType_type > weatherRelatedRoadConditionType_sequence;
    typedef xsd::cxx::tree::sequence< weatherRelatedRoadConditionType_type >::iterator weatherRelatedRoadConditionType_iterator;
    typedef xsd::cxx::tree::sequence< weatherRelatedRoadConditionType_type >::const_iterator weatherRelatedRoadConditionType_const_iterator;
    typedef ::xsd::cxx::tree::traits< weatherRelatedRoadConditionType_type, char > weatherRelatedRoadConditionType_traits;

    const weatherRelatedRoadConditionType_sequence&
    weatherRelatedRoadConditionType () const;

    weatherRelatedRoadConditionType_sequence&
    weatherRelatedRoadConditionType ();

    void
    weatherRelatedRoadConditionType (const weatherRelatedRoadConditionType_sequence& s);

    // roadSurfaceConditionMeasurements
    // 
    typedef ::datex2::RoadSurfaceConditionMeasurements roadSurfaceConditionMeasurements_type;
    typedef ::xsd::cxx::tree::optional< roadSurfaceConditionMeasurements_type > roadSurfaceConditionMeasurements_optional;
    typedef ::xsd::cxx::tree::traits< roadSurfaceConditionMeasurements_type, char > roadSurfaceConditionMeasurements_traits;

    const roadSurfaceConditionMeasurements_optional&
    roadSurfaceConditionMeasurements () const;

    roadSurfaceConditionMeasurements_optional&
    roadSurfaceConditionMeasurements ();

    void
    roadSurfaceConditionMeasurements (const roadSurfaceConditionMeasurements_type& x);

    void
    roadSurfaceConditionMeasurements (const roadSurfaceConditionMeasurements_optional& x);

    void
    roadSurfaceConditionMeasurements (::std::auto_ptr< roadSurfaceConditionMeasurements_type > p);

    // weatherRelatedRoadConditionsExtension
    // 
    typedef ::datex2::ExtensionType weatherRelatedRoadConditionsExtension_type;
    typedef ::xsd::cxx::tree::optional< weatherRelatedRoadConditionsExtension_type > weatherRelatedRoadConditionsExtension_optional;
    typedef ::xsd::cxx::tree::traits< weatherRelatedRoadConditionsExtension_type, char > weatherRelatedRoadConditionsExtension_traits;

    const weatherRelatedRoadConditionsExtension_optional&
    weatherRelatedRoadConditionsExtension () const;

    weatherRelatedRoadConditionsExtension_optional&
    weatherRelatedRoadConditionsExtension ();

    void
    weatherRelatedRoadConditionsExtension (const weatherRelatedRoadConditionsExtension_type& x);

    void
    weatherRelatedRoadConditionsExtension (const weatherRelatedRoadConditionsExtension_optional& x);

    void
    weatherRelatedRoadConditionsExtension (::std::auto_ptr< weatherRelatedRoadConditionsExtension_type > p);

    // Constructors.
    //
    WeatherRelatedRoadConditions (const situationRecordCreationTime_type&,
                                  const situationRecordVersion_type&,
                                  const situationRecordVersionTime_type&,
                                  const probabilityOfOccurrence_type&,
                                  const validity_type&,
                                  const groupOfLocations_type&,
                                  const id_type&);

    WeatherRelatedRoadConditions (const situationRecordCreationTime_type&,
                                  const situationRecordVersion_type&,
                                  const situationRecordVersionTime_type&,
                                  const probabilityOfOccurrence_type&,
                                  ::std::auto_ptr< validity_type >&,
                                  ::std::auto_ptr< groupOfLocations_type >&,
                                  const id_type&);

    WeatherRelatedRoadConditions (const xercesc::DOMElement& e,
                                  ::xml_schema::flags f = 0,
                                  ::xml_schema::container* c = 0);

    WeatherRelatedRoadConditions (const WeatherRelatedRoadConditions& x,
                                  ::xml_schema::flags f = 0,
                                  ::xml_schema::container* c = 0);

    virtual WeatherRelatedRoadConditions*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~WeatherRelatedRoadConditions ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    weatherRelatedRoadConditionType_sequence weatherRelatedRoadConditionType_;
    roadSurfaceConditionMeasurements_optional roadSurfaceConditionMeasurements_;
    weatherRelatedRoadConditionsExtension_optional weatherRelatedRoadConditionsExtension_;
  };

  class WeatherRelatedRoadConditionTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      blackIce,
      deepSnow,
      dry,
      freezingOfWetRoads,
      freezingPavements,
      freezingRain,
      freshSnow,
      ice,
      iceBuildUp,
      iceWithWheelBarTracks,
      icyPatches,
      looseSnow,
      normalWinterConditionsForPedestrians,
      packedSnow,
      roadSurfaceMelting,
      slipperyRoad,
      slushOnRoad,
      slushStrings,
      snowDrifts,
      snowOnPavement,
      snowOnTheRoad,
      surfaceWater,
      wet,
      wetAndIcyRoad,
      wetIcyPavement,
      other
    };

    WeatherRelatedRoadConditionTypeEnum (value v);

    WeatherRelatedRoadConditionTypeEnum (const char* v);

    WeatherRelatedRoadConditionTypeEnum (const ::std::string& v);

    WeatherRelatedRoadConditionTypeEnum (const ::xml_schema::string& v);

    WeatherRelatedRoadConditionTypeEnum (const xercesc::DOMElement& e,
                                         ::xml_schema::flags f = 0,
                                         ::xml_schema::container* c = 0);

    WeatherRelatedRoadConditionTypeEnum (const xercesc::DOMAttr& a,
                                         ::xml_schema::flags f = 0,
                                         ::xml_schema::container* c = 0);

    WeatherRelatedRoadConditionTypeEnum (const ::std::string& s,
                                         const xercesc::DOMElement* e,
                                         ::xml_schema::flags f = 0,
                                         ::xml_schema::container* c = 0);

    WeatherRelatedRoadConditionTypeEnum (const WeatherRelatedRoadConditionTypeEnum& x,
                                         ::xml_schema::flags f = 0,
                                         ::xml_schema::container* c = 0);

    virtual WeatherRelatedRoadConditionTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    WeatherRelatedRoadConditionTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_WeatherRelatedRoadConditionTypeEnum_convert ();
    }

    protected:
    value
    _xsd_WeatherRelatedRoadConditionTypeEnum_convert () const;

    public:
    static const char* const _xsd_WeatherRelatedRoadConditionTypeEnum_literals_[26];
    static const value _xsd_WeatherRelatedRoadConditionTypeEnum_indexes_[26];
  };

  class WeekOfMonthEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      firstWeekOfMonth,
      secondWeekOfMonth,
      thirdWeekOfMonth,
      fourthWeekOfMonth,
      fifthWeekOfMonth
    };

    WeekOfMonthEnum (value v);

    WeekOfMonthEnum (const char* v);

    WeekOfMonthEnum (const ::std::string& v);

    WeekOfMonthEnum (const ::xml_schema::string& v);

    WeekOfMonthEnum (const xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    WeekOfMonthEnum (const xercesc::DOMAttr& a,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    WeekOfMonthEnum (const ::std::string& s,
                     const xercesc::DOMElement* e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    WeekOfMonthEnum (const WeekOfMonthEnum& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual WeekOfMonthEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    WeekOfMonthEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_WeekOfMonthEnum_convert ();
    }

    protected:
    value
    _xsd_WeekOfMonthEnum_convert () const;

    public:
    static const char* const _xsd_WeekOfMonthEnum_literals_[5];
    static const value _xsd_WeekOfMonthEnum_indexes_[5];
  };

  class WidthCharacteristic: public ::xml_schema::type
  {
    public:
    // comparisonOperator
    // 
    typedef ::datex2::ComparisonOperatorEnum comparisonOperator_type;
    typedef ::xsd::cxx::tree::traits< comparisonOperator_type, char > comparisonOperator_traits;

    const comparisonOperator_type&
    comparisonOperator () const;

    comparisonOperator_type&
    comparisonOperator ();

    void
    comparisonOperator (const comparisonOperator_type& x);

    void
    comparisonOperator (::std::auto_ptr< comparisonOperator_type > p);

    // vehicleWidth
    // 
    typedef ::datex2::MetresAsFloat vehicleWidth_type;
    typedef ::xsd::cxx::tree::traits< vehicleWidth_type, char > vehicleWidth_traits;

    const vehicleWidth_type&
    vehicleWidth () const;

    vehicleWidth_type&
    vehicleWidth ();

    void
    vehicleWidth (const vehicleWidth_type& x);

    void
    vehicleWidth (::std::auto_ptr< vehicleWidth_type > p);

    // widthCharacteristicExtension
    // 
    typedef ::datex2::ExtensionType widthCharacteristicExtension_type;
    typedef ::xsd::cxx::tree::optional< widthCharacteristicExtension_type > widthCharacteristicExtension_optional;
    typedef ::xsd::cxx::tree::traits< widthCharacteristicExtension_type, char > widthCharacteristicExtension_traits;

    const widthCharacteristicExtension_optional&
    widthCharacteristicExtension () const;

    widthCharacteristicExtension_optional&
    widthCharacteristicExtension ();

    void
    widthCharacteristicExtension (const widthCharacteristicExtension_type& x);

    void
    widthCharacteristicExtension (const widthCharacteristicExtension_optional& x);

    void
    widthCharacteristicExtension (::std::auto_ptr< widthCharacteristicExtension_type > p);

    // Constructors.
    //
    WidthCharacteristic (const comparisonOperator_type&,
                         const vehicleWidth_type&);

    WidthCharacteristic (const xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    WidthCharacteristic (const WidthCharacteristic& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual WidthCharacteristic*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~WidthCharacteristic ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< comparisonOperator_type > comparisonOperator_;
    ::xsd::cxx::tree::one< vehicleWidth_type > vehicleWidth_;
    widthCharacteristicExtension_optional widthCharacteristicExtension_;
  };

  class Wind: public ::xml_schema::type
  {
    public:
    // maximumWindSpeed
    // 
    typedef ::datex2::KilometresPerHour maximumWindSpeed_type;
    typedef ::xsd::cxx::tree::optional< maximumWindSpeed_type > maximumWindSpeed_optional;
    typedef ::xsd::cxx::tree::traits< maximumWindSpeed_type, char > maximumWindSpeed_traits;

    const maximumWindSpeed_optional&
    maximumWindSpeed () const;

    maximumWindSpeed_optional&
    maximumWindSpeed ();

    void
    maximumWindSpeed (const maximumWindSpeed_type& x);

    void
    maximumWindSpeed (const maximumWindSpeed_optional& x);

    void
    maximumWindSpeed (::std::auto_ptr< maximumWindSpeed_type > p);

    // windDirectionBearing
    // 
    typedef ::datex2::AngleInDegrees windDirectionBearing_type;
    typedef ::xsd::cxx::tree::optional< windDirectionBearing_type > windDirectionBearing_optional;
    typedef ::xsd::cxx::tree::traits< windDirectionBearing_type, char > windDirectionBearing_traits;

    const windDirectionBearing_optional&
    windDirectionBearing () const;

    windDirectionBearing_optional&
    windDirectionBearing ();

    void
    windDirectionBearing (const windDirectionBearing_type& x);

    void
    windDirectionBearing (const windDirectionBearing_optional& x);

    void
    windDirectionBearing (::std::auto_ptr< windDirectionBearing_type > p);

    // windDirectionCompass
    // 
    typedef ::datex2::DirectionCompassEnum windDirectionCompass_type;
    typedef ::xsd::cxx::tree::optional< windDirectionCompass_type > windDirectionCompass_optional;
    typedef ::xsd::cxx::tree::traits< windDirectionCompass_type, char > windDirectionCompass_traits;

    const windDirectionCompass_optional&
    windDirectionCompass () const;

    windDirectionCompass_optional&
    windDirectionCompass ();

    void
    windDirectionCompass (const windDirectionCompass_type& x);

    void
    windDirectionCompass (const windDirectionCompass_optional& x);

    void
    windDirectionCompass (::std::auto_ptr< windDirectionCompass_type > p);

    // windMeasurementHeight
    // 
    typedef ::datex2::MetresAsNonNegativeInteger windMeasurementHeight_type;
    typedef ::xsd::cxx::tree::optional< windMeasurementHeight_type > windMeasurementHeight_optional;
    typedef ::xsd::cxx::tree::traits< windMeasurementHeight_type, char > windMeasurementHeight_traits;

    const windMeasurementHeight_optional&
    windMeasurementHeight () const;

    windMeasurementHeight_optional&
    windMeasurementHeight ();

    void
    windMeasurementHeight (const windMeasurementHeight_type& x);

    void
    windMeasurementHeight (const windMeasurementHeight_optional& x);

    void
    windMeasurementHeight (::std::auto_ptr< windMeasurementHeight_type > p);

    // windSpeed
    // 
    typedef ::datex2::KilometresPerHour windSpeed_type;
    typedef ::xsd::cxx::tree::optional< windSpeed_type > windSpeed_optional;
    typedef ::xsd::cxx::tree::traits< windSpeed_type, char > windSpeed_traits;

    const windSpeed_optional&
    windSpeed () const;

    windSpeed_optional&
    windSpeed ();

    void
    windSpeed (const windSpeed_type& x);

    void
    windSpeed (const windSpeed_optional& x);

    void
    windSpeed (::std::auto_ptr< windSpeed_type > p);

    // windExtension
    // 
    typedef ::datex2::ExtensionType windExtension_type;
    typedef ::xsd::cxx::tree::optional< windExtension_type > windExtension_optional;
    typedef ::xsd::cxx::tree::traits< windExtension_type, char > windExtension_traits;

    const windExtension_optional&
    windExtension () const;

    windExtension_optional&
    windExtension ();

    void
    windExtension (const windExtension_type& x);

    void
    windExtension (const windExtension_optional& x);

    void
    windExtension (::std::auto_ptr< windExtension_type > p);

    // Constructors.
    //
    Wind ();

    Wind (const xercesc::DOMElement& e,
          ::xml_schema::flags f = 0,
          ::xml_schema::container* c = 0);

    Wind (const Wind& x,
          ::xml_schema::flags f = 0,
          ::xml_schema::container* c = 0);

    virtual Wind*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Wind ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    maximumWindSpeed_optional maximumWindSpeed_;
    windDirectionBearing_optional windDirectionBearing_;
    windDirectionCompass_optional windDirectionCompass_;
    windMeasurementHeight_optional windMeasurementHeight_;
    windSpeed_optional windSpeed_;
    windExtension_optional windExtension_;
  };

  class WindInformation: public ::datex2::WeatherValue
  {
    public:
    // wind
    // 
    typedef ::datex2::Wind wind_type;
    typedef ::xsd::cxx::tree::traits< wind_type, char > wind_traits;

    const wind_type&
    wind () const;

    wind_type&
    wind ();

    void
    wind (const wind_type& x);

    void
    wind (::std::auto_ptr< wind_type > p);

    // windInformationExtension
    // 
    typedef ::datex2::ExtensionType windInformationExtension_type;
    typedef ::xsd::cxx::tree::optional< windInformationExtension_type > windInformationExtension_optional;
    typedef ::xsd::cxx::tree::traits< windInformationExtension_type, char > windInformationExtension_traits;

    const windInformationExtension_optional&
    windInformationExtension () const;

    windInformationExtension_optional&
    windInformationExtension ();

    void
    windInformationExtension (const windInformationExtension_type& x);

    void
    windInformationExtension (const windInformationExtension_optional& x);

    void
    windInformationExtension (::std::auto_ptr< windInformationExtension_type > p);

    // Constructors.
    //
    WindInformation (const wind_type&);

    WindInformation (::std::auto_ptr< wind_type >&);

    WindInformation (const xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    WindInformation (const WindInformation& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual WindInformation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~WindInformation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< wind_type > wind_;
    windInformationExtension_optional windInformationExtension_;
  };

  class WinterDrivingManagement: public ::datex2::NetworkManagement
  {
    public:
    // winterEquipmentManagementType
    // 
    typedef ::datex2::WinterEquipmentManagementTypeEnum winterEquipmentManagementType_type;
    typedef ::xsd::cxx::tree::traits< winterEquipmentManagementType_type, char > winterEquipmentManagementType_traits;

    const winterEquipmentManagementType_type&
    winterEquipmentManagementType () const;

    winterEquipmentManagementType_type&
    winterEquipmentManagementType ();

    void
    winterEquipmentManagementType (const winterEquipmentManagementType_type& x);

    void
    winterEquipmentManagementType (::std::auto_ptr< winterEquipmentManagementType_type > p);

    // winterDrivingManagementExtension
    // 
    typedef ::datex2::ExtensionType winterDrivingManagementExtension_type;
    typedef ::xsd::cxx::tree::optional< winterDrivingManagementExtension_type > winterDrivingManagementExtension_optional;
    typedef ::xsd::cxx::tree::traits< winterDrivingManagementExtension_type, char > winterDrivingManagementExtension_traits;

    const winterDrivingManagementExtension_optional&
    winterDrivingManagementExtension () const;

    winterDrivingManagementExtension_optional&
    winterDrivingManagementExtension ();

    void
    winterDrivingManagementExtension (const winterDrivingManagementExtension_type& x);

    void
    winterDrivingManagementExtension (const winterDrivingManagementExtension_optional& x);

    void
    winterDrivingManagementExtension (::std::auto_ptr< winterDrivingManagementExtension_type > p);

    // Constructors.
    //
    WinterDrivingManagement (const situationRecordCreationTime_type&,
                             const situationRecordVersion_type&,
                             const situationRecordVersionTime_type&,
                             const probabilityOfOccurrence_type&,
                             const validity_type&,
                             const groupOfLocations_type&,
                             const id_type&,
                             const complianceOption_type&,
                             const winterEquipmentManagementType_type&);

    WinterDrivingManagement (const situationRecordCreationTime_type&,
                             const situationRecordVersion_type&,
                             const situationRecordVersionTime_type&,
                             const probabilityOfOccurrence_type&,
                             ::std::auto_ptr< validity_type >&,
                             ::std::auto_ptr< groupOfLocations_type >&,
                             const id_type&,
                             const complianceOption_type&,
                             const winterEquipmentManagementType_type&);

    WinterDrivingManagement (const xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    WinterDrivingManagement (const WinterDrivingManagement& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual WinterDrivingManagement*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~WinterDrivingManagement ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< winterEquipmentManagementType_type > winterEquipmentManagementType_;
    winterDrivingManagementExtension_optional winterDrivingManagementExtension_;
  };

  class WinterEquipmentManagementTypeEnum: public ::xml_schema::string
  {
    public:
    enum value
    {
      doNoUseStudTyres,
      useSnowChains,
      useSnowChainsOrTyres,
      useSnowTyres,
      winterEquipmentOnBoardRequired,
      other
    };

    WinterEquipmentManagementTypeEnum (value v);

    WinterEquipmentManagementTypeEnum (const char* v);

    WinterEquipmentManagementTypeEnum (const ::std::string& v);

    WinterEquipmentManagementTypeEnum (const ::xml_schema::string& v);

    WinterEquipmentManagementTypeEnum (const xercesc::DOMElement& e,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    WinterEquipmentManagementTypeEnum (const xercesc::DOMAttr& a,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    WinterEquipmentManagementTypeEnum (const ::std::string& s,
                                       const xercesc::DOMElement* e,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    WinterEquipmentManagementTypeEnum (const WinterEquipmentManagementTypeEnum& x,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    virtual WinterEquipmentManagementTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    WinterEquipmentManagementTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_WinterEquipmentManagementTypeEnum_convert ();
    }

    protected:
    value
    _xsd_WinterEquipmentManagementTypeEnum_convert () const;

    public:
    static const char* const _xsd_WinterEquipmentManagementTypeEnum_literals_[6];
    static const value _xsd_WinterEquipmentManagementTypeEnum_indexes_[6];
  };

  class measurementSpecificCharacteristics: public ::datex2::MeasurementSpecificCharacteristics
  {
    public:
    // index
    // 
    typedef ::xml_schema::int_ index_type;
    typedef ::xsd::cxx::tree::traits< index_type, char > index_traits;

    const index_type&
    index () const;

    index_type&
    index ();

    void
    index (const index_type& x);

    // Constructors.
    //
    measurementSpecificCharacteristics (const specificMeasurementValueType_type&,
                                        const index_type&);

    measurementSpecificCharacteristics (const xercesc::DOMElement& e,
                                        ::xml_schema::flags f = 0,
                                        ::xml_schema::container* c = 0);

    measurementSpecificCharacteristics (const measurementSpecificCharacteristics& x,
                                        ::xml_schema::flags f = 0,
                                        ::xml_schema::container* c = 0);

    virtual measurementSpecificCharacteristics*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~measurementSpecificCharacteristics ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< index_type > index_;
  };

  class measuredValue: public ::datex2::MeasuredValue
  {
    public:
    // index
    // 
    typedef ::xml_schema::int_ index_type;
    typedef ::xsd::cxx::tree::traits< index_type, char > index_traits;

    const index_type&
    index () const;

    index_type&
    index ();

    void
    index (const index_type& x);

    // Constructors.
    //
    measuredValue (const basicDataValue_type&,
                   const index_type&);

    measuredValue (::std::auto_ptr< basicDataValue_type >&,
                   const index_type&);

    measuredValue (const xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    measuredValue (const measuredValue& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual measuredValue*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~measuredValue ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< index_type > index_;
  };
}

#include <iosfwd>

#include <xercesc/sax/InputSource.hpp>
#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>

namespace datex2
{
  // Parse a URI or a local file.
  //

  ::std::auto_ptr< ::datex2::D2LogicalModel >
  d2LogicalModel (const ::std::string& uri,
                  ::xml_schema::flags f = 0,
                  const ::xml_schema::properties& p = ::xml_schema::properties ());

  ::std::auto_ptr< ::datex2::D2LogicalModel >
  d2LogicalModel (const ::std::string& uri,
                  ::xml_schema::error_handler& eh,
                  ::xml_schema::flags f = 0,
                  const ::xml_schema::properties& p = ::xml_schema::properties ());

  ::std::auto_ptr< ::datex2::D2LogicalModel >
  d2LogicalModel (const ::std::string& uri,
                  xercesc::DOMErrorHandler& eh,
                  ::xml_schema::flags f = 0,
                  const ::xml_schema::properties& p = ::xml_schema::properties ());

  // Parse std::istream.
  //

  ::std::auto_ptr< ::datex2::D2LogicalModel >
  d2LogicalModel (::std::istream& is,
                  ::xml_schema::flags f = 0,
                  const ::xml_schema::properties& p = ::xml_schema::properties ());

  ::std::auto_ptr< ::datex2::D2LogicalModel >
  d2LogicalModel (::std::istream& is,
                  ::xml_schema::error_handler& eh,
                  ::xml_schema::flags f = 0,
                  const ::xml_schema::properties& p = ::xml_schema::properties ());

  ::std::auto_ptr< ::datex2::D2LogicalModel >
  d2LogicalModel (::std::istream& is,
                  xercesc::DOMErrorHandler& eh,
                  ::xml_schema::flags f = 0,
                  const ::xml_schema::properties& p = ::xml_schema::properties ());

  ::std::auto_ptr< ::datex2::D2LogicalModel >
  d2LogicalModel (::std::istream& is,
                  const ::std::string& id,
                  ::xml_schema::flags f = 0,
                  const ::xml_schema::properties& p = ::xml_schema::properties ());

  ::std::auto_ptr< ::datex2::D2LogicalModel >
  d2LogicalModel (::std::istream& is,
                  const ::std::string& id,
                  ::xml_schema::error_handler& eh,
                  ::xml_schema::flags f = 0,
                  const ::xml_schema::properties& p = ::xml_schema::properties ());

  ::std::auto_ptr< ::datex2::D2LogicalModel >
  d2LogicalModel (::std::istream& is,
                  const ::std::string& id,
                  xercesc::DOMErrorHandler& eh,
                  ::xml_schema::flags f = 0,
                  const ::xml_schema::properties& p = ::xml_schema::properties ());

  // Parse xercesc::InputSource.
  //

  ::std::auto_ptr< ::datex2::D2LogicalModel >
  d2LogicalModel (xercesc::InputSource& is,
                  ::xml_schema::flags f = 0,
                  const ::xml_schema::properties& p = ::xml_schema::properties ());

  ::std::auto_ptr< ::datex2::D2LogicalModel >
  d2LogicalModel (xercesc::InputSource& is,
                  ::xml_schema::error_handler& eh,
                  ::xml_schema::flags f = 0,
                  const ::xml_schema::properties& p = ::xml_schema::properties ());

  ::std::auto_ptr< ::datex2::D2LogicalModel >
  d2LogicalModel (xercesc::InputSource& is,
                  xercesc::DOMErrorHandler& eh,
                  ::xml_schema::flags f = 0,
                  const ::xml_schema::properties& p = ::xml_schema::properties ());

  // Parse xercesc::DOMDocument.
  //

  ::std::auto_ptr< ::datex2::D2LogicalModel >
  d2LogicalModel (const xercesc::DOMDocument& d,
                  ::xml_schema::flags f = 0,
                  const ::xml_schema::properties& p = ::xml_schema::properties ());

  ::std::auto_ptr< ::datex2::D2LogicalModel >
  d2LogicalModel (::xml_schema::dom::auto_ptr< xercesc::DOMDocument >& d,
                  ::xml_schema::flags f = 0,
                  const ::xml_schema::properties& p = ::xml_schema::properties ());
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

#endif // DATEXIISCHEMA_2_0_2_0_HXX
